(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.M_GoodDocsMainte = {};

  // インスタンスプロパティを追加する
  var AppSpec = App.AppSpec = new $R.Class($R.AppSpec);
  AppSpec.fn.init = function(name) {
    $R.log("AppSpec init : start");

    this.name       = name;
    this.nextname   = "";
    this.beforename = "M_GoodsMainte";

    $R.log("AppSpec init : end");
  }

  // 共通モジュールを追加する
  AppSpec.include($R.Library.AppSpecMixin);

  AppSpec.include({
    // -----------------------------------------------------------------------------------------------
    // プログラム・JSONファイルのURL情報を定義する（サブシステム名・種類・Apps・プログラムフォルダ名）
    // -----------------------------------------------------------------------------------------------
    urlInfo: [
      {app:  "FlowerShop/Html/Apps/M_GoodDocsMainte/"}
     ,{json: "FlowerShop/Json/Apps/M_GoodDocsMainte/"}
    ]
    // --------------------------
    // JSONファイル情報を定義する
    // --------------------------
   ,jsonInfo: [
      {dataset:     "yes"}
     ,{validation:  "yes"}
    ]
    // ----------------------------------------------------------------------------------------
    // トランザクション・リクエストチェック・レスポンス編集・エラーのコールバック関数を定義する
    // ----------------------------------------------------------------------------------------
   ,requestInfo: [
      ["select",         "on照会OfCheckRequestData",         "on照会OfEditResponseData",         "onErrorResponseData"]
      // ここから追加
     ,["imageinsert",    "on画像登録OfCheckRequestData",     "on画像登録OfEditResponseData",     "onErrorResponseData"]
     ,["imageupdate",    "on画像訂正OfCheckRequestData",     "on画像訂正OfEditResponseData",     "onErrorResponseData"]
     ,["imagedelete",    "on画像削除OfCheckRequestData",     "on画像削除OfEditResponseData",     "onErrorResponseData"]
     ,["imageselect",    "on画像照会OfCheckRequestData",     "on画像照会OfEditResponseData",     "onErrorResponseData"]
     ,["imagefile",      "on画像表示OfCheckRequestData",     "on画像表示OfEditResponseData",     "onErrorResponseData"]
     ,["download",       "onダウンロードOfCheckRequestData", "onダウンロードOfEditResponseData", "onErrorResponseData"]
    ]
    // --------------------------------------------------
    // エンター・タブとPFキーのコールバック関数を定義する
    // --------------------------------------------------
   ,enterTabPFKey: {
      Enter:true
     ,Tab:true
     ,F1:null
     ,F2:null
     ,F3:null
     ,F4:null
     ,F5:null
     ,F6:null
     ,F7:null
     ,F8:null
     ,F9:null
     ,F10:null
     ,F11:null
     ,F12:null
     ,ESC:"on戻る"
     ,Forms:0
    }
    // ----------------------------------------------------------------
    // イベント設定はセレクタ・イベント・コールバック関数の順に指定する
    // ----------------------------------------------------------------
    // NAVボタンのイベントを定義する
   ,navButtonEvent: [
      ["#戻る",           "click", "on戻る"]
      //,["#実行",           "click", "on実行"]
      // ここから追加
     ,["#画像登録",       "click", "on画像登録"]
     ,["#画像変更",       "click", "on画像変更"]
     ,["#画像削除",       "click", "on画像削除"]
     ,["#ダウンロード",   "click", "onダウンロード"]
     ,["#mainTable td",   "click", "onテーブル行クリック"]
    ]
    // バリデーションのイベントを定義する
   ,validationEvent: [
      ["#mainForm", "focus", "onFocus"]
     ,["#mainForm", "blur",  "onBlur"]
    ]
    // その他セレクターイベントを定義する
   ,selectorEvent: [
      ["#upload",         "change", "onChangeファイル参照"]
 		 // ここから追加
     ,["#カタログ出力２", "change", "onChangeチェックボックス"]
     ,["#社外閲覧可否２", "change", "onChangeチェックボックス"]
    ]
    // ----------------------------------------------------------------------------------
    // カスタムイベント設定はイベント名・実行コンテキスト・コールバック関数の順に指定する
    // ----------------------------------------------------------------------------------
    // チェック用カスタムイベントを定義する
   ,pubsubCheckEvent: [
    ]
    // 導出項目編集用カスタムイベントを定義する
   ,pubsubDeriveEvent: [
    ]
    // その他カスタムイベントを定義する
   ,pubsubOtherEvent: [
      ["showログイン情報",     "view", "showログイン情報"]
     ,["showヘッダータイトル", "view", "showヘッダータイトル"]
     ,["show初期処理",         "view", "show初期処理"]
      // ここから追加
     ,["onテーブル表示",       "view", "onテーブル表示"]
     ,["onテーブル行クリック", "view", "onテーブル行クリック"]
     ,["showファイル名２",     "view", "showファイル名２"]
     ,["show画像表示",         "view", "show画像表示"]
     ,["show画像非表示",       "view", "show画像非表示"]
     ,["setファイル更新不可",  "view", "setファイル更新不可"]
     ,["setファイル更新可能",  "view", "setファイル更新可能"]
    ]
		
    // ----------------------------------------------------------------------------------
    // チェックボックス　定義
		// selectorid  : HTMLのIDを指定する
		// selectorname: HTMLのnameを指定する（テーブル内で使用する時に定義する）
		// datasetid   : チェックボックスの値が設定されるdatasetのＩＤ名を指定する
		// datasetname : チェックボックスの値が設定されるdatasetの項目名を指定する
		// onvalue     : チェックされた時に取る値を指定する
		// offvalue    : チェックが外された時に取る値を指定する
    // ----------------------------------------------------------------------------------
   ,checkbox: [
      {
			 selectorid: "カタログ出力２", datasetid: "header2", datasetname: "カタログ出力２"
			,value:     {on: 1, off: 0}
			}
			
     ,{
			 selectorid: "社外閲覧可否２", datasetid: "header2", datasetname: "社外閲覧可否２"
			,value:     {on: 1, off: 0}
			}
    ]
		
  });
}(jQuery, Rmenu));