(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.M_GoodDocsMainte;

  // インスタンスプロパティを追加する
  var Controller = App.Controller = new $R.Class($R.Controller);
  Controller.fn.init = function(appspec, model, view) {
    $R.log("Controllerr init : start");

    this.appspec = appspec;
    this.model   = model;
    this.view    = view;
    this.createPubSubEvent();

    $R.log("Controllerr init : end");
  };

  // モジュールを追加する
  Controller.include($R.Library.EnterTabPFKeyMixin);
  Controller.include($R.Library.ControllerMixin);

  // マスターメンテパターン　ミックスインを追加する
  Controller.include($R.Library.MasterMainteControllerMixin);

  // 関数を追加する
  Controller.include({
    // ---------------------------------------
    // 画像登録 イベント処理
    // ---------------------------------------
    on画像登録: function(event) {
      $R.log("Controller on画像登録 : start");

      this.model.on画像アップロード(this, "imageinsert");

      $R.log("Controller on画像登録 : end");
    }
    // ---------------------------------------
    // 画像変更 イベント処理
    // ---------------------------------------
   ,on画像変更: function(event) {
      $R.log("Controller on画像変更 : start");

      this.model.on画像アップロード(this, "imageupdate");

      $R.log("Controller on画像変更 : end");
    }
    // ---------------------------------------
    // 画像削除 イベント処理
    // ---------------------------------------
   ,on画像削除: function(event) {
      $R.log("Controller on画像削除 : start");

      this.ajaxExecute("imagedelete");

      $R.log("Controller on画像削除 : end");
    }
    // ---------------------------------------
    // 画像ダウンロード イベント処理
    // ---------------------------------------
   ,onダウンロード: function(event) {
      $R.log("Controller onダウンロード : start");

      this.ajaxExecute("download");

      $R.log("Controller onダウンロード : end");
    }
    // ---------------------------------------
    // 画像アップロード後処理
    // ---------------------------------------
   ,on画像アップロード後処理: function(mode) {
      $R.log("Controller 画像アップロード後処理 : start");

      this.ajaxExecute(mode);

      $R.log("Controller 画像アップロード後処理 : end");
    }
    // ---------------------------------------
    // チェンジ イベント処理（追加処理）
    // ---------------------------------------
   ,onChangeチェックボックス: function(event) {
      $R.log("Controller onChangeチェックボックス : start");

      this.model.onChangeCheckBox(event, this.appspec.checkbox);

      $R.log("Controller onChangeチェックボックス : end");
    }
    // ----------------------------------------------------------------
    // ファイル参照 チェンジ イベント処理（アップロードファイルを選択）
    // ----------------------------------------------------------------
   ,onChangeファイル参照: function(event) {
      $R.log("Controller onChangeファイル参照 : start");

      this.model.onChangeファイル参照();

      $R.log("Controller onChangeファイル参照 : end");
    }
    // ---------------------------------------
    // テーブル行　クリック処理処理
    // ---------------------------------------
   ,onテーブル行クリック: function(event, arg) {
      $R.log("Controller onテーブル行クリック : start");

			var row    = event.currentTarget.parentNode.rowIndex;
			var idName = event.currentTarget.offsetParent.id;
      var arg9   = {クリック行: row, セレクタ名: idName};
      this.model.onテーブル行クリック(arg9);

      this.ajaxExecute("imagefile");

      $R.log("Controller onテーブル行クリック : end");
    }
    // -----------------------------------
    //  リクエストデータ　チェック処理
    // -----------------------------------
   ,on画像登録OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on画像登録OfCheckRequestData : start");

      var status = this.model.on画像登録OfCheckRequestData(requestData, mode);
      if (status) {
        status = this.checkRequestData(requestData);
      }

      $R.log("Controller on画像登録OfCheckRequestData : end");
      return status;
    }
   ,on画像訂正OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on画像訂正OfCheckRequestData : start");

      var status = this.model.on画像訂正OfCheckRequestData(requestData, mode);
      if (status) {
        status = this.checkRequestData(requestData);
      }

      $R.log("Controller on画像訂正OfCheckRequestData : end");
      return status;
    }
   ,on画像削除OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on画像削除OfCheckRequestData : start");

      var status = this.model.on画像削除OfCheckRequestData(requestData, mode);
      if (status) {
        status = this.checkRequestData(requestData);
      }

      $R.log("Controller on画像削除OfCheckRequestData : end");
      return status;
    }
   ,on画像照会OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on画像照会OfCheckRequestData : start");

      var status = this.checkRequestData(requestData);

      $R.log("Controller on画像照会OfCheckRequestData : end");
      return status;
    }
   ,on画像表示OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on画像表示OfCheckRequestData : start");

      var status = this.checkRequestData(requestData);

      $R.log("Controller on画像表示OfCheckRequestData : end");
      return status;
    }
   ,onダウンロードOfCheckRequestData: function(requestData, mode) {
      $R.log("Controller onダウンロードOfCheckRequestData : start");

      var status = this.checkRequestData(requestData);

      $R.log("Controller onダウンロードOfCheckRequestData : end");
      return status;
    }
    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,on照会OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on照会OfEditResponseData : start");

      this.editResponseData(responseData);
      this.model.on照会OfEditResponseData(responseData);
      this.setTableRowEvent();

      $R.log("Controller on照会OfEditResponseData : end");
    }
   ,on画像登録OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on画像登録OfEditResponseData : start");

      this.model.on画像登録OfEditResponseData(responseData);
      this.editResponseData(responseData);

      this.ajaxExecute("imageselect");

      //this.model.onサーバ処理確認ダイアログ(responseData);

      $R.log("Controller on画像登録OfEditResponseData : end");
    }
   ,on画像訂正OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on画像訂正OfEditResponseData : start");

      this.model.on画像訂正OfEditResponseData(responseData);
      this.editResponseData(responseData);

      this.ajaxExecute("imageselect");

      //this.model.onサーバ処理確認ダイアログ(responseData);

      $R.log("Controller on画像登録OfEditResponseData : end");
    }
   ,on画像削除OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on画像削除OfEditResponseData : start");

      this.model.on画像削除OfEditResponseData(responseData);
      this.editResponseData(responseData);

      this.ajaxExecute("imageselect");

      //this.model.onサーバ処理確認ダイアログ(responseData);

      $R.log("Controller on画像登録OfEditResponseData : end");
    }
   ,on画像照会OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on画像照会OfEditResponseData : start");

      this.model.on画像照会OfEditResponseData(responseData);
      this.editResponseData(responseData);
      this.setTableRowEvent();

      $R.log("Controller on画像照会OfEditResponseData : end");
    }
   ,on画像表示OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on画像表示OfEditResponseData : start");

      this.model.on画像表示OfEditResponseData(responseData);
      this.editResponseData(responseData);

      $R.log("Controller on画像表示OfEditResponseData : end");
    }
   ,onダウンロードOfEditResponseData: function(responseData, mode) {
      $R.log("Controller onダウンロードOfEditResponseData : start");

      this.editResponseData(responseData);
      this.model.onダウンロードOfEditResponseData(responseData);

      $R.log("Controller onダウンロードOfEditResponseData : end");
    }
  });
}(jQuery, Rmenu));