(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.M_GoodDocsMainte;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスターメンテパターン　ミックスインを追加する
  Model.include($R.Library.MasterMainteModelMixin);

  Model.include({
    // -------------------------------------------
    //  画像アップロード処理
    // -------------------------------------------
    on画像アップロード: function(self, mode) {
      $R.log("Model on画像アップロード : start");

      // ファイル選択　チェック
      var file = $('#upload')[0].files[0];
      if (!file) {
        var arg    = {title: "ファイル選択エラー", message: "ファイルが選択されていません。ファイルを選択して下さい。"};
        this.pubsub.publish("alertDialog", arg);
				return;
			}

      // ファイル拡張子　チェック
      var fileName       = this.dataset.getElementData("ファイル名２");
      var extensionArray = fileName.split(".");
      var extensionMax   = extensionArray.length;
      var extension      = extensionArray[extensionMax - 1].toLowerCase();
			
      var dataset        = this.dataset.getData();
      var detailInfo     = this.appspec.getJSONChunkByIdAtRecords(dataset, "filetype");
      var fileTypeArray  = detailInfo["record"]["チェックファイルタイプ"]["value"];
      var max            = fileTypeArray.length;
      var fileType;
			var filetypeSW     = false;
      for (var i = 0; i < max; i++) {
        fileType = fileTypeArray[i].split(":");

        if (fileType[1] == extension) {
				  filetypeSW = true;
          break;
        }
      }

      if (!filetypeSW) {
        var arg    = {title: "ファイル拡張子エラー", message: "ファイルの拡張子が間違っています。訂正して下さい。"};
        this.pubsub.publish("alertDialog", arg);
				return;
			}

      // ファイル　アップロード
      var fileName = this.dataset.getElementData("ファイル名２");
      var dataStrint  = "FlowerShop/UpLoad/Apps/M_GoodDocsMainte";
      dataStrint     += "#";
      dataStrint     += fileName
      $('#upload').upload(
         $R.UploadRackURL                             // 送信先
        ,{data:dataStrint}                            // 同時にPOSTするデータ
        ,function (responseData) {
           self.on画像アップロード後処理(mode);
         }
        ,'text'                                       // 戻り値の種類
      );

      $R.log("Model on画像アップロード : end");
    }
    // ----------------------------------------------------------------
    // ファイル参照 チェンジ イベント処理（アップロードファイルを選択）
    // ----------------------------------------------------------------
   ,onChangeファイル参照: function() {
      $R.log("Model onChangeファイル参照 : start");

      var fileName = $('#upload')[0].files[0].name;
      this.dataset.setElementData(fileName, "ファイル名２");


      var extensionArray = fileName.split(".");
      var extensionMax   = extensionArray.length;
      var extension      = extensionArray[extensionMax - 1].toLowerCase();
      this.dataset.setElementData(extension, "ファイルタイプ２");

      var arg = {ファイル名２: fileName};
      this.pubsub.publish("showファイル名２", arg);
			

      $R.log("Model onChangeファイル参照 : end");
    }
    // -------------------------------------------------------
    //  テーブルの選択行をセッションストレージに格納する
    // -------------------------------------------------------
   ,onテーブル行クリック: function(arg) {
      $R.log("Model onテーブル行クリック : start");

      var clickRow  = arg["クリック行"] - 1;

      var dataset    = this.dataset.getData();
      var detailInfo = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail")["record"];
      if (detailInfo["商品ドキュメントＩＤ"]["value"][clickRow]) {
        this.dataset.setElementData(detailInfo["商品ドキュメントＩＤ"]["value"][clickRow], "商品ドキュメントＩＤ２");
        this.dataset.setElementData(detailInfo["ファイル名"]["value"][clickRow], "ファイル名２");
        this.dataset.setElementData(detailInfo["ファイルタイプ"]["value"][clickRow], "ファイルタイプ２");
        this.dataset.setElementData(detailInfo["コメント"]["value"][clickRow], "コメント２");
        this.dataset.setElementData(detailInfo["カタログ出力"]["value"][clickRow], "カタログ出力２");
        this.dataset.setElementData(detailInfo["社外閲覧可否"]["value"][clickRow], "社外閲覧可否２");
        this.dataset.setElementData(detailInfo["バージョン番号"]["value"][clickRow], "バージョン番号２");
        this.dataset.setElementData(detailInfo["更新日時"]["value"][clickRow], "更新日時２");

        arg["テーブルデータ"] = detailInfo;
        this.pubsub.publish("onテーブル行クリック", arg);
      }

      $R.log("Model onテーブル行クリック : end");
    }
    // ---------------------------------------------------
    //  リクエストデータ　画像登録処理　編集・チェック処理
    // ---------------------------------------------------
   ,on画像登録OfCheckRequestData: function(requestData, mode) {
      $R.log("Model on画像登録OfCheckRequestData : start");

			this.on画像訂正OfCheckRequestData(requestData, mode);

      var tableID    = this.dataset.getElementData("テーブルＩＤ");
      var headerData = this.appspec.getJSONChunkByIdAtRecords(requestData, "header2")["record"];
			headerData["テーブルＩＤ"]["value"][0] = tableID;

      $R.log("Model on画像登録OfCheckRequestData : end");
      return true;
    }
    // ---------------------------------------------------
    //  リクエストデータ　画像訂正処理　編集・チェック処理
    // ---------------------------------------------------
   ,on画像訂正OfCheckRequestData: function(requestData, mode) {
      $R.log("Model on画像訂正OfCheckRequestData : start");

      // ログイン情報を設定する
      var loginRecord = this.appspec.getJSONChunkByIdAtRecords(requestData, "login")["record"];

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + ".Login");
      loginRecord["ユーザＩＤ"]["value"][0] = sessionStorage.loadItem("ユーザＩＤ");
      loginRecord["ユーザ名称"]["value"][0] = sessionStorage.loadItem("ユーザ名称");
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      $R.log("Model on画像訂正OfCheckRequestData : end");
      return true;
    }
    // ---------------------------------------------------
    //  リクエストデータ　画像削除処理　編集・チェック処理
    // ---------------------------------------------------
   ,on画像削除OfCheckRequestData: function(requestData, mode) {
      $R.log("Model on画像訂正OfCheckRequestData : start");
			
			this.on画像訂正OfCheckRequestData(requestData, mode);

      $R.log("Model on画像削除OfCheckRequestData : end");
      return true;
    }
    // -----------------------------------
    //  登録処理レスポンスデータ　編集処理
    // -----------------------------------
   ,on登録OfEditResponseData: function(responseData) {
      $R.log("Model on登録OfEditResponseData : start");

      this.pubsub.publish("setファイル更新可能", "");

      $R.log("Model on登録OfEditResponseData : end");
    }
    // -----------------------------------
    //  検索レスポンスデータ　編集処理
    // -----------------------------------
   ,on照会OfEditResponseData: function(responseData) {
      $R.log("Model on照会OfEditResponseData : start");

      var tableData = this.appspec.getJSONChunkByIdAtRecords(responseData, "detail");
      var arg       = {テーブルＩＤ: "mainTable", テーブルデータ: tableData};
      this.pubsub.publish("onテーブル表示", arg);

      $R.log("Model on照会OfEditResponseData : end");
    }
    // -----------------------------------
    //  画像登録レスポンスデータ　編集処理
    // -----------------------------------
   ,on画像登録OfEditResponseData: function(responseData) {
      $R.log("Model on画像登録OfEditResponseData : start");


      $R.log("Model on画像登録OfEditResponseData : end");
    }
    // -----------------------------------
    //  画像訂正レスポンスデータ　編集処理
    // -----------------------------------
   ,on画像訂正OfEditResponseData: function(responseData) {
      $R.log("Model on画像訂正OfEditResponseData : start");


      $R.log("Model on画像訂正OfEditResponseData : end");
    }
    // -----------------------------------
    //  画像削除レスポンスデータ　編集処理
    // -----------------------------------
   ,on画像削除OfEditResponseData: function(responseData) {
      $R.log("Model on画像削除OfEditResponseData : start");


      $R.log("Model on画像削除OfEditResponseData : end");
    }
    // -----------------------------------
    //  画像削除レスポンスデータ　編集処理
    // -----------------------------------
   ,on画像照会OfEditResponseData: function(responseData) {
      $R.log("Model on画像照会OfEditResponseData : start");

      var tableData = this.appspec.getJSONChunkByIdAtRecords(responseData, "detail");
      var arg       = {テーブルＩＤ: "mainTable", テーブルデータ: tableData};
      this.pubsub.publish("onテーブル表示", arg);

			// 表示中の画像を非表示にする
      this.pubsub.publish("show画像非表示", "");

      $R.log("Model on画像照会OfEditResponseData : end");
    }
    // -----------------------------------------------------
    //  画像表示　レスポンスデータ　編集処理
    // -----------------------------------------------------
   ,on画像表示OfEditResponseData: function(responseData) {
      $R.log("Model on画像表示OfEditResponseData : start");

      var headerRecord    = this.appspec.getJSONChunkByIdAtRecords(responseData, "header2");
      var fileName        = headerRecord["record"]["ファイル名２"]["value"][0];
      var downloadfile    = headerRecord["record"]["downloadfile"]["value"][0];
      var mimeType        = headerRecord["record"]["マイムタイプ"]["value"][0];
      var arg             = {ファイル名２: fileName, ダウンロードファイル: downloadfile, マイムタイプ: mimeType};
      this.pubsub.publish("show画像表示", arg);

      $R.log("Model on画像表示OfEditResponseData : end");
    }
   ,onダウンロードOfEditResponseData: function(responseData) {
      $R.log("Model onダウンロードOfEditResponseData : start");

      var headerRecord  = this.appspec.getJSONChunkByIdAtRecords(responseData, "header2");
      var downloadfile  = headerRecord["record"]["downloadfile"]["value"][0];
      var filename      = headerRecord["record"]["ファイル名２"]["value"][0];
      var mimeType      = headerRecord["record"]["マイムタイプ"]["value"][0];
      var mimeTypeArray = mimeType.split("/");
			
      var argHash  = new Object();
      argHash["file"]     = downloadfile;
      argHash["type"]     = mimeTypeArray[1];
      argHash["download"] = filename;
      this.postDownloadRack(argHash);

      $R.log("Model onダウンロードOfEditResponseData : end");
    }
  });
}(jQuery, Rmenu));