(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.M_GoodDocsMainte;

  // インスタンスプロパティを追加する
  var View = App.View = new $R.Class($R.View);
  View.fn.init = function(appspec) {
    $R.log("View init : start");

    this.appspec = appspec;

    $R.log("View init : end");
  }

  // モジュールを追加する
  View.include($R.Library.FormatMixin);
  View.include($R.Library.OutlineMixin);
  View.include($R.Library.LoadTemplateMixin);
  View.include($R.Library.ViewMixin);

  // マスターメンテパターン　ミックスインを追加する
  View.include($R.Library.MasterMainteViewMixin);

  View.include({
    // -------------------------
    //  ヘッダタイトルを表示する
    // -------------------------
    showヘッダータイトル: function(arg) {
      $R.log("View showヘッダータイトル : start");

      var title;
      title   = "商品ドキュメント　データ　アップロード";
      $("#ヘッダータイトル").html(title);

      $("#mainTable2").hide();
			
      $R.log("View onHeaderInfo : end");
    }
    // -------------------------
    //  ヘッダタイトルを表示する
    // -------------------------
   ,showファイル名２: function(arg) {
      $R.log("View showファイル名２ : start");

      $("#ファイル名２").val(arg["ファイル名２"]);

      $R.log("View showファイル名２ : end");
    }
    // ---------------------------------------
    //  ファイル更新ボタンを使用不可に設定する
    // ---------------------------------------
    ,setファイル更新不可: function() {
      $R.log("View setファイル更新不可 : start");

      $("#upload").attr("disabled", "disabled");
      $("#画像登録").attr("disabled", "disabled");
      $("#画像変更").attr("disabled", "disabled");
      $("#画像削除").attr("disabled", "disabled");
      $("#ダウンロード").attr("disabled", "disabled");

      $R.log("View setファイル更新不可 : end");
    }
    // ---------------------------------------
    //  ファイル更新ボタンを使用可能に設定する
    // ---------------------------------------
    ,setファイル更新可能: function() {
      $R.log("View setファイル更新可能 : start");

      $("#upload").removeAttr("disabled");
      $("#画像登録").removeAttr("disabled");
      $("#画像変更").removeAttr("disabled");
      $("#画像削除").removeAttr("disabled");
      $("#ダウンロード").removeAttr("disabled");

      $R.log("View setファイル更新可能 : end");
    }
    // -------------------------
    //  テーブル行　クリック処理
    // -------------------------
    ,onテーブル行クリック: function(arg) {
      $R.log("View onTableRowClick : start");

        var clickRow  = arg["クリック行"] - 1;

        // セッションデータに識別名を設定する
        sessionStorage.setIdName('FlowerShop.M_GoodDocsMainte');

        // 選択行にCSSクラスを設定する
        var j, k;
        var before_row = sessionStorage.loadItem("選択行");
        var rows = $("#mainTable")[0].rows;
        jQuery.each(rows, function(j) {
          k = j -1;
          var cells = rows[j].cells;
          jQuery.each(cells, function() {
            if (k == before_row) {
              $(this).removeClass("rowBackground");
             }

            if (k == clickRow) {
              $(this).addClass("rowBackground");
            }
          });
        });

        sessionStorage.saveItem("選択行", clickRow);

				// ファイル参照情報をクリアする
				$('#upload').val("");
				
        var detailInfo      = arg["テーブルデータ"];
        $('#ファイル名２').val(detailInfo["ファイル名"]["value"][clickRow]);
        $('#コメント２').val(detailInfo["コメント"]["value"][clickRow]);
        $('#バージョン番号２').val(detailInfo["バージョン番号"]["value"][clickRow]);

				if (detailInfo["カタログ出力"]["value"][clickRow] == "1") {
				  $('#カタログ出力２').prop("checked", true);
				}
				else {
				  $('#カタログ出力２').prop("checked", false);
				}
				
				if (detailInfo["社外閲覧可否"]["value"][clickRow] == "1") {
				  $('#社外閲覧可否２').prop("checked", true);
				}
				else {
				  $('#社外閲覧可否２').prop("checked", false);
				}
				
      $R.log("View onTableRowClick : end");
     }
    // -------------------------------------------------------
    // テーブルにデータを表示する
    // -------------------------------------------------------
   ,onテーブル表示: function(arg) {
      $R.log("View onテーブル表示 : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName('FlowerShop.M_GoodDocsMainte');

      // 選択行に設定されているCSSクラスを削除する
      var before_row = sessionStorage.loadItem("選択行");
      var rows = $("#mainTable")[0].rows;
      jQuery.each(rows, function(j) {
        k = j -1;
        var cells = rows[j].cells;
        jQuery.each(cells, function() {
          if (k == before_row) {
            $(this).removeClass("rowBackground");
           }
        });
      });
      sessionStorage.saveItem("選択行", "");

      // テーブルにデータを表示する
     tableID   = arg["テーブルＩＤ"];
     tableData = arg["テーブルデータ"];

     // 明細行を削除する
     var table = document.getElementById(tableID);
     var max   = table.rows.length - 1;
     var i;
     for (i = max; i > 0; i--) {
       table.deleteRow(i);
     }

     // 表示するデータの行数を取得する
     var max = tableData["record"]["商品ドキュメントＩＤ"]["value"].length;

     // データを表示する
     for (i = 0; i < max; i++) {
       var table = document.getElementById(tableID);
       var row   = table.insertRow(-1);

       if (tableData["record"]["商品ドキュメントＩＤ"]["value"][i] == "") {
         break;
       }

       // 行
       var value = i + 1;
       var cell  = row.insertCell(-1);
       cell.appendChild(document.createTextNode(value));

       // ファイル名
       var value = tableData["record"]["ファイル名"]["value"][i];
       var cell  = row.insertCell(-1);
       cell.appendChild(document.createTextNode(value));
       $(cell).addClass("rmenuLeft"); 
			 
       // ファイルタイプ
       var value = tableData["record"]["ファイルタイプ"]["value"][i];
       var cell  = row.insertCell(-1);
       cell.appendChild(document.createTextNode(value));
       $(cell).addClass("rmenuLeft"); 
			 
       // カタログ出力
       var value = tableData["record"]["カタログ出力"]["value"][i];
			 if (value == "1") {
			   value = "カタログへ出力する";
			 }
			 else {
			   value = "カタログへ出力しない";
			 }
       var cell  = row.insertCell(-1);
       cell.appendChild(document.createTextNode(value));
       $(cell).addClass("rmenuLeft"); 				

       // 社外閲覧可否
       var value = tableData["record"]["社外閲覧可否"]["value"][i];
			 if (value == "1") {
			   value = "社外へ公開する";
			 }
			 else {
			   value = "社外へ公開しない";
			 }
       var cell  = row.insertCell(-1);
       cell.appendChild(document.createTextNode(value));
       $(cell).addClass("rmenuLeft"); 

       // バージョン番号
       var value = tableData["record"]["バージョン番号"]["value"][i];
       var cell  = row.insertCell(-1);
       cell.appendChild(document.createTextNode(value));
       $(cell).addClass("rmenuLeft"); 

       // 更新日時
       var value = tableData["record"]["更新日時"]["value"][i];
       var cell  = row.insertCell(-1);
       cell.appendChild(document.createTextNode(value));
       $(cell).addClass("rmenuCenter"); 
			 
		  }

      $R.log("View onテーブル表示 : end");
    }
    // -----------------------
    //  画像表示する
    // -----------------------
   ,show画像表示: function(arg) {
      $R.log("View show画像表示 : start");

      var dataName     = arg["ファイル名２"];
      var downloadfile = arg["ダウンロードファイル"];
      var mimeType     = arg["マイムタイプ"];
			
      var fileName   = $R.ApplicationURL + downloadfile;
      var str = '<div><object id="画像" name="画像" data="' + fileName + '" width="360" height="360" type="' + mimeType + '"></object></div>';

      // 画像を表示する
			$("#mainTable2").show();
			var table = document.getElementById("mainTable2");
      var row = table.rows[1];
      row.cells[0].innerHTML = "";
      row.cells[0].innerHTML = str;
			
      $R.log("View show画像表示 : end");
    }
    // -----------------------
    //  画像を非表示にする
    // -----------------------
   ,show画像非表示: function(arg) {
      $R.log("View show画像非表示 : start");

			$("#mainTable2").hide();
			
      $R.log("View show画像非表示 : end");
    }

  });
}(jQuery, Rmenu));
