(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.M_GoodsMainte = {};

  // インスタンスプロパティを追加する
  var AppSpec = App.AppSpec = new $R.Class($R.AppSpec);
  AppSpec.fn.init = function(name) {
    $R.log("AppSpec init : start");

    this.name       = name;
    this.nextname   = "M_GoodDocsMainte";
    this.beforename = "M_GoodsList";

    $R.log("AppSpec init : end");
  }

  // 共通モジュールを追加する
  AppSpec.include($R.Library.AppSpecMixin);

  AppSpec.include({
    // -----------------------------------------------------------------------------------------------
    // プログラム・JSONファイルのURL情報を定義する（サブシステム名・種類・Apps・プログラムフォルダ名）
    // -----------------------------------------------------------------------------------------------
    urlInfo: [
      {app:  "FlowerShop/Html/Apps/M_GoodsMainte/"}
     ,{json: "FlowerShop/Json/Apps/M_GoodsMainte/"}
    ]
    // --------------------------
    // JSONファイル情報を定義する
    // --------------------------
   ,jsonInfo: [
      {dataset:     "yes"}
     ,{validation:  "yes"}
    ]
    // ----------------------------------------------------------------------------------------
    // トランザクション・リクエストチェック・レスポンス編集・エラーのコールバック関数を定義する
    // ----------------------------------------------------------------------------------------
   ,requestInfo: [
      ["purposecategory", "on目的種類OfCheckRequestData", "on目的種類OfEditResponseData", "onErrorResponseData"]
     ,["select",          "on照会OfCheckRequestData",     "on照会OfEditResponseData",     "onErrorResponseData"]
     ,["insert",          "on登録OfCheckRequestData",     "on登録OfEditResponseData",     "onErrorResponseData"]
     ,["update",          "on訂正OfCheckRequestData",     "on訂正OfEditResponseData",     "onErrorResponseData"]
     ,["delete",          "on削除OfCheckRequestData",     "on削除OfEditResponseData",     "onErrorResponseData"]
    ]
    // --------------------------------------------------
    // エンター・タブとPFキーのコールバック関数を定義する
    // --------------------------------------------------
   ,enterTabPFKey: {
      Enter:true
     ,Tab:true
     ,F1:"on実行"
     ,F2:null
     ,F3:null
     ,F4:null
     ,F5:null
     ,F6:null
     ,F7:null
     ,F8:null
     ,F9:null
     ,F10:null
     ,F11:null
     ,F12:null
     ,ESC:"on戻る"
     ,Forms:0
    }
    // ----------------------------------------------------------------
    // イベント設定はセレクタ・イベント・コールバック関数の順に指定する
    // ----------------------------------------------------------------
    // NAVボタンのイベントを定義する
   ,navButtonEvent: [
      ["#戻る",              "click", "on戻る"]
     ,["#実行",              "click", "on実行"]
     // ここから追加処理
     ,["#商品ドキュメント",  "click", "on商品ドキュメント"]
    ]
    // バリデーションのイベントを定義する
   ,validationEvent: [
      ["#mainForm", "focus", "onFocus"]
     ,["#mainForm", "blur",  "onBlur"]
    ]
    // その他セレクターイベントを定義する
   ,selectorEvent: [
    // ここから追加処理
      ["#検索目的選択",     "change", "onChange検索目的選択"]
     ,["#検索種類選択",     "change", "onChange検索種類選択"]
    ]
    // ----------------------------------------------------------------------------------
    // カスタムイベント設定はイベント名・実行コンテキスト・コールバック関数の順に指定する
    // ----------------------------------------------------------------------------------
    // チェック用カスタムイベントを定義する
   ,pubsubCheckEvent: [
    ]
    // 導出項目編集用カスタムイベントを定義する
   ,pubsubDeriveEvent: [
    ]
    // その他カスタムイベントを定義する
   ,pubsubOtherEvent: [
      ["showログイン情報",      "view", "showログイン情報"]
     ,["showヘッダータイトル",  "view", "showヘッダータイトル"]
     ,["show初期処理",          "view", "show初期処理"]
    ]
    // ----------------------------------------------------------------------------------
    // セレクトボックス　定義
    // selectorid  : HTMLのIDを指定する
    // selectorname: HTMLのnameを指定する（テーブル内で使用する時に定義する）
    // init        :
    // initvalue   : 初期値（０）
    // inithtml    : 初期表示（～選択）
    // datasetid   : datasetのID名を指定する
    // valuename   : datasetに定義されているキー値の項目名
    // htmlname    : datasetに定義されている表示用データの項目名
    // change      :
    // datasetid   : datasetのID名を指定する
    // valuename   : 選択したキー値を格納するdatasetの項目名
    // htmlname    : 選択した表示値を格納するdatasetの項目名
    // ----------------------------------------------------------------------------------
   ,selectbox: [
      {
          selectorid: "検索目的選択"
         ,selectorname: ""
         ,init:     {initvalue: "0", inithtml: "未選択", datasetid: "purpose", valuename: "選択目的ＩＤ", htmlname: "選択目的名称"}
         ,change:   {datasetid: "header", valuename: "目的ＩＤ", htmlname: "目的名称"}
      }
     ,{
          selectorid: "検索種類選択"
         ,selectorname: ""
         ,init:     {initvalue: "0", inithtml: "未選択", datasetid: "category", valuename: "選択種類ＩＤ", htmlname: "選択種類名称"}
         ,change:   {datasetid: "header", valuename: "種類ＩＤ", htmlname: "種類名称"}
      }
		]
  });
}(jQuery, Rmenu));