(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.M_GoodsMainte;

  // インスタンスプロパティを追加する
  var Controller = App.Controller = new $R.Class($R.Controller);
  Controller.fn.init = function(appspec, model, view) {
    $R.log("Controllerr init : start");

    this.appspec = appspec;
    this.model   = model;
    this.view    = view;
    this.createPubSubEvent();

    $R.log("Controllerr init : end");
  };

  // モジュールを追加する
  Controller.include($R.Library.EnterTabPFKeyMixin);
  Controller.include($R.Library.ControllerMixin);

  // マスターメンテパターン　ミックスインを追加する
  Controller.include($R.Library.MasterMainteControllerMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Controller.include({
    // ---------------------------------------
    // 初期処理
    // ---------------------------------------
    on初期処理: function() {
      $R.log("Controller on初期処理 : start");

      this.model.on初期処理();

			// 目的・種類情報を取得する
      this.ajaxExecute("purposecategory");

      $R.log("Controller on初期処理 : end");
    }
    // -----------------------------------------------
    //  商品ドキュメント画面へ遷移（追加処理）
    // -----------------------------------------------
   ,on商品ドキュメント: function(event) {
      $R.log("Controller on商品ドキュメント : start");

      this.model.on商品ドキュメント();
			
      this.model.setTransitionData("FlowerShop/Html/Apps/M_GoodsMainte");
      this.model.postHtmlTransition("FlowerShop/Html/Apps/M_GoodDocsMainte");

      $R.log("Controller on商品ドキュメント : end");
    }
    // -------------------------------------
    // チェンジ イベント処理（追加処理）
    // -------------------------------------
   ,onChange検索目的選択: function(event) {
      $R.log("Controller onChange検索目的選択 : start");

      this.model.onChangeSelectBox(event, this.appspec.selectbox);
			
      $R.log("Controller onChange検索目的選択 : end");
    }
   ,onChange検索種類選択: function(event) {
      $R.log("Controller onChange検索種類選択 : start");

      this.model.onChangeSelectBox(event, this.appspec.selectbox);
			
      $R.log("Controller onChange検索種類選択 : end");
    }
    // -------------------------------------
    //  リクエストデータ　編集・チェック処理
    // -------------------------------------
		,on目的種類OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on目的種類OfCheckRequestData : start");

      var status = this.checkRequestData(requestData);

      $R.log("Controller on目的種類OfCheckRequestData : end");
      return status;
    }
    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,on目的種類OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on目的種類OfEditResponseData : start");

      this.editResponseData(responseData);
			
			// datasetに記述しているセレクトボックスの一括初期表示
			var dataSetInfo = this.model.dataset.getData();
      this.onShowSelectBoxAll(dataSetInfo, this.appspec.selectbox);

      // セッションデータに識別名を設定する
			// 2015.10.07 shimoji 訂正
      //sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.beforename);
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      var mode = sessionStorage.loadItem("処理モード");

      if (mode == "insert") {
				var arg = this.model.set表示順();
				this.view.set表示順(arg);
			}
			else {
        this.model.setテーブルＩＤ();
        this.ajaxExecute("select");
      }

      $R.log("Controller on目的種類OfEditResponseData : end");
    }

		,on照会OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on照会OfEditResponseData : start");
			
      this.editResponseData(responseData);
      this.model.on照会OfEditResponseData(responseData, mode);

			// datasetに記述しているセレクトボックスの一括初期表示
			var dataSetInfo = this.model.dataset.getData();
			this.view.showCurrentSelectBox(dataSetInfo, this.appspec.selectbox);
			
      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      var save_mode = sessionStorage.loadItem("処理モード");

			if (save_mode == "convert") {
				var arg = this.model.set表示順();
				this.view.set表示順(arg);
			}

      $R.log("Controller on照会OfEditResponseData : end");
    }
		
  });

}(jQuery, Rmenu));