(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.M_SearchGoodsList;

  // インスタンスプロパティを追加する
  var Controller = App.Controller = new $R.Class($R.Controller);
  Controller.fn.init = function(appspec, model, view) {
    $R.log("Controllerr init : start");

    this.appspec = appspec;
    this.model   = model;
    this.view    = view;
    this.createPubSubEvent();

    $R.log("Controllerr init : end");
  };

  // 共通モジュールを追加する
  Controller.include($R.Library.EnterTabPFKeyMixin);
  Controller.include($R.Library.ControllerMixin);

  // マスター一覧パターン　ミックスインを追加する
  Controller.include($R.Library.TranMainteListControllerMixin);

  // ----------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　  　　
  // また、パターン内の処理を変更するときは、オーバライドする　
  // ----------------------------------------------------------
  Controller.include({
    // ---------------------------------------
    // 初期処理
    // ---------------------------------------
    on初期処理: function() {
      $R.log("Controller on初期処理 : start");

      this.model.on初期処理();

			// 目的・種類情報を取得する
      this.ajaxExecute("init");

      $R.log("Controller on初期処理 : end");
    }
    // -----------------------------------
    //  検索文字列　クリア処理（追加処理）
    // -----------------------------------
   ,on検索: function(event) {
      $R.log("Controller on検索 : start");

      this.model.on最初のページ();
      this.ajaxExecute("selectmaintable");

      $R.log("Controller on検索 : end");
    }
    // ---------------------------------
    //  検索文字列　表示処理（追加処理）
    // ---------------------------------
   ,on検索文字列クリア: function(event) {
      $R.log("Controller on検索文字列クリア : start");

      this.model.on検索文字列クリア();

      $R.log("Controller on検索文字列クリア : end");
    }
    // ---------------------------------
    //  検索文字列　表示処理（追加処理）
    // ---------------------------------
   ,on注文指示: function(event) {
      $R.log("Controller on注文指示 : start");

			var name      = event.currentTarget.name;
			var nameArray = name.split("/"); 
			var arg       = this.model.on注文指示(nameArray);
			
			//this.onメンテナンス画面表示();
			
      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      var callBackID  = sessionStorage.loadItem("コールバックＩＤ");
      window.opener.$(callBackID).trigger("click", [arg]);
      this.model.clearセッション情報();

      window.close();

      $R.log("Controller on注文指示 : end");
    }
		,on戻る: function(event) {
      $R.log("Controller on戻る : start");

      this.model.clearセッション情報();
      window.close();

      $R.log("Controller on戻る : end");
    }
    // -------------------------------------
    // チェンジ イベント処理（追加処理）
    // -------------------------------------
   ,onChange検索目的選択: function(event) {
      $R.log("Controller onChange検索目的選択 : start");

      this.model.onChangeSelectBox(event, this.appspec.selectbox);
			
      $R.log("Controller onChange検索目的選択 : end");
    }
   ,onChange検索種類選択: function(event) {
      $R.log("Controller onChange検索種類選択 : start");

      this.model.onChangeSelectBox(event, this.appspec.selectbox);
			
      $R.log("Controller onChange検索種類選択 : end");
    }
    // -----------------------------------------------
    //  メンテナンス画面呼び出し処理（次画面呼び出し）
    // -----------------------------------------------
   ,onメンテナンス画面表示: function() {
      $R.log("Controller onメンテナンス画面表示 : start");

      this.model.onメンテナンス画面表示();

      // ログイン情報のユーザＩＤ（得意先ＩＤ）を取得しロードする
      sessionStorage.setIdName(this.appspec.sysname + ".Login");
      var w_ユーザＩＤ = sessionStorage.loadItem("ユーザＩＤ");


      var currName  = this.appspec.urlInfo[0]["app"];
      var nextArray = currName.split("/"); 
      nextArray[3]  = this.appspec.nextname;
      var nextName  = nextArray.join("/");

      this.model.setTransitionData(currName.slice(0, -1));
      this.model.postHtmlTransition(nextName.slice(0, -1));

      $R.log("Controller onメンテナンス画面表示 : end");
    }
    // -----------------------------------
    //  リクエストデータ　チェック処理
    // -----------------------------------
   ,on初期処理OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on初期処理OfCheckRequestData : start");

      var status = this.checkRequestData(requestData);

      $R.log("Controller on初期処理OfCheckRequestData : end");
      return status;
    }
   ,onメインテーブル照会OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller onメインテーブル照会OfCheckRequestData : start");

      var status = this.model.onメインテーブル照会OfCheckRequestData(requestData, mode);
      if (status) {
        status = this.checkRequestData(requestData);
      }

      $R.log("Controller onメインテーブル照会OfCheckRequestData : end");
      return status;
    }
    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,on初期処理OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on初期処理OfEditResponseData : start");
      this.editResponseData(responseData);
			
			// datasetに記述しているセレクトボックスの一括初期表示
			var dataSetInfo = this.model.dataset.getData();
      this.onShowSelectBoxAll(dataSetInfo, this.appspec.selectbox);

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var currentpage = sessionStorage.loadItem("カレントページ");
      if (currentpage){
        this.onリロード();
      }
      else {
        this.on最初のページ();
      }

      $R.log("Controller on初期処理OfEditResponseData : end");
    }
   ,onメインテーブル照会OfEditResponseData: function(responseData, mode) {
      $R.log("Controller onメインテーブル照会OfEditResponseData : start");

      this.editResponseData(responseData);
      this.model.onメインテーブル照会OfEditResponseData(responseData);
      this.view.onメインテーブル照会OfEditResponseData(responseData);

      $R.log("Controller onメインテーブル照会OfEditResponseData : end");
    }

  });
}(jQuery, Rmenu));