(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.M_SearchGoodsList;

  // インスタンスプロパティを追加する
  var View = App.View = new $R.Class($R.View);
  View.fn.init = function(appspec) {
    $R.log("View init : start");

    this.appspec = appspec;

    $R.log("View init : end");
  }

  // 共通モジュールを追加する
  View.include($R.Library.FormatMixin);
  View.include($R.Library.OutlineMixin);
  View.include($R.Library.LoadTemplateMixin);
  View.include($R.Library.ViewMixin);

  // マスター一覧パターン　ミックスインを追加する
  View.include($R.Library.TranMainteListViewMixin);

  // ----------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　  　　
  // また、パターン内の処理を変更するときは、オーバライドする　
  // ----------------------------------------------------------
  View.include({
    // --------
    // 処理開始
    // --------
    initExecute: function(dataset) {
      $R.log("View initExecute : start");

      this.initテンプレートロード();
      this.initAlertDialog();                     // 警告メッセージ用ダイアログ 初期処理
      this.initConfirmDialog(this);               // 確認メッセージ用ダイアログ 初期処理
      this.initExecuteDialog(this);               // 実行確認メッセージ用ダイアログ 初期処理
      this.initServerDialog(this);                // サーバ確認メッセージ用ダイアログ 初期処理

      // テーブルの空行を作成する
      //var detailInfo  = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
      //var defaultline = detailInfo["defaultline"];
      this.createTableRows("#mainTable", 2);

      $R.log("View initExecute : end");
    }
    // -----------------------
    //  ログイン情報を表示する
    // -----------------------
   ,showログイン情報: function(arg) {
      $R.log("View showログイン情報 : start");

      if ( arg["ログイン和暦"] != "") {
        $("#ログイン和暦").html(arg["ログイン和暦"]); 
      }

      $("#ログイン日時").html(arg["ログイン時刻"]); 
      $("#ユーザ氏名").html(arg["ユーザ名称"]); 

      $R.log("View showログイン情報 : end");
    }
    // -----------------------------------
    //  検索文字列　クリア処理（追加処理）
    // -----------------------------------
   ,on検索文字列クリア: function(arg) {
      $R.log("View on検索文字列クリア : start");

      $("#検索目的選択").val("");
      $("#検索種類選択").val("");

      $R.log("View on検索文字列クリア : end");
    }
    // ---------------------------------
    //  検索文字列　表示処理（追加処理）
    // ---------------------------------
   ,on検索文字列表示: function(arg) {
      $R.log("View on検索文字列表示 : start");

      $("#検索目的選択").val(arg["検索目的ＩＤ"]);
      $("#検索種類選択").val(arg["検索種類ＩＤ"  ]);

      $R.log("View on検索文字列表示 : end");
    }
    // ---------------------
    //  ページ情報を表示する
    // ---------------------
   ,showページ情報: function(arg) {
      $R.log("View showページ情報 : start");

      var pageline   = arg["ページライン数"];
      var curpage    = arg["カレントページ"];
      var maxpage    = arg["最大ページ"];
      var totalcount = arg["トータル件数"];
      var pagedata   = curpage + "/" + maxpage + "ページ(" + totalcount + "件)";
      $("#mainForm input[name='ページ情報']").val(pagedata);
      $("#mainForm input[name='ページ情報']").attr("disabled","disabled");

      $("#最初のページ").removeAttr("disabled");
      $("#前のページ").removeAttr("disabled");
      $("#次のページ").removeAttr("disabled");
      $("#最後のページ").removeAttr("disabled");
      if (curpage == 1) {
        $("#最初のページ").attr("disabled","disabled");
        $("#前のページ").attr("disabled","disabled");
      }
      if (curpage == maxpage) {
        $("#最後のページ").attr("disabled","disabled");
        $("#次のページ").attr("disabled","disabled");
      }

			// ここから追加
      $("#mainForm input[name='ページ情報９']").val(pagedata);
      $("#mainForm input[name='ページ情報９']").attr("disabled","disabled");

      $("#最初のページ９").removeAttr("disabled");
      $("#前のページ９").removeAttr("disabled");
      $("#次のページ９").removeAttr("disabled");
      $("#最後のページ９").removeAttr("disabled");
      if (curpage == 1) {
        $("#最初のページ９").attr("disabled","disabled");
        $("#前のページ９").attr("disabled","disabled");
      }
      if (curpage == maxpage) {
        $("#最後のページ９").attr("disabled","disabled");
        $("#次のページ９").attr("disabled","disabled");
      }

      $R.log("View showページ情報 : end");
    }
    // -------------------------------------------------------
    //  メインテーブル照会　レスポンスデータ　編集処理
    // -------------------------------------------------------
   ,onメインテーブル照会OfEditResponseData: function(responseData) {
      $R.log("View onメインテーブル照会OfEditResponseData : start");

      var detailRecord = this.appspec.getJSONChunkByIdAtRecords(responseData, "detail")["record"];			
			var max          = detailRecord["テーブルＩＤ"]["value"].length;
      var table        = document.getElementById("mainTable");

			// 表示内容をクリアする
			for (var i = 0; i < 2; i++) {
        var tableRow = table.rows[i +1];
				
				tableRow.cells[0].innerHTML = "";
				tableRow.cells[1].innerHTML = "";
				tableRow.cells[2].innerHTML = "";
				tableRow.cells[3].innerHTML = "";
			}
			
			var j = 0;
			for (var i = 0; i < max; i++) {
          var tableRow = table.rows[j + 1];
					
          var fileName = $R.ApplicationURL + detailRecord["ダウンロードファイル"]["value"][i];
          var str      = '<img name="画像" src="' + fileName + '" width="240" height="240">';
				
			    // 画像を表示する
          tableRow.cells[0].innerHTML = str;

			    // 商品名称
					var name = "注文指示/" + i; 
			    var str  = "<div>"               + detailRecord["商品名称"]["value"][i] + "</div>";
					str     += "<div>　</div>";
			    str     += "<div>目的名称：　"   + detailRecord["目的名称"]["value"][i] + "</div>";
			    str     += "<div>種類名称：　"   + detailRecord["種類名称"]["value"][i] + "</div>";
			    str     += "<div>販売価格：　"   + detailRecord["販売価格"]["value"][i] + "</div>";
					str     += "<div>　</div>";
			    str     += "<div><input name='" + name + "' type='button' class='注文指示 btn color4 btn-sm rfocusblue' value='注　文　す　る'></div>";
          tableRow.cells[1].innerHTML = str;
					
          i = i + 1;
					if (i < max) {
            var fileName = $R.ApplicationURL + detailRecord["ダウンロードファイル"]["value"][i];
            var str      = '<img name="画像" src="' + fileName + '" width="240" height="240">';
				
			      // 画像を表示する
            tableRow.cells[2].innerHTML = str;

			      // 商品名称
					  var name = "注文指示/" + i; 
			      var str  = "<div>"               + detailRecord["商品名称"]["value"][i] + "</div>";
					  str     += "<div>　</div>";
			      str     += "<div>目的名称：　"   + detailRecord["目的名称"]["value"][i] + "</div>";
			      str     += "<div>種類名称：　"   + detailRecord["種類名称"]["value"][i] + "</div>";
			      str     += "<div>販売価格：　"   + detailRecord["販売価格"]["value"][i] + "</div>";
						str     += "<div>　</div>";
			      str     += "<div><input name='" + name + "' type='button' class='注文指示 btn color4 btn-sm rfocusblue' value='注　文　す　る'></div>";
            tableRow.cells[3].innerHTML = str;
					}

					j = j + 1;
			}

      $R.log("View onメインテーブル照会OfEditResponseData : end");
    }

  });

}(jQuery, Rmenu));