(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.M_SearchItemDetail;

  // インスタンスプロパティを追加する
  var Controller = App.Controller = new $R.Class($R.Controller);
  Controller.fn.init = function(appspec, model, view) {
    $R.log("Controllerr init : start");

    this.appspec = appspec;
    this.model   = model;
    this.view    = view;
    this.createPubSubEvent();

    $R.log("Controllerr init : end");
  };

  // 共通モジュールを追加する
  Controller.include($R.Library.EnterTabPFKeyMixin);
  Controller.include($R.Library.ControllerMixin);

  // マスター一覧パターン　ミックスインを追加する
  Controller.include($R.Library.MasterMainteListControllerMixin);

  // ----------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　  　　
  // また、パターン内の処理を変更するときは、オーバライドする　
  // ----------------------------------------------------------
  Controller.include({
    // ---------------------------------------
    // 初期処理
    // ---------------------------------------
    on初期処理: function() {
      $R.log("Controller on初期処理 : start");

      this.model.on初期処理();

			// 目的・種類情報を取得する
      this.ajaxExecute("supplier");

      $R.log("Controller on初期処理 : end");
    }
    // -----------------------------------
    //  検索文字列　クリア処理（追加処理）
    // -----------------------------------
   ,on検索: function(event) {
      $R.log("Controller on検索 : start");

      this.model.on最初のページ();
      this.ajaxExecute("selectmaintable");

      $R.log("Controller on検索 : end");
    }
    // ---------------------------------
    //  検索文字列　表示処理（追加処理）
    // ---------------------------------
   ,on検索文字列クリア: function(event) {
      $R.log("Controller on検索文字列クリア : start");

      this.model.on検索文字列クリア();

      $R.log("Controller on検索文字列クリア : end");
    }
    // -------------------------------------
    // チェンジ イベント処理（追加処理）
    // -------------------------------------
   ,onChange検索仕入先選択: function(event) {
      $R.log("Controller onChange検索仕入先選択 : start");

      this.model.onChangeSelectBox(event, this.appspec.selectbox);
			
      $R.log("Controller onChange検索仕入先選択 : end");
    }
    // ---------------------------------------
    // ボタン・ファンクションキー イベント処理
    // ---------------------------------------
   ,on画像データ: function(event, arg) {
      $R.log("Controller on画像データ : start");

			var row    = event.currentTarget.parentNode.parentNode.rowIndex;
			var cell   = event.currentTarget.parentNode.cellIndex;
      var arg1   = {クリック行: row, クリックセル: cell};
		  var arg9   = this.model.set選択情報設定(arg1);

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      var callBackID  = sessionStorage.loadItem("コールバックＩＤ");
      window.opener.$(callBackID).trigger("click", [arg9]);
      this.model.clearセッション情報();

      window.close();

      $R.log("Controller on画像データ : end");
    }

		,on戻る: function(event) {
      $R.log("Controller on戻る : start");

      this.model.clearセッション情報();
      window.close();

      $R.log("Controller on戻る : end");
    }
    // -------------------------------------
    //  リクエストデータ　編集・チェック処理
    // -------------------------------------
		,on仕入先OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on仕入先OfCheckRequestData : start");

      var status = this.checkRequestData(requestData);

      $R.log("Controller on仕入先OfCheckRequestData : end");
      return status;
    }
    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,on仕入先OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on仕入先OfEditResponseData : start");

      this.editResponseData(responseData);
			
			// datasetに記述しているセレクトボックスの一括初期表示
			var dataSetInfo = this.model.dataset.getData();
      this.onShowSelectBoxAll(dataSetInfo, this.appspec.selectbox);

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      var w_仕入先ＩＤ  = sessionStorage.loadItem("仕入先ＩＤ");
			if (w_仕入先ＩＤ != "") {
				this.model.on仕入先OfEditResponseData(w_仕入先ＩＤ);
				this.view.on仕入先OfEditResponseData(w_仕入先ＩＤ);
			}

      var currentpage = sessionStorage.loadItem("カレントページ");
      if (currentpage){
        this.onリロード();
      }
      else {
        this.on最初のページ();
      }

      $R.log("Controller on仕入先OfEditResponseData : end");
    }
		
  });
}(jQuery, Rmenu));