(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.M_SearchItemDetail;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスター一覧パターン　ミックスインを追加する
  Model.include($R.Library.MasterMainteListModelMixin);

  // ----------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　  　　
  // また、パターン内の処理を変更するときは、オーバライドする　
  // ----------------------------------------------------------
  Model.include({
    // -----------------------------------
    //  検索文字列　クリア処理（追加処理）
    // -----------------------------------
    on検索文字列クリア: function(arg) {
      $R.log("Model on検索文字列クリア : start");

      this.dataset.setElementData("", "検索単品名");
      this.dataset.setElementData("", "検索仕入先ＩＤ");
      this.dataset.setElementData("", "検索仕入先名称");

      this.pubsub.publish("on検索文字列クリア", "");

      $R.log("Model on検索文字列クリア : end");
    }
    // ---------------------------------
    //  選択情報を設定する（追加処理）
    // ---------------------------------
   ,set選択情報設定: function(arg9) {
      $R.log("Model set選択情報設定 : start");

			var row   = arg9["クリック行"];
			var cell  = arg9["クリックセル"];
			var line  = 0;
			if (row == 1) {
				line = cell;
			}
			if (row == 2) {
				line = cell + 3;
			}
			if (row == 3) {
				line = cell + 6;
			}
			
      var dataset            = this.dataset.getData();
      var detailInfo         = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail")["record"];
      var w_単品ＩＤ         = detailInfo["単品ＩＤ"]["value"][line];
      var w_単品名称         = detailInfo["単品名称"]["value"][line];
      var w_仕入先ＩＤ       = detailInfo["仕入先ＩＤ"]["value"][line];
      var w_仕入単価         = detailInfo["仕入単価"]["value"][line];
      var w_発注リードタイム = detailInfo["発注リードタイム"]["value"][line];
      var w_購入単位数       = detailInfo["購入単位数"]["value"][line];
      var w_品質維持可能日数 = detailInfo["品質維持可能日数"]["value"][line];
      var downloadfile       = detailInfo["downloadfile"]["value"][line];
			
			var arg                     = {};
			arg["単品ＩＤ"]             = w_単品ＩＤ;
			arg["単品名称"]             = w_単品名称;
			arg["仕入先ＩＤ"]           = w_仕入先ＩＤ;
			arg["仕入単価"]             = w_仕入単価;
			arg["発注リードタイム"]     = w_発注リードタイム;
			arg["購入単位数"]           = w_購入単位数;
			arg["品質維持可能日数"]     = w_品質維持可能日数;
			arg["ダウンロードファイル"] = downloadfile;
			

      $R.log("Model set選択情報設定 : end");
      return arg;
    }
		
    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,on仕入先OfEditResponseData: function(w_仕入先ＩＤ) {
      $R.log("Model on仕入先OfEditResponseData : start");

      this.dataset.setElementData(w_仕入先ＩＤ, "検索仕入先ＩＤ");

      $R.log("Model on仕入先OfEditResponseData : end");
    }

  });
}(jQuery, Rmenu));