(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.M_SearchItemDetail;

  // インスタンスプロパティを追加する
  var View = App.View = new $R.Class($R.View);
  View.fn.init = function(appspec) {
    $R.log("View init : start");

    this.appspec = appspec;

    $R.log("View init : end");
  }

  // 共通モジュールを追加する
  View.include($R.Library.FormatMixin);
  View.include($R.Library.OutlineMixin);
  View.include($R.Library.LoadTemplateMixin);
  View.include($R.Library.ViewMixin);

  // マスター一覧パターン　ミックスインを追加する
  View.include($R.Library.MasterMainteListViewMixin);

  // ----------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　  　　
  // また、パターン内の処理を変更するときは、オーバライドする　
  // ----------------------------------------------------------
  View.include({
     // --------
    // 処理開始
    // --------
    initExecute: function(dataset) {
      $R.log("View initExecute : start");

      this.initテンプレートロード();
      this.initAlertDialog();                     // 警告メッセージ用ダイアログ 初期処理
      this.initConfirmDialog(this);               // 確認メッセージ用ダイアログ 初期処理
      this.initExecuteDialog(this);               // 実行確認メッセージ用ダイアログ 初期処理
      this.initServerDialog(this);                // サーバ確認メッセージ用ダイアログ 初期処理

      // テーブルのボディ部を複製する
      this.createTableBodys("#mainTable", 3);

      $R.log("View initExecute : end");
    }
    // -----------------------------------
    //  検索文字列　クリア処理（追加処理）
    // -----------------------------------
    ,on検索文字列クリア: function(arg) {
      $R.log("View on検索文字列クリア : start");

      $("#検索単品名").val("");
      $("#検索仕入先ＩＤ").val(0);

      $R.log("View on検索文字列クリア : end");
    }
    // ---------------------
    //  ページ情報を表示する
    // ---------------------
   ,showページ情報: function(arg) {
      $R.log("View showページ情報 : start");

      var pageline   = arg["ページライン数"];
      var curpage    = arg["カレントページ"];
      var maxpage    = arg["最大ページ"];
      var totalcount = arg["トータル件数"];
      var pagedata   = curpage + "/" + maxpage + "ページ(" + totalcount + "件)";
      $("#mainForm input[name='ページ情報']").val(pagedata);
      $("#mainForm input[name='ページ情報']").attr("disabled","disabled");

      $("#最初のページ").removeAttr("disabled");
      $("#前のページ").removeAttr("disabled");
      $("#次のページ").removeAttr("disabled");
      $("#最後のページ").removeAttr("disabled");
      if (curpage == 1) {
        $("#最初のページ").attr("disabled","disabled");
        $("#前のページ").attr("disabled","disabled");
      }
      if (curpage == maxpage) {
        $("#最後のページ").attr("disabled","disabled");
        $("#次のページ").attr("disabled","disabled");
      }

			// ここから追加
      $("#mainForm input[name='ページ情報９']").val(pagedata);
      $("#mainForm input[name='ページ情報９']").attr("disabled","disabled");

      $("#最初のページ９").removeAttr("disabled");
      $("#前のページ９").removeAttr("disabled");
      $("#次のページ９").removeAttr("disabled");
      $("#最後のページ９").removeAttr("disabled");
      if (curpage == 1) {
        $("#最初のページ９").attr("disabled","disabled");
        $("#前のページ９").attr("disabled","disabled");
      }
      if (curpage == maxpage) {
        $("#最後のページ９").attr("disabled","disabled");
        $("#次のページ９").attr("disabled","disabled");
      }

      $R.log("View showページ情報 : end");
    }
    // -------------------------------------------------------
    // テーブルにデータを表示する
    // -------------------------------------------------------
   ,onテーブル表示: function(arg) {
      $R.log("View onテーブル表示 : start");

      var tableid   = arg["テーブルＩＤ"];
      var tabledata = arg["テーブルデータ"];
			
			var w_画像データ１ = $(".画像データ１");
			var w_単品名称１   = $(".単品名称１");

			var w_画像データ２ = $(".画像データ２");
			var w_単品名称２   = $(".単品名称２");
			
			var w_画像データ３ = $(".画像データ３");
			var w_単品名称３   = $(".単品名称３");
			
      // 表示中のデータをクリアする
			for (var i = 0; i < 3; i++) {
			  $(w_画像データ１[i]).html("");
			  $(w_単品名称１[i]).val("");

			  $(w_画像データ２[i]).html("");
			  $(w_単品名称２[i]).val("");

			  $(w_画像データ３[i]).html("");
			  $(w_単品名称３[i]).val("");
			}

			// レスポンスデータを表示する
			var dataSize = tabledata["record"]["単品ＩＤ"]["value"].length - 1
			var j = -1;
			for (var i = 0; i < 3; i++) {			
        j = j + 1;
				if (j > dataSize) {
				  break;
				}
				
        var fileName1 = $R.ApplicationURL + tabledata["record"]["downloadfile"]["value"][j];
				var str1      = '<img name="表示画像１" src="' + fileName1 + '" width="180" height="180">';
			  $(w_画像データ１[i]).html(str1);
			  $(w_単品名称１[i]).val(tabledata["record"]["単品名称"]["value"][j]);
				
				
        j = j + 1;
				if (j > dataSize) {
				  break;
				}

        var fileName2 = $R.ApplicationURL + tabledata["record"]["downloadfile"]["value"][j];
				var str2      = '<img name="表示画像２" src="' + fileName2 + '" width="180" height="180">';
			  $(w_画像データ２[i]).html(str2);
			  $(w_単品名称２[i]).val(tabledata["record"]["単品名称"]["value"][j]);
				
				
        j = j + 1;
				if (j > dataSize) {
				  break;
				}

        var fileName3 = $R.ApplicationURL + tabledata["record"]["downloadfile"]["value"][j];
				var str3      = '<img name="表示画像３" src="' + fileName3 + '" width="180" height="180">';
			  $(w_画像データ３[i]).html(str3);
			  $(w_単品名称３[i]).val(tabledata["record"]["単品名称"]["value"][j]);
			}

      $R.log("View onテーブル表示 : end");
    }
		
    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,on仕入先OfEditResponseData: function(w_仕入先ＩＤ) {
      $R.log("View on仕入先OfEditResponseData : start");

      $("#検索仕入先選択").val(w_仕入先ＩＤ);

      $R.log("View on仕入先OfEditResponseData : end");
    }

  });
}(jQuery, Rmenu));