(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.M_SetItemDetail;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスターメンテパターン　ミックスインを追加する
  Model.include($R.Library.MasterMainteModelMixin9);

  // ----------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　  　　
  // また、パターン内の処理を変更するときは、オーバライドする　
  // ----------------------------------------------------------
  Model.include({
    // ---------------------------------------
    // テーブル　画像検索 クリックイベント処理
    // ---------------------------------------
    on画像検索: function(arg) {
      $R.log("Model on画像検索 : start");
			
      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      sessionStorage.saveItem("クリック行", arg["クリック行"]);

      $R.log("Model on画像検索 : end");
    }
		
    // ---------------------------------------
    // テーブル　画像検索 後処理
    // ---------------------------------------
   ,on画像検索後処理: function(arg) {
      $R.log("Model on画像検索後処理 : start");
			
      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      var row    = sessionStorage.loadItem("クリック行") - 1;
			
			var itemID = arg["単品ＩＤ"];
			this.dataset.setElementData(itemID, "単品ＩＤ", row);


      $R.log("Model on画像検索後処理 : end");
    }
		
    // -------------------------------------
    //  リクエストデータ　編集・チェック処理
    // -------------------------------------
   ,on訂正OfCheckRequestData: function(requestData, mode) {
      $R.log("Model on訂正OfCheckRequestData : start");

      // ログイン情報を設定する
      var loginRecord = this.appspec.getJSONChunkByIdAtRecords(requestData, "login")["record"];

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + ".Login");
      loginRecord["ユーザＩＤ"]["value"][0] = sessionStorage.loadItem("ユーザＩＤ");
      loginRecord["ユーザ名称"]["value"][0] = sessionStorage.loadItem("ユーザ名称");
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
			
      // ヘッダー情報を設定する
      var dataSet        = this.dataset.getData();
      var dataSetHRecord = this.appspec.getJSONChunkByIdAtRecords(dataSet, "header")["record"];

      var headerRecord = this.appspec.getJSONChunkByIdAtRecords(requestData, "header")["record"];
      headerRecord["テーブルＩＤ"]["value"][0] = dataSetHRecord["テーブルＩＤ"]["value"][0];
			
      // 明細情報をクリアする
      var detailRecord   = this.appspec.getJSONChunkByIdAtRecords(requestData, "detail")["record"];
		  detailRecord["単品ＩＤ"]["value"] = [];
			detailRecord["数量"]["value"]     = [];
			detailRecord["表示順"]["value"]   = [];

      // 明細情報を設定する
      var dataSetDRecord = this.appspec.getJSONChunkByIdAtRecords(dataSet, "detail")["record"];
			var j              = 0;
      var deleteCheckBox = $(".削除");

		  for (var i = 0; i < 7; i++) {
        // 削除行かを判定する　削除行の時次の行へ
        if ( $(deleteCheckBox[i]).is(':checked') ) {
          continue;
        }

				if (dataSetDRecord["単品ＩＤ"]["value"][i] == "") {
					if (dataSetDRecord["数量"]["value"][i] == "") {
						if (dataSetDRecord["表示順"]["value"][i] == "") {
							continue;
						}
					}
				}
				
				detailRecord["単品ＩＤ"]["value"][j] = dataSetDRecord["単品ＩＤ"]["value"][i];
				detailRecord["数量"]["value"][j]     = dataSetDRecord["数量"]["value"][i];
				detailRecord["表示順"]["value"][j]   = dataSetDRecord["表示順"]["value"][i];
				j++;
			}
			
      $R.log("Model on訂正OfCheckRequestData : end");
      return true;
    }

	});
}(jQuery, Rmenu));