(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.M_SetItemDetail;

  // インスタンスプロパティを追加する
  var View = App.View = new $R.Class($R.View);
  View.fn.init = function(appspec) {
    $R.log("View init : start");

    this.appspec = appspec;

    $R.log("View init : end");
  }

  // モジュールを追加する
  View.include($R.Library.FormatMixin);
  View.include($R.Library.OutlineMixin);
  View.include($R.Library.LoadTemplateMixin);
  View.include($R.Library.ViewMixin);

  // マスターメンテパターン　ミックスインを追加する
  View.include($R.Library.MasterMainteViewMixin);

  // ----------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　  　　
  // また、パターン内の処理を変更するときは、オーバライドする　
  // ----------------------------------------------------------
  View.include({
    // ---------------------------------------
    // テーブル　画像検索 クリックイベント処理
    // ---------------------------------------
    on画像検索後処理: function(arg) {
      $R.log("View on画像検索後処理 : start");
			
      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      var row = sessionStorage.loadItem("クリック行");

      var fileName  = $R.ApplicationURL +  arg["ダウンロードファイル"];
      var str = '<img name="画像" src="' + fileName + '" width="180" height="180" class="画像">';
			
      // 単品ＩＤ・画像・単品名を表示する
      var table = document.getElementById("mainTable");
      var row9 = table.rows[Number(row)];
			
			// 単品ＩＤ
      row9.cells[0].innerHTML = arg["単品ＩＤ"];
			
      // 画像を表示する
      row9.cells[2].innerHTML = str;

      // 単品名を表示する
      row9.cells[3].innerHTML = arg["単品名称"];

      $R.log("View on画像検索後処理 : end");
    }
    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,on照会OfEditResponseData: function(responseData, mode) {
      $R.log("View on照会OfEditResponseData : start");
			
      var detailRecord = this.appspec.getJSONChunkByIdAtRecords(responseData, "detail")["record"];
			var max          = detailRecord["単品ＩＤ"]["value"].length;
      var table        = document.getElementById("mainTable");

			for (var i = 0; i < max; i++) {
          var tableRow = table.rows[i + 1];
          var fileName = $R.ApplicationURL + detailRecord["downloadfile"]["value"][i];
          var str      = '<img name="画像" src="' + fileName + '" width="180" height="180" class="画像">';
				
			    // 単品ＩＤ
          tableRow.cells[0].innerHTML = detailRecord["単品ＩＤ"]["value"][i];

			    // 画像を表示する
          tableRow.cells[2].innerHTML = str;

			    // 単品名称
          tableRow.cells[3].innerHTML = detailRecord["単品名称"]["value"][i];
			}

      $R.log("View on照会OfEditResponseData : end");
    }

  });
}(jQuery, Rmenu));
