(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.M_SingleItemMainte;

  // インスタンスプロパティを追加する
  var Controller = App.Controller = new $R.Class($R.Controller);
  Controller.fn.init = function(appspec, model, view) {
    $R.log("Controllerr init : start");

    this.appspec = appspec;
    this.model   = model;
    this.view    = view;
    this.createPubSubEvent();

    $R.log("Controllerr init : end");
  };

  // モジュールを追加する
  Controller.include($R.Library.EnterTabPFKeyMixin);
  Controller.include($R.Library.ControllerMixin);

  // マスターメンテパターン　ミックスインを追加する
  Controller.include($R.Library.MasterMainteControllerMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Controller.include({
    // ---------------------------------------
    // 初期処理
    // ---------------------------------------
    on初期処理: function() {
      $R.log("Controller on初期処理 : start");

      this.model.on初期処理();

			// 目的・種類情報を取得する
      this.ajaxExecute("supplier");

      $R.log("Controller on初期処理 : end");
    }
    // -------------------------------------
    // チェンジ イベント処理（追加処理）
    // -------------------------------------
   ,onChange検索仕入先選択: function(event) {
      $R.log("Controller onChange検索仕入先選択 : start");

      this.model.onChangeSelectBox(event, this.appspec.selectbox);
			
      $R.log("Controller onChange検索仕入先選択 : end");
    }
    // ----------------------------------------------------------------
    // ファイル参照 チェンジ イベント処理
    // ----------------------------------------------------------------
   ,onChange画像ファイル参照: function(event) {
      $R.log("Controller onChange画像ファイル参照 : start");

      this.model.onChange画像ファイル参照(event);
      this.view.onChange画像ファイル参照();

      $R.log("Controller onChange画像ファイル参照 : end");
    }
    // ---------------------------------------
    // 画像アップロード後処理
    // ---------------------------------------
   ,on画像アップロード後処理: function(mode) {
      $R.log("Controller 画像アップロード後処理 : start");

      this.ajaxExecute(mode);

      $R.log("Controller 画像アップロード後処理 : end");
    }
    // -------------------------------------
    //  リクエストデータ　編集・チェック処理
    // -------------------------------------
		,on仕入先OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on仕入先OfCheckRequestData : start");

      var status = this.checkRequestData(requestData);

      $R.log("Controller on仕入先OfCheckRequestData : end");
      return status;
    }
   ,on画像アップロードOfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on画像アップロードOfCheckRequestData : start");

      var status = this.model.on画像アップロードOfCheckRequestData(requestData, mode);
      if (status) {
        status = this.checkRequestData(requestData);
      }

      $R.log("Controller on画像アップロードOfCheckRequestData : end");
      return status;
    }
    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,on仕入先OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on仕入先OfEditResponseData : start");

      this.editResponseData(responseData);
			
			// datasetに記述しているセレクトボックスの一括初期表示
			var dataSetInfo = this.model.dataset.getData();
      this.onShowSelectBoxAll(dataSetInfo, this.appspec.selectbox);

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      var mode = sessionStorage.loadItem("処理モード");

      if (mode == "insert") {
				var arg = this.model.set表示順();
				this.view.set表示順(arg);
			}
			else {
        this.model.setテーブルＩＤ();
        this.ajaxExecute("select");
      }

      $R.log("Controller on仕入先OfEditResponseData : end");
    }

		,on照会OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on照会OfEditResponseData : start");
			
      this.editResponseData(responseData);
      this.model.on照会OfEditResponseData(responseData, mode);

			// datasetに記述しているセレクトボックスの一括初期表示
			var dataSetInfo = this.model.dataset.getData();
			this.view.showCurrentSelectBox(dataSetInfo, this.appspec.selectbox);
			
      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      var save_mode = sessionStorage.loadItem("処理モード");

			if (save_mode == "convert") {
				var arg = this.model.set表示順();
				this.view.set表示順(arg);
			}

			this.view.on照会OfEditResponseData(responseData);
			
      $R.log("Controller on照会OfEditResponseData : end");
    }
   ,on登録OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on登録OfEditResponseData : start");

      this.editResponseData(responseData);
      this.model.on登録OfEditResponseData(responseData, mode);
			
      this.model.on画像アップロード(this, "imageupload", responseData);

      $R.log("Controller on登録OfEditResponseData : end");
    }
   ,on訂正OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on訂正OfEditResponseData : start");

      this.editResponseData(responseData);
      this.model.on訂正OfEditResponseData(responseData, mode);
			
      this.model.on画像アップロード(this, "imageupload", responseData);

      $R.log("Controller on訂正OfEditResponseData : end");
    }
   ,on画像アップロードOfEditResponseData: function(responseData, mode) {
      $R.log("Controller on画像アップロードOfEditResponseData : start");

      this.model.on画像アップロードOfEditResponseData(responseData);
      this.editResponseData(responseData);

      this.model.onサーバ処理確認ダイアログ(responseData);

      $R.log("Controller on画像アップロードOfEditResponseData : end");
    }
		
  });

}(jQuery, Rmenu));