(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.ParallelDivisionList;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスター一覧パターン　ミックスインを追加する
  Model.include($R.Library.MasterMainteListModelMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Model.include({
    // -------------------------------------------------------
    //  処理モードをセッションストレージに格納する
    // -------------------------------------------------------
    set処理モード: function(mode) {
      $R.log("Model set処理モード : start");

      // セッションデータに識別名を設定する 2015.10.07 shimoji 訂正
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      sessionStorage.saveItem("処理モード", mode);

      var row        = sessionStorage.loadItem("クリック行");
			var id         = 0;
			if (row != "") {
        var dataset    = this.dataset.getData();
        var detailInfo = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
        id             = detailInfo["record"]["テーブルＩＤ"]["value"][row]
			}

      // セッションデータに識別名を設定する 2015.10.07 shimoji 訂正
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.nextname);
      sessionStorage.saveItem("処理モード", mode);
      sessionStorage.saveItem("テーブルＩＤ", id);

      $R.log("Model set処理モード : end");
      return true;
    }
    // -------------------------------------------------------
    //  テーブルの選択行をセッションストレージに格納する
    // -------------------------------------------------------
   ,onテーブル行クリック: function(arg) {
      $R.log("Model onテーブル行クリック : start");

      var clickRow  = arg["クリック行"] - 1;

      var dataset    = this.dataset.getData();
      var detailInfo = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
      if (detailInfo["record"]["並列分散管理ＩＤ"]["value"][clickRow]) {
        sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
        sessionStorage.saveItem("並列分散管理ＩＤ", detailInfo["record"]["並列分散管理ＩＤ"]["value"][clickRow]);
        sessionStorage.saveItem("並列分割管理ＩＤ", detailInfo["record"]["並列分割管理ＩＤ"]["value"][clickRow]);
        sessionStorage.saveItem("終了日時",         detailInfo["record"]["終了日時"]["value"][clickRow]);

        this.pubsub.publish("onテーブル行クリック", arg);
      }

      $R.log("Model onテーブル行クリック : end");
    }
    // -----------------------------------
    //  リクエストデータ　チェック処理
    // -----------------------------------
   ,onメインテーブル照会OfCheckRequestData: function(requestData, mode) {
      $R.log("Model onメインテーブル照会OfCheckRequestData : start");

      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      var controllID = sessionStorage.loadItem("テーブルＩＤ");
      var status     = false;

      if (controllID) {
        var headerInfo    = this.appspec.getJSONChunkByIdAtRecords(requestData, "header");
        headerInfo["record"]["並列分散管理ＩＤ"]["value"][0] = controllID;
        status = true;
      }

      $R.log("Model onメインテーブル照会OfCheckRequestData : end");
      return status;
    }
   ,on再処理OfCheckRequestData: function(requestData, mode) {
      $R.log("Model on再処理OfCheckRequestData : start");

      sessionStorage.setIdName('RmenuSample2.ParallelDivisionList');
      var finishDateTime = sessionStorage.loadItem("終了日時");
      if (finishDateTime  != "") {
        var arg = {};
        arg["title"]   = "選択エラー";
        arg["status"]  = "ERROR";
        arg["message"] = "処理は終了しています。再処理できません。";
        this.pubsub.publish("alertDialog", arg);
        return false;
      }

      var controllID = sessionStorage.loadItem("並列分散管理ＩＤ");
      var devisionID = sessionStorage.loadItem("並列分割管理ＩＤ");
      var status     = false;

      if (controllID) {
        var headerInfo    = this.appspec.getJSONChunkByIdAtRecords(requestData, "header");
        headerInfo["record"]["並列分散管理ＩＤ"]["value"][0] = controllID;
        headerInfo["record"]["並列分割管理ＩＤ"]["value"][0] = devisionID;
        status = true;
      }

      $R.log("Model on再処理OfCheckRequestData : end");
      return status;
    }
  });
}(jQuery, Rmenu));