(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.T_ArrivalGoodsNew;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスターメンテパターン　ミックスインを追加する
  Model.include($R.Library.TranMainteModelMixin9);

  // ----------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　  　　
  // また、パターン内の処理を変更するときは、オーバライドする　
  // ----------------------------------------------------------
  Model.include({
    // ---------------------------------------
    // テーブル　画像検索 クリックイベント処理
    // ---------------------------------------
    on画像検索: function(arg) {
      $R.log("Model on画像検索 : start");
			
      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      sessionStorage.saveItem("クリック行", arg["クリック行"]);
			
			var w_仕入先ＩＤ = this.dataset.getElementData("仕入先ＩＤ");
			
      $R.log("Model on画像検索 : end");
			return w_仕入先ＩＤ;
    }
		
    // ---------------------------------------
    // テーブル　画像検索 後処理
    // ---------------------------------------
   ,on画像検索後処理: function(arg) {
      $R.log("Model on画像検索後処理 : start");
			
      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      var row    = sessionStorage.loadItem("クリック行") - 1;
			
			var w_単品ＩＤ         = arg["単品ＩＤ"];
			var w_単品名称         = arg["単品名称"];
			var w_仕入単価         = arg["仕入単価"];
			var w_発注リードタイム = arg["発注リードタイム"];
			var w_購入単位数       = arg["購入単位数"];
			var w_品質維持可能日数 = arg["品質維持可能日数"];
			
			this.dataset.setElementData(w_単品ＩＤ, "単品ＩＤ", row);
			this.dataset.setElementData(w_単品名称, "単品名称", row);
			this.dataset.setElementData(w_仕入単価, "単価", row);
			this.dataset.setElementData(w_発注リードタイム, "発注リードタイム", row);
			this.dataset.setElementData(w_購入単位数, "購入単位数", row);
			this.dataset.setElementData(w_品質維持可能日数, "品質維持可能日数", row);

      $R.log("Model on画像検索後処理 : end");
    }
		
    // ---------------------------------------
    // onChange　発注日付　処理
    // ---------------------------------------
   ,onChange発注日付: function() {
      $R.log("Model onChange発注日付 : start");

		  var w_発注日付 = $('#発注日付').val();
      //this.dataset.setElementData(w_発注日付.replace(/\//g, ""), "発注日付");
      this.dataset.setElementData(w_発注日付, "発注日付");
			
      $R.log("Model onChange発注日付 : end");
    }
    // ---------------------------------------
    // onChange　入荷日付　処理
    // ---------------------------------------
   ,onChange入荷日付: function() {
      $R.log("Model onChange入荷日付 : start");

		  var w_入荷日付 = $('#入荷日付').val();
      this.dataset.setElementData(w_入荷日付, "入荷日付");
			
      $R.log("Model onChange入荷日付 : end");
    }
    // -------------------------------------
    //  リクエストデータ　編集・チェック処理
    // -------------------------------------
   ,on登録OfCheckRequestData: function(requestData, mode) {
      $R.log("Model on登録OfCheckRequestData : start");

      var status = this.onリクエストデータOf編集処理(requestData, mode);

      $R.log("Model on登録OfCheckRequestData : end");
      return status;
    }

    // -------------------------------------
    //  リクエストデータ　編集処理
    // -------------------------------------
   ,onリクエストデータOf編集処理: function(requestData, mode) {
      $R.log("Model onリクエストデータOf編集処理 : start");

      // ログイン情報を設定する
      var loginRecord = this.appspec.getJSONChunkByIdAtRecords(requestData, "login")["record"];

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + ".Login");
      loginRecord["ユーザＩＤ"]["value"][0] = sessionStorage.loadItem("ユーザＩＤ");
      loginRecord["ユーザ名称"]["value"][0] = sessionStorage.loadItem("ユーザ名称");
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
			
			
      // データセットのヘッダー情報を取得する
      var dataSet        = this.dataset.getData();
      var dataSetHRecord = this.appspec.getJSONChunkByIdAtRecords(dataSet, "header")["record"];

      // データセットの明細情報を取得する
      var dataSetDRecord = this.appspec.getJSONChunkByIdAtRecords(dataSet, "detail")["record"];

      // リクエストの明細情報をクリアする
      var detailRecord   = this.appspec.getJSONChunkByIdAtRecords(requestData, "detail")["record"];
			detailRecord["行番号"]["value"]       = [];
		  detailRecord["単品ＩＤ"]["value"]     = [];
			detailRecord["数量"]["value"]         = [];
			detailRecord["単価"]["value"]         = [];
			detailRecord["品質維持期限"]["value"] = [];

			var j              = 0;
      var deleteCheckBox = $(".削除");

		  for (var i = 0; i < 6; i++) {
        // 削除行かを判定する　削除行の時次の行へ
        if ( $(deleteCheckBox[i]).is(':checked') ) {
          continue;
        }

				if (dataSetDRecord["単品ＩＤ"]["value"][i] == "") {
					if (dataSetDRecord["数量"]["value"][i] == "") {
						if (dataSetDRecord["単価"]["value"][i] == "") {
							continue;
						}
					}
				}
				
				detailRecord["行番号"]["value"][j]       = j + 1;
				detailRecord["単品ＩＤ"]["value"][j]     = dataSetDRecord["単品ＩＤ"]["value"][i];
				detailRecord["数量"]["value"][j]         = dataSetDRecord["数量"]["value"][i];
				detailRecord["単価"]["value"][j]         = dataSetDRecord["単価"]["value"][i];
				
				var w_品質維持期限 = this.add日数ＴＯ日付(dataSetHRecord["納入予定日付"]["value"][0], dataSetDRecord["品質維持可能日数"]["value"][i]);
				detailRecord["品質維持期限"]["value"][j] = w_品質維持期限;
				
				j++;
			}
			
      $R.log("Model onリクエストデータOf編集処理 : end");
      return true;
    }
    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,on照会OfEditResponseData: function(responseData, mode) {
      $R.log("Model on照会OfEditResponseData : start");
			
      var headerRecord = this.appspec.getJSONChunkByIdAtRecords(responseData, "header")["record"];
			var w_入荷日付   = headerRecord["納入予定日付"]["value"][0];
      this.dataset.setElementData(w_入荷日付, "入荷日付");
			

      $R.log("Model on照会OfEditResponseData : end");
    }
    // -------------------------------------------------------------------
    //  システム日付を取得する
    // -------------------------------------------------------------------
   ,getシステム日付: function() {
      $R.log("Model getシステム日付 : start");

      var date  = new Date();
			var year  = date.getFullYear();
			var month = date.getMonth() + 1;
			var day   = date.getDate();
			
			if (month < 10) {
				month = "0" + month;
			}
			
			if (day < 10) {
				day = "0" + day;
			}
			
      var today = year + "/" +month + "/" + day;

      $R.log("Model getシステム日付 : end");
			return today;
    }
    // -------------------------------------------------------------------
    //  日付に日数を加算
    // -------------------------------------------------------------------
   ,add日数ＴＯ日付: function(date, days) {
      $R.log("Model add日数ＴＯ日付 : start");
			
      var date  = new Date(date);
			date.setDate(date.getDate() + Number(days));
			
			var year  = date.getFullYear();
			var month = date.getMonth() + 1;
			var day   = date.getDate();
			
			if (month < 10) {
				month = "0" + month;
			}
			
			if (day < 10) {
				day = "0" + day;
			}
			
      var today = year + "/" +month + "/" + day;

      $R.log("Model add日数ＴＯ日付 : end");
			return today;
    }

	});
}(jQuery, Rmenu));