(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.T_ArrivalGoodsUpdate;

  // インスタンスプロパティを追加する
  var Controller = App.Controller = new $R.Class($R.Controller);
  Controller.fn.init = function(appspec, model, view) {
    $R.log("Controllerr init : start");

    this.appspec = appspec;
    this.model   = model;
    this.view    = view;
    this.createPubSubEvent();
		
    var self = this;
    var api0 = $('#datetimepicker0').datetimepicker({
	      format : 'yyyy/MM/dd',
        language : 'ja',
	      pickTime : false
    }).data('datetimepicker');
    api0.widget.on('click','.day',function(){
	      api0.hide();
        self.onChange入荷日付();
    });

    $R.log("Controllerr init : end");
  };

  // モジュールを追加する
  Controller.include($R.Library.EnterTabPFKeyMixin);
  Controller.include($R.Library.ControllerMixin);

  // マスターメンテパターン　ミックスインを追加する
  Controller.include($R.Library.TranMainteControllerMixin);

  // ----------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　  　　
  // また、パターン内の処理を変更するときは、オーバライドする　
  // ----------------------------------------------------------
  Controller.include({
    // ---------------------------------------
    // 初期処理
    // ---------------------------------------
    on初期処理: function() {
      $R.log("Controller on初期処理 : start");

      this.model.on初期処理();

			// 仕入先情報を取得する
      this.ajaxExecute("supplier");

      $R.log("Controller on初期処理 : end");
    }
    // ---------------------------------------
    // テーブル行　画像検索　クリック処理処理
    // ---------------------------------------
   ,on画像検索: function(event, arg) {
      $R.log("Controller on画像検索 : start");

      if (arg === undefined) {
			  var row    = event.currentTarget.parentNode.parentNode.rowIndex;
        var arg9   = {クリック行: row};
        var w_仕入先ＩＤ = this.model.on画像検索(arg9);
				
        // コールバックＩＤを設定する
        sessionStorage.setIdName(this.appspec.sysname + ".M_SearchItemDetail");
        sessionStorage.saveItem("コールバックＩＤ", "#画像検索後処理");
        sessionStorage.saveItem("仕入先ＩＤ", w_仕入先ＩＤ);
				
        var argWin = "fullscreen=1, scrollbars=1";
        this.model.postPopupTransition("FlowerShop/Html/Apps/M_SearchItemDetail", argWin);
      }

      $R.log("Controller on画像検索 : end");
    }

    // ---------------------------------------
    // テーブル　画像検索 後処理
    // ---------------------------------------
   ,on画像検索後処理: function(event, arg) {
      $R.log("Controller on画像検索後処理 : start");

      if (arg === undefined) {
      }
      else {
        this.model.on画像検索後処理(arg);
        this.view.on画像検索後処理(arg);
      }

      $R.log("Controller on画像検索後処理 : end");
    }
    // ---------------------------------------
    // onChange　入荷日付　処理
    // ---------------------------------------
   ,onChange入荷日付: function() {
      $R.log("Controller onChange入荷日付 : start");

		  this.model.onChange入荷日付();
				
      $R.log("Controller onChange入荷日付 : end");
    }
    // -------------------------------------
    // チェンジ イベント処理（追加処理）
    // -------------------------------------
   ,onChange検索仕入先選択: function(event) {
      $R.log("Controller onChange検索仕入先選択 : start");

      this.model.onChangeSelectBox(event, this.appspec.selectbox);
			
      $R.log("Controller onChange検索仕入先選択 : end");
    }
    // -----------------------------------------------------------------
    //  単価入力後、金額計算する
    // -----------------------------------------------------------------
   ,onCheck数量: function(arg) {
      $R.log("Controller onCheck数量 : start");

			arg = this.view.onCheck数量(arg);
      this.view.set入荷金額合計();
			
      $R.log("Controller onCheck数量 : end");
			return arg;
    }
    // -----------------------------------------------------------------
    //  単価入力後、金額計算する
    // -----------------------------------------------------------------
   ,onCheck単価: function(arg) {
      $R.log("Controller onCheck単価 : start");

			arg = this.view.onCheck単価(arg);
      this.view.set入荷金額合計();

      $R.log("Controller onCheck単価 : end");
			return arg;
    }
    // -------------------------------------
    //  リクエストデータ　編集・チェック処理
    // -------------------------------------
		,on仕入先OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on仕入先OfCheckRequestData : start");

      var status = this.checkRequestData(requestData);

      $R.log("Controller on仕入先OfCheckRequestData : end");
      return status;
    }
    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,on仕入先OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on仕入先OfEditResponseData : start");

      this.editResponseData(responseData);
			
			// datasetに記述しているセレクトボックスの一括初期表示
			var dataSetInfo = this.model.dataset.getData();
      this.onShowSelectBoxAll(dataSetInfo, this.appspec.selectbox);

      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      var mode = sessionStorage.loadItem("処理モード");

      if (mode != "insert") {
        this.model.setテーブルＩＤ();
        this.ajaxExecute("select");
			}

      $R.log("Controller on仕入先OfEditResponseData : end");
    }
   ,on照会OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on照会OfEditResponseData : start");
			
      this.editResponseData(responseData);
      this.model.on照会OfEditResponseData(responseData, mode);
      this.view.on照会OfEditResponseData(responseData, mode);
      this.view.set入荷金額合計();

      $R.log("Controller on照会OfEditResponseData : end");
    }
		
  });
}(jQuery, Rmenu));