(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.T_DailyStockUpdate;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // 基本名称メンテ　パターン　ミックスインを追加する
  Model.include($R.Library.BaseNameMainteModelMixin);
  Model.include($R.Library.FlowerShopModelMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Model.include({
    // ------------------------------------------------------------------------
    // 処理起動確認ダイアログ後の処理
    // ------------------------------------------------------------------------
    onExecuteDialogAfter: function() {
      $R.log("Model onExecuteDialogAfter : start");

      // ダイアログの選択結果の取得
      var yesno = sessionStorage.getItem('executeDialog');
      if (yesno == 1) {
        this.pubsub.publish("on実行確認後処理");
      }

      $R.log("Model onExecuteDialogAfter : end");
    }
    // ---------------------------------------------------
    //  リクエストデータ　編集・チェック処理
    // ---------------------------------------------------
   ,on実行処理OfCheckRequestData: function(requestData, mode) {
      $R.log("Model on実行処理OfCheckRequestData : start");
			
      // ログイン情報を設定する
      var requestRecord = this.appspec.getJSONChunkByIdAtRecords(requestData, "login");
      var loginRecord   = requestRecord["record"];

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + ".Login");
      loginRecord["ユーザＩＤ"]["value"][0] = sessionStorage.loadItem("ユーザＩＤ");
      loginRecord["ユーザ名称"]["value"][0] = sessionStorage.loadItem("ユーザ名称");
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      // システム日付と抽出日付を設定する
			var w_システム日付  = this.getシステム日付();
			var w_抽出日付      = this.add日数ＴＯ日付(w_システム日付, -1);

      var headerRecord    = this.appspec.getJSONChunkByIdAtRecords(requestData, "header")["record"];
      headerRecord["システム日付"]["value"][0]   = w_システム日付;
      headerRecord["抽出日付"]["value"][0]       = w_抽出日付;

      $R.log("Model on実行処理OfCheckRequestData : end");
      return true;
    }

	});

}(jQuery, Rmenu));