(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.T_OrderInput;

  // インスタンスプロパティを追加する
  var View = App.View = new $R.Class($R.View);
  View.fn.init = function(appspec) {
    $R.log("View init : start");

    this.appspec = appspec;

    $R.log("View init : end");
  }

  // モジュールを追加する
  View.include($R.Library.FormatMixin);
  View.include($R.Library.OutlineMixin);
  View.include($R.Library.LoadTemplateMixin);
  View.include($R.Library.ViewMixin);

  // マスターメンテパターン　ミックスインを追加する
  View.include($R.Library.TranMainteViewMixin);

  // ----------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　  　　
  // また、パターン内の処理を変更するときは、オーバライドする　
  // ----------------------------------------------------------
  View.include({
    // ---------------------------------------
    // テーブル　画像検索 クリックイベント処理
    // ---------------------------------------
    on画像検索後処理: function(arg) {
      $R.log("View on画像検索後処理 : start");
			
      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      var row = sessionStorage.loadItem("クリック行");

			
      // 単品ＩＤ・画像・単品名を表示する
      var table      = document.getElementById("mainTable");
      var tableRow   = table.rows[Number(row)];
			var w_仕入単価 = $(".単価");

			// 行
      tableRow.cells[0].innerHTML = row;
			
      // 画像を表示する
      var fileName  = $R.ApplicationURL +  arg["ダウンロードファイル"];
      var str = '<img name="画像" src="' + fileName + '" width="180" height="180" class="画像">';
      tableRow.cells[2].innerHTML = str;

      // 単品名を表示する
			var str = "<div>"                       + arg["単品名称"]         + "</div>";
			str    += "<div>　</div>";
			str    += "<div>　　　リードタイム：　" + arg["発注リードタイム"] + "　日</div>";
			str    += "<div>　　　購入単位数：　"   + arg["購入単位数"]       + "　本</div>";
      tableRow.cells[3].innerHTML = str;

      // 仕入単価を表示する
			$(w_仕入単価[row - 1]).val(arg["仕入単価"])

      $R.log("View on画像検索後処理 : end");
    }
    // -----------------------------------------------------------------
    //  数量入力後、金額計算する
    // -----------------------------------------------------------------
   ,onCheck数量: function(arg) {
      $R.log("View onCheck数量 : start");

			arg["status"]  = "OK";
			arg["message"] = "";

			var row    = arg["row"];
			var w_数量 = $($(".数量")[row]).val();
			var w_単価 = $($(".単価")[row]).val();

			var status = isNaN(w_数量);
			if (status) {
				w_数量 = 0;
			  arg["status"]  = "ERROR";
			  arg["message"] = "数字を入録して下さい。";
			}
			else {
				if (w_数量 == "") {
				  w_数量 = 0;
				}
				else {
				  w_数量 = Number(w_数量);
				}
			}
			
			status = isNaN(w_単価);
			if (status) {
				w_単価 = 0;
			  arg["status"]  = "ERROR";
			  arg["message"] = "数字を入録して下さい。";
			}
			else {
				if (w_単価 == "") {
				  w_単価 = 0;
				}
				else {
				  w_単価 = Number(w_単価);
				}
			}
			
			var w_金額 = new BigNumber(w_数量).times(w_単価);

      // 金額を表示する
			var table      = document.getElementById("mainTable");
      var tableRow   = table.rows[row + 1];
      tableRow.cells[6].innerHTML = this.formatExecute.quantity.format(w_金額);

			
      $R.log("View onCheck数量 : end");
			return arg;
    }
    // -----------------------------------------------------------------
    //  単価入力後、金額計算する
    // -----------------------------------------------------------------
   ,onCheck単価: function(arg) {
      $R.log("View onCheck単価 : start");

			arg = this.onCheck数量(arg);

      $R.log("View onCheck単価 : end");
			return arg;
    }

    // -----------------------------------------------------------------
    //  発注合計金額を表示する
    // -----------------------------------------------------------------
   ,set発注合計金額: function(arg) {
      $R.log("View set発注合計金額 : start");

			var w_数量     = $(".数量");
			var w_単価     = $(".単価");
			var x_数量     = 0;
			var x_単価     = 0;
			var w_合計金額 = 0;
			var w_金額     = 0;
			var status;
			
			for (var i = 0; i < 7; i++) {
				x_数量 = $(w_数量[i]).val();
				x_単価 = $(w_単価[i]).val();

			  status = isNaN(x_数量);
			  if (status) {
				  break;
			  }
			  else {
				  if (x_数量 == "") {
				    x_数量 = 0;
				  }
				  else {
				    x_数量 = Number(x_数量);
				  }
			  }
			
			  status = isNaN(x_単価);
			  if (status) {
				  break;
			  }
			  else {
				  if (x_単価 == "") {
				    x_単価 = 0;
				  }
				  else {
				    x_単価 = Number(x_単価);
				  }
			  }
				
				w_金額     = new BigNumber(x_数量).times(x_単価);
				w_合計金額 = new BigNumber(w_合計金額).plus(w_金額);
			}

			$("#発注合計金額").val(this.formatExecute.quantity.format(w_合計金額));
			
      $R.log("View set発注合計金額 : end");
    }
    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,on照会OfEditResponseData: function(responseData, mode) {
      $R.log("View on照会OfEditResponseData : start");
			
      var headerRecord = this.appspec.getJSONChunkByIdAtRecords(responseData, "header")["record"];
			$("#検索仕入先選択").val(headerRecord["仕入先ＩＤ"]["value"][0]);
			
      var detailRecord = this.appspec.getJSONChunkByIdAtRecords(responseData, "detail")["record"];
			var max          = detailRecord["単品ＩＤ"]["value"].length;
      var table        = document.getElementById("mainTable");

			for (var i = 0; i < max; i++) {
          var tableRow = table.rows[i + 1];
          var fileName = $R.ApplicationURL + detailRecord["downloadfile"]["value"][i];
          var str      = '<img name="画像" src="' + fileName + '" width="180" height="180" class="画像">';
				
			    // 単品ＩＤ
          tableRow.cells[0].innerHTML = detailRecord["行番号"]["value"][i];

			    // 画像を表示する
          tableRow.cells[2].innerHTML = str;

			    // 単品名称
			    var str = "<div>"                       + detailRecord["単品名称"]["value"][i]         + "</div>";
					str    += "<div>　</div>";
			    str    += "<div>　　　リードタイム：　" + detailRecord["発注リードタイム"]["value"][i] + "日</div>";
			    str    += "<div>　　　購入単位数：　"   + detailRecord["購入単位数"]["value"][i]       + "本</div>";
          tableRow.cells[3].innerHTML = str;

			    // 金額
          tableRow.cells[6].innerHTML = detailRecord["金額"]["value"][i];
			}

      $R.log("View on照会OfEditResponseData : end");
    }

  });
}(jQuery, Rmenu));
