(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.T_OrderList;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスター一覧パターン　ミックスインを追加する
  Model.include($R.Library.TranMainteListModelMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Model.include({
    // ---------------------------------------
    // onChange　検索発注日付　処理
    // ---------------------------------------
    onChange検索発注日付: function() {
      $R.log("Model onChange検索発注日付 : start");

		  var w_発注日付 = $('#検索発注日付').val();
      //this.dataset.setElementData(w_発注日付.replace(/\//g, ""), "検索発注日付");
      this.dataset.setElementData(w_発注日付, "検索発注日付");
			
      $R.log("Model onChange検索発注日付 : end");
    }
    // ---------------------------------------
    // onChange　検索納入予定日　処理
    // ---------------------------------------
   ,onChange検索納入予定日: function() {
      $R.log("Model onChange検索納入予定日 : start");

		  var w_納入予定日 = $('#検索納入予定日').val();
      //this.dataset.setElementData(w_納入予定日.replace(/\//g, ""), "検索納入予定日");
      this.dataset.setElementData(w_納入予定日, "検索納入予定日");
			
      $R.log("Model onChange検索納入予定日 : end");
    }
    // -----------------------------------
    //  検索文字列　クリア処理（追加処理）
    // -----------------------------------
   ,on検索文字列クリア: function(arg) {
      $R.log("Model on検索文字列クリア : start");

      this.dataset.setElementData("", "検索仕入先ＩＤ");
      this.dataset.setElementData("", "検索発注日付");
      this.dataset.setElementData("", "検索納入予定日");

      this.pubsub.publish("on検索文字列クリア", "");

      $R.log("Model on検索文字列クリア : end");
    }
    // -------------------------------------------------------------------
    //  メンテナンス画面呼び出し（次画面呼び出し）準備処理（オーバライド）
    // -------------------------------------------------------------------
   ,onメンテナンス画面表示: function() {
      $R.log("Model onメンテナンス画面表示 : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var searchString01 = this.dataset.getElementData("検索仕入先ＩＤ");
      var searchString02 = this.dataset.getElementData("検索発注日付");
      var searchString03 = this.dataset.getElementData("検索納入予定日");

      sessionStorage.saveItem("検索仕入先ＩＤ" , searchString01);
      sessionStorage.saveItem("検索発注日付"   , searchString02);
      sessionStorage.saveItem("検索納入予定日" , searchString03);

      $R.log("Model onメンテナンス画面表示 : end");
    }
    // ---------------------------------------------
    //  ページネーションリロード処理（オーバライド）
    // ---------------------------------------------
   ,onリロード: function() {
      $R.log("Model onリロード : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var pageline       = sessionStorage.loadItem("ページライン数");
      var pageno         = sessionStorage.loadItem("カレントページ");

      var searchString01 = sessionStorage.loadItem("検索仕入先ＩＤ");
      var searchString02 = sessionStorage.loadItem("検索発注日付");
      var searchString03 = sessionStorage.loadItem("検索納入予定日");

      this.dataset.setElementData(pageline, "ページライン数");
      this.dataset.setElementData(pageno, "カレントページ");

      this.dataset.setElementData(searchString01, "検索仕入先ＩＤ");
      this.dataset.setElementData(searchString02, "検索発注日付");
      this.dataset.setElementData(searchString03, "検索納入予定日");

      var arg = {
              "検索仕入先ＩＤ" : searchString01,
              "検索発注日付"   : searchString02,
              "検索納入予定日" : searchString03,
          };

      this.pubsub.publish("on検索文字列表示", arg);

      $R.log("Model onリロード : end");
    }

	});

}(jQuery, Rmenu));