(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.T_Processing;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスターメンテパターン　ミックスインを追加する
  Model.include($R.Library.TranMainteModelMixin9);
  Model.include($R.Library.FlowerShopModelMixin);

  // ----------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　  　　
  // また、パターン内の処理を変更するときは、オーバライドする　
  // ----------------------------------------------------------
  Model.include({
    // ----------------------------------------
    // テーブルＩＤをデータセットに格納する
    // ----------------------------------------
    setテーブルＩＤ: function() {
      $R.log("Model setテーブルＩＤ : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var w_テーブルＩＤ = sessionStorage.loadItem("テーブルＩＤ");
      var w_出荷日付     = sessionStorage.loadItem("出荷日付");
      var w_お届け日     = this.add日数ＴＯ日付(w_出荷日付, 1);

      this.dataset.setElementData(w_テーブルＩＤ, "テーブルＩＤ");
      this.dataset.setElementData(w_お届け日, "お届け日");

      $R.log("Model setテーブルＩＤ : end");
    }
    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,on印刷OfEditResponseData: function(responseData, mode) {
      $R.log("Model on印刷OfEditResponseData : start");

      var argHash  = new Object();
      argHash["file"  ] = responseData["pdfinfo"]["pdffile"];
      argHash["type"  ] = "pdf";
      argHash["delete"] = "yes";
      this.postDownloadRack(argHash);

      $R.log("Model on印刷OfEditResponseData : end");
    }

});
}(jQuery, Rmenu));
