(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.T_ReceiveOrder;

  // インスタンスプロパティを追加する
  var Controller = App.Controller = new $R.Class($R.Controller);
  Controller.fn.init = function(appspec, model, view) {
    $R.log("Controllerr init : start");

    this.appspec = appspec;
    this.model   = model;
    this.view    = view;
    this.createPubSubEvent();

    var self = this;
    var api0 = $('#datetimepicker0').datetimepicker({
	      format : 'yyyy/MM/dd',
        language : 'ja',
	      pickTime : false
    }).data('datetimepicker');
    api0.widget.on('click','.day',function(){
	      api0.hide();
        self.onChangeお届け日();
    });

    $R.log("Controllerr init : end");
  };

  // モジュールを追加する
  Controller.include($R.Library.EnterTabPFKeyMixin);
  Controller.include($R.Library.ControllerMixin);

  // マスターメンテパターン　ミックスインを追加する
  Controller.include($R.Library.TranMainteControllerMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Controller.include({
    // ---------------------------------------
    // 初期処理
    // ---------------------------------------
    on初期処理: function() {
      $R.log("Controller on初期処理 : start");

      this.model.on初期処理();

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      this.model.setテーブルＩＤ();
      this.view.setテーブルＩＤ();
      var mode = sessionStorage.loadItem("処理モード");

      if (mode != "insert") {
        this.ajaxExecute("select");
			}

      $R.log("Controller on初期処理 : end");
    }
    // ---------------------------------------
    // onChange　入荷日付　処理
    // ---------------------------------------
   ,onChangeお届け日: function() {
      $R.log("Controller onChangeお届け日 : start");

		  this.model.onChangeお届け日();
				
      $R.log("Controller onChangeお届け日 : end");
    }
    // ---------------------------------------
    // onChange　メッセージ要不要　処理
    // ---------------------------------------
		,onChangeメッセージ要不要: function(event) {
      $R.log("Controller onChangeメッセージ要不要 : start");

      var datasetRecord = this.model.onChangeメッセージ要不要(event);
			
      this.view.onChangeメッセージ要不要(datasetRecord);
			
      $R.log("Controller onChangeメッセージ要不要 : end");
    }
    // -------------------------------------
    //  リクエストデータ　編集・チェック処理
    // -------------------------------------
   ,on登録OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on登録OfCheckRequestData : start");

      var status = this.model.on登録OfCheckRequestData(requestData, mode);
      if (status) {
        status = this.checkRequestData(requestData);
      }

      $R.log("Controller on登録OfCheckRequestData : end");
      return status;
    }
   ,on訂正OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on訂正OfCheckRequestData : start");

      var status = this.model.on訂正OfCheckRequestData(requestData, mode);
      if (status) {
        status = this.checkRequestData(requestData);
      }

      $R.log("Controller on訂正OfCheckRequestData : end");
      return status;
    }

  });

}(jQuery, Rmenu));