(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.T_ReceiveOrder;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスターメンテパターン　ミックスインを追加する
  Model.include($R.Library.TranMainteModelMixin9);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Model.include({
    // ----------------------------------------
    // テーブルＩＤをデータセットに格納する
    // ----------------------------------------
    setテーブルＩＤ: function() {
      $R.log("Model setテーブルＩＤ : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var w_商品ＩＤ = sessionStorage.loadItem("商品ＩＤ");
      var w_商品名称 = sessionStorage.loadItem("商品名称");
      var w_販売価格 = sessionStorage.loadItem("販売価格");
			
      this.dataset.setElementData(w_商品ＩＤ, "ご注文商品ＩＤ");
      this.dataset.setElementData(w_商品名称, "ご注文商品名");
      this.dataset.setElementData(w_販売価格, "お買い上げ金額");
			
      $R.log("Model setテーブルＩＤ : end");
    }
    // ---------------------------------------
    // onChange　発注日付　処理
    // ---------------------------------------
   ,onChangeお届け日: function() {
      $R.log("Model onChangeお届け日 : start");

		  var w_お届け日 = $('#お届け日').val();
      this.dataset.setElementData(w_お届け日, "お届け日");
			
      $R.log("Model onChangeお届け日 : end");
    }
    // ---------------------------------------
    // onChange　メッセージ要不要　処理
    // ---------------------------------------
   ,onChangeメッセージ要不要: function() {
      $R.log("Model onChangeメッセージ要不要 : start");

	    var datasetRecord = this.appspec.getJSONChunkByIdAtRecords(this.dataset.data, "detail")["record"];
      if ( $("#メッセージ要不要").is(":checked") ) {
        datasetRecord["メッセージ要不要"]["value"][0]   = "1";
			}
      else {
        datasetRecord["メッセージ要不要"]["value"][0]   = "0";
        datasetRecord["お届けメッセージ"]["value"][0]   = "";
      }
			
      $R.log("Model onChangeお届け日 : end");
			return datasetRecord;
    }
    // -------------------------------------
    //  リクエストデータ　編集・チェック処理
    // -------------------------------------
   ,on登録OfCheckRequestData: function(requestData, mode) {
      $R.log("Model on登録OfCheckRequestData : start");

      var status = this.on訂正OfCheckRequestData(requestData, mode);

      $R.log("Model on登録OfCheckRequestData : end");
      return status;
    }
   ,on訂正OfCheckRequestData: function(requestData, mode) {
      $R.log("Model on訂正OfCheckRequestData : start");

      var detailRecord = this.appspec.getJSONChunkByIdAtRecords(requestData, "detail")["record"];
			
			var w_お届け日       = detailRecord["お届け日"]["value"][0];
			var w_お買い上げ金額 = detailRecord["お買い上げ金額"]["value"][0];

      detailRecord["出荷予定日付"]["value"][0]   = this.add日数ＴＯ日付(w_お届け日, -1);
      detailRecord["お買い上げ金額"]["value"][0] = new String(w_お買い上げ金額).replace( /,/g, "" );
			
      $R.log("Model on訂正OfCheckRequestData : end");
      return true;
    }
    // -------------------------------------------------------------------
    //  日付に日数を加算
    // -------------------------------------------------------------------
   ,add日数ＴＯ日付: function(date, days) {
      $R.log("Model add日数ＴＯ日付 : start");
			
      var date  = new Date(date);
			date.setDate(date.getDate() + Number(days));
			
			var year  = date.getFullYear();
			var month = date.getMonth() + 1;
			var day   = date.getDate();
			
			if (month < 10) {
				month = "0" + month;
			}
			
			if (day < 10) {
				day = "0" + day;
			}
			
      var today = year + "/" +month + "/" + day;

      $R.log("Model add日数ＴＯ日付 : end");
			return today;
    }

	});

}(jQuery, Rmenu));