(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.T_ReceiveOrder;

  // インスタンスプロパティを追加する
  var View = App.View = new $R.Class($R.View);
  View.fn.init = function(appspec) {
    $R.log("View init : start");

    this.appspec = appspec;

    $R.log("View init : end");
  }

  // モジュールを追加する
  View.include($R.Library.FormatMixin);
  View.include($R.Library.OutlineMixin);
  View.include($R.Library.LoadTemplateMixin);
  View.include($R.Library.ViewMixin);

  // マスターメンテパターン　ミックスインを追加する
  View.include($R.Library.TranMainteViewMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  View.include({
    // -----------------------
    //  ログイン情報を表示する
    // -----------------------
    showログイン情報: function(arg) {
      $R.log("View showログイン情報 : start");

      if ( arg["ログイン和暦"] != "") {
        $("#ログイン和暦").html(arg["ログイン和暦"]); 
      }

      $("#ログイン日時").html(arg["ログイン時刻"]); 
      $("#ユーザ氏名").html(arg["ユーザ名称"]); 

      $R.log("View showログイン情報 : end");
    }
    // -------------------------
    //  ヘッダタイトルを表示する
    // -------------------------
   ,showヘッダータイトル: function(arg) {
      $R.log("View showヘッダータイトル : start");

      var title = $("#ヘッダータイトル").html();
      //var mode  = arg["処理モード"];

      //switch (mode) {
      //  case "select":
      //    title   += "（照会）";
      //    $("#実行").attr("disabled","disabled");
      //    break;
      //  case "insert":
      //    title   += "（新規）";
      //    break;
      //  case "convert":
      //    title   += "（転用）";
      //    break;
      //  case "update":
      //    title   += "（訂正）";
      //    break;
      //  case "delete":
      //    title   += "（削除）";
      //}
			
      $("#ヘッダータイトル").html(title); 

      $R.log("View showヘッダータイトル : end");
    }
    // ----------------------------------------
    // テーブルＩＤをデータセットに格納する
    // ----------------------------------------
   ,setテーブルＩＤ: function() {
      $R.log("View setテーブルＩＤ : start");

      var w_商品名称 = sessionStorage.loadItem("商品名称");
      var w_販売価格 = sessionStorage.loadItem("販売価格");
			
			$("#ご注文商品名").val(w_商品名称);
			$("#お買い上げ金額").val(w_販売価格);
			
      $R.log("View setテーブルＩＤ : end");
    }
    // ---------------------------------------
    // onChange　メッセージ要不要　処理
    // ---------------------------------------
		,onChangeメッセージ要不要: function(datasetRecord) {
      $R.log("View onChangeメッセージ要不要 : start");
			
			var value = datasetRecord["メッセージ要不要"]["value"][0];
			if (value == "0") {
				$("#お届けメッセージ").val("");
				$("#お届けメッセージ").attr("disabled","disabled");
			}
			else {
				$("#お届けメッセージ").removeAttr("disabled");
			}

      $R.log("View onChangeメッセージ要不要 : end");
    }

  });

}(jQuery, Rmenu));