(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.T_ReceiveOrderList;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスター一覧パターン　ミックスインを追加する
  Model.include($R.Library.TranMainteListModelMixin);

  // ----------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　  　　
  // また、パターン内の処理を変更するときは、オーバライドする　
  // ----------------------------------------------------------
  Model.include({
    // -----------------------------------
    //  検索文字列　クリア処理（追加処理）
    // -----------------------------------
    on検索文字列クリア: function(arg) {
      $R.log("Model on検索文字列クリア : start");

      this.dataset.setElementData("", "検索目的ＩＤ");
      this.dataset.setElementData("", "検索目的名称");
      this.dataset.setElementData("", "検索種類ＩＤ");
      this.dataset.setElementData("", "検索種類名称");

      this.pubsub.publish("on検索文字列クリア", "");

      $R.log("Model on検索文字列クリア : end");
    }
    // ---------------------------------
    //  検索文字列　表示処理（追加処理）
    // ---------------------------------
   ,on注文指示: function(nameArray) {
      $R.log("Model on注文指示 : start");

			var row = nameArray[1];
			
      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      sessionStorage.saveItem("処理モード", "insert");

      var dataset    = this.dataset.getData();
      var detailInfo = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
      w_商品ＩＤ     = detailInfo["record"]["テーブルＩＤ"]["value"][row]
      w_商品名称     = detailInfo["record"]["商品名称"]["value"][row]
      w_販売価格     = detailInfo["record"]["販売価格"]["value"][row]

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.nextname);
      sessionStorage.saveItem("処理モード", "insert");
      sessionStorage.saveItem("商品ＩＤ", w_商品ＩＤ);
      sessionStorage.saveItem("商品名称", w_商品名称);
      sessionStorage.saveItem("販売価格", w_販売価格);
			
      $R.log("Model on注文指示 : end");
    }
    // -------------------------------------------------------------------
    //  メンテナンス画面呼び出し（次画面呼び出し）準備処理（オーバライド）
    // -------------------------------------------------------------------
   ,onメンテナンス画面表示: function() {
      $R.log("Model onメンテナンス画面表示 : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var searchString01 = this.dataset.getElementData("検索目的ＩＤ");
      var searchString02 = this.dataset.getElementData("検索種類ＩＤ"  );

      sessionStorage.saveItem("検索目的ＩＤ" , searchString01);
      sessionStorage.saveItem("検索種類ＩＤ" , searchString02);

      $R.log("Model onメンテナンス画面表示 : end");
    }
    // ---------------------------------------------
    //  ページネーションリロード処理（オーバライド）
    // ---------------------------------------------
   ,onリロード: function() {
      $R.log("Model onリロード : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var pageline       = sessionStorage.loadItem("ページライン数");
      var pageno         = sessionStorage.loadItem("カレントページ");

      var searchString01 = sessionStorage.loadItem("検索目的ＩＤ");
      var searchString02 = sessionStorage.loadItem("検索種類ＩＤ");

			if (!searchString01) {
				searchString01   = "";
			}
			if (!searchString02) {
				searchString02   = "";
			}

      this.dataset.setElementData(pageline, "ページライン数");
      this.dataset.setElementData(pageno, "カレントページ");

      this.dataset.setElementData(searchString01, "検索目的ＩＤ");
      this.dataset.setElementData(searchString02, "検索種類ＩＤ");

      var arg = {
              "検索目的ＩＤ"   : searchString01,
              "検索種類ＩＤ"   : searchString02
          };

      this.pubsub.publish("on検索文字列表示", arg);

      $R.log("Model onリロード : end");
    }
    // -------------------------------------------------------
    //  メインテーブル照会　レスポンスデータ　編集処理
    // -------------------------------------------------------
   ,onメインテーブル照会OfEditResponseData: function(responseData) {
      $R.log("Model onメインテーブル照会OfEditResponseData : start");


      $R.log("Model onメインテーブル照会OfEditResponseData : end");
    }

	});

}(jQuery, Rmenu));