(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.T_ReceiveOrderUpdateList;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスター一覧パターン　ミックスインを追加する
  Model.include($R.Library.TranMainteListModelMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Model.include({
    // ---------------------------------------
    // onChange　検索受注日　処理
    // ---------------------------------------
    onChange検索受注日: function() {
      $R.log("Model onChange検索受注日 : start");

		  var w_受注日 = $('#検索受注日').val();
      this.dataset.setElementData(w_受注日, "検索受注日");
			
      $R.log("Model onChange検索受注日 : end");
    }
    // ---------------------------------------
    // onChange　検索お届け日　処理
    // ---------------------------------------
   ,onChange検索お届け日: function() {
      $R.log("Model onChange検索お届け日 : start");

		  var w_お届け日 = $('#検索お届け日').val();
      this.dataset.setElementData(w_お届け日, "検索お届け日");
			
      $R.log("Model onChange検索お届け日 : end");
    }
    // -----------------------------------
    //  検索文字列　クリア処理（追加処理）
    // -----------------------------------
   ,on検索文字列クリア: function(arg) {
      $R.log("Model on検索文字列クリア : start");

      this.dataset.setElementData("", "検索受注日");
      this.dataset.setElementData("", "検索お届け日");

      this.pubsub.publish("on検索文字列クリア", "");

      $R.log("Model on検索文字列クリア : end");
    }
    // -------------------------------------------------------------------
    //  メンテナンス画面呼び出し（次画面呼び出し）準備処理（オーバライド）
    // -------------------------------------------------------------------
   ,onメンテナンス画面表示: function() {
      $R.log("Model onメンテナンス画面表示 : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var searchString02 = this.dataset.getElementData("検索受注日");
      var searchString03 = this.dataset.getElementData("検索お届け日");

      sessionStorage.saveItem("検索受注日"   , searchString02);
      sessionStorage.saveItem("検索お届け日"   , searchString03);

      $R.log("Model onメンテナンス画面表示 : end");
    }
    // ---------------------------------------------
    //  ページネーションリロード処理（オーバライド）
    // ---------------------------------------------
   ,onリロード: function() {
      $R.log("Model onリロード : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var pageline       = sessionStorage.loadItem("ページライン数");
      var pageno         = sessionStorage.loadItem("カレントページ");

      var searchString01 = sessionStorage.loadItem("検索受注日");
      var searchString02 = sessionStorage.loadItem("検索お届け日");

      this.dataset.setElementData(pageline, "ページライン数");
      this.dataset.setElementData(pageno, "カレントページ");

      this.dataset.setElementData(searchString01, "検索受注日");
      this.dataset.setElementData(searchString02, "検索お届け日");

      var arg = {
              "検索受注日"   : searchString01,
              "検索お届け日"   : searchString02,
          };

      this.pubsub.publish("on検索文字列表示", arg);

      $R.log("Model onリロード : end");
    }

	});

}(jQuery, Rmenu));