(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.T_SingleItemPlanStockList;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスター一覧パターン　ミックスインを追加する
  Model.include($R.Library.TranMainteListModelMixin);
  Model.include($R.Library.FlowerShopModelMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Model.include({
    // -----------------------------------
    //  検索文字列　クリア処理（追加処理）
    // -----------------------------------
    on検索文字列クリア: function(arg) {
      $R.log("Model on検索文字列クリア : start");

      this.dataset.setElementData("", "検索単品名");
      this.dataset.setElementData("", "検索仕入先ＩＤ");
      this.dataset.setElementData("", "検索仕入先名称");

      this.pubsub.publish("on検索文字列クリア", "");

      $R.log("Model on検索文字列クリア : end");
    }
    // -------------------------------------------------------------------
    //  メンテナンス画面呼び出し（次画面呼び出し）準備処理（オーバライド）
    // -------------------------------------------------------------------
   ,onメンテナンス画面表示: function() {
      $R.log("Model onメンテナンス画面表示 : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var searchString01 = this.dataset.getElementData("検索単品名");
      var searchString02 = this.dataset.getElementData("検索仕入先ＩＤ");

      sessionStorage.saveItem("検索単品名"   , searchString01);
      sessionStorage.saveItem("検索仕入先ＩＤ" , searchString02);

      $R.log("Model onメンテナンス画面表示 : end");
    }
    // ---------------------------------------------
    //  ページネーションリロード処理（オーバライド）
    // ---------------------------------------------
   ,onリロード: function() {
      $R.log("Model onリロード : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var pageline       = sessionStorage.loadItem("ページライン数");
      var pageno         = sessionStorage.loadItem("カレントページ");

      var searchString01 = sessionStorage.loadItem("検索単品名");
      var searchString02 = sessionStorage.loadItem("検索仕入先ＩＤ");
			
			if (!searchString01) {
				searchString01   = "";
			}
			if (!searchString02) {
				searchString02   = "";
			}

      this.dataset.setElementData(pageline, "ページライン数");
      this.dataset.setElementData(pageno, "カレントページ");

      this.dataset.setElementData(searchString01, "検索単品名");
      this.dataset.setElementData(searchString02, "検索仕入先ＩＤ");

      var arg = {
              "検索単品名"     : searchString01,
              "検索仕入先ＩＤ" : searchString02
          };

      this.pubsub.publish("on検索文字列表示", arg);

      $R.log("Model onリロード : end");
    }
    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,on印刷OfEditResponseData: function(responseData, mode) {
      $R.log("Model on印刷OfEditResponseData : start");

      var argHash  = new Object();
      argHash["file"  ] = responseData["pdfinfo"]["pdffile"];
      argHash["type"  ] = "pdf";
      argHash["delete"] = "yes";
      this.postDownloadRack(argHash);

      $R.log("Model on印刷OfEditResponseData : end");
    }

 });
}(jQuery, Rmenu));
