(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.main;

  // インスタンスプロパティを追加する
  var Controller = App.Controller = new $R.Class($R.Controller);
  Controller.fn.init = function(appspec, model, view) {
    $R.log("Controllerr init : start");

    this.appspec = appspec;
    this.model   = model;
    this.view    = view;
    this.createPubSubEvent();

    $R.log("Controllerr init : end");
  };

  // 共通モジュールを追加する
  Controller.include($R.Library.EnterTabPFKeyMixin);
  Controller.include($R.Library.ControllerMixin);

  // 関数を追加する
  Controller.include({
    // --------
    // 処理開始
    // --------
    initExecute: function() {
      $R.log("Controller initExecute : start");

      var argArray = ["init", "init", "操作方法"];
      this.model.postDocsTransition(this, argArray);

      $R.log("Controller initExecute : end");
    }
    // ------------------------
    // イベント処理
    // ------------------------
   ,onRmenuImage: function(event) {
      $R.log("Controller onRmenuImage : start");

      location.reload();

      $R.log("Controller onRmenuImage : end");
    }
   ,onタブを追加: function(event) {
      $R.log("Controller onタブを追加 : start");

      var argString = $(event.target).attr("id");
      var argArray  = argString.split("/");

      var status = this.view.onタブが有るか(argArray);
      if (!status) {
        this.model.postDocsTransition(this, argArray);
      }

      $R.log("Controller onタブを追加 : end");
    }
   ,onタブを削除: function(event) {
      $R.log("Controller onタブを削除 : start");

      this.view.onタブを削除(event);

      $R.log("Controller onタブを削除 : end");
    }
   ,onEsc: function(event) {
      $R.log("Controller onEsc : start");

      this.view.on全タブを削除();

      $R.log("Controller onEsc : end");
    }
    // ------------------------------
    // 追加ボタン処理（アンカー）
    // ------------------------------
   ,onアンカー: function(event) {
      $R.log("Controller onアンカー : start");
			
			var htmlName = event.target.id;
      this.model.postTextTransition(htmlName);
			
      $R.log("Controller onアンカー : end");
    }		
    // ------------------------------
    // 追加ボタン処理（PDF出力処理）
    // ------------------------------
   ,onPDF: function(event) {
      $R.log("Controller onPDF : start");
			
			var pdfURL  = event.currentTarget.id;
			var pdfName = event.currentTarget.name;
			
      var argHash  = new Object();
      argHash["file"]     = pdfURL;
      argHash["type"]     = "pdf";
      argHash["download"] = pdfName;
      argHash["delete"]   = "no";
			
      this.model.postDownloadRack(argHash);

      $R.log("Controller onPDF : end");
    }	
	
  });
}(jQuery, Rmenu));