# coding: UTF-8

require 'FlowerShop/Server/Modules/FlowerShopOfMasterMainteOfModelMixin'

class M_CustomersList_model
  include FlowerShopOfMasterMainteOfModelMixin

  def initialize(rmenu_dbi, sql_data, request_data)
    begin
      # initialize 開始ログを出力する
      $Mlog.debug("M_CustomersList_model") {"initialize start"}                   # Logファイル Debug用

      @rmenu_dbi      = rmenu_dbi
      @sql_data       = sql_data
      @request_data   = request_data

      # initialize 終了ログを出力する
      $Mlog.debug("M_CustomersList_model") {"initialize normal end"}              # Logファイル Debug用
    rescue Exception
      # エラーログを出力する
      $Mlog.error("M_CustomersList_model") {"initialize exception: #{$!}"}        # Logファイル Debug用
      raise
    end
  end

  # SQL文の検索条件を変更する
  def setSql_得意先OfFlowerShop(idname1, idname2 ,genesql_freesql)
    $Mlog.debug("M_CustomersList_model") {"setSql_得意先OfFlowerShop start"}                  # Logファイル Debug用

    requestInfo  = getJsonChunkById(@request_data, "records", idname1)

    searchString01  = requestInfo["record"]["検索得意先名"]["value"][0]
    searchString02  = requestInfo["record"]["検索郵便ＮＯ"]["value"][0]
    searchString03  = requestInfo["record"]["検索住所"]["value"][0]
    searchString04  = requestInfo["record"]["検索電話番号"]["value"][0]
    searchString05  = requestInfo["record"]["検索携帯番号"]["value"][0]

    sqlInfo      = getJsonChunkById(@sql_data, "sqls", idname2)

    rep = ""

    # 検索得意先名
    if searchString01 != ""
      rep = rep + "AND 得意先名 LIKE '%#{searchString01}%'"
    end

    # 検索郵便番号
    if searchString02 != ""
      rep = rep + "AND 郵便番号 LIKE '%#{searchString02}%'"
    end

    # 検索住所
    if searchString03 != ""
      rep = rep + "AND 住所１ LIKE '%#{searchString03}%'"
    end

    # 検索電話番号
    if searchString04 != ""
      rep = rep + "AND 電話番号 LIKE '%#{searchString04}%'"
    end

    # 検索携帯番号
    if searchString05 != ""
      rep = rep + "AND 携帯番号 LIKE '%#{searchString05}%'"
    end

    # 検索条件の置き換え
    if    genesql_freesql == 'genesql'
      sqlInfo["sql"]["genesql"]["where"].sub!(/&&/,rep)
    elsif genesql_freesql == 'freesql'
      strJoin = sqlInfo["sql"]["freesql"].join("\t")
      strJoin.sub!(/&&/,rep)
      strSplit = strJoin.split("\t")
      sqlInfo["sql"]["freesql"].each_with_index do |temp, idx|
        sqlInfo["sql"]["freesql"][idx] = strSplit[idx]
      end
    end

    $Mlog.debug("M_CustomersList_model") {"setSql_得意先OfFlowerShop end"}                    # Logファイル Debug用
    return "OK"
  end

end
