# coding: UTF-8

require 'FlowerShop/Server/Modules/FlowerShopOfMasterMainteOfModelMixin'

class M_GoodsList_model
  include FlowerShopOfMasterMainteOfModelMixin

  def initialize(rmenu_dbi, sql_data, request_data)
    begin
      # initialize 開始ログを出力する
      $Mlog.debug("M_GoodsList_model") {"initialize start"}                   # Logファイル Debug用

      @rmenu_dbi      = rmenu_dbi
      @sql_data       = sql_data
      @request_data   = request_data

      # initialize 終了ログを出力する
      $Mlog.debug("M_GoodsList_model") {"initialize normal end"}              # Logファイル Debug用
    rescue Exception
      # エラーログを出力する
      $Mlog.error("M_GoodsList_model") {"initialize exception: #{$!}"}        # Logファイル Debug用
      raise
    end
  end

  # SQL文の検索条件を変更する
  def setSql_商品OfFlowerShop(idname1, idname2 ,genesql_freesql)
    $Mlog.debug("M_GoodsList_model") {"setSql_商品OfFlowerShop start"}                  # Logファイル Debug用

    requestInfo  = getJsonChunkById(@request_data, "records", idname1)

    searchString01  = requestInfo["record"]["検索商品名"]["value"][0]
    searchString02  = requestInfo["record"]["検索目的ＩＤ"]["value"][0]
    searchString03  = requestInfo["record"]["検索種類ＩＤ"]["value"][0]

    sqlInfo      = getJsonChunkById(@sql_data, "sqls", idname2)

    rep = ""

    # 検索商品名
    if searchString01 != ""
      rep = rep + "AND 商品名称 LIKE '%#{searchString01}%'"
    end

    # 検索目的
    if searchString02 != ""
      rep = rep + "AND ref_目的ＩＤ = #{searchString02}"
    end

    # 検索種類
    if searchString03 != ""
      rep = rep + "AND ref_種類ＩＤ = #{searchString03}"
    end

    # 検索条件の置き換え
    if    genesql_freesql == 'genesql'
      sqlInfo["sql"]["genesql"]["where"].sub!(/&&/,rep)
    elsif genesql_freesql == 'freesql'
      strJoin = sqlInfo["sql"]["freesql"].join("\t")
      strJoin.sub!(/&&/,rep)
      strSplit = strJoin.split("\t")
      sqlInfo["sql"]["freesql"].each_with_index do |temp, idx|
        sqlInfo["sql"]["freesql"][idx] = strSplit[idx]
      end
    end

    $Mlog.debug("M_GoodsList_model") {"setSql_商品OfFlowerShop end"}                    # Logファイル Debug用
    return "OK"
  end

end
