# coding: UTF-8

require 'RmenuJsonMixin'                                                        # ID名で該当レコードを取得する
require 'RmenuLoggerMixin'                                                      # Logファイル Debug用
require 'base64'
require 'fileutils'
require 'date'


class M_SetItemDetail_model
  include RmenuJsonMixin
  include RmenuLoggerMixin                                                      # Logファイル Debug用

  def initialize(rmenu_dbi, sql_data, request_data)
    begin
      # initialize 開始ログを出力する
      $Mlog.debug("M_SetItemDetail_model") {"initialize start"}                   # Logファイル Debug用

      @rmenu_dbi      = rmenu_dbi
      @sql_data       = sql_data
      @request_data   = request_data

      # initialize 終了ログを出力する
      $Mlog.debug("M_SetItemDetail_model") {"initialize normal end"}              # Logファイル Debug用
    rescue Exception
      # エラーログを出力する
      $Mlog.error("M_SetItemDetail_model") {"initialize exception: #{$!}"}        # Logファイル Debug用
      raise
    end
  end

  # ＤＢから読み込みこんだイメージデータを、ファイルに出力する
  def downloadImageDataOf花束セット明細OfFlowerShop(idName)
    $Mlog.debug("M_SetItemDetail_model") {"downloadImageDataOf花束セット明細OfFlowerShop start"}                  # Logファイル Debug用

    # 当日日付とカレント時刻を設定する
    w_date      = Date.today
	  w_time      = Time.now
		yyyymmdd    = w_date.strftime("%Y%m%d")
		hhmmss      = w_time.strftime("%H%M%S")
			
    # ディレクトリが無ければ作成する（有れば何もしない）
    downloadDir = $Rconfig['apps_path'] + "/FlowerShop/DownLoad/Apps/M_SetItemDetail"
    newDir      = $Rconfig['apps_path'] + "/FlowerShop/DownLoad/Apps/M_SetItemDetail" + "/d" + yyyymmdd
    createDir(newDir)
			
		# 当日よりも古いディレクトリーを削除する
		deleteDir(downloadDir, newDir)
		

    sqlRecord  = getJsonChunkById(@sql_data, "sqls", idName, "output")
    nameArray  = sqlRecord["record"]["画像ファイル名"]["value"]
    imageArray = sqlRecord["record"]["画像データ"]["value"]
		
    nameArray.each_with_index { |val, index| 
      if val != ""
        if imageArray[index] != ""
				  fileArray = nameArray[index].split(".")

		      # イメージデータをBase64デコードし、ファイルへ出力する
          imageData64   = imageArray[index]
          imageData     = Base64.decode64(imageData64)
          url = newDir + "/" + fileArray[0] + hhmmss + "." + fileArray[1]
          writeBinFile(url, imageData)

          # ダウンロード用パス＋ファイル名を設定する
		      downloadfile = "FlowerShop/DownLoad/Apps/M_SetItemDetail" + "/d" + yyyymmdd + "/" + fileArray[0] + hhmmss + "." + fileArray[1]
          sqlRecord["record"]["画像データ"]["value"][index] = downloadfile
        else
          sqlRecord["record"]["画像データ"]["value"][index] = ""
        end
      else
        sqlRecord["record"]["画像データ"]["value"][index] = ""
      end
    }


    $Mlog.debug("M_SetItemDetail_model") {"downloadImageDataOf花束セット明細OfFlowerShop end"}                    # Logファイル Debug用
    return "OK"
  end

end
