# coding: UTF-8

require 'RmenuLoggerMixin'                                                      # Logファイル Debug用
require 'FlowerShop/Server/Modules/FlowerShopOfBaseNameMainteOfModelMixin'                                               # 基本名称　マスターメンテ用
require 'base64'
require 'fileutils'
require 'date'

class M_SingleItemMainte_model
  include FlowerShopOfBaseNameMainteOfModelMixin

  def initialize(rmenu_db, sql_data, request_data)
    begin
      # initialize 開始ログを出力する
      $Mlog.debug("M_SingleItemMainte") {"initialize start"}                   # Logファイル Debug用

      @rmenu_db       = rmenu_db
      @sql_data       = sql_data
      @request_data   = request_data
      
      # initialize 終了ログを出力する
      $Mlog.debug("M_SingleItemMainte") {"initialize normal end"}              # Logファイル Debug用
    rescue Exception
      # エラーログを出力する
      $Mlog.error("M_SingleItemMainte") {"initialize exception: #{$!}"}        # Logファイル Debug用
      raise
    end
  end
	
  # アップロードしたファイルをＤＢに更新する
  def uploadImageDataOf単品OfFlowerShop(idName)
    $Mlog.debug("M_SingleItemMainte") {"uploadImageDataOf単品OfFlowerShop start"}                  # Logファイル Debug用

    headerRecord = getJsonChunkById(@request_data, "records", idName)
    faleName = headerRecord["record"]["ファイル名"]["value"][0]
    url = $Rconfig["apps_path"] + "/FlowerShop/UpLoad/Apps/M_SingleItemMainte/" + faleName

    # ファイルを読み込み、Data64でエンコードする
    imageData   = readBinFile(url)
    imageData64 = Base64.encode64(imageData)

    tableID = headerRecord["record"]["テーブルＩＤ"]["value"][0]

    # DBへ出力する
    str_sql   = "UPDATE 単品 SET "
    str_sql  += "単品画像 = '#{imageData64}' WHERE 単品ＩＤ = #{tableID}"
    @rmenu_db["default"].update(str_sql)

    # ファイルを削除する
    deleteFile(url)

    $Mlog.debug("M_SingleItemMainte") {"uploadImageDataOf単品OfFlowerShop end"}                    # Logファイル Debug用
    return "OK"
  end

  # ＤＢから読み込みこんだイメージデータを、ファイルに出力する
  def downloadImageDataOf単品OfFlowerShop(idName)
    $Mlog.debug("M_SingleItemMainte") {"downloadImageDataOf単品OfFlowerShop start"}                  # Logファイル Debug用

    sqlRecord = getJsonChunkById(@sql_data, "sqls", idName, "output")
    nameArray = sqlRecord["record"]["画像ファイル名"]["value"][0].split(".")
		

    # 当日日付とカレント時刻を設定する
    w_date      = Date.today
	  w_time      = Time.now
		yyyymmdd    = w_date.strftime("%Y%m%d")
		hhmmss      = w_time.strftime("%H%M%S")
			
    # ディレクトリが無ければ作成する（有れば何もしない）
    downloadDir = $Rconfig['apps_path'] + "/FlowerShop/DownLoad/Apps/M_SingleItemMainte"
    newDir      = $Rconfig['apps_path'] + "/FlowerShop/DownLoad/Apps/M_SingleItemMainte" + "/d" + yyyymmdd
    createDir(newDir)
			
		# 当日よりも古いディレクトリーを削除する
		deleteDir(downloadDir, newDir)

		# イメージデータをBase64デコードし、ファイルへ出力する
    imageData64   = sqlRecord["record"]["単品画像"]["value"][0]
    imageData     = Base64.decode64(imageData64)
    url = newDir + "/" + nameArray[0] + hhmmss + "." + nameArray[1]
    writeBinFile(url, imageData)

    # ダウンロード用パス＋ファイル名を設定する
		downloadfile = "FlowerShop/DownLoad/Apps/M_SingleItemMainte" + "/d" + yyyymmdd + "/" + nameArray[0] + hhmmss + "." + nameArray[1]
    sqlRecord["record"]["単品画像"]["value"][0] = downloadfile

    $Mlog.debug("M_SingleItemMainte") {"downloadImageDataOf単品OfFlowerShop end"}                    # Logファイル Debug用
    return "OK"
  end

end
