# coding: UTF-8

require "date"
require 'FlowerShop/Server/Modules/FlowerShopOfBaseNameMainteOfModelMixin'

class T_DailyPlanStockUpdate_model
  include FlowerShopOfBaseNameMainteOfModelMixin

  def initialize(rmenu_db, sql_data, request_data)
    begin
      # initialize 開始ログを出力する
      $Mlog.debug("T_DailyPlanStockUpdate_model") {"initialize start"}                   # Logファイル Debug用

      @rmenu_db       = rmenu_db
      @sql_data       = sql_data
      @request_data   = request_data

      # initialize 終了ログを出力する
      $Mlog.debug("T_DailyPlanStockUpdate_model") {"initialize normal end"}              # Logファイル Debug用
    rescue Exception
      # エラーログを出力する
      $Mlog.error("T_DailyPlanStockUpdate_model") {"initialize exception: #{$!}"}        # Logファイル Debug用
      raise
    end
  end

  # 引当開始日の設定
  def set引当開始日Of単品予定在庫更新日次処理()
    $Mlog.debug("T_DailyPlanStockUpdate_model") {"set引当開始日Of単品予定在庫更新日次処理 start"}

    sqlRecord1  = getJsonChunkById(@sql_data, "sqls", "単品在庫明細最大在庫日付抽出", "output", "record")
		w_在庫日付  = sqlRecord1["在庫日付"]["value"][0]
		
		w_システム日付１    = Date.today
		w_システム日付２    = w_システム日付１.strftime("%Y/%m/%d")
		
    sqlRecord2  = getJsonChunkById(@sql_data, "sqls", "単品予定在庫作成処理", "input", "record")
		if w_在庫日付 > w_システム日付２
		  sqlRecord2["引当開始日"]["value"][0] = w_システム日付２
		else
		  sqlRecord2["引当開始日"]["value"][0] = w_在庫日付
		end
		
    $Mlog.debug("T_DailyPlanStockUpdate_model") {"set引当開始日Of単品予定在庫更新日次処理 end"}
    return "OK"
  end


  # バッチ処理キーの作成
  def createバッチ処理キーOf単品予定在庫更新日次処理()
    $Mlog.debug("T_DailyPlanStockUpdate_model") {"createバッチ処理キーOf単品予定在庫更新日次処理 start"}

    status = "OK"

    sqlRecord0  = getJsonChunkById(@sql_data, "sqls", "単品予定在庫作成処理",  "input", "record")
    sqlRecord1  = getJsonChunkById(@sql_data, "sqls", "バッチキー作成１",      "output", "record")
    sqlRecord2  = getJsonChunkById(@sql_data, "sqls", "バッチキー作成２",      "output", "record")
    sqlRecord3  = getJsonChunkById(@sql_data, "sqls", "parallelKey",           "input",  "record")
		
		w_引当開始日  = sqlRecord0["引当開始日"]["value"][0]
		max単品ＩＤ   = sqlRecord1["単品ＩＤ"]["value"].length - 1
		w_引当終了日  = sqlRecord2["引当終了日"]["value"][0]
    key単品ＩＤ   = [""]
    key引当日     = [""]
		
		j = 0
		for i in 0..max単品ＩＤ do
		  if sqlRecord1["単品ＩＤ"]["value"][i] == ""
			  break
			end
			
		  dateワーク１ = Date.strptime(w_引当開始日,'%Y/%m/%d')
			
		  loop do
			
			  dateワーク１ = dateワーク１ + 1
				dateワーク２ = dateワーク１.strftime("%Y/%m/%d")
				if dateワーク２ > w_引当終了日
				  break
				end
				
        key単品ＩＤ[j] = sqlRecord1["単品ＩＤ"]["value"][i]
        key引当日[j]   = dateワーク２
				j = j + 1
				
		  end
			
		end
		
		sqlRecord3["単品ＩＤ"]["value"] = key単品ＩＤ
		sqlRecord3["引当日"]["value"]   = key引当日
		
    $Mlog.debug("T_DailyPlanStockUpdate_model") {"createバッチ処理キーOf単品予定在庫更新日次処理 end"}
    return status
  end

  # バッチ実行可否判定
  def checkバッチ実行可否判定(sqlIdName, sqlIO, sqlItemName)
    $Mlog.debug("T_DailyPlanStockUpdate_model") {"checkバッチ実行可否判定 start"}

    status = "OK"

    cond_chunk = getJsonChunkById(@sql_data, "sqls", sqlIdName, sqlIO, "record")
    checkValue = cond_chunk[sqlItemName]["value"][0]
		
    if checkValue == ""
      status = "ALLPASS"
    end

    $Mlog.debug("T_DailyPlanStockUpdate_model") {"checkバッチ実行可否判定: #{sqlIdName} #{sqlIO} #{sqlItemName} #{checkValue} #{status}"}
    $Mlog.debug("T_DailyPlanStockUpdate_model") {"checkバッチ実行可否判定 end"}
    return status
  end

end
