# coding: UTF-8

require 'date'
require 'RmenuJsonMixin'
require 'FlowerShop/Server/Modules/FlowerShopOfBaseNameMainteOfModelMixin'

class T_DailyStockUpdate_model
  include FlowerShopOfBaseNameMainteOfModelMixin
  include RmenuJsonMixin

  def initialize(rmenu_db, sql_data, request_data)
    begin
      # initialize 開始ログを出力する
      $Mlog.debug("T_DailyStockUpdate_model") {"initialize start"}                   # Logファイル Debug用

      @rmenu_db       = rmenu_db
      @sql_data       = sql_data
      @request_data   = request_data

      # initialize 終了ログを出力する
      $Mlog.debug("T_DailyStockUpdate_model") {"initialize normal end"}              # Logファイル Debug用
    rescue Exception
      # エラーログを出力する
      $Mlog.error("T_DailyStockUpdate_model") {"initialize exception: #{$!}"}        # Logファイル Debug用
      raise
    end
  end

  # バッチ実行可否判定
  def checkバッチ実行可否判定(sqlIdName, sqlIO, sqlItemName)
    $Mlog.debug("T_DailyPlanStockUpdate_model") {"checkバッチ実行可否判定 start"}

    status = "OK"

    cond_chunk = getJsonChunkById(@sql_data, "sqls", sqlIdName, sqlIO, "record")
    checkValue = cond_chunk[sqlItemName]["value"][0]
		
    if checkValue == ""
      status = "ALLPASS"
    end

    $Mlog.debug("T_DailyPlanStockUpdate_model") {"checkバッチ実行可否判定: #{sqlIdName} #{sqlIO} #{sqlItemName} #{checkValue} #{status}"}
    $Mlog.debug("T_DailyPlanStockUpdate_model") {"checkバッチ実行可否判定 end"}
    return status
  end

  # バッチ処理キーの作成
  def createバッチ処理キーOf単品在庫明細更新日次処理()
    $Mlog.debug("T_DailyPlanStockUpdate_model") {"createバッチ処理キーOf単品在庫明細更新日次処理 start"}

    status = "OK"

    sqlRecord1  = getJsonChunkById(@sql_data, "sqls", "バッチキー作成１",                  "output", "record")
    sqlRecord2  = getJsonChunkById(@sql_data, "sqls", "単品在庫明細最大在庫日付抽出",      "output", "record")
    sqlRecord3  = getJsonChunkById(@sql_data, "sqls", "parallelKey",                       "input",  "record")
		
		max単品ＩＤ    = sqlRecord1["単品ＩＤ"]["value"].length - 1
		w_在庫日付     = sqlRecord2["在庫日付"]["value"][0]
		w_システム日付 = Date.today - 1
		
		w_終了引当日   = w_システム日付.strftime("%Y/%m/%d")
		if w_在庫日付 < w_終了引当日
		  w_開始引当日 = w_在庫日付
		else
		  w_開始引当日 = w_終了引当日
		end
		
    key単品ＩＤ    = [""]
    key在庫抽出日  = [""]
    key在庫日付    = [""]
		
		j = 0
		for i in 0..max単品ＩＤ do
		  if sqlRecord1["単品ＩＤ"]["value"][i] == ""
			  break
			end
			
		  dateワーク１ = Date.strptime(w_開始引当日,'%Y/%m/%d')
			
		  loop do
			
				dateワーク２ = dateワーク１.strftime("%Y/%m/%d")
				if dateワーク２ > w_終了引当日
				  break
				end
				
        key単品ＩＤ[j]   = sqlRecord1["単品ＩＤ"]["value"][i]
        key在庫抽出日[j] = dateワーク２
				
			  dateワーク１     = dateワーク１ + 1
        key在庫日付[j]   = dateワーク１.strftime("%Y/%m/%d")
				
				j = j + 1
				
		  end
			
		end
		
		sqlRecord3["単品ＩＤ"]["value"]   = key単品ＩＤ
		sqlRecord3["在庫抽出日"]["value"] = key在庫抽出日
		sqlRecord3["在庫日付"]["value"]   = key在庫日付
		
    $Mlog.debug("T_DailyPlanStockUpdate_model") {"createバッチ処理キーOf単品在庫明細更新日次処理 end"}
    return status
  end

end
