# coding: UTF-8

require 'FlowerShop/Server/Modules/FlowerShopOfBaseNameMainteOfModelMixin'

class T_EachTimePlanStockUpdate_model
  include FlowerShopOfBaseNameMainteOfModelMixin

  def initialize(rmenu_db, sql_data, request_data)
    begin
      # initialize 開始ログを出力する
      $Mlog.debug("T_EachTimePlanStockUpdate_model") {"initialize start"}                   # Logファイル Debug用

      @rmenu_db       = rmenu_db
      @sql_data       = sql_data
      @request_data   = request_data

      # initialize 終了ログを出力する
      $Mlog.debug("T_EachTimePlanStockUpdate_model") {"initialize normal end"}              # Logファイル Debug用
    rescue Exception
      # エラーログを出力する
      $Mlog.error("T_EachTimePlanStockUpdate_model") {"initialize exception: #{$!}"}        # Logファイル Debug用
      raise
    end
  end

  # バッチ処理キーの作成
  def createバッチ処理キーOf単品予定在庫更新随時処理()
    $Mlog.debug("T_DailyPlanStockUpdate_model") {"createバッチ処理キーOf単品予定在庫更新随時処理 start"}

    status = "OK"

    sqlRecord1  = getJsonChunkById(@sql_data, "sqls", "バッチキー作成１",    "output", "record")
    sqlRecord2  = getJsonChunkById(@sql_data, "sqls", "バッチキー作成２",    "output", "record")
    sqlRecord3  = getJsonChunkById(@sql_data, "sqls", "parallelKey",         "input",  "record")
		
		max単品ＩＤ = sqlRecord1["単品ＩＤ"]["value"].length - 1
		
    key単品ＩＤ = [""]
    key引当日   = [""]
		

    if sqlRecord1["単品ＩＤ"]["value"][0] == ""
		  sqlRecord3["単品ＩＤ"]["value"] = key単品ＩＤ
		  sqlRecord3["引当日"]["value"]   = key引当日
			
      $Mlog.debug("T_DailyPlanStockUpdate_model") {"createバッチ処理キーOf単品予定在庫更新日次処理 end"}
      return status
		end
		
		
		j = 0
		for i in 0..max単品ＩＤ do
		  if sqlRecord1["単品ＩＤ"]["value"][i] == ""
			  break
			end
			
			
			if sqlRecord1["最大希望納入日付"]["value"][i] > sqlRecord2["最大在庫日付"]["value"][0]
			  max最大日 = sqlRecord1["最大希望納入日付"]["value"][i]
			else
			  max最大日 = sqlRecord2["最大在庫日付"]["value"][0]
			end
			
			
			if sqlRecord1["最小希望納入日付"]["value"][i] < sqlRecord2["最大在庫日付"]["value"][0]
		    dateワーク１ = Date.strptime(sqlRecord1["最小希望納入日付"]["value"][i],'%Y/%m/%d')
			else
		    dateワーク１ = Date.strptime(sqlRecord2["最大在庫日付"]["value"][0],'%Y/%m/%d')
			end
			

		  loop do
			
				dateワーク２ = dateワーク１.strftime("%Y/%m/%d")
				if dateワーク２ > max最大日
				  break
				end
				
        key単品ＩＤ[j] = sqlRecord1["単品ＩＤ"]["value"][i]
        key引当日[j]   = dateワーク２
				j = j + 1
			  dateワーク１ = dateワーク１ + 1
				
		  end
			
		end
		
		sqlRecord3["単品ＩＤ"]["value"] = key単品ＩＤ
		sqlRecord3["引当日"]["value"]   = key引当日
		
    $Mlog.debug("T_DailyPlanStockUpdate_model") {"createバッチ処理キーOf単品予定在庫更新日次処理 end"}
    return status
  end


  # バッチ実行可否判定
  def checkバッチ実行可否判定(sqlIdName, sqlIO, sqlItemName)
    $Mlog.debug("T_DailyPlanStockUpdate_model") {"checkバッチ実行可否判定 start"}

    status = "OK"

    cond_chunk = getJsonChunkById(@sql_data, "sqls", sqlIdName, sqlIO, "record")
    checkValue = cond_chunk[sqlItemName]["value"][0]
		
    if checkValue == ""
      status = "ALLPASS"
    end

    $Mlog.debug("T_DailyPlanStockUpdate_model") {"checkバッチ実行可否判定: #{sqlIdName} #{sqlIO} #{sqlItemName} #{checkValue} #{status}"}
    $Mlog.debug("T_DailyPlanStockUpdate_model") {"checkバッチ実行可否判定 end"}
    return status
  end

end
