# coding: UTF-8

require 'FlowerShop/Server/Modules/FlowerShopOfMasterMainteOfModelMixin'

class T_PlanStockList_model
  include FlowerShopOfMasterMainteOfModelMixin

  def initialize(rmenu_dbi, sql_data, request_data)
    begin
      # initialize 開始ログを出力する
      $Mlog.debug("T_PlanStockList_model") {"initialize start"}                   # Logファイル Debug用

      @rmenu_dbi      = rmenu_dbi
      @sql_data       = sql_data
      @request_data   = request_data

      # initialize 終了ログを出力する
      $Mlog.debug("T_PlanStockList_model") {"initialize normal end"}              # Logファイル Debug用
    rescue Exception
      # エラーログを出力する
      $Mlog.error("T_PlanStockList_model") {"initialize exception: #{$!}"}        # Logファイル Debug用
      raise
    end
  end

  # SQL文の検索条件を変更する
  def setSql_商品一覧表Of加工指示書OfFlowerShop(idname1, idname2 ,genesql_freesql)
    $Mlog.debug("T_PlanStockList_model") {"setSql_商品一覧表Of加工指示書OfFlowerShop start"}                  # Logファイル Debug用

    requestInfo  = getJsonChunkById(@request_data, "records", idname1)

    searchString01  = requestInfo["record"]["検索商品ＩＤ"]["value"][0]
    searchString02  = requestInfo["record"]["検索お届け日"]["value"][0]

    sqlInfo      = getJsonChunkById(@sql_data, "sqls", idname2)

    rep = ""

    # 検索商品ＩＤ
    if searchString01 != ""
      rep = "WHERE ref_商品ＩＤ = #{searchString01}"
    end

    # 検索お届け日
    if searchString02 != ""
		  if rep == ""
        rep = "WHERE お届け日 = '#{searchString02}'"
			else
        rep = rep + "AND お届け日 = '#{searchString02}'"
			end
    end

    # 検索条件の置き換え
    if    genesql_freesql == 'genesql'
      sqlInfo["sql"]["genesql"]["where"].sub!(/WHERE &&/,rep)
    elsif genesql_freesql == 'freesql'
      strJoin = sqlInfo["sql"]["freesql"].join("\t")
      strJoin.sub!(/WHERE &&/,rep)
      strSplit = strJoin.split("\t")
      sqlInfo["sql"]["freesql"].each_with_index do |temp, idx|
        sqlInfo["sql"]["freesql"][idx] = strSplit[idx]
      end
    end

    $Mlog.debug("T_PlanStockList_model") {"setSql_商品一覧表Of加工指示書OfFlowerShop end"}                    # Logファイル Debug用
    return "OK"
  end

end
