# coding: UTF-8

require "date"
require 'RmenuJsonMixin'                                                        # ID名で該当レコードを取得する
require 'FlowerShop/Server/Modules/FlowerShopOfPrintOfFormMixin'

class T_ProcessingPrint_form
  include RmenuJsonMixin
  include FlowerShopOfPrintOfFormMixin

  def initialize(pdfcreate, response_data, sql_data, request_data)
    begin
      # initialize 開始ログを出力する
      $PDFC.debug("T_ProcessingPrint_form") {"initialize start"}                          # Logファイル Debug用

      @pdfcreate      = pdfcreate
      @response_data  = response_data
      @sql_data       = sql_data
      @request_data   = request_data
      
      # initialize 終了ログを出力する
      $PDFC.debug("T_ProcessingPrint_form") {"initialize normal end"}                     # Logファイル Debug用
    rescue Exception
      # エラーログを出力する
      $PDFC.error("T_ProcessingPrint_form") {"initialize exception: #{$!}"}               # Logファイル Debug用
      raise
    end
  end


  # ページヘッダー処理（システム日付・ページ番号）
  def page_header()
    begin
      $PDFC.debug("T_ProcessingPrint_form") {"page_header start"}                               # Logファイル Debug用

      responseRecord       = getJsonChunkById(@response_data, "records", "page_header","record")

      responseRecord["処理日付"]["value"][0] = formatDateTime(Date.today.to_s,'YYYY年M月D日')
      responseRecord["ページ"  ]["value"][0] = @pdfcreate.getTotalPageCount()

      $PDFC.debug("T_ProcessingPrint_form") {"page_header end"}                                 # Logファイル Debug用
      return "OK"
    rescue Exception
      # エラーログを出力する
      $PDFC.error("T_ProcessingPrint_form") {"page_header: #{$!}"}               # Logファイル Debug用
      raise
    end
  end
end
