# coding: UTF-8

require 'RmenuJsonMixin'                                                        # ID名で該当レコードを取得する
require 'RmenuLoggerMixin'                                                      # Logファイル Debug用
require 'base64'
require 'fileutils'
require 'date'


class T_ShippingNew_model
  include RmenuJsonMixin
  include RmenuLoggerMixin                                                      # Logファイル Debug用

  def initialize(rmenu_dbi, sql_data, request_data)
    begin
      # initialize 開始ログを出力する
      $Mlog.debug("T_ShippingNew_model") {"initialize start"}                   # Logファイル Debug用

      @rmenu_dbi      = rmenu_dbi
      @sql_data       = sql_data
      @request_data   = request_data

      # initialize 終了ログを出力する
      $Mlog.debug("T_ShippingNew_model") {"initialize normal end"}              # Logファイル Debug用
    rescue Exception
      # エラーログを出力する
      $Mlog.error("T_ShippingNew_model") {"initialize exception: #{$!}"}        # Logファイル Debug用
      raise
    end
  end

  # Base64Encode
  def setBase64DecodeOf出荷入力OfFlowerShop(reqIdName, reqItemName1, reqItemName2, reqItemName3, reqItemName4, sqlIdName, sqlItemName)
    $Mlog.debug("T_ShippingNew_model") {"setBase64DecodeOf出荷入力OfFlowerShop start"}                  # Logファイル Debug用

    requestInfo = getJsonChunkById(@request_data, "records", reqIdName)
    sqlInfo     = getJsonChunkById(@sql_data, "sqls", sqlIdName, "input")
		
		w_クレジット番号１ = requestInfo["record"]["#{reqItemName1}"]["value"][0]
		w_クレジット番号２ = requestInfo["record"]["#{reqItemName2}"]["value"][0]
		w_クレジット番号３ = requestInfo["record"]["#{reqItemName3}"]["value"][0]
		w_クレジット番号４ = requestInfo["record"]["#{reqItemName4}"]["value"][0]
		w_クレジット番号   = w_クレジット番号１ + "-" + w_クレジット番号２ + "-" + w_クレジット番号３ + "-" + w_クレジット番号４
		
		w_クレジット番号９ = Base64.encode64(w_クレジット番号)
		
		
    sqlInfo["record"]["#{sqlItemName}"]["value"][0] = w_クレジット番号９
		
    $Mlog.debug("T_ShippingNew_model") {"setBase64DecodeOf出荷入力OfFlowerShop end"}                    # Logファイル Debug用
    return "OK"
  end

  # Base64Decode
  def setBase64DecodeOf出荷入力OfFlowerShop(sqlIdName, sqlItemName)
    $Mlog.debug("T_ShippingNew_model") {"setBase64DecodeOf出荷入力OfFlowerShop start"}                  # Logファイル Debug用

    sqlInfo     = getJsonChunkById(@sql_data, "sqls", sqlIdName, "output")
		
		w_クレジット番号 = Base64.decode64(sqlInfo["record"]["#{sqlItemName}"]["value"][0])
		
    sqlInfo["record"]["#{sqlItemName}"]["value"][0] = w_クレジット番号
		
    $Mlog.debug("T_ShippingNew_model") {"setBase64DecodeOf出荷入力OfFlowerShop end"}                    # Logファイル Debug用
    return "OK"
  end

end
