# coding: UTF-8

require 'RmenuLoggerMixin'                                                      # Logファイル Debug用
require 'RmenuJsonMixin'                                                        # ID名で該当レコードを取得する
require 'base64'

module FlowerShopOfBase64Mixin
  include RmenuLoggerMixin                                                      # Logファイル Debug用
  include RmenuJsonMixin

  # Base64Encode
  def setBase64EncodeOfFlowerShop(idName, itemName)
    $Mlog.debug("FlowerShopOfBase64Mixin_model") {"setBase64EncodeOfFlowerShop start"}                  # Logファイル Debug用

    sqlRecord = getJsonChunkById(@sql_data, "sqls", idName, "input")
		
		w_クレジット番号１ = sqlRecord["record"]["#{itemName}"]["value"][0]
		w_クレジット番号２ = Base64.encode64(w_クレジット番号１)
		
    sqlRecord["record"]["#{itemName}"]["value"][0] = w_クレジット番号２
		
    $Mlog.debug("FlowerShopOfBase64Mixin_model") {"setBase64EncodeOfFlowerShop end"}                    # Logファイル Debug用
    return "OK"
  end
	
  # Base64Decode
  def setBase64DecodeOfFlowerShop(idName, itemName)
    $Mlog.debug("FlowerShopOfBase64Mixin_model") {"setBase64DecodeOfFlowerShop start"}                  # Logファイル Debug用

    sqlRecord = getJsonChunkById(@sql_data, "sqls", idName, "output")
		
		w_クレジット番号１ = sqlRecord["record"]["#{itemName}"]["value"][0]
		w_クレジット番号２ = Base64.decode64(w_クレジット番号１)
		
    sqlRecord["record"]["#{itemName}"]["value"][0] = w_クレジット番号２

    $Mlog.debug("FlowerShopOfBase64Mixin_model") {"setBase64DecodeOfFlowerShop end"}                    # Logファイル Debug用
    return "OK"
  end
	

end
