(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.AccountsReceivableList = {};

  // インスタンスプロパティを追加する
  var AppSpec = App.AppSpec = new $R.Class($R.AppSpec);
  AppSpec.fn.init = function(name) {
    $R.log("AppSpec init : start");

    this.name       = name;
    this.nextname   = "DG_320U";
    this.beforename = "";

    $R.log("AppSpec init : end");
  }

  // 共通モジュールを追加する
  AppSpec.include($R.Library.AppSpecMixin);

  AppSpec.include({
    // -----------------------------------------------------------------------------------------------
    // プログラム・JSONファイルのURL情報を定義する（サブシステム名・種類・Apps・プログラムフォルダ名）
    // -----------------------------------------------------------------------------------------------
    urlInfo: [
      {app:  "RmenuSales/Html/Apps/AccountsReceivableList/"}
     ,{json: "RmenuSales/Json/Apps/AccountsReceivableList/"}
    ]
    // --------------------------
    // JSONファイル情報を定義する
    // --------------------------
   ,jsonInfo: [
      {dataset:     "yes"}
     ,{validation:  "yes"}
    ]
    // ----------------------------------------------------------------------------------------
    // トランザクション・リクエストチェック・レスポンス編集・エラーのコールバック関数を定義する
    // ----------------------------------------------------------------------------------------
   ,requestInfo: [
    ]
    // --------------------------------------------------
    // エンター・タブとPFキーのコールバック関数を定義する
    // --------------------------------------------------
   ,enterTabPFKey: {
      Enter:true
     ,Tab:true
     ,F1:"on登録"
     ,F2:""
     ,F3:""
     ,F4:""
     ,F5:""
     ,F6:""
     ,F7:null
     ,F8:null
     ,F9:""
     ,F10:""
     ,F11:""
     ,F12:""
     ,ESC:"on戻る"
     ,Forms:0
    }
    // ----------------------------------------------------------------
    // イベント設定はセレクタ・イベント・コールバック関数の順に指定する
    // ----------------------------------------------------------------
    // NAVボタンのイベントを定義する
   ,navButtonEvent: [
      ["#戻る",             "click", "on戻る"]
     //,["#登録",             "click", "on登録"]
     //,["#転用",             "click", "on転用"]
     //,["#訂正",             "click", "on訂正"]
     //,["#削除",             "click", "on削除"]
     //,["#照会",             "click", "on照会"]
     //,["#最初のページ",     "click", "on最初のページ"]
     //,["#前のページ",       "click", "on前のページ"]
     //,["#次のページ",       "click", "on次のページ"]
     //,["#最後のページ",     "click", "on最後のページ"]
     //,["#表示順再設定",     "click", "on表示順再設定"]
     //,["#mainTable td",     "click", "onテーブル行クリック"]
     // ここから追加処理
     //,["#検索",             "click", "on検索"]
     ,["#検索文字列クリア", "click", "on検索文字列クリア"]
     ,["#売掛金補助元帳", "click", "on売掛金補助元帳"]
		 ]
    // バリデーションのイベントを定義する
   ,validationEvent: [
      ["#mainForm", "focus", "onFocus"]
     ,["#mainForm", "blur",  "onBlur"]
    ]
    // その他セレクターイベントを定義する
   ,selectorEvent: [
    // ここから追加処理
    ]
    // ----------------------------------------------------------------------------------
    // カスタムイベント設定はイベント名・実行コンテキスト・コールバック関数の順に指定する
    // ----------------------------------------------------------------------------------
    // チェック用カスタムイベントを定義する
   ,pubsubCheckEvent: [
    ]
    // 導出項目編集用カスタムイベントを定義する
   ,pubsubDeriveEvent: [
      ["deriveトータル件数", "model", "onDeriveトータル件数"]
    ]
    // その他カスタムイベントを定義する
   ,pubsubOtherEvent: [
      ["showログイン情報",     "view", "showログイン情報"]
     ,["show初期処理",         "view", "show初期処理"]
     ,["showページ情報",       "view", "showページ情報"]
     ,["onテーブル表示",       "view", "onテーブル表示"]
     ,["onテーブル行クリック", "view", "onテーブル行クリック"]
     // ここから追加処理
     ,["on検索文字列クリア",   "view", "on検索文字列クリア"]
     ,["on検索文字列表示",     "view", "on検索文字列表示"]
    ]
    // ----------------------------------------------------------------------------------
    // セレクトボックス　定義
    // selectorid  : HTMLのIDを指定する
    // selectorname: HTMLのnameを指定する（テーブル内で使用する時に定義する）
    // init        :
    // initvalue   : 初期値（０）
    // inithtml    : 初期表示（～選択）
    // datasetid   : datasetのID名を指定する
    // valuename   : datasetに定義されているキー値の項目名
    // htmlname    : datasetに定義されている表示用データの項目名
    // change      :
    // datasetid   : datasetのID名を指定する
    // valuename   : 選択したキー値を格納するdatasetの項目名
    // htmlname    : 選択した表示値を格納するdatasetの項目名
    // ----------------------------------------------------------------------------------
   ,selectbox: [
      {
          selectorid: "検索サブシステム選択"
         ,selectorname: ""
         ,init:     {initvalue: "", inithtml: "サブシステム選択", datasetid: "サブシステム", valuename: "選択サブシステムＮｏ", htmlname: "選択サブシステム名称"}
         ,change:   {datasetid: "header", valuename: "検索サブシステムＮｏ", htmlname: "検索サブシステム名称"}
      }
     ,{
          selectorid: "検索管理単位選択"
         ,selectorname: ""
         ,init:     {initvalue: "", inithtml: "管理単位選択", datasetid: "管理単位", valuename: "選択管理単位Ｎｏ", htmlname: "選択管理単位名称"}
         ,change:   {datasetid: "header", valuename: "検索管理単位Ｎｏ", htmlname: "検索管理単位名称"}
      }
     ,{
          selectorid: "検索システム入出力選択"
         ,selectorname: ""
         ,init:     {initvalue: "", inithtml: "システム入出力選択", datasetid: "システム入出力", valuename: "選択システム入出力Ｎｏ", htmlname: "選択システム入出力名称"}
         ,change:   {datasetid: "header", valuename: "検索システム入出力Ｎｏ", htmlname: "検索システム入出力名称"}
      }
     ,{
          selectorid: "検索インタフェース選択"
         ,selectorname: ""
         ,init:     {initvalue: "", inithtml: "インタフェース選択", datasetid: "インタフェース", valuename: "選択インタフェースＮｏ", htmlname: "選択インタフェース名称"}
         ,change:   {datasetid: "header", valuename: "検索インタフェースＮｏ", htmlname: "検索インタフェース名称"}
      }
		]
  });
}(jQuery, Rmenu));