(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.BillingAmountList;

  // インスタンスプロパティを追加する
  var Controller = App.Controller = new $R.Class($R.Controller);
  Controller.fn.init = function(appspec, model, view) {
    $R.log("Controllerr init : start");

    this.appspec = appspec;
    this.model   = model;
    this.view    = view;
    this.createPubSubEvent();

    var self = this;

    var api1 = $('#datetimepicker').datetimepicker({
	      format : 'yyyy/MM/dd',
        language : 'ja',
      	pickTime : false
    }).data('datetimepicker');
    api1.widget.on('click','td.day',function(){
      	api1.hide();
        self.onChange請求発行日付();
    });


    $R.log("Controllerr init : end");
  };

  // 共通モジュールを追加する
  Controller.include($R.Library.EnterTabPFKeyMixin);
  Controller.include($R.Library.ControllerMixin);

  // 基本名称メンテ　パターン　ミックスインを追加する
  Controller.include($R.Library.MasterMainteListControllerMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Controller.include({
    // ---------------------------------------
    // 初期処理
    // ---------------------------------------
    on初期処理: function() {
      $R.log("Controller on初期処理 : start");

      this.model.on初期処理();

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var w_契約者ＩＤ = sessionStorage.loadItem("契約者ＩＤ");
      if (w_契約者ＩＤ){
        this.onリロード();
      }

      $R.log("Controller on初期処理 : end");
    }
    // ---------------------------
    //  リロード処理
    // ---------------------------
   ,onリロード: function() {
      $R.log("Controller onリロード : start");

      var arg = this.model.onリロード();
			this.view.onリロード(arg);
      this.ajaxExecute("select");

      $R.log("Controller onリロード : end");
    }
		
    // -------------------------------------
    // チェンジ イベント処理（追加処理）
    // -------------------------------------
   ,onChange請求発行日付: function() {
      $R.log("Controller onChange請求発行日付 : start");
			
			this.model.onChange請求発行日付();

      $R.log("Controller onChange請求発行日付 : end");
    }
		
    // ---------------------------------------
    // ボタン・ファンクションキー イベント処理
    // ---------------------------------------
   ,on検索契約者: function(event, arg) {
      $R.log("Controller on検索契約者 : start");

      if (arg === undefined) {
        // セッションデータに識別名を設定する
        sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);


			  // コールバックＩＤを設定する
        sessionStorage.setIdName(this.appspec.sysname + "." + "ContractantListSearch");
        sessionStorage.saveItem("コールバックＩＤ", "#検索契約者");

        var argWin = "fullscreen=1, scrollbars=1";
        this.model.postPopupTransition("RmenuSales/Html/Apps/ContractantListSearch", argWin);
				
				
        //this.model.setTransitionData("RmenuSales/Html/Apps/MoneyReceivedInputList");
        //this.model.postHtmlTransition("RmenuSales/Html/Apps/ContractantListSearch");

      }
      else {
        this.model.on検索契約者(arg);
        this.view.on検索契約者(arg);
      }

      $R.log("Controller on検索契約者 : end");
    }
   ,onクリア: function(event) {
      $R.log("Controller onクリア : start");

      this.model.onクリア();
      this.view.onクリア();

      $R.log("Controller onクリア : end");
    }
		
   ,on検索: function(event) {
      $R.log("Controller on検索 : start");

      this.ajaxExecute("select");

      $R.log("Controller on検索 : end");
    }
		
   ,on請求書: function(event) {
      $R.log("Controller on請求書 : start");

			var status = this.model.check行選択();
			if (!status) {
				return;
			}
			
      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      this.model.on請求書();

      this.model.setTransitionData("RmenuSales/Html/Apps/BillingAmountList");
      this.model.postHtmlTransition("RmenuSales/Html/Apps/BillingStatement");

      $R.log("Controller on請求書 : end");
    }

		,on印刷: function(event) {
      $R.log("Controller on印刷 : start");

      this.ajaxExecute("print");

      $R.log("Controller on印刷 : end");
    }
		
    // -------------------------------------
    //  リクエストデータ　編集・チェック処理
    // -------------------------------------
   ,on照会OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on照会OfCheckRequestData : start");

			this.model.on照会OfCheckRequestData(requestData);
      var status = this.checkRequestData(requestData);

      $R.log("Controller on照会OfCheckRequestData : end");
      return status;
    }
   ,on印刷OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on印刷OfCheckRequestData : start");

			this.model.on印刷OfCheckRequestData(requestData);
      var status = this.checkRequestData(requestData);

      $R.log("Controller on印刷OfCheckRequestData : end");
      return status;
    }
		
    // -------------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------------
   ,on照会OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on照会OfEditResponseData : start");

      this.editResponseData(responseData);
      var arg = this.model.on照会OfEditResponseData(responseData);
      this.view.on照会OfEditResponseData(arg);

      $R.log("Controller on照会OfEditResponseData : end");
    }
		
   ,on印刷OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on印刷OfEditResponseData : start");

      this.editResponseData(responseData);
      this.model.on印刷OfEditResponseData(responseData, mode);

      $R.log("Controller on印刷OfEditResponseData : end");
    }
		
  });

}(jQuery, Rmenu));