(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.BillingAmountList;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // 基本名称メンテ　パターン　ミックスインを追加する
  Model.include($R.Library.MasterMainteListModelMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Model.include({
    // ---------------------------
    //  リロード処理
    // ---------------------------
    onリロード: function() {
      $R.log("Model onリロード : start");

      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      var w_検索契約区分               = sessionStorage.loadItem("検索契約区分");
      var w_検索アカウント発行区分ＩＤ = sessionStorage.loadItem("検索アカウント発行区分ＩＤ");
      var w_検索契約者ＩＤ             = sessionStorage.loadItem("検索契約者ＩＤ");
      var w_検索契約者名               = sessionStorage.loadItem("検索契約者名");
      var w_請求発行日付               = sessionStorage.loadItem("請求発行日付");

      this.dataset.setElementData(w_検索契約区分, "検索契約区分");
      this.dataset.setElementData(w_検索アカウント発行区分ＩＤ, "検索アカウント発行区分ＩＤ");
      this.dataset.setElementData(w_検索契約者ＩＤ, "検索契約者ＩＤ");
      this.dataset.setElementData(w_検索契約者名, "検索契約者名");
      this.dataset.setElementData(w_請求発行日付, "請求発行日付");

			var arg                           = {};
			arg["検索契約区分"]               = w_検索契約区分;
			arg["検索アカウント発行区分ＩＤ"] = w_検索アカウント発行区分ＩＤ;
			arg["検索契約者ＩＤ"]             = w_検索契約者ＩＤ;
			arg["検索契約者名"]               = w_検索契約者名;
			arg["請求発行日付"]               = w_請求発行日付;
			
			
      $R.log("Model onリロード : end");
			return arg;
    }
    // ---------------------------------------
    // ボタン・ファンクションキー イベント処理
    // ---------------------------------------
   ,on検索契約者: function(arg) {
      $R.log("Model on検索契約者 : start");

      this.dataset.setElementData(arg["契約区分"], "検索契約区分");
      this.dataset.setElementData(arg["アカウント発行区分ＩＤ"], "検索アカウント発行区分ＩＤ");
      this.dataset.setElementData(arg["契約者ＩＤ"], "検索契約者ＩＤ");
      this.dataset.setElementData(arg["会社名"], "検索契約者名");

      $R.log("Model on検索契約者 : end");
    }
   ,onクリア: function(event) {
      $R.log("Model onクリア : start");

      this.dataset.setElementData("", "検索契約区分");
      this.dataset.setElementData("", "検索アカウント発行区分ＩＤ");
      this.dataset.setElementData("", "検索契約者ＩＤ");
      this.dataset.setElementData("", "検索契約者名");
      this.dataset.setElementData("", "請求発行日付");

      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      sessionStorage.saveItem("クリック行", "");

      $R.log("Model onクリア : end");
    }
		
   ,on検索: function(event) {
      $R.log("Model on検索 : start");

      $R.log("Model on検索 : end");
    }
		
   ,on請求書: function(event) {
      $R.log("Model on請求書 : start");

      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var dataset      = this.dataset.getData();
      var headerRecord = this.appspec.getJSONChunkByIdAtRecords(dataset, "header")["record"];
      var detailRecord = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail")["record"];
      var clickRow     = Number(sessionStorage.loadItem("クリック行"));

      // セッションデータに識別名を設定する
			var w_検索契約区分               = headerRecord["検索契約区分"]["value"][0];
			var w_検索アカウント発行区分ＩＤ = headerRecord["検索アカウント発行区分ＩＤ"]["value"][0];
			var w_検索契約者ＩＤ             = headerRecord["検索契約者ＩＤ"]["value"][0];
			var w_検索契約者名               = headerRecord["検索契約者名"]["value"][0];
			var w_請求発行日付               = headerRecord["請求発行日付"]["value"][0];
			
      sessionStorage.saveItem("検索契約区分", w_検索契約区分);
      sessionStorage.saveItem("検索アカウント発行区分ＩＤ", w_検索アカウント発行区分ＩＤ);
      sessionStorage.saveItem("検索契約者ＩＤ", w_検索契約者ＩＤ);
      sessionStorage.saveItem("検索契約者名", w_検索契約者名);
      sessionStorage.saveItem("請求発行日付", w_請求発行日付);

			var w_契約区分               = detailRecord["契約区分"]["value"][clickRow];
			var w_アカウント発行区分ＩＤ = detailRecord["アカウント発行区分ＩＤ"]["value"][clickRow];
			var w_契約者ＩＤ             = detailRecord["契約者ＩＤ"]["value"][clickRow];
			var w_請求日付               = detailRecord["請求日付"]["value"][clickRow];
			
      sessionStorage.saveItem("契約区分", w_契約区分);
      sessionStorage.saveItem("アカウント発行区分ＩＤ", w_アカウント発行区分ＩＤ);
      sessionStorage.saveItem("契約者ＩＤ", w_契約者ＩＤ);
      sessionStorage.saveItem("請求日付", w_請求日付);
			
			
      // セッションデータに次画面用の識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.nextname);
			
      sessionStorage.saveItem("契約区分", w_契約区分);
      sessionStorage.saveItem("アカウント発行区分ＩＤ", w_アカウント発行区分ＩＤ);
      sessionStorage.saveItem("契約者ＩＤ", w_契約者ＩＤ);
      sessionStorage.saveItem("請求日付", w_請求日付);

      $R.log("Model on請求書 : end");
    }

    // -------------------------------------
    // チェンジ イベント処理（追加処理）
    // -------------------------------------
   ,onChange請求発行日付: function() {
      $R.log("Model onChange請求発行日付 : start");
			
			var w_請求発行日付 = $("#請求発行日付").val();
      this.dataset.setElementData(w_請求発行日付, "請求発行日付");

      $R.log("Model onChange請求発行日付 : end");
    }
		
    // -------------------------------------------------------
    //  テーブルの選択行をセッションストレージに格納する
    // -------------------------------------------------------
   ,onテーブル行クリック: function(arg) {
      $R.log("Model onテーブル行クリック : start");

      var clickRow  = arg["クリック行"] - 1;
      this.pubsub.publish("onテーブル行クリック", arg);
			

      $R.log("Model onテーブル行クリック : end");
    }

    // -------------------------------------------------------
    //  データが選択されているかチェックする
    // -------------------------------------------------------
   ,check行選択: function() {
      $R.log("Model check行選択 : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var value = sessionStorage.loadItem("クリック行");
			
			if (!isNaN(value)) {
		    if (value != "") {
					return true;
			  }
			}
			
      var arg = {};
      arg["title"]   = "選択エラー";
      arg["status"]  = "ERROR";
      arg["message"] = "行が選択されていません。選択して下さい。";
      this.pubsub.publish("alertDialog", arg);

      $R.log("Model check行選択 : end");
      return false;
    }

    // -------------------------------------
    //  リクエストデータ　編集・チェック処理
    // -------------------------------------
   ,on照会OfCheckRequestData: function(requestData) {
      $R.log("Model on照会OfCheckRequestData : start");

			var w_請求発行日付   = $("#請求発行日付").val();

      var headerRecord = this.appspec.getJSONChunkByIdAtRecords(requestData, "header")["record"];
      headerRecord["請求発行日付"]["value"][0]   = w_請求発行日付;				

      $R.log("Model on照会OfCheckRequestData : end");
    }
		
   ,on印刷OfCheckRequestData: function(requestData) {
      $R.log("Model on印刷OfCheckRequestData : start");

      var dataset       = this.dataset.getData();
      var datasetRecord = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail")["record"];

			// レスポンスデータの明細行を取得する
      var detailRecord  = this.appspec.getJSONChunkByIdAtRecords(requestData, "queryCondition")["record"];
			
			// リクエストデータのクリア
			detailRecord["検索契約区分"]["value"]               = new Array("");
			detailRecord["検索アカウント発行区分ＩＤ"]["value"] = new Array("");
			detailRecord["検索契約者ＩＤ"]["value"]             = new Array("");
			detailRecord["請求発行日付"]["value"]               = new Array("");
			
			var max           = datasetRecord["契約者ＩＤ"]["value"].length;
			for (var i = 0; i < max; i++) {
				if (datasetRecord["契約者ＩＤ"]["value"][i] == "") {
					break;
				}
				
			  detailRecord["検索契約区分"]["value"][i]               = datasetRecord["契約区分"]["value"][i];
			  detailRecord["検索アカウント発行区分ＩＤ"]["value"][i] = datasetRecord["アカウント発行区分ＩＤ"]["value"][i];
			  detailRecord["検索契約者ＩＤ"]["value"][i]             = datasetRecord["契約者ＩＤ"]["value"][i];
			  detailRecord["請求発行日付"]["value"][i]               = datasetRecord["請求日付"]["value"][i];
			}
			

      $R.log("Model on印刷OfCheckRequestData : end");
    }
		
    // -------------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------------
   ,on照会OfEditResponseData: function(responseData) {
      $R.log("Model on照会OfEditResponseData : start");
			
			// 明細のデフォルト行を取得する
      var dataset       = this.dataset.getData();
      var datasetRecord = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
      var defaultline   = datasetRecord["defaultline"];
			
			// レスポンスデータの明細行を取得する
      var detailRecord  = this.appspec.getJSONChunkByIdAtRecords(responseData, "detail");
			

			var arg = {};
			arg["テーブルＩＤ"] = "#mainTable";
			arg["表示データ"]   = detailRecord;
			arg["デフォルト行"] = defaultline;

      $R.log("Model on照会OfEditResponseData : end");
			return arg;
    }
   ,on印刷OfEditResponseData: function(responseData, mode) {
      $R.log("Model on印刷OfEditResponseData : start");

      var argHash  = new Object();
      argHash["file"  ] = responseData["pdfinfo"]["pdffile"];
      argHash["type"  ] = "pdf";
      argHash["delete"] = "yes";
      this.postDownloadRack(argHash);

      $R.log("Model on印刷OfEditResponseData : end");
    }

	});

}(jQuery, Rmenu));