(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.BillingAmountList;

  // インスタンスプロパティを追加する
  var View = App.View = new $R.Class($R.View);
  View.fn.init = function(appspec) {
    $R.log("View init : start");

    this.appspec = appspec;

    $R.log("View init : end");
  }

  // 共通モジュールを追加する
  View.include($R.Library.FormatMixin);
  View.include($R.Library.OutlineMixin);
  View.include($R.Library.LoadTemplateMixin);
  View.include($R.Library.ViewMixin);

  // 基本名称メンテ　パターン　ミックスインを追加する
  View.include($R.Library.MasterMainteListViewMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  View.include({
    // ---------------------------
    //  リロード処理
    // ---------------------------
    onリロード: function(arg) {
      $R.log("View onリロード : start");

      $("#請求発行日付").val(arg["請求発行日付"]);
			$("#検索契約者名").val(arg["検索契約者名"]);

      $R.log("View onリロード : end");
    }
    // ---------------------------------------
    // ボタン・ファンクションキー イベント処理
    // ---------------------------------------
   ,on検索契約者: function(arg) {
      $R.log("View on検索契約者 : start");
			
			$("#検索契約者名").val(arg["会社名"]);

      $R.log("View on検索契約者 : end");
    }
    ,onクリア: function(arg) {
      $R.log("View onクリア : start");

      $("#請求発行日付").val("");
			$("#検索契約者名").val("");

      $R.log("View onクリア : end");
    }
    // -------------------------
    //  テーブル行　クリック処理
    // -------------------------
    ,onテーブル行クリック: function(arg) {
      $R.log("View onTableRowClick : start");

      var clickRow  = arg["クリック行"] - 1;

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      // 選択行にCSSクラスを設定する
      var j, k;
      var beforeRow = sessionStorage.loadItem("クリック行");
      var rows = $("#mainTable")[0].rows;
      jQuery.each(rows, function(j) {
        k = j - 1;
        var cells = rows[j].cells;
        jQuery.each(cells, function() {
          if (k == beforeRow) {
            $(this).removeClass("rowBackground");
           }
          if (k == clickRow) {
            $(this).addClass("rowBackground");
          }
        });
      });

      sessionStorage.saveItem("クリック行", clickRow);

      $R.log("View onTableRowClick : end");
     }
    // -------------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------------
   ,on照会OfEditResponseData: function(arg) {
      $R.log("View on照会OfEditResponseData : start");
			
			this.showTableALLData(arg);

      $R.log("View on照会OfEditResponseData : end");
    }

	});

}(jQuery, Rmenu));