(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.BillingCancelClosingDays;

  // インスタンスプロパティを追加する
  var Controller = App.Controller = new $R.Class($R.Controller);
  Controller.fn.init = function(appspec, model, view) {
    $R.log("Controllerr init : start");

    this.appspec = appspec;
    this.model   = model;
    this.view    = view;
    this.createPubSubEvent();

    var self = this;

    var api1 = $('#datetimepicker').datetimepicker({
	      format : 'yyyy/MM/dd',
        language : 'ja',
      	pickTime : false
    }).data('datetimepicker');
    api1.widget.on('click','td.day',function(){
      	api1.hide();
        self.onChange請求発行日付();
    });


    $R.log("Controllerr init : end");
  };

  // 共通モジュールを追加する
  Controller.include($R.Library.EnterTabPFKeyMixin);
  Controller.include($R.Library.ControllerMixin);

  // 基本名称メンテ　パターン　ミックスインを追加する
  Controller.include($R.Library.BaseNameMainteControllerMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Controller.include({
    // ---------------------------------------
    // 初期処理
    // ---------------------------------------
    on初期処理: function() {
      $R.log("Controller on初期処理 : start");

      this.model.on初期処理();

      $R.log("Controller on初期処理 : end");
    }
		
    // -------------------------------------
    // チェンジ イベント処理（追加処理）
    // -------------------------------------
   ,onChange請求発行日付: function() {
      $R.log("Controller onChange請求発行日付 : start");
			
			this.model.onChange請求発行日付();

      $R.log("Controller onChange請求発行日付 : end");
    }
		
    // ---------------------------------------
    // ボタン・ファンクションキー イベント処理
    // ---------------------------------------
   ,onクリア: function(event) {
      $R.log("Controller onクリア : start");

      this.model.onクリア();
      this.view.onクリア();

      $R.log("Controller onクリア : end");
    }
		
   ,on検索: function(event) {
      $R.log("Controller on検索 : start");

      this.ajaxExecute("select");

      $R.log("Controller on検索 : end");
    }
		
   ,on実行前処理: function(event, arg) {
      $R.log("Controller on実行前処理 : start");

			var arg = {};
			arg["title"]   = "実行確認";
			arg["message"] = "請求取消処理を実行してもよろしいですか？";
			
			this.pubsub.publish("executeDialog", arg);

      $R.log("Controller on実行前処理 : end");
    }
		
   ,on実行: function(event, arg) {
      $R.log("Controller on実行 : start");

      this.ajaxExecute("execute");

      $R.log("Controller on実行 : end");
    }
		
    // -------------------------------------
    //  リクエストデータ　編集・チェック処理
    // -------------------------------------
   ,on照会OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on照会OfCheckRequestData : start");

			this.model.on照会OfCheckRequestData(requestData, mode);
      var status = this.checkRequestData(requestData);

      $R.log("Controller on照会OfCheckRequestData : end");
      return status;
    }
   ,on実行処理OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on実行処理OfCheckRequestData : start");

			this.model.on実行処理OfCheckRequestData(requestData, mode);
      var status = this.checkRequestData(requestData);

      $R.log("Controller on実行処理OfCheckRequestData : end");
      return status;
    }
		
    // -------------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------------
   ,on照会OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on照会OfEditResponseData : start");

      this.editResponseData(responseData);
      var arg = this.model.on照会OfEditResponseData(responseData);
      this.view.on照会OfEditResponseData(arg);

      $R.log("Controller on照会OfEditResponseData : end");
    }
   ,on実行処理OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on実行処理OfEditResponseData : start");

      var status = responseData["message"]["status"];
      var msg    = responseData["message"]["msg"];
      var arg    = {title: "サーバ処理確認", status: status, message: msg};
      this.pubsub.publish("serverDialog", arg);

      $R.log("Controller on実行処理OfEditResponseData : end");
    }
		
  });

}(jQuery, Rmenu));