(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.BillingIssueClosingDays;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // 基本名称メンテ　パターン　ミックスインを追加する
  Model.include($R.Library.BaseNameMainteModelMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Model.include({
    // ---------------------------------------
    // ボタン・ファンクションキー イベント処理
    // ---------------------------------------
    onクリア: function(event) {
      $R.log("Model onクリア : start");

      this.dataset.setElementData("", "請求発行日付");
      this.dataset.setElementData("", "請求締切日ＩＤ");

      $R.log("Model onクリア : end");
    }
		
   ,on検索: function(event) {
      $R.log("Model on検索 : start");

      $R.log("Model on検索 : end");
    }
		
   ,on実行: function(event) {
      $R.log("Model on実行 : start");

      $R.log("Model on実行 : end");
    }
		
    // -------------------------------------
    // チェンジ イベント処理（追加処理）
    // -------------------------------------
   ,onChange請求発行日付: function() {
      $R.log("Model onChange請求発行日付 : start");
			
			var w_請求発行日付 = $("#請求発行日付").val();
      this.dataset.setElementData(w_請求発行日付, "請求発行日付");

      $R.log("Model onChange請求発行日付 : end");
    }
		
   ,onChange請求締切日選択: function() {
      $R.log("Model onChange請求締切日選択 : start");
			
			var w_請求締切日ＩＤ = $("#請求締切日選択").val();
      this.dataset.setElementData(w_請求締切日ＩＤ, "請求締切日ＩＤ");

      $R.log("Model onChange請求締切日選択 : end");
    }
		
    // ------------------------------------------------------------------------
    // 処理起動確認ダイアログ後の処理
    // ------------------------------------------------------------------------
   ,onExecuteDialogAfter: function() {
      $R.log("Model onExecuteDialogAfter : start");

      var yesno = sessionStorage.getItem("executeDialog");

      if (yesno == 1){
				
        var arg = {};
        this.pubsub.publish("on実行",arg);
      }

      $R.log("Model onExecuteDialogAfter : end");
    }
		
    // -------------------------------------
    //  リクエストデータ　編集・チェック処理
    // -------------------------------------
   ,on照会OfCheckRequestData: function(requestData, mode) {
      $R.log("Model on照会OfCheckRequestData : start");

			var w_請求発行日付   = $("#請求発行日付").val();
			var w_請求締切日ＩＤ = $("#請求締切日選択").val();

      var headerRecord = this.appspec.getJSONChunkByIdAtRecords(requestData, "header")["record"];
      headerRecord["請求発行日付"]["value"][0]   = w_請求発行日付;				
      headerRecord["請求締切日ＩＤ"]["value"][0] = w_請求締切日ＩＤ;				

      $R.log("Model on照会OfCheckRequestData : end");
    }
		
   ,on実行処理OfCheckRequestData: function(requestData, mode) {
      $R.log("Model on実行処理OfCheckRequestData : start");

      var loginRecord  = this.appspec.getJSONChunkByIdAtRecords(requestData, "login")["record"];
      var headerRecord = this.appspec.getJSONChunkByIdAtRecords(requestData, "header")["record"];

      // ログイン情報を設定する
      sessionStorage.setIdName(this.appspec.sysname + ".Login");
      loginRecord["ユーザＩＤ"]["value"][0] = sessionStorage.loadItem("ユーザＩＤ");
      loginRecord["ユーザ名称"]["value"][0] = sessionStorage.loadItem("ユーザ名称");
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);


			var w_請求発行日付   = $("#請求発行日付").val();
			var w_請求締切日ＩＤ = $("#請求締切日選択").val();

      var headerRecord = this.appspec.getJSONChunkByIdAtRecords(requestData, "header")["record"];
      headerRecord["請求発行日付"]["value"][0]   = w_請求発行日付;				
      headerRecord["請求締切日ＩＤ"]["value"][0] = w_請求締切日ＩＤ;				

      $R.log("Model on実行処理OfCheckRequestData : end");
    }
		
    // -------------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------------
   ,on照会OfEditResponseData: function(responseData) {
      $R.log("Model on照会OfEditResponseData : start");
			
			// レスポンスデータの明細行を取得する
      var detailRecord  = this.appspec.getJSONChunkByIdAtRecords(responseData, "detail");
			
			// 明細のデフォルト行を取得する
      var dataset       = this.dataset.getData();
      var datasetRecord = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
      var defaultline   = datasetRecord["defaultline"];

			var arg = {};
			arg["テーブルＩＤ"] = "#mainTable";
			arg["表示データ"]   = detailRecord;
			arg["デフォルト行"] = defaultline;

      $R.log("Model on照会OfEditResponseData : end");
			return arg;
    }

	});

}(jQuery, Rmenu));