(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.BillingIssueCustomer;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // 基本名称メンテ　パターン　ミックスインを追加する
  Model.include($R.Library.BaseNameMainteModelMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Model.include({
    // ---------------------------------------
    // ボタン・ファンクションキー イベント処理
    // ---------------------------------------
    onクリア: function(event) {
      $R.log("Model onクリア : start");

      this.dataset.setElementData("", "請求発行日付");
			
      var dataset       = this.dataset.getData();
      var datasetRecord = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail1");
			
			datasetRecord["record"]["契約区分１"]["value"]               = new Array("");
      datasetRecord["record"]["アカウント発行区分ＩＤ１"]["value"] = new Array("");
			datasetRecord["record"]["契約者ＩＤ１"]["value"]             = new Array("");
			datasetRecord["record"]["契約者氏名１"]["value"]             = new Array("");
			datasetRecord["record"]["郵便番号１"]["value"]               = new Array("");
			datasetRecord["record"]["住所１"]["value"]                   = new Array("");

      $R.log("Model onクリア : end");
			return datasetRecord;
    }
		
   ,on検索: function(event) {
      $R.log("Model on検索 : start");

      $R.log("Model on検索 : end");
    }
		
   ,on得意先追加: function(arg) {
      $R.log("Controller on得意先追加 : start");
			
			var w_契約区分               = new Array("");
			var w_アカウント発行区分ＩＤ = new Array("");
			var w_契約者ＩＤ             = new Array("");
			var w_契約者氏名             = new Array("");
			var w_郵便番号               = new Array("");
			var w_住所                   = new Array("");
			
      var dataset       = this.dataset.getData();
      var datasetRecord = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail1");
			var maxSize       = datasetRecord["record"]["契約者ＩＤ１"]["value"].length;
			var j             = -1;
			for (var i = 0; i < maxSize; i++) {
				if(datasetRecord["record"]["契約者ＩＤ１"]["value"][i] == "") {
					continue;
				}
				
			  j++;
			  w_契約区分[j]               = datasetRecord["record"]["契約区分１"]["value"][i];
			  w_アカウント発行区分ＩＤ[j] = datasetRecord["record"]["アカウント発行区分ＩＤ１"]["value"][i];
			  w_契約者ＩＤ[j]             = datasetRecord["record"]["契約者ＩＤ１"]["value"][i];
			  w_契約者氏名[j]             = datasetRecord["record"]["契約者氏名１"]["value"][i];
			  w_郵便番号[j]               = datasetRecord["record"]["郵便番号１"]["value"][i];
			  w_住所[j]                   = datasetRecord["record"]["住所１"]["value"][i];
			}
			
			j++;
			w_契約区分[j]               = arg["契約区分"];
			w_アカウント発行区分ＩＤ[j] = arg["アカウント発行区分ＩＤ"];
			w_契約者ＩＤ[j]             = arg["契約者ＩＤ"];
			w_契約者氏名[j]             = arg["会社名"];
			w_郵便番号[j]               = arg["郵便番号"];
			w_住所[j]                   = arg["住所"];
			
			datasetRecord["record"]["契約区分１"]["value"]               = w_契約区分;
      datasetRecord["record"]["アカウント発行区分ＩＤ１"]["value"] = w_アカウント発行区分ＩＤ;
			datasetRecord["record"]["契約者ＩＤ１"]["value"]             = w_契約者ＩＤ;
			datasetRecord["record"]["契約者氏名１"]["value"]             = w_契約者氏名;
			datasetRecord["record"]["郵便番号１"]["value"]               = w_郵便番号;
			datasetRecord["record"]["住所１"]["value"]                   = w_住所;

			$R.log("Controller on得意先追加 : end");
			return datasetRecord;
    }

		,on実行: function(event) {
      $R.log("Model on実行 : start");

      $R.log("Model on実行 : end");
    }
		
    // -------------------------------------
    // チェンジ イベント処理（追加処理）
    // -------------------------------------
   ,onChange請求発行日付: function() {
      $R.log("Model onChange請求発行日付 : start");
			
			var w_請求発行日付 = $("#請求発行日付").val();
      this.dataset.setElementData(w_請求発行日付, "請求発行日付");

      $R.log("Model onChange請求発行日付 : end");
    }
		
    // ------------------------------------------------------------------------
    // 処理起動確認ダイアログ後の処理
    // ------------------------------------------------------------------------
   ,onExecuteDialogAfter: function() {
      $R.log("Model onExecuteDialogAfter : start");

      var yesno = sessionStorage.getItem("executeDialog");

      if (yesno == 1){
				
        var arg = {};
        this.pubsub.publish("on実行",arg);
      }

      $R.log("Model onExecuteDialogAfter : end");
    }
		
    // -------------------------------------
    //  リクエストデータ　編集・チェック処理
    // -------------------------------------
   ,on照会OfCheckRequestData: function(requestData, mode) {
      $R.log("Model on照会OfCheckRequestData : start");

      $R.log("Model on照会OfCheckRequestData : end");
    }
		
   ,on実行処理OfCheckRequestData: function(requestData, mode) {
      $R.log("Model on実行処理OfCheckRequestData : start");

      var loginRecord  = this.appspec.getJSONChunkByIdAtRecords(requestData, "login")["record"];
      var headerRecord = this.appspec.getJSONChunkByIdAtRecords(requestData, "header")["record"];

      // ログイン情報を設定する
      sessionStorage.setIdName(this.appspec.sysname + ".Login");
      loginRecord["ユーザＩＤ"]["value"][0] = sessionStorage.loadItem("ユーザＩＤ");
      loginRecord["ユーザ名称"]["value"][0] = sessionStorage.loadItem("ユーザ名称");
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);


			var w_請求発行日付   = $("#請求発行日付").val();

      var headerRecord = this.appspec.getJSONChunkByIdAtRecords(requestData, "header")["record"];
      headerRecord["請求発行日付"]["value"][0]   = w_請求発行日付;				

      $R.log("Model on実行処理OfCheckRequestData : end");
    }
		
    // -------------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------------
   ,on照会OfEditResponseData: function(responseData) {
      $R.log("Model on照会OfEditResponseData : start");
			
			// レスポンスデータの明細行を取得する
      var detailRecord  = this.appspec.getJSONChunkByIdAtRecords(responseData, "detail2");
			
			// 明細のデフォルト行を取得する
      var dataset       = this.dataset.getData();
      var datasetRecord = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail2");
      var defaultline   = datasetRecord["defaultline"];

			var arg = {};
			arg["テーブルＩＤ"] = "#mainTable2";
			arg["表示データ"]   = detailRecord;
			arg["デフォルト行"] = defaultline;

      $R.log("Model on照会OfEditResponseData : end");
			return arg;
    }

	});

}(jQuery, Rmenu));