(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.BillingIssueCustomer;

  // インスタンスプロパティを追加する
  var View = App.View = new $R.Class($R.View);
  View.fn.init = function(appspec) {
    $R.log("View init : start");

    this.appspec = appspec;

    $R.log("View init : end");
  }

  // 共通モジュールを追加する
  View.include($R.Library.FormatMixin);
  View.include($R.Library.OutlineMixin);
  View.include($R.Library.LoadTemplateMixin);
  View.include($R.Library.ViewMixin);

  // 基本名称メンテ　パターン　ミックスインを追加する
  View.include($R.Library.BaseNameMainteViewMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  View.include({
    // --------
    // 処理開始
    // --------
    initExecute: function(dataset) {
      $R.log("View initExecute : start");

      this.initテンプレートロード();
      this.initAlertDialog();                     // 警告メッセージ用ダイアログ 初期処理
      this.initConfirmDialog(this);               // 確認メッセージ用ダイアログ 初期処理
      this.initExecuteDialog(this);               // 実行確認メッセージ用ダイアログ 初期処理
      this.initServerDialog(this);                // サーバ確認メッセージ用ダイアログ 初期処理

      // テーブルの空行を作成する
      var detailInfo1  = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail1");
      if (detailInfo1) {
        if (detailInfo1["multiline"] == "yes") {
          var defaultline1 = detailInfo1["defaultline"];
          this.createTableRows("#mainTable1", defaultline1);
        }
      }

      var detailInfo2  = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail2");
      if (detailInfo2) {
        if (detailInfo2["multiline"] == "yes") {
          var defaultline2 = detailInfo2["defaultline"];
          this.createTableRows("#mainTable2", defaultline2);
        }
      }

      $R.log("View initExecute : end");
    }
    // ---------------------------------------
    // ボタン・ファンクションキー イベント処理
    // ---------------------------------------
    ,onクリア: function(arg) {
      $R.log("View onクリア : start");

      $("#請求発行日付").val("");
			
			this.showTableALLData(arg);

      $R.log("View onクリア : end");
    }
		
   ,on得意先追加: function(arg) {
      $R.log("Controller on得意先追加 : start");
			
			this.showTableALLData(arg);

      $R.log("Controller on得意先追加 : end");
    }

    // -------------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------------
   ,on照会OfEditResponseData: function(arg) {
      $R.log("View on照会OfEditResponseData : start");
			
			this.showTableALLData(arg);

      $R.log("View on照会OfEditResponseData : end");
    }

	});

}(jQuery, Rmenu));