(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.BillingStatement;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスター一覧パターン　ミックスインを追加する
  Model.include($R.Library.MasterMainteListModelMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Model.include({
    // ---------------------------------------
    // 初期処理
    // ---------------------------------------
    on初期処理: function() {
      $R.log("Model on初期処理 : start");

      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      var w_契約区分               = sessionStorage.loadItem("契約区分");
      var w_アカウント発行区分ＩＤ = sessionStorage.loadItem("アカウント発行区分ＩＤ");
      var w_契約者ＩＤ             = sessionStorage.loadItem("契約者ＩＤ");
      var w_請求日付               = sessionStorage.loadItem("請求日付");

      this.dataset.setElementData(w_契約区分, "検索契約区分");
      this.dataset.setElementData(w_アカウント発行区分ＩＤ, "検索アカウント発行区分ＩＤ");
      this.dataset.setElementData(w_契約者ＩＤ, "検索契約者ＩＤ");
      this.dataset.setElementData(w_請求日付, "請求発行日付");


      $R.log("Model on初期処理 : end");
    }
    // -------------------------------------
    //  リクエストデータ　編集・チェック処理
    // -------------------------------------
   ,on照会OfCheckRequestData: function(requestData, mode) {
      $R.log("Model on照会OfCheckRequestData : start");


      $R.log("Model on照会OfCheckRequestData : end");
    }
    // -------------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------------
   ,on照会ヘッダーOfEditResponseData: function(responseData) {
      $R.log("Model on照会ヘッダーOfEditResponseData : start");
			
			// 明細のデフォルト行を取得する
      var dataset       = this.dataset.getData();
      var datasetRecord = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
      var defaultline   = datasetRecord["defaultline"];
			
			// レスポンスデータの明細行を取得する
      var detailRecord  = this.appspec.getJSONChunkByIdAtRecords(responseData, "header");
			

			var arg = {};
			arg["テーブルＩＤ"] = "#mainTableH";
			arg["表示データ"]   = detailRecord;
			arg["デフォルト行"] = 0;

      $R.log("Model on照会ヘッダーOfEditResponseData : end");
			return arg;
    }

   ,on照会明細OfEditResponseData: function(responseData) {
      $R.log("Model on照会明細OfEditResponseData : start");
			
			// 明細のデフォルト行を取得する
      var dataset       = this.dataset.getData();
      var datasetRecord = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
      var defaultline   = datasetRecord["defaultline"];
			
			// レスポンスデータの明細行を取得する
      var detailRecord  = this.appspec.getJSONChunkByIdAtRecords(responseData, "detail");
			

			var arg = {};
			arg["テーブルＩＤ"] = "#mainTable";
			arg["表示データ"]   = detailRecord;
			arg["デフォルト行"] = defaultline;

      $R.log("Model on照会明細OfEditResponseData : end");
			return arg;
    }
		
   ,on印刷OfEditResponseData: function(responseData, mode) {
      $R.log("Model on印刷OfEditResponseData : start");

      var argHash  = new Object();
      argHash["file"  ] = responseData["pdfinfo"]["pdffile"];
      argHash["type"  ] = "pdf";
      argHash["delete"] = "yes";
      this.postDownloadRack(argHash);

      $R.log("Model on印刷OfEditResponseData : end");
    }

	});

}(jQuery, Rmenu));