(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.ContractantInput = {};

  // インスタンスプロパティを追加する
  var AppSpec = App.AppSpec = new $R.Class($R.AppSpec);
  AppSpec.fn.init = function(name) {
    $R.log("AppSpec init : start");

    this.name       = name;
    this.nextname   = "";
    this.beforename = "ProductItemList";

    $R.log("AppSpec init : end");
  }

  // 共通モジュールを追加する
  AppSpec.include($R.Library.AppSpecMixin);

  AppSpec.include({
    // -----------------------------------------------------------------------------------------------
    // プログラム・JSONファイルのURL情報を定義する（サブシステム名・種類・Apps・プログラムフォルダ名）
    // -----------------------------------------------------------------------------------------------
    urlInfo: [
      {app:  "RmenuSales/Html/Apps/ContractantInput/"}
     ,{json: "RmenuSales/Json/Apps/ContractantInput/"}
    ]
    // --------------------------
    // JSONファイル情報を定義する
    // --------------------------
   ,jsonInfo: [
      {dataset:     "yes"}
     ,{validation:  "yes"}
    ]
    // ----------------------------------------------------------------------------------------
    // トランザクション・リクエストチェック・レスポンス編集・エラーのコールバック関数を定義する
    // ----------------------------------------------------------------------------------------
   ,requestInfo: [
      ["init",      "on初期処理OfCheckRequestData",     "on初期処理OfEditResponseData",     "onErrorResponseData"]
     ,["select",    "on照会OfCheckRequestData",         "on照会OfEditResponseData",         "onErrorResponseData"]
     ,["insert",    "on登録OfCheckRequestData",         "on登録OfEditResponseData",         "onErrorResponseData"]
     ,["update",    "on訂正OfCheckRequestData",         "on訂正OfEditResponseData",         "onErrorResponseData"]
     ,["delete",    "on削除OfCheckRequestData",         "on削除OfEditResponseData",         "onErrorResponseData"]
    ]
    // --------------------------------------------------
    // エンター・タブとPFキーのコールバック関数を定義する
    // --------------------------------------------------
   ,enterTabPFKey: {
      Enter:true
     ,Tab:true
     ,F1:"on実行"
     ,F2:null
     ,F3:null
     ,F4:null
     ,F5:null
     ,F6:null
     ,F7:null
     ,F8:null
     ,F9:null
     ,F10:null
     ,F11:null
     ,F12:null
     ,ESC:"on戻る"
     ,Forms:0
    }
    // ----------------------------------------------------------------
    // イベント設定はセレクタ・イベント・コールバック関数の順に指定する
    // ----------------------------------------------------------------
    // NAVボタンのイベントを定義する
   ,navButtonEvent: [
      ["#戻る",               "click", "on戻る"]
     ,["#実行",               "click", "on実行"]
     //,[".画像検索",       "click", "on画像検索"]
     //,["#画像検索後処理", "click", "on画像検索後処理"]
    ]
    // バリデーションのイベントを定義する
   ,validationEvent: [
      ["#mainForm", "focus", "onFocus"]
     ,["#mainForm", "blur",  "onBlur"]
    ]
    // その他セレクターイベントを定義する
   ,selectorEvent: [
    // ここから追加処理
      ["#アカウント発行区分ＩＤ",  "change", "onChangeアカウント発行区分ＩＤ"]
     ,["#請求締切日ＩＤ",          "change", "onChange請求締切日ＩＤ"]
     ,["#支払方法ＩＤ",            "change", "onChange支払方法ＩＤ"]
     ,["#管理者ＩＤ",      "change", "onChange管理者ＩＤ"]
    ]
    // ----------------------------------------------------------------------------------
    // カスタムイベント設定はイベント名・実行コンテキスト・コールバック関数の順に指定する
    // ----------------------------------------------------------------------------------
    // チェック用カスタムイベントを定義する
   ,pubsubCheckEvent: [
      //["check数量", "controller", "onCheck数量"]
     //,["check単価", "controller", "onCheck単価"]
    ]
    // 導出項目編集用カスタムイベントを定義する
   ,pubsubDeriveEvent: [
    ]
    // その他カスタムイベントを定義する
   ,pubsubOtherEvent: [
      ["showログイン情報",      "view", "showログイン情報"]
     ,["showヘッダータイトル",  "view", "showヘッダータイトル"]
     ,["show初期処理",          "view", "show初期処理"]
    ]
    // ----------------------------------------------------------------------------------
    // セレクトボックス　定義
    // selectorid  : HTMLのIDを指定する
    // selectorname: HTMLのnameを指定する（テーブル内で使用する時に定義する）
    // init        :
    // initvalue   : 初期値（０）
    // inithtml    : 初期表示（～選択）
    // datasetid   : datasetのID名を指定する
    // valuename   : datasetに定義されているキー値の項目名
    // htmlname    : datasetに定義されている表示用データの項目名
    // change      :
    // datasetid   : datasetのID名を指定する
    // valuename   : 選択したキー値を格納するdatasetの項目名
    // htmlname    : 選択した表示値を格納するdatasetの項目名
    // ----------------------------------------------------------------------------------
   ,selectbox: [
      {
          selectorid: "アカウント発行区分ＩＤ"
         ,selectorname: ""
         ,init:     {initvalue: "", inithtml: "アカウント発行区分選択", datasetid: "アカウント発行区分", valuename: "選択アカウント発行区分ＩＤ", htmlname: "選択アカウント発行区分名称"}
         ,change:   {datasetid: "header", valuename: "アカウント発行区分ＩＤ", htmlname: "アカウント発行区分名称"}
      }
     ,{
          selectorid: "請求締切日ＩＤ"
         ,selectorname: ""
         ,init:     {initvalue: "", inithtml: "請求締切日選択", datasetid: "請求締切日", valuename: "選択請求締切日ＩＤ", htmlname: "選択締切日"}
         ,change:   {datasetid: "header", valuename: "請求締切日ＩＤ", htmlname: "締切日"}
      }
     ,{
          selectorid: "支払方法ＩＤ"
         ,selectorname: ""
         ,init:     {initvalue: "", inithtml: "支払方法選択", datasetid: "支払方法", valuename: "選択支払方法ＩＤ", htmlname: "選択支払方法名称"}
         ,change:   {datasetid: "header", valuename: "支払方法ＩＤ", htmlname: "支払方法名称"}
      }
     ,{
          selectorid: "管理者ＩＤ"
         ,selectorname: ""
         ,init:     {initvalue: "", inithtml: "自社担当者", datasetid: "管理者", valuename: "選択管理者ＩＤ", htmlname: "選択管理者名称"}
         ,change:   {datasetid: "header", valuename: "管理者ＩＤ", htmlname: "管理者名称"}
      }
		]
  });
}(jQuery, Rmenu));