(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.ContractantInput;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスターメンテパターン　ミックスインを追加する
  Model.include($R.Library.MasterMainteModelMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Model.include({
    // ----------------------------------------
    // テーブルＩＤをデータセットに格納する
    // ----------------------------------------
    setテーブルＩＤ: function() {
      $R.log("Model setテーブルＩＤ : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var w_契約区分               = sessionStorage.loadItem("契約区分");
      var w_アカウント発行区分ＩＤ = sessionStorage.loadItem("アカウント発行区分ＩＤ");
      var w_契約者ＩＤ             = sessionStorage.loadItem("契約者ＩＤ");
			
      this.dataset.setElementData(w_契約区分, "契約区分");
      this.dataset.setElementData(w_アカウント発行区分ＩＤ, "アカウント発行区分ＩＤ");
      this.dataset.setElementData(w_契約者ＩＤ, "契約者ＩＤ");

      $R.log("Model setテーブルＩＤ : end");
    }
    // -------------------------------------
    //  リクエストデータ　編集・チェック処理
    // -------------------------------------
   ,on訂正OfCheckRequestData: function(requestData, mode) {
      $R.log("Model on訂正OfCheckRequestData : start");

      // ログイン情報を設定する
      var requestRecord = this.appspec.getJSONChunkByIdAtRecords(requestData, "login");
      var loginRecord   = requestRecord["record"];

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + ".Login");
      loginRecord["ユーザＩＤ"]["value"][0] = sessionStorage.loadItem("ユーザＩＤ");
      loginRecord["ユーザ名称"]["value"][0] = sessionStorage.loadItem("ユーザ名称");
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
			
			
			
			var w_アカウント発行区分ＩＤ = $("#アカウント発行区分ＩＤ").val();
			var w_請求締切日ＩＤ         = $("#請求締切日ＩＤ").val();
			var w_支払方法ＩＤ           = $("#支払方法ＩＤ").val();
			var w_管理者ＩＤ     = $("#管理者ＩＤ").val();

      var headerRecord = this.appspec.getJSONChunkByIdAtRecords(requestData, "header")["record"];
			headerRecord["アカウント発行区分ＩＤ"]["value"][0] = w_アカウント発行区分ＩＤ;
			headerRecord["請求締切日ＩＤ"]["value"][0]         = w_請求締切日ＩＤ;
			headerRecord["支払方法ＩＤ"]["value"][0]           = w_支払方法ＩＤ;
			headerRecord["管理者ＩＤ"]["value"][0]     = w_管理者ＩＤ;
			

      $R.log("Model on訂正OfCheckRequestData : end");
      return true;
    }

    // -------------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------------
   ,on初期処理OfEditResponseData: function(responseData, mode) {
      $R.log("Model on初期処理OfEditResponseData : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      var w_契約区分               = sessionStorage.loadItem("契約区分");
      var w_アカウント発行区分ＩＤ = sessionStorage.loadItem("アカウント発行区分ＩＤ");
      var w_請求締切日ＩＤ         = sessionStorage.loadItem("請求締切日ＩＤ");
      var w_支払方法ＩＤ           = sessionStorage.loadItem("支払方法ＩＤ");
      var w_管理者ＩＤ     = sessionStorage.loadItem("管理者ＩＤ");
			
			if (w_アカウント発行区分ＩＤ == "0") {
				w_アカウント発行区分ＩＤ = "";
			}
			if ( isNaN(w_請求締切日ＩＤ) ) {
				w_請求締切日ＩＤ = "";
			}
			if ( isNaN(w_支払方法ＩＤ) ) {
				w_支払方法ＩＤ = "";
			}
			if ( isNaN(w_管理者ＩＤ) ) {
				w_管理者ＩＤ = "";
			}
			
      this.dataset.setElementData(w_契約区分, "契約区分");
      this.dataset.setElementData(w_アカウント発行区分ＩＤ, "アカウント発行区分ＩＤ");
      this.dataset.setElementData(w_請求締切日ＩＤ, "請求締切日ＩＤ");
      this.dataset.setElementData(w_支払方法ＩＤ, "支払方法ＩＤ");
      this.dataset.setElementData(w_管理者ＩＤ, "管理者ＩＤ");
			
			var arg = {};
			arg["契約区分"]               = w_契約区分;
			arg["アカウント発行区分ＩＤ"] = w_アカウント発行区分ＩＤ;
			arg["請求締切日ＩＤ"]         = w_請求締切日ＩＤ;
			arg["支払方法ＩＤ"]           = w_支払方法ＩＤ;
			arg["管理者ＩＤ"]     = w_管理者ＩＤ;

      $R.log("Model on初期処理OfEditResponseData : end");
			return arg;
    }
		
   ,on訂正OfEditResponseData: function(responseData, mode) {
      $R.log("Model on訂正OfEditResponseData : start");


			this.onサーバ処理確認ダイアログ(responseData);

      $R.log("Model on訂正OfEditResponseData : end");
    }

	});
}(jQuery, Rmenu));