(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.ContractantList;

  // インスタンスプロパティを追加する
  var Controller = App.Controller = new $R.Class($R.Controller);
  Controller.fn.init = function(appspec, model, view) {
    $R.log("Controllerr init : start");

    this.appspec = appspec;
    this.model   = model;
    this.view    = view;
    this.createPubSubEvent();

    $R.log("Controllerr init : end");
  };

  // 共通モジュールを追加する
  Controller.include($R.Library.EnterTabPFKeyMixin);
  Controller.include($R.Library.ControllerMixin);

  // マスター一覧パターン　ミックスインを追加する
  Controller.include($R.Library.MasterMainteListControllerMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Controller.include({
    // ---------------------------------------
    // 初期処理
    // ---------------------------------------
    on初期処理: function() {
      $R.log("Controller on初期処理 : start");

      this.model.on初期処理();
      this.ajaxExecute("init");

      $R.log("Controller on初期処理 : end");
    }
    // ---------------------------------------
    // ボタン・ファンクションキー イベント処理
    // ---------------------------------------
   ,on登録: function(event) {
      $R.log("Controller on登録 : start");

			// 2015.10.14 追加（shimoji）
      //if (!this.model.check行選択()) return;

      var status = this.model.set処理モード("insert");
      if (status) {
        this.onメンテナンス画面表示();
      }

      $R.log("Controller on登録 : end");
    }
   ,on検索: function(event) {
      $R.log("Controller on検索 : start");

      this.model.on検索();
      this.model.on最初のページ();
      this.ajaxExecute("selectmaintable");

      $R.log("Controller on検索 : end");
    }
    // ---------------------------------
    //  検索文字列　表示処理（追加処理）
    // ---------------------------------
   ,onクリア: function(event) {
      $R.log("Controller onクリア : start");

      this.model.onクリア();
      this.view.onクリア();

      $R.log("Controller onクリア : end");
    }
				
    // -------------------------------------
    // チェンジ イベント処理（追加処理）
    // -------------------------------------
   ,onChange検索支払方法選択: function(event) {
      $R.log("Controller onChange検索支払方法選択 : start");

      this.model.onChangeSelectBox(event, this.appspec.selectbox);
			this.model.onChangeセレクトボックス();

      $R.log("Controller onChange検索支払方法選択 : end");
    }
		
   ,onChange検索自社担当者選択: function(event) {
      $R.log("Controller onChange検索自社担当者選択 : start");

      this.model.onChangeSelectBox(event, this.appspec.selectbox);
			this.model.onChangeセレクトボックス();
			
      this.ajaxExecute("control");

      $R.log("Controller onChange検索自社担当者選択 : end");
    }
		
    // -------------------------------------
    //  リクエストデータ　編集・チェック処理
    // -------------------------------------
   ,on初期処理OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on初期処理OfCheckRequestData : start");

      var status = this.checkRequestData(requestData);

      $R.log("Controller on初期処理OfCheckRequestData : end");
      return status;
    }
		
    // -------------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------------
   ,on初期処理OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on初期処理OfEditResponseData : start");

      this.editResponseData(responseData);
			
      // セレクトボックスの一括初期表示
      this.onShowSelectBoxAll(responseData, this.appspec.selectbox);
			

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var currentpage = sessionStorage.loadItem("カレントページ");
      if (currentpage){
			  var arg = this.model.on初期処理リロードOfEditResponseData(responseData, mode);
			  this.view.on初期処理リロードOfEditResponseData(arg);
        this.onリロード();
      }
      else {
			  this.model.on初期処理OfEditResponseData(responseData, mode);
        this.on最初のページ();
      }

      $R.log("Controller on初期処理OfEditResponseData : end");
    }

		
  });

}(jQuery, Rmenu));