(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.ContractantList;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスター一覧パターン　ミックスインを追加する
  Model.include($R.Library.MasterMainteListModelMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Model.include({
    // -----------------------------------
    //  検索文字列　クリア処理（追加処理）
    // -----------------------------------
     on検索: function() {
      $R.log("Model on検索 : start");

      this.onChangeセレクトボックス();
			
      $R.log("Model on検索 : end");
    }

    // -----------------------------------
    //  検索文字列　クリア処理（追加処理）
    // -----------------------------------
   ,onクリア: function(arg) {
      $R.log("Model onクリア : start");

      this.dataset.setElementData("", "検索会社名");
      this.dataset.setElementData("", "検索支払方法ＩＤ");
      this.dataset.setElementData("", "検索自社担当者ＩＤ");

      $R.log("Model onクリア : end");
    }

    // -------------------------------------------------------
    //  テーブルの選択行をセッションストレージに格納する
    // -------------------------------------------------------
   ,onテーブル行クリック: function(arg) {
      $R.log("Model onテーブル行クリック : start");

      var clickRow  = arg["クリック行"] - 1;

      var dataset    = this.dataset.getData();
      var detailInfo = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
      var value      = detailInfo["record"]["契約者ＩＤ"]["value"][clickRow];
      if (value == "0") {
        this.pubsub.publish("onテーブル行クリック", arg);
        $R.log("Model onテーブル行クリック : end");
        return;
      }
      if (value) {
        this.pubsub.publish("onテーブル行クリック", arg);
      }

      $R.log("Model onテーブル行クリック : end");
    }

    // -------------------------------------------------------
    //  データが選択されているかチェックする
    // -------------------------------------------------------
   ,check行選択: function() {
      $R.log("Model check行選択 : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var value = sessionStorage.loadItem("クリック行");
			if (!isNaN(value)) {
        if (value) return true;
			}
			

      var arg = {};
      arg["title"]   = "選択エラー";
      arg["status"]  = "ERROR";
      arg["message"] = "行が選択されていません。選択して下さい。";
      this.pubsub.publish("alertDialog", arg);

      $R.log("Model check行選択 : end");
      return false;
    }
    // -------------------------------------------------------
    //  処理モードをセッションストレージに格納する
    // -------------------------------------------------------
   ,set処理モード: function(mode) {
      $R.log("Model set処理モード : start");

      // セッションデータに識別名を設定する 2015.10.07 shimoji 訂正
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      sessionStorage.saveItem("処理モード", mode);

      var row        = sessionStorage.loadItem("クリック行");
			var w_契約区分               = 9;
			var w_アカウント発行区分ＩＤ = 0;
			var w_契約者ＩＤ             = 0;
			if (mode != "insert") {
        var dataset    = this.dataset.getData();
        var detailInfo = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
        w_契約区分               = detailInfo["record"]["契約区分"]["value"][row]
        w_アカウント発行区分ＩＤ = detailInfo["record"]["アカウント発行区分ＩＤ"]["value"][row]
        w_契約者ＩＤ             = detailInfo["record"]["契約者ＩＤ"]["value"][row]
			}

      // セッションデータに識別名を設定する 2015.10.07 shimoji 訂正
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.nextname);
      sessionStorage.saveItem("処理モード", mode);
      sessionStorage.saveItem("契約区分", w_契約区分);
      sessionStorage.saveItem("アカウント発行区分ＩＤ", w_アカウント発行区分ＩＤ);
      sessionStorage.saveItem("契約者ＩＤ", w_契約者ＩＤ);

      $R.log("Model set処理モード : end");
      return true;
    }
    // -------------------------------------
    // チェンジ イベント処理（追加処理）
    // -------------------------------------
   ,onChangeセレクトボックス: function() {
      $R.log("Model onChangeセレクトボックス : start");

			var w_検索会社名             = $("#検索会社名").val();
			var w_検索支払方法選択       = $("#検索支払方法選択").val();
			var w_検索自社担当者選択 = $("#検索自社担当者選択").val();
			
      this.dataset.setElementData(w_検索会社名, "検索会社名");
      this.dataset.setElementData(w_検索支払方法選択, "検索支払方法ＩＤ");
      this.dataset.setElementData(w_検索自社担当者選択, "検索自社担当者ＩＤ");

			// 次画面用のセッションストレージデータを設定
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.nextname);
      sessionStorage.saveItem("検索会社名", w_検索会社名);
      sessionStorage.saveItem("検索支払方法ＩＤ", w_検索支払方法選択);
      sessionStorage.saveItem("検索自社担当者ＩＤ", w_検索自社担当者選択);

			// 当画面用のセッションストレージデータを設定
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      sessionStorage.saveItem("検索会社名", w_検索会社名);
      sessionStorage.saveItem("検索支払方法ＩＤ", w_検索支払方法選択);
      sessionStorage.saveItem("検索自社担当者ＩＤ", w_検索自社担当者選択);

      $R.log("Model onChangeセレクトボックス : end");
    }
		
    // -------------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------------
   ,on初期処理OfEditResponseData: function(responseData, mode) {
      $R.log("Model on初期処理OfEditResponseData : start");

      this.dataset.setElementData("", "検索会社名");
      this.dataset.setElementData("", "検索支払方法ＩＤ");
      this.dataset.setElementData("", "検索自社担当者ＩＤ");

      $R.log("Model on初期処理OfEditResponseData : end");
    }

   ,on初期処理リロードOfEditResponseData: function(responseData, mode) {
      $R.log("Model on初期処理リロードOfEditResponseData : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      var w_検索会社名             = sessionStorage.loadItem("検索会社名");
      var w_検索支払方法ＩＤ       = sessionStorage.loadItem("検索支払方法ＩＤ");
      var w_検索自社担当者ＩＤ = sessionStorage.loadItem("検索自社担当者ＩＤ");
			
			if ( w_検索会社名 == null ) {
				w_検索会社名 = "";
			}
			if ( w_検索支払方法ＩＤ == null ) {
				w_検索支払方法ＩＤ = "";
			}
			if ( w_検索自社担当者ＩＤ == null ) {
				w_検索自社担当者ＩＤ = "";
			}

      this.dataset.setElementData(w_検索会社名, "検索会社名");
      this.dataset.setElementData(w_検索支払方法ＩＤ, "検索支払方法ＩＤ");
      this.dataset.setElementData(w_検索自社担当者ＩＤ, "検索自社担当者ＩＤ");
			
			var arg = {};
			arg["検索会社名"]             = w_検索会社名;
			arg["検索支払方法ＩＤ"]       = w_検索支払方法ＩＤ;
			arg["検索自社担当者ＩＤ"] = w_検索自社担当者ＩＤ;

      $R.log("Model on初期処理リロードOfEditResponseData : end");
			return arg;
    }

	});

}(jQuery, Rmenu));