(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.ContractantListSearch;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスター一覧パターン　ミックスインを追加する
  Model.include($R.Library.MasterMainteListModelMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Model.include({
    // -----------------------------------
    //  検索文字列　クリア処理（追加処理）
    // -----------------------------------
     on検索: function() {
      $R.log("Model on検索 : start");

      this.onChangeセレクトボックス();
			
      $R.log("Model on検索 : end");
    }

    // -----------------------------------
    //  検索文字列　クリア処理（追加処理）
    // -----------------------------------
   ,onクリア: function(arg) {
      $R.log("Model onクリア : start");

      this.dataset.setElementData("", "検索会社名");
      this.dataset.setElementData("", "検索支払方法ＩＤ");
      this.dataset.setElementData("", "検索自社担当者ＩＤ");

      $R.log("Model onクリア : end");
    }

    // -----------------------------------
    //  実行処理
    // -----------------------------------
   ,on実行: function(arg) {
      $R.log("Model on実行 : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      var clickRow = sessionStorage.loadItem("クリック行");
			var arg = {};
			
			if ( isNaN(clickRow) ) {
			  arg["契約区分"]               = "";
			  arg["アカウント発行区分ＩＤ"] = "";
			  arg["契約者ＩＤ"]             = "";
			  arg["会社名"]                 = "";
			  arg["郵便番号"]               = "";
			  arg["住所"]                   = "";
				return arg;
			}

      var dataset    = this.dataset.getData();
      var detailInfo = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail")["record"];

			arg["契約区分"]               = detailInfo["契約区分"]["value"][clickRow];
			arg["アカウント発行区分ＩＤ"] = detailInfo["アカウント発行区分ＩＤ"]["value"][clickRow];
			arg["契約者ＩＤ"]             = detailInfo["契約者ＩＤ"]["value"][clickRow];
			arg["会社名"]                 = detailInfo["会社名"]["value"][clickRow];
			arg["郵便番号"]               = detailInfo["郵便番号"]["value"][clickRow];
			arg["住所"]                   = detailInfo["住所"]["value"][clickRow];
			
      $R.log("Model on実行 : end");
			return arg;
    }

    // -------------------------------------------------------
    //  テーブルの選択行をセッションストレージに格納する
    // -------------------------------------------------------
   ,onテーブル行クリック: function(arg) {
      $R.log("Model onテーブル行クリック : start");

      var clickRow  = arg["クリック行"] - 1;

      var dataset    = this.dataset.getData();
      var detailInfo = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
      var value      = detailInfo["record"]["契約者ＩＤ"]["value"][clickRow];
      if (value == "0") {
        this.pubsub.publish("onテーブル行クリック", arg);
        $R.log("Model onテーブル行クリック : end");
        return;
      }
      if (value) {
        this.pubsub.publish("onテーブル行クリック", arg);
      }

      $R.log("Model onテーブル行クリック : end");
    }

    // -------------------------------------------------------
    //  データが選択されているかチェックする
    // -------------------------------------------------------
   ,check行選択: function() {
      $R.log("Model check行選択 : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var value = sessionStorage.loadItem("クリック行");
			if (!isNaN(value)) {
        if (value) return true;
			}
			

      var arg = {};
      arg["title"]   = "選択エラー";
      arg["status"]  = "ERROR";
      arg["message"] = "行が選択されていません。選択して下さい。";
      this.pubsub.publish("alertDialog", arg);

      $R.log("Model check行選択 : end");
      return false;
    }
    // -------------------------------------
    // チェンジ イベント処理（追加処理）
    // -------------------------------------
   ,onChangeセレクトボックス: function() {
      $R.log("Model onChangeセレクトボックス : start");

			var w_検索会社名             = $("#検索会社名").val();
			var w_検索支払方法選択       = $("#検索支払方法選択").val();
			var w_検索自社担当者選択 = $("#検索自社担当者選択").val();
			
      this.dataset.setElementData(w_検索会社名, "検索会社名");
      this.dataset.setElementData(w_検索支払方法選択, "検索支払方法ＩＤ");
      this.dataset.setElementData(w_検索自社担当者選択, "検索自社担当者ＩＤ");

      $R.log("Model onChangeセレクトボックス : end");
    }
		
    // ---------------------------------
    //  セッション情報をクリアする
    // ---------------------------------
   ,clearセッション情報: function() {
      $R.log("Model clearページ情報 : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      sessionStorage.deleteAll("");


      $R.log("Model clearページ情報 : end");
    }
    // -------------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------------
   ,on初期処理OfEditResponseData: function(responseData, mode) {
      $R.log("Model on初期処理OfEditResponseData : start");

      this.dataset.setElementData("", "検索会社名");
      this.dataset.setElementData("", "検索支払方法ＩＤ");
      this.dataset.setElementData("", "検索自社担当者ＩＤ");

      $R.log("Model on初期処理OfEditResponseData : end");
    }

	});

}(jQuery, Rmenu));