(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.DailyProcessing;

  // インスタンスプロパティを追加する
  var Controller = App.Controller = new $R.Class($R.Controller);
  Controller.fn.init = function(appspec, model, view) {
    $R.log("Controllerr init : start");

    this.appspec = appspec;
    this.model   = model;
    this.view    = view;
    this.createPubSubEvent();


    $R.log("Controllerr init : end");
  };

  // 共通モジュールを追加する
  Controller.include($R.Library.EnterTabPFKeyMixin);
  Controller.include($R.Library.ControllerMixin);

  // マスター一覧パターン　ミックスインを追加する
  Controller.include($R.Library.MasterMainteListControllerMixin);
  Controller.include($R.Library.RmenuSalesControllerMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Controller.include({
    // ---------------------------------------
    // ボタン・ファンクションキー イベント処理
    // ---------------------------------------
    on実行前処理: function(event, arg) {
      $R.log("Controller on実行前処理 : start");

			var arg = {};
			arg["title"]   = "実行確認";
			arg["message"] = "日次処理を実行してもよろしいですか？";
			
			this.pubsub.publish("executeDialog", arg);

      $R.log("Controller on実行前処理 : end");
    }
		
   ,on実行: function(event, arg) {
      $R.log("Controller on実行 : start");

      this.ajaxExecute("execute");

      $R.log("Controller on実行 : end");
    }
    // -------------------------------------
    //  リクエストデータ　編集・チェック処理
    // -------------------------------------
   ,on実行処理OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on実行処理OfCheckRequestData : start");

			this.model.on実行処理OfCheckRequestData(requestData, mode);
      var status = this.checkRequestData(requestData);

      $R.log("Controller on実行処理OfCheckRequestData : end");
      return status;
    }
    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,on実行処理OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on実行処理OfEditResponseData : start");

      var status = responseData["message"]["status"];
      var msg    = responseData["message"]["msg"];
      var arg    = {title: "サーバ処理確認", status: status, message: msg};
      this.pubsub.publish("serverDialog", arg);

      $R.log("Controller on実行処理OfEditResponseData : end");
    }
		
  });

}(jQuery, Rmenu));