(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.DailyProcessing;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスター一覧パターン　ミックスインを追加する
  Model.include($R.Library.MasterMainteListModelMixin);
  Model.include($R.Library.RmenuSalesModelMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Model.include({
    // ------------------------------------------------------------------------
    // 処理起動確認ダイアログ後の処理
    // ------------------------------------------------------------------------
    onExecuteDialogAfter: function() {
      $R.log("Model onExecuteDialogAfter : start");

      var yesno = sessionStorage.getItem("executeDialog");

      if (yesno == 1){
				
        var arg = {};
        this.pubsub.publish("on実行",arg);
      }

      $R.log("Model onExecuteDialogAfter : end");
    }
    // -------------------------------------
    //  リクエストデータ　編集・チェック処理
    // -------------------------------------
   ,on実行処理OfCheckRequestData: function(requestData, mode) {
      $R.log("Model on実行処理OfCheckRequestData : start");

      var loginRecord  = this.appspec.getJSONChunkByIdAtRecords(requestData, "login")["record"];
      var headerRecord = this.appspec.getJSONChunkByIdAtRecords(requestData, "header")["record"];

      // ログイン情報を設定する
      sessionStorage.setIdName(this.appspec.sysname + ".Login");
      loginRecord["ユーザＩＤ"]["value"][0] = sessionStorage.loadItem("ユーザＩＤ");
      loginRecord["ユーザ名称"]["value"][0] = sessionStorage.loadItem("ユーザ名称");
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);


      // 会計年度を設定する
			var date = this.getシステム日付();
      this.dataset.setElementData(date, "ヘッダー日付");
				
			var w_会計年度 = this.get会計年度();
      headerRecord["会計年度"]["value"][0] = w_会計年度;				

      $R.log("Model on実行処理OfCheckRequestData : end");
    }

	});

}(jQuery, Rmenu));