(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.MoneyReceivedCheckList;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスター一覧パターン　ミックスインを追加する
  Model.include($R.Library.MasterMainteListModelMixin);
  Model.include($R.Library.RmenuSalesModelMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Model.include({
    // -------------------------------------------------------------------
    //  初期処理
    // -------------------------------------------------------------------
    on初期処理: function() {
      $R.log("Model on初期処理 : start");


      $R.log("Model on初期処理 : end");
    }
   ,on初期処理_リロード: function() {
      $R.log("Model on初期処理_リロード : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var w_ヘッダー日付               = sessionStorage.loadItem("ヘッダー日付");
      var w_検索契約区分               = sessionStorage.loadItem("検索契約区分");
      var w_検索アカウント発行区分ＩＤ = sessionStorage.loadItem("検索アカウント発行区分ＩＤ");
      var w_検索契約者ＩＤ             = sessionStorage.loadItem("検索契約者ＩＤ");
      var w_検索契約者名               = sessionStorage.loadItem("検索契約者名");

      this.dataset.setElementData(w_ヘッダー日付, "ヘッダー日付");
      this.dataset.setElementData(w_検索契約区分, "検索契約区分");
      this.dataset.setElementData(w_検索アカウント発行区分ＩＤ, "検索アカウント発行区分ＩＤ");
      this.dataset.setElementData(w_検索契約者ＩＤ, "検索契約者ＩＤ");
      this.dataset.setElementData(w_検索契約者名, "検索契約者名");

      $R.log("Model on初期処理_リロード : end");
    }
   ,on初期処理_最初のページ: function() {
      $R.log("Model on初期処理_最初のページ : start");

      this.dataset.setElementData("", "ヘッダー日付");
      this.dataset.setElementData("", "検索契約区分");
      this.dataset.setElementData("", "検索アカウント発行区分ＩＤ");
      this.dataset.setElementData("", "検索契約者ＩＤ");
      this.dataset.setElementData("", "検索契約者名");

      $R.log("Model on初期処理_最初のページ : end");
    }
    // ---------------------------------------
    // ボタン・ファンクションキー イベント処理
    // ---------------------------------------
   ,on検索契約者: function(arg) {
      $R.log("Controller on検索契約者 : start");

      this.dataset.setElementData(arg["契約区分"], "検索契約区分");
      this.dataset.setElementData(arg["アカウント発行区分ＩＤ"], "検索アカウント発行区分ＩＤ");
      this.dataset.setElementData(arg["契約者ＩＤ"], "検索契約者ＩＤ");
      this.dataset.setElementData(arg["会社名"], "検索契約者名");

      $R.log("Controller on検索契約者 : end");
    }
    ,onクリア: function(arg) {
      $R.log("Model onクリア : start");

      this.dataset.setElementData("", "ヘッダー日付");
      this.dataset.setElementData("", "検索契約区分");
      this.dataset.setElementData("", "検索アカウント発行区分ＩＤ");
      this.dataset.setElementData("", "検索契約者ＩＤ");
      this.dataset.setElementData("", "検索契約者名");

      $R.log("Model onクリア : end");
    }
    // -------------------------------------------------------
    //  処理モードをセッションストレージに格納する
    // -------------------------------------------------------
   ,set処理モード: function(mode) {
      $R.log("Model set処理モード : start");

			var w_ヘッダー日付               = this.dataset.getElementData("ヘッダー日付");
			var w_検索契約区分               = this.dataset.getElementData("検索契約区分");
			var w_検索アカウント発行区分ＩＤ = this.dataset.getElementData("検索アカウント発行区分ＩＤ");
			var w_検索契約者ＩＤ             = this.dataset.getElementData("検索契約者ＩＤ");
			var w_検索契約者名               = this.dataset.getElementData("検索契約者名");

		  // セッションデータに識別名を設定する 2015.10.07 shimoji 訂正
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      sessionStorage.saveItem("処理モード", mode);
      sessionStorage.saveItem("ヘッダー日付", w_ヘッダー日付);
      sessionStorage.saveItem("検索契約区分", w_検索契約区分);
      sessionStorage.saveItem("検索アカウント発行区分ＩＤ", w_検索アカウント発行区分ＩＤ);
      sessionStorage.saveItem("検索契約者ＩＤ", w_検索契約者ＩＤ);
      sessionStorage.saveItem("検索契約者名", w_検索契約者名);

      var row        = sessionStorage.loadItem("クリック行");
			var w_会計年度                   = "0";
			var w_伝票番号                   = "0";
			if (row != "") {
        var dataset    = this.dataset.getData();
        var detailInfo = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
        w_会計年度 = detailInfo["record"]["会計年度"]["value"][row]
        w_伝票番号 = detailInfo["record"]["伝票番号"]["value"][row]
			}

      // セッションデータに識別名を設定する 2015.10.07 shimoji 訂正
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.nextname);
      sessionStorage.saveItem("処理モード", mode);
      sessionStorage.saveItem("会計年度", w_会計年度);
      sessionStorage.saveItem("伝票番号", w_伝票番号);
			

      $R.log("Model set処理モード : end");
      return true;
    }
    // -------------------------------------------------------
    //  テーブルの選択行をセッションストレージに格納する
    // -------------------------------------------------------
   ,onテーブル行クリック: function(arg) {
      $R.log("Model onテーブル行クリック : start");

      var clickRow  = arg["クリック行"] - 1;

      var dataset    = this.dataset.getData();
      var detailInfo = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
      var value      = detailInfo["record"]["伝票番号"]["value"][clickRow];
      if (value == "0") {
        this.pubsub.publish("onテーブル行クリック", arg);
        $R.log("Model onテーブル行クリック : end");
        return;
      }
      if (value) {
        this.pubsub.publish("onテーブル行クリック", arg);
      }

      $R.log("Model onテーブル行クリック : end");
    }
    // -------------------------------------------------------
    //  データが選択されているかチェックする
    // -------------------------------------------------------
   ,check行選択: function(mode) {
      $R.log("Model check行選択 : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var value = sessionStorage.loadItem("クリック行");
			
		  if (value != "") {
					return true;
			}

			if (mode == "insert") {
					return true;
			}
			
      var arg = {};
      arg["title"]   = "選択エラー";
      arg["status"]  = "ERROR";
      arg["message"] = "行が選択されていません。選択して下さい。";
      this.pubsub.publish("alertDialog", arg);

      $R.log("Model check行選択 : end");
      return false;
    }

	});

}(jQuery, Rmenu));