(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.MoneyReceivedClearing = {};

  // インスタンスプロパティを追加する
  var AppSpec = App.AppSpec = new $R.Class($R.AppSpec);
  AppSpec.fn.init = function(name) {
    $R.log("AppSpec init : start");

    this.name       = name;
    this.nextname   = "";
    this.beforename = "MoneyReceivedClearingList";

    $R.log("AppSpec init : end");
  }

  // 共通モジュールを追加する
  AppSpec.include($R.Library.AppSpecMixin);

  AppSpec.include({
    // -----------------------------------------------------------------------------------------------
    // プログラム・JSONファイルのURL情報を定義する（サブシステム名・種類・Apps・プログラムフォルダ名）
    // -----------------------------------------------------------------------------------------------
    urlInfo: [
      {app:  "RmenuSales/Html/Apps/MoneyReceivedClearing/"}
     ,{json: "RmenuSales/Json/Apps/MoneyReceivedClearing/"}
    ]
    // --------------------------
    // JSONファイル情報を定義する
    // --------------------------
   ,jsonInfo: [
      {dataset:     "yes"}
     ,{validation:  "yes"}
    ]
    // ----------------------------------------------------------------------------------------
    // トランザクション・リクエストチェック・レスポンス編集・エラーのコールバック関数を定義する
    // ----------------------------------------------------------------------------------------
   ,requestInfo: [
      //["init"  , "on初期処理OfCheckRequestData" , "on初期処理OfEditResponseData", "onErrorResponseData"]
     //,["select", "on照会OfCheckRequestData"     , "on照会OfEditResponseData"    , "onErrorResponseData"]
     //,["insert", "on登録OfCheckRequestData"     , "on登録OfEditResponseData"    , "onErrorResponseData"]
    ]
    // --------------------------------------------------
    // エンター・タブとPFキーのコールバック関数を定義する
    // --------------------------------------------------
   ,enterTabPFKey: {
      Enter:true
     ,Tab:true
     ,F1:null
     ,F2:null
     ,F3:null
     ,F4:null
     ,F5:null
     ,F6:null
     ,F7:null
     ,F8:null
     ,F9:null
     ,F10:null
     ,F11:null
     ,F12:null
     ,ESC:"on戻る"
     ,Forms:0
    }
    // ----------------------------------------------------------------
    // イベント設定はセレクタ・イベント・コールバック関数の順に指定する
    // ----------------------------------------------------------------
    // NAVボタンのイベントを定義する
   ,navButtonEvent: [
      ["#戻る", "click", "on戻る"]
     //,["#実行", "click", "on実行"]
     // ここから追加処理
     //,["#継続入力", "click", "on継続入力"]
     //,["#出荷先名検索",               "click", "onClickポップアップ画面"]
    ]
    // バリデーションのイベントを定義する
   ,validationEvent: [
      ["#mainForm", "focus", "onFocus"]
     ,["#mainForm", "blur",  "onBlur"]
    ]
    // その他セレクターイベントを定義する
   ,selectorEvent: [
      //["#ref_売上区分ＩＤ"          , "change", "onChangeセレクトボックス"  ]
     //,["#納入区分"                  , "change", "onChangeセレクトボックス"  ]
     //,["#mainTable td .ref_単位ＩＤ", "change", "onChange行セレクトボックス"]
     //,["#行削除"                    , "change", "onChange行チェックボックス"]
     //,["#計上日付"                  , "change", "onChangeカレンダー"        ]
//   ,["#mainTable td .数量"        , "change", "onChange数量単価"          ]
//   ,["#mainTable td .単価"        , "change", "onChange数量単価"          ]
    ]
    // ------------------------------------------------------------------------
    // テーブルイベント設定はセレクタ・イベント・コールバック関数の順に指定する
    // ------------------------------------------------------------------------
    // テーブルRowイベントを定義する
   ,tableRowEvent: [
    ]
    // テーブルオブジェクト　イベントを定義する
   ,tableObjectEvent: [
    ]
    // ----------------------------------------------------------------------------------
    // カスタムイベント設定はイベント名・実行コンテキスト・コールバック関数の順に指定する
    // ----------------------------------------------------------------------------------
    // チェック用カスタムイベントを定義する
   ,pubsubCheckEvent: [
    ]
    // 導出項目編集用カスタムイベントを定義する
   ,pubsubDeriveEvent: [
      //["derive数量"               , "model" , "edit金額計算"        ]
     //,["derive単価"               , "model" , "edit金額計算"        ]
     //,["derive金額"               , "model" , "edit合計金額計算"    ]
    ]
    // その他カスタムイベントを定義する
   ,pubsubOtherEvent: [
      ["showログイン情報"         , "view"  , "showログイン情報"    ]
     ,["showヘッダータイトル"     , "view"  , "showヘッダータイトル"]
     ,["show初期処理"             , "view"  , "show初期処理"        ]
     // ここから追加処理
     ,["show金額"                 , "view"  , "show金額"            ]
     ,["show合計金額"             , "view"  , "show合計金額"        ]
    ]
    // ----------------------------------------------------------------------------------
    // ポップアップ画面　定義
    // app         : ポップアップ画面のURLを指定する
    // targetid    : clickイベントが設定されているボタンのセレクタ名
    // input       : ポップアップ画面側で設定される引き渡し項目名
    // selector    : 呼び出し側画面で表示するhtmlのセレクタ名
    //             : inputに対応する項目を表示しない時は、””を設定する
    // output      :
    // datasetid   : 呼び出し側画面で受け取るdatasetのＩＤ名
    // datasetname : 呼び出し側画面で受け取るdatasetの項目名
    //             : inputに対応する項目を表示しない時は、””を設定する   
    // ----------------------------------------------------------------------------------
   ,popup: [
      {
         app:      "RmenuSales/Html/Apps/DestinationOutPeopleSearch"
        ,targetid: "出荷先名検索"
        ,input:    ["送り先略称","送り先ＩＤ"]
        ,selector: ["出荷先名"]
        ,output:   {datasetid: "header", datasetname: ["出荷先名","ref_出荷先ＩＤ"]}
      }
    ]
    // ----------------------------------------------------------------------------------
    // セレクトボックス　定義
    // selectorid  : HTMLのIDを指定する
    // selectorname: HTMLのnameを指定する（テーブル内で使用する時に定義する）
    // init        :
    // initvalue   : 初期値（０）
    // inithtml    : 初期表示（～選択）
    // datasetid   : datasetのID名を指定する
    // valuename   : datasetに定義されているキー値の項目名
    // htmlname    : datasetに定義されている表示用データの項目名
    // change      :
    // datasetid   : datasetのID名を指定する
    // valuename   : 選択したキー値を格納するdatasetの項目名
    // htmlname    : 選択した表示値を格納するdatasetの項目名
    // ----------------------------------------------------------------------------------
   ,selectbox: [
      {
          selectorid: "ref_売上区分ＩＤ"
         ,selectorname: "ref_売上区分ＩＤ"
         ,init:     {initvalue: "", inithtml: "", datasetid: "MoneyReceivedClearingClassification", valuename: "売上伝票区分ＩＤ", htmlname: "売上伝票区分名"}
         ,change:   {datasetid: "header", valuename: "ref_売上区分ＩＤ", htmlname: ""}
      }
     ,{
          selectorid: "納入区分"
         ,selectorname: "納入区分"
         ,init:     {initvalue: "", inithtml: "", datasetid: "DeliveryDivision", valuename: "納入区分ＩＤ", htmlname: "納入区分名"}
         ,change:   {datasetid: "header", valuename: "納入区分", htmlname: ""}
      }
     ,{
          selectorid: "ref_単位ＩＤ"
         ,selectorname: "ref_単位ＩＤ"
         ,init:     {initvalue: "", inithtml: " ", datasetid: "Unit", valuename: "単位ＩＤ", htmlname: "単位名"}
         ,change:   {datasetid: "detail", valuename: "ref_単位ＩＤ", htmlname: "単位名"}
      }
    ]

  });
}(jQuery, Rmenu));
