(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.MoneyReceivedClearing;

  // インスタンスプロパティを追加する
  var Controller = App.Controller = new $R.Class($R.Controller);
  Controller.fn.init = function(appspec, model, view) {
    $R.log("Controllerr init : start");

    this.appspec = appspec;
    this.model   = model;
    this.view    = view;
    this.createPubSubEvent();

    var self = this;

    var datetimepickerArg = {
        format : 'yyyy/MM/dd',
        language : 'ja',
        pickTime : false
    };
    var api01 = $('#計上日付カレンダー').datetimepicker(datetimepickerArg).data('datetimepicker');
    api01.widget.on('click','td.day',function(){
        api01.hide();
        self.onChange計上日付();
    });

    $R.log("Controllerr init : end");
  };

  // モジュールを追加する
  Controller.include($R.Library.EnterTabPFKeyMixin);
  Controller.include($R.Library.ControllerMixin);

  // マスターメンテパターン　ミックスインを追加する
  Controller.include($R.Library.MasterMainteControllerMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Controller.include({
    // ---------------------------------------
    // 初期処理（オーバライド処理）
    // ---------------------------------------
    on初期処理: function() {
      $R.log("Controller on初期処理 : start");

      this.model.on初期処理();
      //this.ajaxExecute("init");

      $R.log("Controller on初期処理 : end");
    }

    // -------------------------------------
    //  リクエストデータ　編集・チェック処理
    // -------------------------------------
   ,on初期処理OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on初期処理OfCheckRequestData : start");

      var status = this.checkRequestData(requestData);

      $R.log("Controller on初期処理OfCheckRequestData : end");
      return status;
    }

    // ---------------------------------------
    // ボタン・ファンクションキー イベント処理
    // ---------------------------------------
   ,on継続入力: function(event) {
      $R.log("Controller on継続入力 : start");

      this.ajaxExecute("select");

      $R.log("Controller on戻る : end");
    }

    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,on初期処理OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on初期処理OfEditResponseData : start");

      this.editResponseData(responseData);

      // セレクトボックスの一括初期表示
      var dataSetInfo = this.model.dataset.getData();
      this.onShowSelectBoxAll(dataSetInfo, this.appspec.selectbox);

      // データセットにセレクトボックスの初期値をセットする。
      $('#ref_売上区分ＩＤ').trigger('change');
      $('#納入区分').trigger('change');

      this.ajaxExecute("select");

      $R.log("Controller on初期処理OfEditResponseData : end");
    }

    // -------------------------------------
    //  ポップアップ画面処理
    // -------------------------------------
   ,onClickポップアップ画面: function(event, arg) {
      $R.log("Controller onClickポップアップ画面 : start");

      if (arg === undefined) {
         this.onClickPopupWindow(event, this.appspec.popup);
      }
      else {

         this.onClickPopupWindowAfter(event, arg, this.appspec.popup);

      }

      $R.log("Controller onClickポップアップ画面 : end");
    }

    // ---------------------------------------
    // チェンジ イベント処理（追加処理） datetimepicker用
    // ---------------------------------------
   ,onChange計上日付: function(event) {
      $R.log("Controller onChange計上日付 : start");

      this.model.onChange計上日付();

      $R.log("Controller onChange計上日付 : end");
    }

    // ---------------------------------------
    // チェンジ イベント処理（追加処理）
    // ---------------------------------------
   ,onChangeセレクトボックス: function(event) {
      $R.log("Controller onChangeセレクトボックス : start");

      this.model.onChangeSelectBox(event, this.appspec.selectbox);

      $R.log("Controller onChangeセレクトボックス : end");
    }

   ,onChange行セレクトボックス: function(event, arg) {
      $R.log("Controller onChange行セレクトボックス : start");

      var arg = this.model.onChange行セレクトボックス(event);

      $R.log("Controller onChange行セレクトボックス : end");
    }

   ,onChange行チェックボックス: function(event, arg) {
      $R.log("Controller onChange行チェックボックス : start");

      var arg = this.model.onChange行チェックボックス(event);

      $R.log("Controller onChange行チェックボックス : end");
    }

//   ,onChange数量単価: function(event, arg) {
//      $R.log("Controller onChange数量単価 : start");
//
//      this.model.edit金額計算(event);
//      this.model.edit合計金額計算();
//
//      $R.log("Controller onChange数量単価 : end");
//    }

  });
}(jQuery, Rmenu));
