(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.MoneyReceivedClearing;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスターメンテパターン　ミックスインを追加する
  Model.include($R.Library.MasterMainteModelMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Model.include({

    // -------------------------------------------------------------------
    //  初期処理（オーバライド）
    // -------------------------------------------------------------------
    on初期処理: function() {
      $R.log("Model on初期処理 : start");

      // セッションデータに識別名を設定する
      //sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.beforename);
      //var テーブルＩＤ = sessionStorage.loadItem('テーブルＩＤ'         );
      //var 行番号       = sessionStorage.loadItem('受注明細_行番号'      );
      //var 受注工程ＩＤ = sessionStorage.loadItem('受注明細_受注工程ＩＤ');
      //var 得意先ＩＤ   = sessionStorage.loadItem('受注明細_得意先ＩＤ'  );
      //var 出荷先ＩＤ   = sessionStorage.loadItem('受注明細_出荷先ＩＤ'  );

      // Datasetに検索条件を初期セットする。
      //var dataset    = this.dataset.getData();
      //var detailInfo = this.appspec.getJSONChunkByIdAtRecords(dataset, "header");
      //detailInfo["record"]["テーブルＩＤ"       ]["value"][0] = テーブルＩＤ;
      //detailInfo["record"]["検索用_行番号"      ]["value"][0] = 行番号;
      //detailInfo["record"]["検索用_得意先ＩＤ"  ]["value"][0] = 得意先ＩＤ;
      //detailInfo["record"]["検索用_出荷先ＩＤ"  ]["value"][0] = 出荷先ＩＤ;
      //detailInfo["record"]["検索用_受注工程ＩＤ"]["value"][0] = 受注工程ＩＤ;

      var arg = {};
      this.pubsub.publish("show初期処理", arg);

      $R.log("Model on初期処理 : end");
    }

    // -------------------------------------
    //  リクエストデータ　編集・チェック処理（オーバライド）
    // -------------------------------------
   ,on登録OfCheckRequestData: function(requestData, mode) {
      $R.log("Model on登録OfCheckRequestData : start");

      var status = this.on訂正OfCheckRequestData(requestData, mode);

      var dataset       = this.dataset.getData();
      var datasetDetail = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
      var datasetRecord = datasetDetail["record"];

      var requestDetail = this.appspec.getJSONChunkByIdAtRecords(requestData, "detail");
      var requestRecord = requestDetail["record"];

      var len = requestRecord["行番号"]["value"].length;
      var j = 0;

      for (var i=0 ; i < len ; i++){
         if (datasetRecord["行削除"]["value"][i] == "1") {
           for (var key in requestRecord) {
              requestRecord[key]["value"].splice(j, 1);
           }
         } else {
           j = j + 1;
        }
      }

      var len = requestRecord["行番号"]["value"].length;
      for (var i=0 ; i < len ; i++){
        requestRecord["行番号"]["value"][i] = i+1;
      }

      $R.log("Model on登録OfCheckRequestData : end");
      return status;
    }

    // -------------------------------
    //  レスポンスデータ　編集処理（オーバライド）
    // -------------------------------
   ,on照会OfEditResponseData: function(responseData, mode) {
      $R.log("Model on照会OfEditResponseData : start");

      // チェックボックスをクリアする
      $(".行削除").prop("checked", false);

      $R.log("Model on照会OfEditResponseData : end");
    }

    // ---------------------------------------
    // チェンジ イベント処理（追加処理） datetimepicker用
    // ---------------------------------------
   ,onChange計上日付: function(event) {
      $R.log("Model onChange計上日付 : start");

      var createDate   = $("#計上日付").val();
      this.dataset.setElementData(createDate, "計上日付");

      $R.log("Model onChange計上日付 : end");
    }

    // ---------------------------------------
    // チェンジ イベント処理（追加処理）
    // ---------------------------------------
   ,onChange行セレクトボックス: function(event) {
      $R.log("Model onChange行セレクトボックス : start");

      // デフォルトラインを設定する
      var dataSet       = this.dataset.getData();
      var dataSetRecord = this.appspec.getJSONChunkByIdAtRecords(dataSet, "detail");

      var name = event.currentTarget.name;
      var row  = event.currentTarget.parentNode.parentNode.rowIndex - 1;

      var selectObject  = $("."+name);
      dataSetRecord["record"][name]["value"][row] = $(selectObject[row]).val();

      $R.log("Model onChange行セレクトボックス : end");
    }

   ,onChange行チェックボックス: function(event) {
      $R.log("Model onChange行チェックボックス : start");

      // デフォルトラインを設定する
      var dataSet       = this.dataset.getData();
      var dataSetRecord = this.appspec.getJSONChunkByIdAtRecords(dataSet, "detail");

      var name = event.currentTarget.name;
      var row  = event.currentTarget.parentNode.parentNode.rowIndex - 1;

      var selectObject  = $("."+name);
      if ($(selectObject[row]).prop('checked')) {
        dataSetRecord["record"][name]["value"][row] = "1";
      } else {
        dataSetRecord["record"][name]["value"][row] = "0";
      }
      $R.log("onChange行チェックボックス : end");
    }

    // -------------------------------------------------------
    //  金額計算　処理
    // -------------------------------------------------------
   ,edit金額計算: function(arg) {
// ,edit金額計算: function(event) {
      $R.log("Model edit金額計算 : start");

      var dataSet       = this.dataset.getData();
      var dataSetRecord = this.appspec.getJSONChunkByIdAtRecords(dataSet, "detail");

      var targetID = arg["target"].name;
      var value    = arg["value"];
      var row      = arg["row"];

//    var name = event.currentTarget.name;
//    var row  = event.currentTarget.parentNode.parentNode.rowIndex - 1;

//    var selectObject1  = $("."+name);
//    dataSetRecord["record"][name]["value"][row] = $(selectObject1[row]).val();

      var 金額    = dataSetRecord["record"]["金額"]["value"][row];

      if (金額 == "") {
         var 数量 = dataSetRecord["record"]["数量"]["value"][row];
         var 単価 = dataSetRecord["record"]["単価"]["value"][row];
         if (数量 != "" && 単価 != "") {
            金額 = new BigNumber(単価).times(数量).floor().toPrecision(); //切り捨て
            dataSetRecord["record"]["金額"]["value"][row] = 金額;

            var argP    = {
                "targetid" : "金額"
               ,"row"      : row
               ,"value"    : 金額
            }
            this.pubsub.publish("show金額", argP);
            this.edit合計金額計算();

         }
      }

      $R.log("Model edit金額計算 : end");
    }

    // -------------------------------------------------------
    //  合計金額計算　処理
    // -------------------------------------------------------
   ,edit合計金額計算: function() {
      $R.log("Model edit合計金額計算 : start");

      var dataSet       = this.dataset.getData();
      var dataSetRecord = this.appspec.getJSONChunkByIdAtRecords(dataSet, "detail");

      var 合計金額 = 0;
      for (var i=0 ; i<dataSetRecord["record"]["金額"]["value"].length ; i++){
         合計金額 = 合計金額 + dataSetRecord["record"]["金額"]["value"][i]*1;
      }

      var argP    = {
          "targetid" : "合計金額"
         ,"value"    : 合計金額
      }
      this.pubsub.publish("show合計金額", argP);

      $R.log("Model edit合計金額計算 : end");
    }

  });
}(jQuery, Rmenu));
