(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.MoneyReceivedInput;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスターメンテパターン　ミックスインを追加する
  Model.include($R.Library.MasterMainteModelMixin9);
  Model.include($R.Library.RmenuSalesModelMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Model.include({
    // ----------------------------------------
    // テーブルＩＤをデータセットに格納する
    // ----------------------------------------
    setテーブルＩＤ: function() {
      $R.log("Model setテーブルＩＤ : start");

      var w_会計年度 = sessionStorage.loadItem("会計年度");
      var w_伝票番号 = sessionStorage.loadItem("伝票番号");
			
      this.dataset.setElementData(w_会計年度, "会計年度");
      this.dataset.setElementData(w_伝票番号, "伝票番号");

      $R.log("Model setテーブルＩＤ : end");
    }

    // ---------------------------------------
    // ボタン・ファンクションキー イベント処理
    // ---------------------------------------
   ,on検索契約者: function(arg) {
      $R.log("Controller on検索契約者 : start");

      this.dataset.setElementData(arg["契約区分"], "契約区分");
      this.dataset.setElementData(arg["アカウント発行区分ＩＤ"], "アカウント発行区分ＩＤ");
      this.dataset.setElementData(arg["契約者ＩＤ"], "契約者ＩＤ");
      this.dataset.setElementData(arg["会社名"], "契約者名");

      $R.log("Controller on検索契約者 : end");
    }
    // ---------------------------------------
    // チェンジ イベント処理（追加処理）
    // ---------------------------------------
   ,onChange入金区分ＩＤ: function(event, row) {
      $R.log("Model onChange入金区分ＩＤ : start");

			var w_入金区分ＩＤ = event.currentTarget.value;
			this.dataset.setElementData(w_入金区分ＩＤ, "入金区分ＩＤ", row - 1);

      $R.log("Model onChange入金区分ＩＤ : end");
    }
   ,onChange削除: function(event, row) {
      $R.log("Model onChange削除 : start");

			var value = event.currentTarget.checked;
			if (value) {
			  this.dataset.setElementData("1", "削除", row - 1);
			}
			else {
			  this.dataset.setElementData("0", "削除", row - 1);
			}
			
      $R.log("Model onChange削除 : end");
    }
   ,check金額: function(event, row) {
      $R.log("Model check金額 : start");

      var dataset       = this.dataset.getData();
      var datasetRecord = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail")["record"];
			var w_削除        = datasetRecord["削除"]["value"];
			var maxsize       = datasetRecord["金額"]["value"].length;
			var status;
			var w_合計金額    = 0;
			var w_金額        = 0;

			for (var i = 0; i < maxsize; i++) {
				if (w_削除[i] == "1") {
					continue;
				}
				
				w_金額 = datasetRecord["金額"]["value"][i];
				if ( w_金額 == "" ) {
					w_金額 = 0;
				}
			  w_合計金額 = new BigNumber(w_合計金額).plus(w_金額);
			}

      var datasetRecordH = this.appspec.getJSONChunkByIdAtRecords(dataset, "header")["record"];
			datasetRecordH["合計金額"]["value"][0] = w_合計金額;
			
			var arg = {};
      arg["合計金額"] = w_合計金額;
			
      $R.log("Model check金額 : end");
			return arg;
    }
    // -------------------------------------
    //  リクエストデータ　編集・チェック処理
    // -------------------------------------
   ,set会計年度: function(requestData, mode) {
      $R.log("Model set会計年度 : start");

      var headerRecord = this.appspec.getJSONChunkByIdAtRecords(requestData, "header")["record"];
			
			w_会計年度     = this.get会計年度();
			w_ヘッダー日付 = this.getヘッダー日付();
			
			headerRecord["会計年度"]["value"][0]     = w_会計年度
			headerRecord["ヘッダー日付"]["value"][0] = w_ヘッダー日付
			
      $R.log("Model set会計年度 : end");
    }

   ,set行番号: function(requestData, mode) {
      $R.log("Model set行番号 : start");

			var status       = true;
      var detailRecord = this.appspec.getJSONChunkByIdAtRecords(requestData, "detail")["record"];
			var maxsize      = detailRecord["金額"]["value"].length;
			var w_行番号     = 1;
			
			for (var i = 0; i < maxsize; i++ ) {
				detailRecord["行"]["value"][i] = w_行番号;
				w_行番号                       = w_行番号 + 1;
			}

			if (w_行番号 == 0) {
        var status = "ERROR";
        var msg    = "明細行が入力されていません。入力して下さい。";
        var arg    = {title: "明細行入力エラー", status: status, message: msg};
        this.pubsub.publish("serverDialog", arg);
				
				status = false;
			}
			
      $R.log("Model set行番号 : end");
      return status;
    }
    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,on初期処理OfEditResponseData: function(responseData, mode) {
      $R.log("Model on初期処理OfEditResponseData : start");

      this.dataset.clearDataValue();                   // Datasetの値をクリアする
      this.dataset.clearFormElementNo();               // フォームオブジェクトの要素番号をクリアする
      this.dataset.setFormElementNo();                 // フォームオブジェクトの要素番号を設定する

      $R.log("Model on初期処理OfEditResponseData : end");
    }

  });
}(jQuery, Rmenu));
