(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.MoneyReceivedInput;

  // インスタンスプロパティを追加する
  var View = App.View = new $R.Class($R.View);
  View.fn.init = function(appspec) {
    $R.log("View init : start");

    this.appspec = appspec;

    $R.log("View init : end");
  }

  // モジュールを追加する
  View.include($R.Library.FormatMixin);
  View.include($R.Library.OutlineMixin);
  View.include($R.Library.LoadTemplateMixin);
  View.include($R.Library.ViewMixin);

  // マスターメンテパターン　ミックスインを追加する
  View.include($R.Library.MasterMainteViewMixin);
  View.include($R.Library.RmenuSalesViewMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  View.include({
    // --------
    // 処理開始
    // --------
    initExecute: function(dataset) {
      $R.log("View initExecute : start");

      this.initテンプレートロード();
      this.initAlertDialog();                     // 警告メッセージ用ダイアログ 初期処理
      this.initConfirmDialog(this);               // 確認メッセージ用ダイアログ 初期処理
      this.initExecuteDialog(this);               // 実行確認メッセージ用ダイアログ 初期処理
      this.initServerDialog(this);                // サーバ確認メッセージ用ダイアログ 初期処理

      $R.log("View initExecute : end");
    }
    // ---------------------------------------
    // ボタン・ファンクションキー イベント処理
    // ---------------------------------------
   ,on検索契約者: function(arg) {
      $R.log("View on検索契約者 : start");
			
			$("#契約者名").val(arg["会社名"]);

      $R.log("View on検索契約者 : end");
    }
   ,show合計金額計算: function(arg) {
      $R.log("Controller show合計金額計算 : start");

      $("#合計金額").text(this.formatExecute["quantity"]["format"](arg["合計金額"]));
			
      $R.log("Controller show合計金額計算 : end");
    }
    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,on初期処理OfEditResponseData: function(dataset, defSelectBox) {
      $R.log("View on初期処理OfEditResponseData : start");
			
      var w_入金区分レコード = this.appspec.getJSONChunkByIdAtRecords(dataset, "入金区分")["record"];
			var max                = w_入金区分レコード["選択入金区分ＩＤ"]["value"].length;			
			var w_入金区分ＩＤ     = $(".入金区分ＩＤ");
			
      $(".入金区分ＩＤ option").remove(); //20150703 追加 Okada

      var option = $('<option selected:selected/>');
      option.val("");
      option.html("区分選択");
      $(w_入金区分ＩＤ[0]).append(option);
			

      for (var i = 0; i < max; i++) {
        option = $('<option />');
        option.val(w_入金区分レコード["選択入金区分ＩＤ"]["value"][i]);
        option.html(w_入金区分レコード["選択入金区分名称"]["value"][i]);
        $(w_入金区分ＩＤ[0]).append(option);
      }


      // テーブルの空行を作成する
      var detailInfo  = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
      if (detailInfo) {
        if (detailInfo["multiline"] == "yes") {
          var defaultline = detailInfo["defaultline"];
          this.createTableRows("#mainTable", defaultline);
        }
      }

      $R.log("View on初期処理OfEditResponseData : end");
    }
    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,on照会OfEditResponseData: function(responseData, mode) {
      $R.log("View on照会OfEditResponseData : start");

			// ヘッダーを表示
      var headerRecord = this.appspec.getJSONChunkByIdAtRecords(responseData, "header")["record"];
			$("#ヘッダー日付").val(headerRecord["ヘッダー日付"]["value"][0]);
			$("#伝票番号").val(headerRecord["伝票番号"]["value"][0]);
			$("#契約者名").val(headerRecord["契約者名"]["value"][0]);
			$("#摘要").val(headerRecord["摘要"]["value"][0]);

			// 明細を表示
      var detailRecord   = this.appspec.getJSONChunkByIdAtRecords(responseData, "detail")["record"];
			var maxsize        = detailRecord["行"]["value"].length;
			var w_行           = $(".行");
			var w_入金区分ＩＤ = $(".入金区分ＩＤ");
			var w_金額         = $(".金額");
			var w_備考         = $(".備考");
			var w_削除         = $(".削除");
			
			for (var i = 0; i < maxsize; i++) {
			  $(w_行[i]).val(detailRecord["行"]["value"][i]);
			  $(w_入金区分ＩＤ[i]).val(detailRecord["入金区分ＩＤ"]["value"][i]);
			  $(w_金額[i]).val(this.formatExecute["quantity"]["format"](detailRecord["金額"]["value"][i]));
			  $(w_備考[i]).val(detailRecord["備考"]["value"][i]);
			}


      $R.log("View on照会OfEditResponseData : end");
    }


  });
}(jQuery, Rmenu));
