(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.ParallelList;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスター一覧パターン　ミックスインを追加する
  Model.include($R.Library.MasterMainteListModelMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Model.include({
    // -------------------------------------------------------
    //  処理モードをセッションストレージに格納する
    // -------------------------------------------------------
    set処理モード: function(mode) {
      $R.log("Model set処理モード : start");

      // セッションデータに識別名を設定する 2015.10.07 shimoji 訂正
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      sessionStorage.saveItem("処理モード", mode);

      var row        = sessionStorage.loadItem("クリック行");
			var id         = 0;
			if (row != "") {
        var dataset    = this.dataset.getData();
        var detailInfo = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
        id             = detailInfo["record"]["テーブルＩＤ"]["value"][row]
			}

      // セッションデータに識別名を設定する 2015.10.07 shimoji 訂正
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.nextname);
      sessionStorage.saveItem("処理モード", mode);
      sessionStorage.saveItem("テーブルＩＤ", id);

      $R.log("Model set処理モード : end");
      return true;
    }
    // -----------------------------------
    //  リクエストデータ　チェック処理
    // -----------------------------------
   ,on処理削除OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on処理削除OfCheckRequestData : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + ".ParallelList");
      var controllID = sessionStorage.loadItem("並列分散管理ＩＤ");
      var status     = false;

      if (controllID) {
        var headerRecord = this.appspec.getJSONChunkByIdAtRecords(requestData, "header")["record"];
        headerRecord["並列分散管理削除ＩＤ"]["value"][0] = controllID;
        status = true;
      }

      $R.log("Controller on処理削除OfCheckRequestData : end");
      return status;
    }
    // -------------------------------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------------------------------
   ,on処理削除OfEditResponseData: function(responseData) {
      $R.log("Model on処理削除OfEditResponseData : start");

      var status = responseData["message"]["status"];
      var msg    = responseData["message"]["msg"];
      var arg    = {title: "サーバ処理確認", status: status, message: msg};
      this.pubsub.publish("serverDialog", arg);

      $R.log("Model on処理削除OfEditResponseData : end");
    }
  });
}(jQuery, Rmenu));