(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.ParallelPrintList;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスター一覧パターン　ミックスインを追加する
  Model.include($R.Library.MasterMainteListModelMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Model.include({
    // -------------------------------------------------------
    //  処理モードをセッションストレージに格納する
    // -------------------------------------------------------
    set処理モード: function(mode) {
      $R.log("Model set処理モード : start");

      // セッションデータに識別名を設定する 2015.10.07 shimoji 訂正
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      sessionStorage.saveItem("処理モード", mode);

      var row        = sessionStorage.loadItem("クリック行");
			var id         = 0;
			if (row != "") {
        var dataset    = this.dataset.getData();
        var detailInfo = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
        id             = detailInfo["record"]["テーブルＩＤ"]["value"][row]
			}

      // セッションデータに識別名を設定する 2015.10.07 shimoji 訂正
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.nextname);
      sessionStorage.saveItem("処理モード", mode);
      sessionStorage.saveItem("テーブルＩＤ", id);

      $R.log("Model set処理モード : end");
      return true;
    }
    // -------------------------------------------------------
    //  テーブルの選択行をセッションストレージに格納する
    // -------------------------------------------------------
   ,onテーブル行クリック: function(arg) {
      $R.log("Model onテーブル行クリック : start");

      var clickRow  = arg["クリック行"] - 1;

      var dataset    = this.dataset.getData();
      var detailInfo = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
      if (detailInfo["record"]["並列分散管理ＩＤ"]["value"][clickRow]) {
        sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
        sessionStorage.saveItem("並列分散管理ＩＤ", detailInfo["record"]["並列分散管理ＩＤ"]["value"][clickRow]);
        sessionStorage.saveItem("ファイル名称", detailInfo["record"]["ファイル名称"]["value"][clickRow]);

        this.pubsub.publish("onテーブル行クリック", arg);
      }

      $R.log("Model onテーブル行クリック : end");
    }
    // -----------------------------------
    //  リクエストデータ　チェック処理
    // -----------------------------------
   ,on帳票出力OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on帳票出力OfCheckRequestData : start");

      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      var controllID = sessionStorage.loadItem("並列分散管理ＩＤ");
      var status     = false;

      if (controllID) {
        var headerInfo    = this.appspec.getJSONChunkByIdAtRecords(requestData, "header");
        headerInfo["record"]["並列分散管理ＩＤ"]["value"][0] = controllID;
        status = true;
      }

      $R.log("Controller on帳票出力OfCheckRequestData : end");
      return status;
    }
   ,on帳票削除OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on帳票削除OfCheckRequestData : start");

      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      var controllID = sessionStorage.loadItem("並列分散管理ＩＤ");
      var filename = sessionStorage.loadItem("ファイル名称");
      var status     = false;

      if (controllID) {
        var headerInfo    = this.appspec.getJSONChunkByIdAtRecords(requestData, "header");
        headerInfo["record"]["並列分散管理ＩＤ"]["value"][0] = controllID;
        headerInfo["record"]["ファイル名称"]["value"][0]     = filename;
        status = true;
      }

      $R.log("Controller on帳票削除OfCheckRequestData : end");
      return status;
    }
    // -------------------------------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------------------------------
   ,on帳票出力OfEditResponseData: function(responseData) {
      $R.log("Model on帳票出力OfEditResponseData : start");

      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      var argHash  = new Object();
      argHash["file"]   = sessionStorage.loadItem("ファイル名称");
      argHash["type"]   = "pdf";
      argHash["delete"] = "no";
      this.postDownloadRack(argHash);

      $R.log("Model on帳票出力OfEditResponseData : end");
    }
   ,on帳票削除OfEditResponseData: function(responseData) {
      $R.log("Model on帳票削除OfEditResponseData : start");

      var status = responseData["message"]["status"];
      var msg    = responseData["message"]["msg"];
      var arg    = {title: "サーバ処理確認", status: status, message: msg};
      this.pubsub.publish("serverDialog", arg);

      $R.log("Model on帳票削除OfEditResponseData : end");
    }

  });
}(jQuery, Rmenu));