(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.ProductItemList;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスター一覧パターン　ミックスインを追加する
  Model.include($R.Library.MasterMainteListModelMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Model.include({
    // -----------------------------------
    //  検索文字列　クリア処理（追加処理）
    // -----------------------------------
     on検索: function() {
      $R.log("Model on検索 : start");

      this.onChangeセレクトボックス();
			
      $R.log("Model on検索 : end");
    }

    // -----------------------------------
    //  検索文字列　クリア処理（追加処理）
    // -----------------------------------
   ,onクリア: function(arg) {
      $R.log("Model onクリア : start");

      this.dataset.setElementData("", "検索請求内容ＩＤ");
      this.dataset.setElementData("", "検索請求形態ＩＤ");
      this.dataset.setElementData("", "検索商品名");

      $R.log("Model onクリア : end");
    }

    // -------------------------------------------------------
    //  データが選択されているかチェックする
    // -------------------------------------------------------
   ,check行選択: function() {
      $R.log("Model check行選択 : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var value = sessionStorage.loadItem("クリック行");
			if (!isNaN(value)) {
        if (value) return true;
			}
			

      //var dataset    = this.dataset.getData();
      //var detailInfo = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
			//if (detailInfo["record"]["テーブルＩＤ"]["value"].length != 0) {
			//	return true;
			//}
			
      var arg = {};
      arg["title"]   = "選択エラー";
      arg["status"]  = "ERROR";
      arg["message"] = "行が選択されていません。選択して下さい。";
      this.pubsub.publish("alertDialog", arg);

      $R.log("Model check行選択 : end");
      return false;
    }
    // -------------------------------------------------------
    //  処理モードをセッションストレージに格納する
    // -------------------------------------------------------
   ,set処理モード: function(mode) {
      $R.log("Model set処理モード : start");

      // セッションデータに識別名を設定する 2015.10.07 shimoji 訂正
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      sessionStorage.saveItem("処理モード", mode);

      var row        = sessionStorage.loadItem("クリック行");
			var id         = 0;
			if (mode != "insert") {
        var dataset    = this.dataset.getData();
        var detailInfo = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
        id             = detailInfo["record"]["テーブルＩＤ"]["value"][row]
			}

      // セッションデータに識別名を設定する 2015.10.07 shimoji 訂正
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.nextname);
      sessionStorage.saveItem("処理モード", mode);
      sessionStorage.saveItem("テーブルＩＤ", id);

      $R.log("Model set処理モード : end");
      return true;
    }
    // -------------------------------------
    // チェンジ イベント処理（追加処理）
    // -------------------------------------
   ,onChangeセレクトボックス: function() {
      $R.log("Model onChangeセレクトボックス : start");

			var w_検索請求内容選択 = $("#検索請求内容選択").val();
			var w_検索請求形態選択 = $("#検索請求形態選択").val();
			var w_検索商品名       = $("#検索商品名").val();
			
      this.dataset.setElementData(w_検索請求内容選択, "検索請求内容ＩＤ");
      this.dataset.setElementData(w_検索請求形態選択, "検索請求形態ＩＤ");
      this.dataset.setElementData(w_検索商品名, "検索商品名");

			// 次画面用のセッションストレージデータを設定
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.nextname);
      sessionStorage.saveItem("検索請求内容ＩＤ", w_検索請求内容選択);
      sessionStorage.saveItem("検索請求形態ＩＤ", w_検索請求形態選択);
      sessionStorage.saveItem("検索商品名", w_検索商品名);

			// 当画面用のセッションストレージデータを設定
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      sessionStorage.saveItem("検索請求内容ＩＤ", w_検索請求内容選択);
      sessionStorage.saveItem("検索請求形態ＩＤ", w_検索請求形態選択);
      sessionStorage.saveItem("検索商品名", w_検索商品名);

      $R.log("Model onChangeセレクトボックス : end");
    }
		
    // -------------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------------
   ,on初期処理OfEditResponseData: function(responseData, mode) {
      $R.log("Model on初期処理OfEditResponseData : start");

      this.dataset.setElementData("", "検索請求内容ＩＤ");
      this.dataset.setElementData("", "検索請求形態ＩＤ");
      this.dataset.setElementData("", "検索商品名");

      $R.log("Model on初期処理OfEditResponseData : end");
    }

   ,on初期処理リロードOfEditResponseData: function(responseData, mode) {
      $R.log("Model on初期処理リロードOfEditResponseData : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      var w_検索請求内容ＩＤ = sessionStorage.loadItem("検索請求内容ＩＤ");
      var w_検索請求形態ＩＤ = sessionStorage.loadItem("検索請求形態ＩＤ");
      var w_検索商品名       = sessionStorage.loadItem("検索商品名");
			
			if ( w_検索請求内容ＩＤ == null ) {
				w_検索請求内容ＩＤ = "";
			}
			if ( w_検索請求形態ＩＤ == null ) {
				w_検索請求形態ＩＤ = "";
			}
			if ( w_検索商品名 == null ) {
				w_検索商品名 = "";
			}

      this.dataset.setElementData(w_検索請求内容ＩＤ, "検索請求内容ＩＤ");
      this.dataset.setElementData(w_検索請求形態ＩＤ, "検索請求形態ＩＤ");
      this.dataset.setElementData(w_検索商品名, "検索商品名");
			
			var arg = {};
			arg["検索請求内容ＩＤ"] = w_検索請求内容ＩＤ;
			arg["検索請求形態ＩＤ"] = w_検索請求形態ＩＤ;
			arg["検索商品名"]       = w_検索商品名;

      $R.log("Model on初期処理リロードOfEditResponseData : end");
			return arg;
    }

	});

}(jQuery, Rmenu));