(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.ProductItemList;

  // インスタンスプロパティを追加する
  var View = App.View = new $R.Class($R.View);
  View.fn.init = function(appspec) {
    $R.log("View init : start");

    this.appspec = appspec;

    $R.log("View init : end");
  }

  // 共通モジュールを追加する
  View.include($R.Library.FormatMixin);
  View.include($R.Library.OutlineMixin);
  View.include($R.Library.LoadTemplateMixin);
  View.include($R.Library.ViewMixin);

  // マスター一覧パターン　ミックスインを追加する
  View.include($R.Library.MasterMainteListViewMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  View.include({
    // -----------------------------------
    //  検索文字列　クリア処理（追加処理）
    // -----------------------------------
    onクリア: function() {
      $R.log("View onクリア : start");

      $("#検索請求内容選択").val("");
      $("#検索請求形態選択").val("");
      $("#検索商品名").val("");
			
      $R.log("View onクリア : end");
    }
		
    // -------------------------------------------------------
    // テーブルにデータを表示する
    // -------------------------------------------------------
   ,onテーブル表示: function(arg) {
      $R.log("View onテーブル表示 : start");

      var rows = $("#mainTable")[0].rows;
      jQuery.each(rows, function(j) {
        k = j -1;
        var cells = rows[j].cells;
        jQuery.each(cells, function() {
          $(this).removeClass("rowBackground");
        });
      });

      // テーブルにデータを表示する
      this.showTableData(arg);

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      var mode     = sessionStorage.loadItem("処理モード");
      var clickRow = sessionStorage.loadItem("クリック行");
      var arg = {クリック行: parseInt(clickRow, 10) + 1};
      this.pubsub.publish("onテーブル行クリック", arg);

      $R.log("View onテーブル表示 : end");
    }
		
    // -------------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------------
   ,on初期処理リロードOfEditResponseData: function(arg) {
      $R.log("View on初期処理リロードOfEditResponseData : start");

      $("#検索請求内容選択").val(arg["検索請求内容ＩＤ"]);
      $("#検索請求形態選択").val(arg["検索請求形態ＩＤ"]);
      $("#検索商品名").val(arg["検索商品名"]);

      $R.log("View on初期処理リロードOfEditResponseData : end");
    }

  });

}(jQuery, Rmenu));