(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.SalesCheckList;

  // インスタンスプロパティを追加する
  var Controller = App.Controller = new $R.Class($R.Controller);
  Controller.fn.init = function(appspec, model, view) {
    $R.log("Controllerr init : start");

    this.appspec = appspec;
    this.model   = model;
    this.view    = view;
    this.createPubSubEvent();

    var self = this;

    var api1 = $('#datetimepicker').datetimepicker({
	      format : 'yyyy/MM/dd',
        language : 'ja',
      	pickTime : false
    }).data('datetimepicker');
    api1.widget.on('click','td.day',function(){
      	api1.hide();
        self.onChangeヘッダー日付();
    });

    $R.log("Controllerr init : end");
  };

  // 共通モジュールを追加する
  Controller.include($R.Library.EnterTabPFKeyMixin);
  Controller.include($R.Library.ControllerMixin);

  // マスター一覧パターン　ミックスインを追加する
  Controller.include($R.Library.MasterMainteListControllerMixin);
  Controller.include($R.Library.RmenuSalesControllerMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Controller.include({
    // 初期処理
    // ---------------------------------------
    on初期処理: function() {
      $R.log("Controller on初期処理 : start");

      this.model.on初期処理();

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var currentpage = sessionStorage.loadItem("カレントページ");
      if (currentpage){
				this.model.on初期処理_リロード();
				this.view.on初期処理_リロード();
        this.onリロード();
      }
      else {
				this.model.on初期処理_最初のページ();
        this.on最初のページ();
      }

      $R.log("Controller on初期処理 : end");
    }
    // ---------------------------------------
    // ボタン・ファンクションキー イベント処理
    // ---------------------------------------
   ,on検索契約者: function(event, arg) {
      $R.log("Controller on検索契約者 : start");

      if (arg === undefined) {
        // セッションデータに識別名を設定する
        sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);


			  // コールバックＩＤを設定する
        sessionStorage.setIdName(this.appspec.sysname + "." + "ContractantListSearch");
        sessionStorage.saveItem("コールバックＩＤ", "#検索契約者");

        var argWin = "fullscreen=1, scrollbars=1";
        this.model.postPopupTransition("RmenuSales/Html/Apps/ContractantListSearch", argWin);
				
				
        //this.model.setTransitionData("RmenuSales/Html/Apps/SalesCheckList");
        //this.model.postHtmlTransition("RmenuSales/Html/Apps/ContractantListSearch");

      }
      else {
        this.model.on検索契約者(arg);
        this.view.on検索契約者(arg);
      }

      $R.log("Controller on検索契約者 : end");
    }
   ,on検索: function(event) {
      $R.log("Controller on検索 : start");

      this.on最初のページ();

      $R.log("Controller on検索 : end");
    }
   ,onクリア: function(event) {
      $R.log("Controller onクリア : start");
			
			this.model.onクリア();
			this.view.onクリア();

      $R.log("Controller onクリア : end");
    }
		
  });

}(jQuery, Rmenu));