(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.SalesInput;

  // インスタンスプロパティを追加する
  var Controller = App.Controller = new $R.Class($R.Controller);
  Controller.fn.init = function(appspec, model, view) {
    $R.log("Controllerr init : start");

    this.appspec = appspec;
    this.model   = model;
    this.view    = view;
    this.createPubSubEvent();

    var self = this;

    var api1 = $('#datetimepicker').datetimepicker({
	      format : 'yyyy/MM/dd',
        language : 'ja',
      	pickTime : false
    }).data('datetimepicker');
    api1.widget.on('click','td.day',function(){
      	api1.hide();
        self.onChangeヘッダー日付();
    });

    $R.log("Controllerr init : end");
  };

  // モジュールを追加する
  Controller.include($R.Library.EnterTabPFKeyMixin);
  Controller.include($R.Library.ControllerMixin);

  // マスターメンテパターン　ミックスインを追加する
  Controller.include($R.Library.MasterMainteControllerMixin);
  Controller.include($R.Library.RmenuSalesControllerMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Controller.include({
    // ---------------------------------------
    // 初期処理（オーバライド処理）
    // ---------------------------------------
    on初期処理: function() {
      $R.log("Controller on初期処理 : start");

      this.model.on初期処理();
      this.ajaxExecute("init");

      $R.log("Controller on初期処理 : end");
    }

    // ---------------------------------------
    // ボタン・ファンクションキー イベント処理
    // ---------------------------------------
   ,on検索契約者: function(event, arg) {
      $R.log("Controller on検索契約者 : start");

      if (arg === undefined) {
        // セッションデータに識別名を設定する
        sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);


			  // コールバックＩＤを設定する
        sessionStorage.setIdName(this.appspec.sysname + "." + "ContractantListSearch");
        sessionStorage.saveItem("コールバックＩＤ", "#検索契約者");

        var argWin = "fullscreen=1, scrollbars=1";
        this.model.postPopupTransition("RmenuSales/Html/Apps/ContractantListSearch", argWin);

      }
      else {
        this.model.on検索契約者(arg);
        this.view.on検索契約者(arg);
      }

      $R.log("Controller on検索契約者 : end");
    }

    // ---------------------------------------
    // テーブル行　画像検索　クリック処理処理
    // ---------------------------------------
   ,on商品検索: function(event, arg) {
      $R.log("Controller on商品検索 : start");

      if (arg === undefined) {
			  var row    = event.currentTarget.parentNode.parentNode.parentNode.rowIndex;
        var arg9   = {クリック行: row};
        this.model.on商品検索(arg9);
				
        // コールバックＩＤを設定する
        sessionStorage.setIdName(this.appspec.sysname + ".ProductItemListSearch");
        sessionStorage.saveItem("コールバックＩＤ", "#商品検索後処理");
				
        var argWin = "fullscreen=1, scrollbars=1";
        this.model.postPopupTransition("RmenuSales/Html/Apps/ProductItemListSearch", argWin);
				
      }

      $R.log("Controller on商品検索 : end");
    }

    // ---------------------------------------
    // テーブル　画像検索 後処理
    // ---------------------------------------
   ,on商品検索後処理: function(event, arg) {
      $R.log("Controller on商品検索後処理 : start");

      if (arg === undefined) {
      }
      else {
        this.model.on商品検索後処理(arg);
        this.view.on商品検索後処理(arg);
      }

      $R.log("Controller on商品検索後処理 : end");
    }

    // ---------------------------------------
    // チェンジ イベント処理（追加処理）
    // ---------------------------------------
   ,onChange売上区分ＩＤ: function(event, arg) {
      $R.log("Controller onChange売上区分ＩＤ : start");

			var row = event.currentTarget.parentNode.parentNode.rowIndex;
      this.model.onChange売上区分ＩＤ(event, row);

      $R.log("Controller onChange売上区分ＩＤ : end");
    }

   ,onChange削除: function(event, arg) {
      $R.log("Controller onChange削除 : start");

			var row = event.currentTarget.parentNode.parentNode.rowIndex;
      this.model.onChange削除(event, row);
			
      var arg2 = this.model.edit合計金額計算();
      this.view.show合計金額計算(arg2);

      $R.log("Controller onChange削除 : end");
    }

   ,onChange数量: function(event, arg) {
      $R.log("Controller onChange数量 : start");

			var row = event.currentTarget.parentNode.parentNode.rowIndex;
			
      var arg1 = this.model.onChange数量(event, row);
      this.view.show金額計算(arg1, row);
			
      var arg2 = this.model.edit合計金額計算();
      this.view.show合計金額計算(arg2);

      $R.log("Controller onChange数量 : end");
    }

   ,onChange単価: function(event, arg) {
      $R.log("Controller onChange単価 : start");

			var row = event.currentTarget.parentNode.parentNode.rowIndex;
			
      var arg1 = this.model.onChange単価(event, row);
      this.view.show金額計算(arg1, row);
			
      var arg2 = this.model.edit合計金額計算();
      this.view.show合計金額計算(arg2);

      $R.log("Controller onChange単価 : end");
    }

    // -------------------------------------
    //  リクエストデータ　編集・チェック処理
    // -------------------------------------
   ,on初期処理OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on初期処理OfCheckRequestData : start");

      var status = this.checkRequestData(requestData);

      $R.log("Controller on初期処理OfCheckRequestData : end");
      return status;
    }
   ,on登録OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on登録OfCheckRequestData : start");

      var status = this.model.on登録OfCheckRequestData(requestData, mode);
      if (status) {
        status = this.checkRequestData(requestData);
      }
      if (status) {
        this.model.set会計年度(requestData, mode);
        status = this.model.set行番号(requestData, mode);
      }

      $R.log("Controller on登録OfCheckRequestData : end");
      return status;
    }
   ,on訂正OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on訂正OfCheckRequestData : start");

      var status = this.model.on訂正OfCheckRequestData(requestData, mode);
      if (status) {
        status = this.checkRequestData(requestData);
      }
      if (status) {
        this.model.set会計年度(requestData, mode);
        status = this.model.set行番号(requestData, mode);
      }

      $R.log("Controller on訂正OfCheckRequestData : end");
      return status;
    }

    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,on初期処理OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on初期処理OfEditResponseData : start");

      this.editResponseData(responseData);
			
			this.on今日();
      var dataset = this.model.dataset.getData();
			this.model.on初期処理OfEditResponseData(responseData, mode);
			this.view.on初期処理OfEditResponseData(dataset, this.appspec.selectbox[0]);


      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      var mode = sessionStorage.loadItem("処理モード");

      if (mode != "insert") {
        this.model.setテーブルＩＤ();
        this.ajaxExecute("select");
      }

      $R.log("Controller on初期処理OfEditResponseData : end");
    }

    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,on照会OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on照会OfEditResponseData : start");
			
      this.model.dataset.clearResponseValue(responseData);
      this.view.clearResponseValue(responseData);
      this.model.dataset.setResponseValue(responseData, this.pubsub);
      //this.view.setResponseValue(responseData);

      this.view.on照会OfEditResponseData(responseData, mode);

      var arg2 = this.model.edit合計金額計算();
      this.view.show合計金額計算(arg2);

      $R.log("Controller on照会OfEditResponseData : end");
    }

  });
}(jQuery, Rmenu));
