(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.SuppliersInput = {};

  // インスタンスプロパティを追加する
  var AppSpec = App.AppSpec = new $R.Class($R.AppSpec);
  AppSpec.fn.init = function(name) {
    $R.log("AppSpec init : start");

    this.name       = name;
    this.nextname   = "";
    this.beforename = "SuppliersInputList";

    $R.log("AppSpec init : end");
  }

  // 共通モジュールを追加する
  AppSpec.include($R.Library.AppSpecMixin);

  AppSpec.include({
    // -----------------------------------------------------------------------------------------------
    // プログラム・JSONファイルのURL情報を定義する（サブシステム名・種類・Apps・プログラムフォルダ名）
    // -----------------------------------------------------------------------------------------------
    urlInfo: [
      {app:  "RmenuSales/Html/Apps/SuppliersInput/"}
     ,{json: "RmenuSales/Json/Apps/SuppliersInput/"}
    ]
    // --------------------------
    // JSONファイル情報を定義する
    // --------------------------
   ,jsonInfo: [
      {dataset:     "yes"}
     ,{validation:  "yes"}
    ]
    // ----------------------------------------------------------------------------------------
    // トランザクション・リクエストチェック・レスポンス編集・エラーのコールバック関数を定義する
    // ----------------------------------------------------------------------------------------
   ,requestInfo: [
      ["init",   "on初期処理OfCheckRequestData", "on初期処理OfEditResponseData", "onErrorResponseData"]
     ,["select", "on照会OfCheckRequestData",     "on照会OfEditResponseData",     "onErrorResponseData"]
     ,["insert", "on登録OfCheckRequestData",     "on登録OfEditResponseData",     "onErrorResponseData"]
     ,["update", "on訂正OfCheckRequestData",     "on訂正OfEditResponseData",     "onErrorResponseData"]
     ,["delete", "on削除OfCheckRequestData",     "on削除OfEditResponseData",     "onErrorResponseData"]
    ]
    // --------------------------------------------------
    // エンター・タブとPFキーのコールバック関数を定義する
    // --------------------------------------------------
   ,enterTabPFKey: {
      Enter:true
     ,Tab:true
     ,F1:"on実行"
     ,F2:null
     ,F3:null
     ,F4:null
     ,F5:null
     ,F6:null
     ,F7:null
     ,F8:null
     ,F9:null
     ,F10:null
     ,F11:null
     ,F12:null
     ,ESC:"on戻る"
     ,Forms:0
    }
    // ----------------------------------------------------------------
    // イベント設定はセレクタ・イベント・コールバック関数の順に指定する
    // ----------------------------------------------------------------
    // NAVボタンのイベントを定義する
   ,navButtonEvent: [
      ["#戻る", "click", "on戻る"]
     ,["#実行", "click", "on実行"]
     // ここから追加処理
     ,["#伝票発行",       "click", "on伝票発行"]
     ,["#検索契約者",     "click", "on検索契約者"]
     ,[".商品検索",       "click", "on商品検索"]
     ,["#商品検索後処理", "click", "on商品検索後処理"]
    ]
    // バリデーションのイベントを定義する
   ,validationEvent: [
      ["#mainForm", "focus", "onFocus"]
     ,["#mainForm", "blur",  "onBlur"]
    ]
    // その他セレクターイベントを定義する
   ,selectorEvent: [
      ["#mainTable td .売上区分ＩＤ", "change", "onChange売上区分ＩＤ"]
     ,["#mainTable td .削除",         "change", "onChange削除"]
     ,["#mainTable td .数量",         "change", "onChange数量"]
     ,["#mainTable td .単価",         "change", "onChange単価"]
    ]
    // ------------------------------------------------------------------------
    // テーブルイベント設定はセレクタ・イベント・コールバック関数の順に指定する
    // ------------------------------------------------------------------------
    // テーブルRowイベントを定義する
   ,tableRowEvent: [
    ]
    // テーブルオブジェクト　イベントを定義する
   ,tableObjectEvent: [
    ]
    // ----------------------------------------------------------------------------------
    // カスタムイベント設定はイベント名・実行コンテキスト・コールバック関数の順に指定する
    // ----------------------------------------------------------------------------------
    // チェック用カスタムイベントを定義する
   ,pubsubCheckEvent: [
    ]
    // 導出項目編集用カスタムイベントを定義する
   ,pubsubDeriveEvent: [
     //,["derive金額"               , "model" , "edit合計金額計算"    ]
    ]
    // その他カスタムイベントを定義する
   ,pubsubOtherEvent: [
      ["showログイン情報",      "view", "showログイン情報"    ]
     ,["showヘッダータイトル",  "view", "showヘッダータイトル"]
     ,["show初期処理",          "view", "show初期処理"        ]
    // ここから追加処理
     ,["showヘッダー日付",      "view", "showヘッダー日付"]
     ,["showヘッダー曜日",      "view", "showヘッダー曜日"]
    ]
    // ----------------------------------------------------------------------------------
    // セレクトボックス　定義
    // selectorid  : HTMLのIDを指定する
    // selectorname: HTMLのnameを指定する（テーブル内で使用する時に定義する）
    // init        :
    // initvalue   : 初期値（０）
    // inithtml    : 初期表示（～選択）
    // datasetid   : datasetのID名を指定する
    // valuename   : datasetに定義されているキー値の項目名
    // htmlname    : datasetに定義されている表示用データの項目名
    // change      :
    // datasetid   : datasetのID名を指定する
    // valuename   : 選択したキー値を格納するdatasetの項目名
    // htmlname    : 選択した表示値を格納するdatasetの項目名
    // ----------------------------------------------------------------------------------
   ,selectbox: [
      {
          selectorid: ""
         ,selectorname: "売上区分ＩＤ"
         ,init:     {initvalue: "", inithtml: "区分選択", datasetid: "売上区分", valuename: "選択売上区分ＩＤ", htmlname: "選択売上区分名称"}
         ,change:   {datasetid: "detail", valuename: "売上区分ＩＤ", htmlname: "売上区分名称"}
      }
    ]

  });
}(jQuery, Rmenu));
