# coding: UTF-8

require 'date'
require 'RmenuLoggerMixin'                                                      # Logファイル Debug用
require 'RmenuJsonMixin'                                                        # ID名で該当レコードを取得する

class BatchBillingIssueClosingDays_model
  include RmenuLoggerMixin                                                      # Logファイル Debug用
  include RmenuJsonMixin

  def initialize(rmenu_dbi, sql_data, request_data)
    begin
      # initialize 開始ログを出力する
      $Mlog.debug("BatchBillingIssueClosingDays") {"initialize start"}                   # Logファイル Debug用

      @rmenu_dbi      = rmenu_dbi
      @sql_data       = sql_data
      @request_data   = request_data
      
      # initialize 終了ログを出力する
      $Mlog.debug("BatchBillingIssueClosingDays") {"initialize normal end"}              # Logファイル Debug用
    rescue Exception
      # エラーログを出力する
      $Mlog.error("BatchBillingIssueClosingDays") {"initialize exception: #{$!}"}        # Logファイル Debug用
      raise
    end
  end
	

  # バッチ売上年月日を設定する
  def is請求発行契約売上区分(idName, itemValue)
    $Mlog.debug("BatchBillingIssueClosingDays") {"is請求発行契約売上区分 start"}                  # Logファイル Debug用

		status        = "OK"
    requestRecord = getJsonChunkById(@request_data, "records", idName)
		
		if requestRecord["record"]["契約売上区分"]["value"][0] != itemValue
		  status = "PASS"
		end
				
    $Mlog.debug("BatchBillingIssueClosingDays") {"is請求発行契約売上区分 end"}                    # Logファイル Debug用
    return status
  end

	
end
