# coding: UTF-8

require 'RmenuSales/Server/Modules/RmenuSalesMasterMainteOfModelMixin'

class BillingIssueCustomer_model
  include RmenuSalesMasterMainteOfModelMixin

  def initialize(rmenu_dbi, sql_data, request_data)
    begin
      # initialize 開始ログを出力する
      $Mlog.debug("BillingIssueCustomer_model") {"initialize start"}                   # Logファイル Debug用

      @rmenu_dbi      = rmenu_dbi
      @sql_data       = sql_data
      @request_data   = request_data

      # initialize 終了ログを出力する
      $Mlog.debug("BillingIssueCustomer_model") {"initialize normal end"}              # Logファイル Debug用
    rescue Exception
      # エラーログを出力する
      $Mlog.error("BillingIssueCustomer_model") {"initialize exception: #{$!}"}        # Logファイル Debug用
      raise
    end
  end

	# is請求処理分散バッチ起動
	def is請求処理分散バッチ起動 (sqlsID)
    $Mlog.debug("DailyProcessing_model") {"is請求処理分散バッチ起動 start"}
		
		status     = "OK"
    sqlInfo    = getJsonChunkById(@sql_data, "sqls", sqlsID)
    sqlRecord  = sqlInfo["output"]["record"]
		
		max = sqlRecord["売上伝票番号"]["value"].length - 1
		i   = 0
		for num in 0..max do
		  if sqlRecord["売上伝票番号"]["value"][num] == ""
			  next
      end
			
			i += 1
		end
		
		if i == 0
		  # 後続のバッチ処理を含めてパスする
		  status = "ALLPASS"
		end
		
    $Mlog.debug("DailyProcessing_model") {"is請求処理分散バッチ起動 status = #{status}"}
    $Mlog.debug("DailyProcessing_model") {"is請求処理分散バッチ起動 normal end"}
		return status
	end
	

end
