# coding: UTF-8

require 'RmenuSales/Server/Modules/RmenuSalesMasterMainteOfModelMixin'

class ContractantList_model
  include RmenuSalesMasterMainteOfModelMixin

  def initialize(rmenu_dbi, sql_data, request_data)
    begin
      # initialize 開始ログを出力する
      $Mlog.debug("ContractantList_model") {"initialize start"}                   # Logファイル Debug用

      @rmenu_dbi      = rmenu_dbi
      @sql_data       = sql_data
      @request_data   = request_data

      # initialize 終了ログを出力する
      $Mlog.debug("ContractantList_model") {"initialize normal end"}              # Logファイル Debug用
    rescue Exception
      # エラーログを出力する
      $Mlog.error("ContractantList_model") {"initialize exception: #{$!}"}        # Logファイル Debug用
      raise
    end
  end

  # SQL文の検索条件を変更する
  def setSql_契約者基本情報OfRmenuSales(idname1, idname2 ,genesql_freesql)
    $Mlog.debug("ContractantList_model") {"setSql_契約者基本情報OfRmenuSales start"}                  # Logファイル Debug用

    requestInfo  = getJsonChunkById(@request_data, "records", idname1)

    searchString01  = requestInfo["record"]["検索会社名"]["value"][0]
    searchString02  = requestInfo["record"]["検索支払方法ＩＤ"]["value"][0]
    searchString03  = requestInfo["record"]["検索担当者ＩＤ"]["value"][0]

    sqlInfo      = getJsonChunkById(@sql_data, "sqls", idname2)

    rep = ""

    # 会社名（氏名）
    if searchString01 != ""
      rep = rep + "AND A.会社名（氏名） LIKE '%#{searchString01}%'"
    end

    # 支払方法
    if searchString02 != ""
      rep = rep + "AND A.ref_支払方法ＩＤ = #{searchString02}"
    end

    # 管理者
    if searchString03 != ""
      rep = rep + "AND A.ref_管理者ＩＤ = #{searchString03}"
    end

    # 検索条件の置き換え
    if    genesql_freesql == 'genesql'
      sqlInfo["sql"]["genesql"]["where"].sub!(/&&/,rep)
    elsif genesql_freesql == 'freesql'
      strJoin = sqlInfo["sql"]["freesql"].join("\t")
      strJoin.sub!(/&&/,rep)
      strSplit = strJoin.split("\t")
      sqlInfo["sql"]["freesql"].each_with_index do |temp, idx|
        sqlInfo["sql"]["freesql"][idx] = strSplit[idx]
      end
    end

    $Mlog.debug("ContractantList_model") {"setSql_契約者基本情報OfRmenuSales end"}                    # Logファイル Debug用
    return "OK"
  end

end
