# coding: UTF-8

require 'RmenuSales/Server/Modules/RmenuSalesOfBaseNameMainteOfModelMixin'           # 基本名称　マスターメンテ用

class MoneyReceivedClearing_model
  include RmenuSalesOfBaseNameMainteOfModelMixin

  def initialize(rmenu_db, sql_data, request_data)
    begin
      # initialize 開始ログを出力する
      $Mlog.debug("MoneyReceivedClearing_model") {"initialize start"}                   # Logファイル Debug用

      @rmenu_db       = rmenu_db
      @sql_data       = sql_data
      @request_data   = request_data
      
      # initialize 終了ログを出力する
      $Mlog.debug("MoneyReceivedClearing_model") {"initialize normal end"}              # Logファイル Debug用
    rescue Exception
      # エラーログを出力する
      $Mlog.error("MoneyReceivedClearing_model") {"initialize exception: #{$!}"}        # Logファイル Debug用
      raise
    end
  end

  # 採番用年度を設定する
  def set採番年度
    $Mlog.debug("MoneyReceivedClearing_model") {"set採番年度 start"}                  # Logファイル Debug用

    yyyy            = Date.today.strftime("%Y").to_s

    sql_chunk1 =
        getJsonChunkById(@sql_data    , "sqls"   , "select_number"  , "input" , "record")
    sql_chunk1["年度"]["value"][0] = yyyy

    # データが無い時、登録する
    str_sql1  = "SELECT 採番番号 FROM 伝票番号採番 WHERE 年度 = #{yyyy} AND 売仕入支区分 = '1'"
    w_number = @rmenu_db["default"].select_value(str_sql1)

    $Mlog.debug("MoneyReceivedClearing_model") {"set採番年度 番号　＝　#{w_number}"}                  # Logファイル Debug用

    if !w_number
      str_sql2 = "INSERT INTO 伝票番号採番 (年度, 売仕入支区分, 採番番号, 登録日時, 更新日時)"
      str_sql3 = " VALUES (#{yyyy.to_i}, '1', 0, CURRENT_TIMESTAMP, CURRENT_TIMESTAMP)"
      @rmenu_db["default"].insert(str_sql2 + str_sql3)
    end

    $Mlog.debug("MoneyReceivedClearing_model") {"set採番年度 end"}                    # Logファイル Debug用
    return "OK"
  end

  # 伝票番号を設定する
  def set伝票番号
    $Mlog.debug("MoneyReceivedClearing_model") {"set伝票番号 start"}                  # Logファイル Debug用

    sql_chunk1 =
        getJsonChunkById(@sql_data    , "sqls"   , "select_number"  , "input" , "record")
    sql_chunk2 =
        getJsonChunkById(@sql_data    , "sqls"   , "select_number"  , "output", "record")
    sql_chunk3 =
        getJsonChunkById(@sql_data    , "sqls"   , "header"         , "input" , "record")

    yyyy     = sql_chunk1["年度"]["value"][0]
    w_number = "0000000" + sql_chunk2["採番番号"]["value"][0].to_s
    sql_chunk3["伝票番号"]["value"][0] = yyyy + w_number[-6, 6]

    $Mlog.debug("MoneyReceivedClearing_model") {"set伝票番号 end"}                    # Logファイル Debug用
    return "OK"
  end

  # 項目のセット状況のチェックをする
  def valueCheck
    $Mlog.debug("MoneyReceivedClearing_model") {"valueCheck start"}                  # Logファイル Debug用

    sts = "OK"

    sql_chunk1 =
        getJsonChunkById(@sql_data    , "sqls"   , "detail"  , "input" , "record")

    if !sql_chunk1["行番号"]["value"][0]
      sts = "PASS"
    end

    $Mlog.debug("MoneyReceivedClearing_model") {"valueCheck status: #{sts}"}        # Logファイル Debug用

    $Mlog.debug("MoneyReceivedClearing_model") {"valueCheck end"}                    # Logファイル Debug用
    return sts
  end

end
