# coding: UTF-8

require 'RmenuLoggerMixin'                                                      # Logファイル Debug用
require 'RmenuJsonMixin'                                                        # ID名で該当レコードを取得する

class MoneyReceivedInput_model
  include RmenuLoggerMixin                                                      # Logファイル Debug用
  include RmenuJsonMixin

  def initialize(rmenu_db, sql_data, request_data)
    begin
      # initialize 開始ログを出力する
      $Mlog.debug("MoneyReceivedInput_model") {"initialize start"}                   # Logファイル Debug用

      @rmenu_db       = rmenu_db
      @sql_data       = sql_data
      @request_data   = request_data
      
      # initialize 終了ログを出力する
      $Mlog.debug("MoneyReceivedInput_model") {"initialize normal end"}              # Logファイル Debug用
    rescue Exception
      # エラーログを出力する
      $Mlog.error("MoneyReceivedInput_model") {"initialize exception: #{$!}"}        # Logファイル Debug用
      raise
    end
  end

  # 入金伝票番号管理を設定する
  def set入金伝票番号管理OfRmenuSales(idName, itemName)
    $Mlog.debug("MoneyReceivedInput_model") {"set入金伝票番号管理OfRmenuSales start"}                  # Logファイル Debug用

    requestInfo  = getJsonChunkById(@request_data, "records", idName)
		w_会計年度   = requestInfo["record"]["会計年度"]["value"][0]
    w_年         = w_会計年度[2, 2].to_i * 10000
		
    # データが無い時、登録する
    str_sql1   = "SELECT 伝票番号 FROM 伝票番号管理 WHERE 年度 = '#{w_会計年度}' AND 伝票種類 = '入金'"
    w_伝票番号 = @rmenu_db["default"].select_value(str_sql1)

    $Mlog.debug("MoneyReceivedInput_model") {"set入金伝票番号管理OfRmenuSales 伝票番号　＝　#{w_伝票番号}"}                  # Logファイル Debug用

    if !w_伝票番号
      str_sql2 = "INSERT INTO 伝票番号管理 (年度, 伝票種類, 伝票番号, 更新者, 更新日時, 削除フラグ)"
      str_sql3 = " VALUES ('#{w_会計年度}', '入金', #{w_年}, 'システム', CURRENT_TIMESTAMP, '0')"
      @rmenu_db["default"].insert(str_sql2 + str_sql3)
    end

    $Mlog.debug("MoneyReceivedInput_model") {"set入金伝票番号管理OfRmenuSales end"}                    # Logファイル Debug用
    return "OK"
  end

end
