# coding: UTF-8

require 'RmenuSales/Server/Modules/RmenuSalesMasterMainteOfModelMixin'

class ProductItemListSearch_model
  include RmenuSalesMasterMainteOfModelMixin

  def initialize(rmenu_dbi, sql_data, request_data)
    begin
      # initialize 開始ログを出力する
      $Mlog.debug("ProductItemListSearch_model") {"initialize start"}                   # Logファイル Debug用

      @rmenu_dbi      = rmenu_dbi
      @sql_data       = sql_data
      @request_data   = request_data

      # initialize 終了ログを出力する
      $Mlog.debug("ProductItemListSearch_model") {"initialize normal end"}              # Logファイル Debug用
    rescue Exception
      # エラーログを出力する
      $Mlog.error("ProductItemListSearch_model") {"initialize exception: #{$!}"}        # Logファイル Debug用
      raise
    end
  end

  # SQL文の検索条件を変更する
  def setSql_商品マスターOfRmenuSales(idname1, idname2 ,genesql_freesql)
    $Mlog.debug("ProductItemListSearch_model") {"setSql_商品マスターOfRmenuSales start"}                  # Logファイル Debug用

    requestInfo  = getJsonChunkById(@request_data, "records", idname1)

    searchString01  = requestInfo["record"]["検索請求内容ＩＤ"]["value"][0]
    searchString02  = requestInfo["record"]["検索請求形態ＩＤ"]["value"][0]
    searchString03  = requestInfo["record"]["検索商品名"]["value"][0]

    sqlInfo      = getJsonChunkById(@sql_data, "sqls", idname2)

    rep = ""

    # 請求内容
    if searchString01 != ""
      rep = rep + "AND A.ref_請求内容ＩＤ = #{searchString01}"
    end

    # 請求形態
    if searchString02 != ""
      rep = rep + "AND A.ref_請求形態ＩＤ = #{searchString02}"
    end

    # 商品名
    if searchString03 != ""
      rep = rep + "AND A.商品名 LIKE '%#{searchString03}%'"
    end

    # 検索条件の置き換え
    if    genesql_freesql == 'genesql'
      sqlInfo["sql"]["genesql"]["where"].sub!(/&&/,rep)
    elsif genesql_freesql == 'freesql'
      strJoin = sqlInfo["sql"]["freesql"].join("\t")
      strJoin.sub!(/&&/,rep)
      strSplit = strJoin.split("\t")
      sqlInfo["sql"]["freesql"].each_with_index do |temp, idx|
        sqlInfo["sql"]["freesql"][idx] = strSplit[idx]
      end
    end

    $Mlog.debug("ProductItemListSearch_model") {"setSql_商品マスターOfRmenuSales end"}                    # Logファイル Debug用
    return "OK"
  end

end
