# coding: UTF-8

require 'RmenuSales/Server/Modules/RmenuSalesMasterMainteOfModelMixin'

class SalesCheckList_model
  include RmenuSalesMasterMainteOfModelMixin

  def initialize(rmenu_dbi, sql_data, request_data)
    begin
      # initialize 開始ログを出力する
      $Mlog.debug("SalesCheckList_model") {"initialize start"}                   # Logファイル Debug用

      @rmenu_dbi      = rmenu_dbi
      @sql_data       = sql_data
      @request_data   = request_data

      # initialize 終了ログを出力する
      $Mlog.debug("SalesCheckList_model") {"initialize normal end"}              # Logファイル Debug用
    rescue Exception
      # エラーログを出力する
      $Mlog.error("SalesCheckList_model") {"initialize exception: #{$!}"}        # Logファイル Debug用
      raise
    end
  end

  # SQL文の検索条件を変更する
  def setSql_売上チェックリストOfRmenuSales(idname1, idname2 ,genesql_freesql)
    $Mlog.debug("SalesCheckList_model") {"setSql_売上チェックリストOfRmenuSales start"}                  # Logファイル Debug用

    requestInfo  = getJsonChunkById(@request_data, "records", idname1)

    searchString01  = requestInfo["record"]["ヘッダー日付"]["value"][0]
    searchString02  = requestInfo["record"]["検索契約区分"]["value"][0]
    searchString03  = requestInfo["record"]["検索アカウント発行区分ＩＤ"]["value"][0]
    searchString04  = requestInfo["record"]["検索契約者ＩＤ"]["value"][0]

    sqlInfo      = getJsonChunkById(@sql_data, "sqls", idname2)

    rep = ""

    # ヘッダー日付（売上年月日）
    if searchString01 != ""
      rep = rep + "AND TO_CHAR(A.伝票年月日, 'YYYY/MM/DD') = '#{searchString01}'"
    end

    # 検索契約区分
    if searchString02 != ""
      rep = rep + "AND A.ref_契約区分 = #{searchString02}"
    end

    # 検索アカウント発行区分ＩＤ
    if searchString03 != ""
      rep = rep + "AND A.ref_アカウント発行区分ＩＤ = #{searchString03}"
    end

    # 検索契約者ＩＤ
    if searchString04 != ""
      rep = rep + "AND A.ref_契約者ＩＤ = #{searchString04}"
    end


    # 検索条件の置き換え
    if    genesql_freesql == 'genesql'
      sqlInfo["sql"]["genesql"]["where"].sub!(/&&/,rep)
    elsif genesql_freesql == 'freesql'
      strJoin = sqlInfo["sql"]["freesql"].join("\t")
      strJoin.sub!(/&&/,rep)
      strSplit = strJoin.split("\t")
      sqlInfo["sql"]["freesql"].each_with_index do |temp, idx|
        sqlInfo["sql"]["freesql"][idx] = strSplit[idx]
      end
    end

    $Mlog.debug("SalesCheckList_model") {"setSql_売上チェックリストOfRmenuSales end"}                    # Logファイル Debug用
    return "OK"
  end

end
