# coding: UTF-8

require 'RmenuLoggerMixin'                                                      # Logファイル Debug用

module RmenuSalesOptimizationOfModelMixin
  include RmenuLoggerMixin                                                      # Logファイル Debug用

  # 検索用として日本語文字列を正規化する。
  def editOptimization(text)
    $Mlog.debug("RmenuSalesOptimizationOfModelMixin_model") {"editOptimization start #{text}"}                  # Logファイル Debug用

    #-- タブ、改行コード -> 全角スペース
    convText = text.gsub(/\r\n|\r|\n|\t/, '　')

    #-- 半角スペース -> 全角スペース
    #-- ぢづゐゑを -> じずいえお
    #-- 全角カタカナ -> 全角ひらがな
    #-- 半角カタカナ -> 全角ひらがな
    #-- 半角アルファベット(大文字) -> 全角アルファベット(小文字)
    #-- 半角アルファベット(小文字) -> 全角アルファベット(小文字)
    #-- 全角アルファベット(大文字) -> 全角アルファベット(小文字)
    #-- 半角数字(0-9) -> 全角数字(0-9) --
    #-- 全角ローマ数字(UpperCase 1-9) -> 全角数字(1-9)
    #-- 全角ローマ数字(LowerCase 1-9) -> 全角数字(1-9)
    #-- 全角○数字(1-9) -> 全角数字(1-9)
    #-- 開括弧
    #-- 閉括弧
    #-- ピリオド
    #-- コロン
    #-- クゥオーテーション
    #-- 記号
    #-- 異体字、類字
    #--    埼碕 → 崎崎 は変換しない 埼碕 → 埼碕 2016/07/16
    #--    檜 → 桧 追加 2016/07/16
    #-- s-jis UTF-8 不整合文字
    #-- ハイフンもどき u2010,u2011,u2012,u2013,u2014,u2015,u2212
    #-- ハイフン ※ ハイフンは 正規表現において『範囲を指定』を表す文字であるため必ず末尾に記述する。

    fromStr  = " " +
               "ぢづゐゑを" +
               "ァアィイゥウヴェエォオカガキギクグケゲコゴサザシジスズセゼソゾタダチヂッツヅテデトドナニヌネノハバパヒビピフブプヘベペホボポマミムメモャヤュユョヨラリルレロヮワヰヱヲン" +
               "ｧｱｨｲｩｳｪｴｫｵｶｷｸｹｺｻｼｽｾｿﾀﾁｯﾂﾃﾄﾅﾆﾇﾈﾉﾊﾋﾌﾍﾎﾏﾐﾑﾒﾓｬﾔｭﾕｮﾖﾗﾘﾙﾚﾛﾜｦﾝﾞﾟｰ･､｡" +
               "ABCDEFGHIJKLMNOPQRSTUVWXYZ" +
               "abcdefghijklmnopqrstuvwxyz" +
               "ＡＢＣＤＥＦＧＨＩＪＫＬＭＮＯＰＱＲＳＴＵＶＷＸＹＺ" +
               "0123456789" +
               "ⅠⅡⅢⅣⅤⅥⅦⅧⅨ" +
               "ⅰⅱⅲⅳⅴⅵⅶⅷⅸ" +
               "①②③④⑤⑥⑦⑧⑨" +
               "［｛〈《「『【＜([{<｢" +
               "］｝〉》」』】＞)]}>｣" +
               "、,." +
               ":；;" +
               '‘’“”"' + "'" +
               "!#$%&*+/?@=※^|" +
               "亞惡鰺壓圍爲醫壹稻飮隱營曵榮頴衞驛圓緣艷鹽奧應橫歐毆黃崗溫穩假價謌畫會囘壞懷繪槪擴殼覺學斈嶽樂渴勸卷" +
               "寬歡罐觀關陷舘巌巖巗顏噐竒籏歸皈氣龜僞戲犧舊據擧虛亰竸峽挾敎况狹鄕堯曉區驅勳薰羣徑惠揭溪經繼莖螢輕鷄" +
               "藝擊缺儉劍劔劒剱釼圈檢權獻硏縣險顯驗嚴乕效廣恆鑛髙號圀國囶黑濟碎劑埼碕嵜﨑做櫻册殺雜參慘棧蠶贊殘絲齒" +
               "兒辭濕實舍寫釋壽收從澁獸縱肅處緖諸敍敘奬獎將枩涉燒祥稱證乘剩塲壤孃條淨狀疊穰讓釀囑觸寢愼晉眞神盡圖埀" +
               "粹翆醉隨髓數樞丗瀨晴聲靑靜斎齋齎齊攝竊專戰淺潛纖賤踐錢禪曾雙壯搜插曺巢爭窗總聰莊裝騷增臟藏卽屬續卆夛" +
               "墮躰軆體骵對帶滯臺瀧擇澤單擔膽團彈斷癡遲晝蟲鑄猪廳廰徵甼聽敕珎鎭塚寉鷆鷏遞喆悊銕鐵鐡鉃鋨锇轉點傳都黨" +
               "嶋嶌盜燈當鬪仂德獨讀屆繩貳迺遒逎惱腦霸廢拜盃賣麥發髮拔晚蠻祕濱甁冨凬福拂佛竝變篇遍邊邉辨辧瓣辯舖步穗" +
               "寶峯襃豐沒夲飜每槇萬滿簑簔梦默埜彌藥譯栁藪豫餘與譽搖樣謠遙來徠賴亂欄覽隆龍虜兩獵綠壘泪淚類勵禮隸靈齡" +
               "曆歷戀鍊爐勞廊朗樓郞祿錄亙灣兊寇瑤覊羮腟諌鑽鵝檜" +
               "〜‖¢£¬" +
               "‐‑‒–—―−" +
               "-"
    toStr    = "　" +
               "じずいえお" +
               "ぁあぃいぅうぶぇえぉおかがきぎくぐけげこごさざしじすずせぜそぞただちじっつずてでとどなにぬねのはばぱひびぴふぶぷへべぺほぼぽまみむめもゃやゅゆょよらりるれろゎわいえおん" +
               "ぁあぃいぅうぇえぉおかきくけこさしすせそたちっつてとなにぬねのはひふへほまみむめもゃやゅゆょよらりるれろわおん゛゜ー・，。" +
               "ａｂｃｄｅｆｇｈｉｊｋｌｍｎｏｐｑｒｓｔｕｖｗｘｙｚ" +
               "ａｂｃｄｅｆｇｈｉｊｋｌｍｎｏｐｑｒｓｔｕｖｗｘｙｚ" +
               "ａｂｃｄｅｆｇｈｉｊｋｌｍｎｏｐｑｒｓｔｕｖｗｘｙｚ" +
               "０１２３４５６７８９" +
               "１２３４５６７８９" +
               "１２３４５６７８９" +
               "１２３４５６７８９" +
               "（（（（（（（（（（（（（" +
               "）））））））））））））" +
               "，，．" +
               "：：：" +
               "’’’’’’" +
               "！＃＄％＆＊＋／？＠＝＊＾｜" +
               "亜悪鯵圧囲為医壱稲飲隠営曳栄穎衛駅円縁艶塩奥応横欧殴黄岡温穏仮価歌画会回壊懐絵概拡殻覚学学岳楽渇勧巻" +
               "寛歓缶観関陥館岩岩岩顔器奇旗帰帰気亀偽戯犠旧拠挙虚京競峡挟教況狭郷尭暁区駆勲薫群径恵掲渓経継茎蛍軽鶏" +
               "芸撃欠倹剣剣剣剣剣圏検権献研県険顕験厳虎効広恒鉱高号国国国黒済砕剤埼碕崎崎作桜冊殺雑参惨桟蚕賛残糸歯" +
               "児辞湿実舎写釈寿収従渋獣縦粛処緒諸叙叙奨奨将松渉焼祥称証乗剰場壌嬢条浄状畳穣譲醸嘱触寝慎晋真神尽図垂" +
               "粋翠酔随髄数枢世瀬晴声青静斉斉斉斉摂窃専戦浅潜繊賎践銭禅曽双壮捜挿曹巣争窓総聡荘装騒増臓蔵即属続卒多" +
               "堕体体体体対帯滞台滝択沢単担胆団弾断痴遅昼虫鋳猪庁庁徴町聴勅珍鎮塚鶴鶴鶴逓哲哲鉄鉄鉄鉄鉄鉄転点伝都党" +
               "島島盗灯当闘働徳独読届縄弐廼廼廼悩脳覇廃拝杯売麦発髪抜晩蛮秘浜瓶富風福払仏並変編辺辺辺弁弁弁弁舗歩穂" +
               "宝峰褒豊没本翻毎槙万満蓑蓑夢黙野弥薬訳柳薮予余与誉揺様謡遥来来頼乱欄覧隆竜虜両猟緑塁涙涙類励礼隷霊齢" +
               "暦歴恋錬炉労廊朗楼郎禄録亘湾兌冦瑶羈羹膣諫鑚鵞桧" +
               "～∥￠￡￢" +
               "－－－－－－－" +
               "－"
    #-- 1文字で変換
    convText.tr!(fromStr, toStr)

    #-- 文字前スペースの取り除き
    convText.gsub!(/[　]+([゛゜ー・，。．])/, '\1')

    #-- 連続文字を一個に
    convText.gsub!(/([゛゜ー・，。．])\1+/, '\1')

    #-- 2文字で変換
    #-- かな + 濁点半濁点、⑩～⑲
    hashTwoChara = {
        'う゛' => 'ぶ',
        'か゛' => 'が', 'き゛' => 'ぎ', 'く゛' => 'ぐ', 'け゛' => 'げ', 'こ゛' => 'ご',
        'さ゛' => 'ざ', 'し゛' => 'じ', 'す゛' => 'ず', 'せ゛' => 'ぜ', 'そ゛' => 'ぞ',
        'た゛' => 'だ', 'ち゛' => 'じ', 'つ゛' => 'ず', 'て゛' => 'で', 'と゛' => 'ど',
        'は゛' => 'ば', 'ひ゛' => 'び', 'ふ゛' => 'ぶ', 'へ゛' => 'べ', 'ほ゛' => 'ぼ',
        'は゜' => 'ぱ', 'ひ゜' => 'ぴ', 'ふ゜' => 'ぷ', 'へ゜' => 'ぺ', 'ほ゜' => 'ぽ',
        '⑩' => '１０', '⑪' => '１１', '⑫' => '１２', '⑬' => '１３', '⑭' => '１４',
        '⑮' => '１５', '⑯' => '１６', '⑰' => '１７', '⑱' => '１８', '⑲' => '１９'
    }
    regTwoChara = Regexp.new(hashTwoChara.keys.join('|'))
    convText.gsub!(/#{regTwoChara}/){|s| hashTwoChara[s]}

    #-- あ段 + 『ぶぁ』 -> ばぁ
    convText.gsub!(/([あかがさざただなはばまやゃらわ])ぶぁ/, '\1ばぁ')

    #-- ぶぁ -> ば
    convText.gsub!(/ぶぁ/, 'ば')

    #-- ぶぃ[っらん] -> び[っらん] , 先頭が ぶぃ -> び , ぶぃ -> びぃ
    convText.gsub!(/ぶぃ([っらん])/, 'び\1')
    convText.gsub!(/(^|　|・)ぶぃ/, '\1び')
    convText.gsub!(/ぶぃ/, 'びぃ')

    #-- ぶぇ -> べ
    convText.gsub!(/ぶぇ/, 'べ')

    #-- ぶぉ -> ぼ
    convText.gsub!(/ぶぉ/, 'ぼ')

    #-- ぶゅ -> びゅ
    convText.gsub!(/ぶゅ/, 'びゅ')

    #-- あ段 + 『ー』 -> ぁ
    convText.gsub!(/([あかがさざただなはばぱまやゃらわ])ー/, '\1ぁ')

    #-- い段 + 『ー』 -> ぃ
    convText.gsub!(/([いきぎしじちにひびぴみり])ー/, '\1ぃ')

    #-- え段 + 『い』 -> ー
    convText.gsub!(/([えぇけげせぜてでねへべぺめれ])い/, '\1ー')

    #-- お段 + 『ー』 -> う
    convText.gsub!(/([おこごそぞとどのほぼぽもよょゅろ])ー/, '\1う')

    #-- ぁ行 + 『ー』 -> 『ー』を除く ※ぇは対象外
    convText.gsub!(/([ぁぃぅぉ])ー/, '\1')

    #-- ・ -> 外す
    convText.gsub!(/・/, '　');

    #-- スペース詰め
    convText.gsub!(/([０-９])[　]+([^０-９])/, '\1\2')
    convText.gsub!(/([ａ-ｚ])[　]+([^ａ-ｚ])/, '\1\2')
    convText.gsub!(/([^０-９ａ-ｚ])[　]+/, '\1')

    #-- 不要濁点半濁点の取り除き
    convText.gsub!(/([がぎぐげござじずぜぞだじずでどばびぶべぼ])[゛]+|([ぱぴぷぺぽ])[゜]+/, '\1\2');

    #-- 連続スペース -> １個スペース
    convText.gsub!(/　+/, '　')

    $Mlog.debug("RmenuSalesOfOptimizationOfModelMixin_model") {"editOptimization end #{convText}"}
    return convText
  end

end
