# coding: UTF-8

require "date"
require 'RmenuJsonMixin'                                                        # ID名で該当レコードを取得する

class PrintListSampleUser_form
  include RmenuJsonMixin

  def initialize(pdfcreate, response_data, sql_data, request_data)
    begin
      # initialize 開始ログを出力する
      $PDFC.debug("PrintListSampleUser_form") {"initialize start"}                          # Logファイル Debug用

      @pdfcreate      = pdfcreate
      @response_data  = response_data
      @sql_data       = sql_data
      @request_data   = request_data
      @row_count   = 0

      # initialize 終了ログを出力する
      $PDFC.debug("PrintListSampleUser_form") {"initialize normal end"}                     # Logファイル Debug用
    rescue Exception
      # エラーログを出力する
      $PDFC.error("PrintListSampleUser_form") {"initialize exception: #{$!}"}               # Logファイル Debug用
      raise
    end
  end

  # ページフォーマット（罫線描画等）
  def background_pattern()
    begin
      $PDFC.debug("PrintListSampleUser_form") {"background_pattern start"}                               # Logファイル Debug用

    pdfObject = @pdfcreate.getPdfObject()



    pdfObject.fill_color "ffd700"
#    pdfObject.fill_color "fff8dc"
    pdfObject.fill_rectangle [-33, 812], 593, 42


      $PDFC.debug("PrintListSampleUser_form") {"background_pattern end"}                                 # Logファイル Debug用
      return "OK"
    rescue Exception
      # エラーログを出力する
      $PDFC.error("PrintListSampleUser_form") {"background_pattern: #{$!}"}               # Logファイル Debug用
      raise
    end
  end

  # ページフォーマット（罫線描画等）
  def triangle()
    begin
      $PDFC.debug("PrintListSampleUser_form") {"triangle start"}                               # Logファイル Debug用

    pdfObject = @pdfcreate.getPdfObject()


    pdfObject.fill_color "483d8b"
    pdfObject.fill_polygon [50, 150], [250, 150], [150, 0]
    pdfObject.fill_color "99FF66"
    pdfObject.fill_polygon [350, 150], [550, 150], [450, 0]

    pdfObject.fill_color "99FF66"
    pdfObject.line_width = 5
    pdfObject.stroke_circle [200, 300], 50
    pdfObject.stroke_circle [200, 300], 100
    pdfObject.stroke_circle [200, 300], 150


    pdfObject.fill_color "483d8b"
    y = 150.mm
    k = 3
    12.times do |i|
    	pdfObject.fill_polygon [k * 3.5.mm + i * 10.mm, k * 1.5.mm + y], [k * 5.5.mm + i * 10.mm, k * 1.5.mm + y], [k * 4.5.mm + i * 10.mm, k * 0.mm + y]
    pdfObject.stroke_circle [0 + i * 10.mm, 0 + y-5.mm], 2.5.mm
    end


      $PDFC.debug("PrintListSampleUser_form") {"triangle end"}                                 # Logファイル Debug用
      return "OK"
    rescue Exception
      # エラーログを出力する
      $PDFC.error("PrintListSampleUser_form") {"triangle: #{$!}"}               # Logファイル Debug用
      raise
    end
  end

  # ページヘッダー処理（システム日付・ページ番号）
  def page_header()
    begin
      $PDFC.debug("PrintListSampleUser_form") {"page_header start"}                               # Logファイル Debug用

      responseRecord       = getJsonChunkById(@response_data, "records", "page_header","record")

      responseRecord["ページ"]["value"][0]     = @pdfcreate.getTotalPageCount()

      $PDFC.debug("PrintListSampleUser_form") {"page_header end"}                                 # Logファイル Debug用
      return "OK"
    rescue Exception
      # エラーログを出力する
      $PDFC.error("PrintListSampleUser_form") {"page_header: #{$!}"}               # Logファイル Debug用
      raise
    end
  end

  # 明細（印刷行数）
  def page_detail()
    begin
      $PDFC.debug("PrintListSampleUser_form") {"page_detail start"}                               # Logファイル Debug用

      @row_count = @row_count + 1

      responseRecord       = getJsonChunkById(@response_data, "records", "detail","record")

      tcount =  @pdfcreate.getTotalRecordCount()

      $PDFC.debug("PrintListSampleUser_form") {"page_detail aaaaaaa #{tcount}"}                                 # Logファイル Debug用

      responseRecord["印刷行数"]["value"][tcount - 1]   = tcount


#      responseRecord["印刷行数"]["value"][@row_count - 1]   = @row_count




      $PDFC.debug("PrintListSampleUser_form") {"page_detail end"}                                 # Logファイル Debug用
      return "OK"
    rescue Exception
      # エラーログを出力する
      $PDFC.error("PrintListSampleUser_form") {"page_detail: #{$!}"}               # Logファイル Debug用
      raise
    end
  end

end
