# coding: UTF-8

require 'RmenuLoggerMixin'                                                      # Logファイル Debug用
require 'RmenuJsonMixin'                                                        # ID名で該当レコードを取得する

module RmenuTry00BaseNameMainteOfModelMixin
  include RmenuLoggerMixin                                                      # Logファイル Debug用
  include RmenuJsonMixin

  # 基本名称メンテナンス用　モジュール
  # 削除データを設定する
  def setDeleteData(requestID, sqlsId, idName)
    $Mlog.debug("BaseNameMainte_model") {"setDeleteData start"}                  # Logファイル Debug用

    requestInfo   = getJsonChunkById(@request_data, "records", requestID)
    requestRecord = requestInfo["record"]

    sqlInfo       = getJsonChunkById(@sql_data, "sqls", sqlsId)
    sqlRecord     = sqlInfo["input"]["record"]

    deleteCheck   = requestRecord["削除"]["value"]
    idData        = requestRecord[idName]["value"]
    maxLength     = deleteCheck.length - 1
    j             = 0
    emptySW       = "PASS"
    for i in 0..maxLength do
      if deleteCheck[i] != "9"
        next
      end
      if idData[i] == ""
        next
      end

      requestRecord.each{|key, value|
        if sqlRecord.key?("#{key}")
          sqlRecord[key]["value"][j] = value["value"][i]
          emptySW = "OK"
        end
      }
      j = j + 1
    end

    $Mlog.debug("BaseNameMainte_model") {"setDeleteData end status = #{emptySW}"}
    return emptySW
  end

  # 基本名称メンテナンス用　モジュール
  # 更新データを設定する
  def setUpdateData(requestID, sqlsId, idName)
    $Mlog.debug("BaseNameMainte_model") {"setUpdateData start"}                  # Logファイル Debug用

    requestInfo   = getJsonChunkById(@request_data, "records", requestID)
    requestRecord = requestInfo["record"]

    sqlInfo       = getJsonChunkById(@sql_data, "sqls", sqlsId)
    sqlRecord     = sqlInfo["input"]["record"]

    deleteCheck   = requestRecord["削除"]["value"]
    idData        = requestRecord[idName]["value"]
    maxLength     = deleteCheck.length - 1
    j             = 0
    emptySW       = "PASS"
    for i in 0..maxLength do
      if deleteCheck[i] == "9"
        next
      end
      if idData[i] == ""
        next
      end

      requestRecord.each { |key, value|
        if sqlRecord.key?("#{key}")
          sqlRecord[key]["value"][j] = value["value"][i]
          emptySW = "OK"
        end
      }
      j = j + 1
    end

    $Mlog.debug("BaseNameMainte_model") {"setUpdateData end status = #{emptySW}"}
    return emptySW
  end

  # 基本名称メンテナンス用　モジュール
  # 登録データを設定する
  def setInsertData(requestID, sqlsId, idName)
    $Mlog.debug("BaseNameMainte_model") {"setUpdateData start"}                  # Logファイル Debug用

    requestInfo   = getJsonChunkById(@request_data, "records", requestID)
    requestRecord = requestInfo["record"]

    sqlInfo       = getJsonChunkById(@sql_data, "sqls", sqlsId)
    sqlRecord     = sqlInfo["input"]["record"]

    deleteCheck   = requestRecord["削除"]["value"]
    idData        = requestRecord[idName]["value"]
    maxLength     = deleteCheck.length - 1
    j             = 0
    emptySW       = "PASS"
    for i in 0..maxLength do
      if deleteCheck[i] == "9"
        next
      end
      if idData[i] != ""
        next
      end

      requestRecord.each { |key, value|
        if sqlRecord.key?("#{key}")
          sqlRecord[key]["value"][j] = value["value"][i]
          emptySW = "OK"
        end
      }
      j = j + 1
    end

    $Mlog.debug("BaseNameMainte_model") {"setUpdateData end status = #{emptySW}"}
    return emptySW
  end

  # データ有無で登録の判定を行う
  def setデータ有無で登録の判定(requestID, idName)
    $Mlog.debug("BaseNameMainte_model") {"setデータ有無で登録の判定 start"}                  # Logファイル Debug用

    requestInfo   = getJsonChunkById(@request_data, "records", requestID)
    requestRecord = requestInfo["record"]

    emptySW       = "PASS"
    if requestRecord[idName]["value"][0]  == ""
      emptySW = "OK"
    end

    $Mlog.debug("BaseNameMainte_model") {"setデータ有無で登録の判定 end status = #{emptySW}"}
    return emptySW
  end

  # データ有無で訂正の判定を行う
  def setデータ有無で訂正の判定(requestID, idName)
    $Mlog.debug("BaseNameMainte_model") {"setデータ有無で訂正の判定 start"}                  # Logファイル Debug用

    requestInfo   = getJsonChunkById(@request_data, "records", requestID)
    requestRecord = requestInfo["record"]

    emptySW       = "PASS"
    if requestRecord[idName]["value"][0]  != ""
      emptySW = "OK"
    end

    $Mlog.debug("BaseNameMainte_model") {"setデータ有無で訂正の判定 end status = #{emptySW}"}
    return emptySW
  end

end
