(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.ListPostCode00;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスター一覧パターン　ミックスインを追加する
  Model.include($R.Library.MasterMainteListModelMixin);

  // ----------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　  　　
  // また、パターン内の処理を変更するときは、オーバライドする　
  // ----------------------------------------------------------
  Model.include({
    // -------------------------------------------------------------------
    //  初期処理
    // -------------------------------------------------------------------
    on初期処理: function() {
      $R.log("Model on初期処理 : start");

      this.on検索文字列クリア();
      var arg = {};
      this.pubsub.publish("show初期処理", arg);

      $R.log("Model on初期処理 : end");
    }
    // -------------------------------------------------------
    //  クリア　処理
    // -------------------------------------------------------
   ,on検索文字列クリア: function() {
      $R.log("Model on検索文字列クリア : start");

      this.dataset.setElementData("" , "検索全国地方公共団体コード");
      this.dataset.setElementData("" , "検索郵便番号");
      this.dataset.setElementData("" , "検索都道府県名カナ");
      this.dataset.setElementData("" , "検索市区町村名カナ");
      this.dataset.setElementData("" , "検索町域名カナ");
      this.dataset.setElementData("" , "検索都道府県名");
      this.dataset.setElementData("" , "検索市区町村名");
      this.dataset.setElementData("" , "検索町域名");

      this.pubsub.publish("on検索文字列クリア", "");

      $R.log("Model on検索文字列クリア : end");
    }

   // -------------------------------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------------------------------
    ,onプリント作成OfEditResponseData: function(responseData) {
      $R.log("Model onプリント作成OfEditResponseData : start");

      var argHash  = new Object();
      argHash["file"]   = responseData["pdfinfo"]["pdffile"];
      argHash["type"]   = "pdf";
      argHash["delete"] = "yes";
      this.postDownloadRack(argHash);

      $R.log("Model onプリント作成OfEditResponseData : end");
    }
   ,onダウンロードOfEditResponseData: function(responseData) {
      $R.log("Model onダウンロードOfEditResponseData : start");

      var argHash  = new Object();
      argHash["file"] = responseData["records"][0]["record"]["downloadfile"]["value"][0];
      argHash["type"] = "csv";
      this.postDownloadRack(argHash);

      $R.log("Model onダウンロードOfEditResponseData : end");
    }
  });
}(jQuery, Rmenu));