(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.Login;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // ログインパターン　ミックスインを追加する
  Model.include($R.Library.LoginModelMixin);

  // ----------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　  　　
  // また、パターン内の処理を変更するときは、オーバライドする　
  // ----------------------------------------------------------
  Model.include({
    // -------------------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------------------
    on初期処理OfEditResponseData: function(responseData) {
      $R.log("Model on初期処理OfEditResponseData : start");

      // ＣＳＳファイル情報をセッションストレージに格納する
      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + ".Login");
      var responseRecord = this.appspec.getJSONChunkByIdAtRecords(responseData, "header");
      var cssName        = responseRecord["record"]["ＣＳＳファイル名"]["value"][0];
      var arg            = {ＣＳＳファイル名: ""};

      if (cssName != "") {
        sessionStorage.saveItem("ＣＳＳファイル名", this.appspec.sysname + "/Html/css/" + cssName + ".css");
        arg = {ＣＳＳファイル名: this.appspec.sysname + "/Html/css/" + cssName + ".css"};
      }
      else {
        sessionStorage.saveItem("ＣＳＳファイル名", "");
      }

      this.pubsub.publish("show初期処理", arg);

      $R.log("Model on初期処理OfEditResponseData : end");
    }

  });
}(jQuery, Rmenu));