# coding: UTF-8

require 'RmenuTry01/Server/Modules/RmenuTry01OfMasterMainteOfModelMixin'

class SearchPrefecture_model
  include RmenuTry01OfMasterMainteOfModelMixin

  def initialize(rmenu_dbi, sql_data, request_data)
    begin
      # initialize 開始ログを出力する
      $Mlog.debug("SearchPrefecture_model") {"initialize start"}                   # Logファイル Debug用

      @rmenu_dbi      = rmenu_dbi
      @sql_data       = sql_data
      @request_data   = request_data

      # initialize 終了ログを出力する
      $Mlog.debug("SearchPrefecture_model") {"initialize normal end"}              # Logファイル Debug用
    rescue Exception
      # エラーログを出力する
      $Mlog.error("SearchPrefecture_model") {"initialize exception: #{$!}"}        # Logファイル Debug用
      raise
    end
  end

  # SQL文の検索条件を変更する
  def setSql(idname1, idname2 ,genesql_freesql)
    $Mlog.debug("SearchPrefecture_model") {"setSql start"}                  # Logファイル Debug用

    requestInfo  = getJsonChunkById(@request_data, "records", idname1)
    searchString01 = requestInfo["record"]["検索都道府県コード"]["value"][0]
    searchString02 = requestInfo["record"]["検索都道府県名称"]["value"][0]

    sqlInfo      = getJsonChunkById(@sql_data, "sqls", idname2)

    rep = "true "
    # 検索都道府県コード
    if searchString01 != ""
      rep = rep + "AND 都道府県ＩＤ = #{searchString01}"
    end
    # 検索得意先略称
    if searchString02 != ""
      rep = rep + "AND 名称 LIKE '%#{searchString02}%'"
    end

    # 検索条件の置き換え
    if    genesql_freesql == 'genesql'
      sqlInfo["sql"]["genesql"]["where"].sub!(/&&/,rep)
    elsif genesql_freesql == 'freesql'
      strJoin = sqlInfo["sql"]["freesql"].join("\t")
      strJoin.sub!(/&&/,rep)
      strSplit = strJoin.split("\t")
      sqlInfo["sql"]["freesql"].each_with_index do |temp, idx|
        sqlInfo["sql"]["freesql"][idx] = strSplit[idx]
      end
    end

    $Mlog.debug("SearchPrefecture_model") {"setSql end"}                    # Logファイル Debug用
    return "OK"
  end


end
