(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.BaseSystemSessionList;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスター一覧パターン　ミックスインを追加する
  Model.include($R.Library.MasterMainteListModelMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Model.include({
    // -----------------------------------
    //  検索文字列　クリア処理（追加処理）
    // -----------------------------------
    on検索文字列クリア: function(arg) {
      $R.log("Model on検索文字列クリア : start");

      this.dataset.setElementData("", "検索文字列");

      this.pubsub.publish("on検索文字列クリア", "");

      $R.log("Model on検索文字列クリア : end");
    }
    // ---------------------------------------------
    //  ページネーションリロード処理（オーバライド）
    // ---------------------------------------------
   ,onリロード: function() {
      $R.log("Model onリロード : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var pageline     = sessionStorage.loadItem("ページライン数");
      var pageno       = sessionStorage.loadItem("カレントページ");
      var searchString = sessionStorage.loadItem("検索文字列");

      this.dataset.setElementData(pageline, "ページライン数");
      this.dataset.setElementData(pageno, "カレントページ");
      this.dataset.setElementData(searchString, "検索文字列");

      var arg           = {};
      arg["検索文字列"] = searchString;
      this.pubsub.publish("on検索文字列表示", arg);

      $R.log("Model onリロード : end");
    }
    // -------------------------------------------------------------------
    //  メンテナンス画面呼び出し（次画面呼び出し）準備処理（オーバライド）
    // -------------------------------------------------------------------
   ,onメンテナンス画面表示: function() {
      $R.log("Model onメンテナンス画面表示 : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var searchString = this.dataset.getElementData("検索文字列");
      sessionStorage.saveItem("検索文字列", searchString);

      $R.log("Model onメンテナンス画面表示 : end");
    }
  });

}(jQuery, Rmenu));