(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.BaseSystemSessionListSub;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスター一覧パターン　ミックスインを追加する
  Model.include($R.Library.MasterMainteListModelMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Model.include({
    // -----------------------------------
    //  検索文字列　クリア処理（追加処理）
    // -----------------------------------
    on検索文字列クリア: function(arg) {
      $R.log("Model on検索文字列クリア : start");

      this.dataset.setElementData("", "検索文字列");

      this.pubsub.publish("on検索文字列クリア", "");

      $R.log("Model on検索文字列クリア : end");
    }
    // ---------------------------------------------
    //  ページネーションリロード処理（オーバライド）
    // ---------------------------------------------
   ,onリロード: function() {
      $R.log("Model onリロード : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var pageline     = sessionStorage.loadItem("ページライン数");
      var pageno       = sessionStorage.loadItem("カレントページ");
      var searchString = sessionStorage.loadItem("検索文字列");

      this.dataset.setElementData(pageline, "ページライン数");
      this.dataset.setElementData(pageno, "カレントページ");
      this.dataset.setElementData(searchString, "検索文字列");

      var arg           = {};
      arg["検索文字列"] = searchString;
      this.pubsub.publish("on検索文字列表示", arg);

      $R.log("Model onリロード : end");
    }
    // -------------------------------------------------------------------
    //  メンテナンス画面呼び出し（次画面呼び出し）準備処理（オーバライド）
    // -------------------------------------------------------------------
   ,onメンテナンス画面表示: function() {
      $R.log("Model onメンテナンス画面表示 : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var searchString = this.dataset.getElementData("検索文字列");
      sessionStorage.saveItem("検索文字列", searchString);

      $R.log("Model onメンテナンス画面表示 : end");
    }

    // -----------------------------------
    //  リクエストデータ　チェック処理
    // -----------------------------------
   ,onメインテーブル照会OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller onメインテーブル照会OfCheckRequestData : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.beforename);

      var id = sessionStorage.loadItem("テーブルＩＤ");
      var headerRecord = this.appspec.getJSONChunkByIdAtRecords(requestData, "header");
      headerRecord["record"]["テーブルＩＤ１"]["value"][0] = id;

      $R.log("Controller onメインテーブル照会OfCheckRequestData : end");
      return true;
    }

    // -------------------------------------------------------
    //  処理モードをセッションストレージに格納する
    // -------------------------------------------------------
   ,set処理モード: function(mode) {
      $R.log("Model set処理モード : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      sessionStorage.saveItem("処理モード", mode);

      var row        = sessionStorage.loadItem("クリック行");
      var dataset    = this.dataset.getData();
      var detailInfo = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
      var id         = detailInfo["record"]["テーブルＩＤ"]["value"][row]
      sessionStorage.saveItem("テーブルＩＤ", id);
      var gyou       = detailInfo["record"]["行番"]["value"][row]
      sessionStorage.saveItem("行番", gyou);

      $R.log("Model set処理モード : end");
      return true;
    }

  });

}(jQuery, Rmenu));