(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.CustomerSearch;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスター一覧パターン　ミックスインを追加する
  Model.include($R.Library.MasterMainteListModelMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Model.include({
    // -----------------------------------
    //  リクエストデータ　チェック処理
    // -----------------------------------
    onメインテーブル照会OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller onメインテーブル照会OfCheckRequestData : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + ".Login");
      var unitname = sessionStorage.loadItem("部署名");

      var headerInfo     = this.appspec.getJSONChunkByIdAtRecords(requestData, "header");
      headerInfo["record"]["ログイン部署名"  ]["value"][0] = unitname;

      $R.log("Controller onメインテーブル照会OfCheckRequestData : end");
      return true;
    }
    // -----------------------------------
    //  検索文字列　クリア処理（追加処理）
    // -----------------------------------
   ,on検索文字列クリア: function(arg) {
      $R.log("Model on検索文字列クリア : start");

      this.dataset.setElementData("", "検索受注番号識別コード");
      this.dataset.setElementData("", "検索得意先略称");

      this.pubsub.publish("on検索文字列クリア", "");

      $R.log("Model on検索文字列クリア : end");
    }
    // ---------------------------------
    //  選択情報を設定する（追加処理）
    // ---------------------------------
   ,set選択情報設定: function() {
      $R.log("Model set選択情報設定 : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      var row        = sessionStorage.loadItem("クリック行");

      var dataset        = this.dataset.getData();
      var detailInfo     = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
      var customerID     = detailInfo["record"]["テーブルＩＤ"]["value"][row];
      var customerName01 = detailInfo["record"]["得意先名称"  ]["value"][row];
      var customerName02 = detailInfo["record"]["得意先略称"  ]["value"][row];
      var arg = {
             "得意先ＩＤ"       : customerID     + "",
             "得意先名称"       : customerName01 + "",
             "得意先略称"       : customerName02 + ""
          };

      $R.log("Model set選択情報設定 : end");
      return arg;
    }
  });

}(jQuery, Rmenu));