(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.KoyouKubunSearch;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスター一覧パターン　ミックスインを追加する
  Model.include($R.Library.MasterMainteListModelMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Model.include({
    // -----------------------------------
    //  リクエストデータ　チェック処理
    // -----------------------------------
   on検索文字列クリア: function(arg) {
      $R.log("Model on検索文字列クリア : start");

      this.dataset.setElementData("", "検索雇用区分コード");
      this.dataset.setElementData("", "検索雇用区分名称");

      this.pubsub.publish("on検索文字列クリア", "");

      $R.log("Model on検索文字列クリア : end");
    }
    // ---------------------------------
    //  選択情報を設定する（追加処理）
    // ---------------------------------
   ,set選択情報設定: function() {
      $R.log("Model set選択情報設定 : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      var row        = sessionStorage.loadItem("クリック行");

      var dataset        = this.dataset.getData();
      var detailInfo     = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
      var customerID     = detailInfo["record"]["テーブルＩＤ"]["value"][row];
      var customerName01 = detailInfo["record"]["雇用区分コード"  ]["value"][row];
      var customerName02 = detailInfo["record"]["区分値摘要"  ]["value"][row];
      var arg = {
             "テーブルＩＤ"       : customerID     + "",
             "雇用区分コード"       : customerName01 + "",
             "区分値摘要"       : customerName02 + ""
          };

      $R.log("Model set選択情報設定 : end");
      return arg;
    }
  });

}(jQuery, Rmenu));