(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.ListBankBranchName;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスター一覧パターン　ミックスインを追加する
  Model.include($R.Library.MasterMainteListModelMixin);

  // ----------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　  　　
  // また、パターン内の処理を変更するときは、オーバライドする　
  // ----------------------------------------------------------
  Model.include({
    // -------------------------------------------------------
    //  処理モードをセッションストレージに格納する
    // -------------------------------------------------------
   set処理モード: function(mode) {
      $R.log("Model set処理モード : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      sessionStorage.saveItem("処理モード", mode);

      var row        = sessionStorage.loadItem("クリック行");
      var dataset    = this.dataset.getData();
      var detailInfo = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
      var value         = detailInfo["record"]["テーブルＩＤ"]["value"][row]
      sessionStorage.saveItem("銀行コード", value);
      var value         = detailInfo["record"]["支店コード"]["value"][row]
      sessionStorage.saveItem("支店コード", value);

      $R.log("Model set処理モード : end");
      return true;
    }
   // -------------------------------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------------------------------
    ,onプリント作成OfEditResponseData: function(responseData) {
      $R.log("Model onプリント作成OfEditResponseData : start");

      var argHash  = new Object();
      argHash["file"]   = responseData["pdfinfo"]["pdffile"];
      argHash["type"]   = "pdf";
      argHash["delete"] = "yes";
      this.postDownloadRack(argHash);

      $R.log("Model onプリント作成OfEditResponseData : end");
    }
   ,onダウンロードOfEditResponseData: function(responseData) {
      $R.log("Model onダウンロードOfEditResponseData : start");

      var argHash  = new Object();
      argHash["file"] = responseData["records"][0]["record"]["downloadfile"]["value"][0];
      argHash["type"] = "csv";
      this.postDownloadRack(argHash);

      $R.log("Model onダウンロードOfEditResponseData : end");
    }
  });
}(jQuery, Rmenu));