(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.ListConsumptionTax;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスター一覧パターン　ミックスインを追加する
  Model.include($R.Library.MasterMainteListModelMixin);

  // ----------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　  　　
  // また、パターン内の処理を変更するときは、オーバライドする　
  // ----------------------------------------------------------
  Model.include({
   // -------------------------------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------------------------------
    onプリント作成OfEditResponseData: function(responseData) {
      $R.log("Model onプリント作成OfEditResponseData : start");

      var argHash  = new Object();
      argHash["file"]   = responseData["pdfinfo"]["pdffile"];
      argHash["type"]   = "pdf";
      argHash["delete"] = "yes";
      this.postDownloadRack(argHash);

      $R.log("Model onプリント作成OfEditResponseData : end");
    }
   ,onダウンロードOfEditResponseData: function(responseData) {
      $R.log("Model onダウンロードOfEditResponseData : start");

      var argHash  = new Object();
      argHash["file"] = responseData["records"][0]["record"]["downloadfile"]["value"][0];
      argHash["type"] = "csv";
      this.postDownloadRack(argHash);

      $R.log("Model onダウンロードOfEditResponseData : end");
    }
  });
}(jQuery, Rmenu));