(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.ListEmployee;

  // インスタンスプロパティを追加する
  var Controller = App.Controller = new $R.Class($R.Controller);
  Controller.fn.init = function(appspec, model, view) {
    $R.log("Controllerr init : start");

    this.appspec = appspec;
    this.model   = model;
    this.view    = view;
    this.createPubSubEvent();

    var self = this;
    var api0 = $('#datetimepicker0').datetimepicker({
	      format : 'yyyy/MM/dd',
        language : 'ja',
	      pickTime : false
    }).data('datetimepicker');
    api0.widget.on('click','.day',function(){
	      api0.hide();
        self.onChange検索入社日付();
    });

    var api1 = $('#datetimepicker1').datetimepicker({
	      format : 'yyyy/MM/dd',
        language : 'ja',
	      pickTime : false
    }).data('datetimepicker');
    api1.widget.on('click','.day',function(){
	      api1.hide();
        self.onChange検索退社日付();
    });


    $R.log("Controllerr init : end");
  }

  // 共通モジュールを追加する
  Controller.include($R.Library.EnterTabPFKeyMixin);
  Controller.include($R.Library.ControllerMixin);

  // マスター一覧パターン　ミックスインを追加する
  Controller.include($R.Library.MasterMainteListControllerMixin);

  // ----------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　  　　
  // また、パターン内の処理を変更するときは、オーバライドする　
  // ----------------------------------------------------------
  Controller.include({
    // ---------------------------------------
    // 初期処理
    // ---------------------------------------
   on初期処理: function() {
      $R.log("Controller on初期処理 : start");

      this.setTableRowEvent();
      this.setTableObjectEvent();

      this.model.on初期処理();
      this.ajaxExecute("init");

      $R.log("Controller on初期処理 : end");
    }
    // -------------------------------------
    //  リクエストデータ　編集・チェック処理
    // -------------------------------------
   ,on初期処理OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on初期処理OfCheckRequestData : start");

      var status = this.checkRequestData(requestData);

      $R.log("Controller on初期処理OfCheckRequestData : end");
      return status;
    }
    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,on初期処理OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on初期処理OfEditResponseData : start");

      this.editResponseData(responseData);
      // セレクトボックスの一括初期表示
      this.onShowSelectBoxAll(responseData, this.appspec.selectbox);

      $R.log("Controller on初期処理OfEditResponseData : end");
    }
    // ---------------------------------------
    // onChange　入社日付　処理
    // ---------------------------------------
   ,onChange検索入社日付: function() {
      $R.log("Controller onChange検索出荷日付 : start");

      this.model.onChange検索入社日付();

      $R.log("Controller onChange検索出荷日付 : end");
    }
   ,onChange検索退社日付: function() {
      $R.log("Controller onChange検索退社日付 : start");

      this.model.onChange検索退社日付();

      $R.log("Controller onChange検索退社日付 : end");
    }
    // ---------------------------------------
    // ボタン・ファンクションキー イベント処理
    // ---------------------------------------
   ,on帳票: function(event) {
      $R.log("Controller on帳票 : start");

      this.ajaxExecute("print");

      $R.log("Controller on帳票 : end");
    }
   ,onダウンロード: function(event) {
      $R.log("Controller onダウンロード : start");

      this.ajaxExecute("download");

      $R.log("Controller onダウンロード : end");
    }
    // -------------------------------------
    // チェンジ イベント処理（追加処理）
    // -------------------------------------
   ,onChange検索商品選択: function(event) {
      $R.log("Controller onChange検索商品選択 : start");

      this.model.onChangeSelectBox(event, this.appspec.selectbox);
			
      $R.log("Controller onChange検索商品選択 : end");
    }
    // -----------------------------------
    //  リクエストデータ　チェック処理
    // -----------------------------------
   ,onプリント作成OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller onプリント作成OfCheckRequestData : start");

      var status = this.checkRequestData(requestData);

      $R.log("Controller onプリント作成OfCheckRequestData : end");
      return status;
    }
   ,onダウンロードOfCheckRequestData: function(requestData, mode) {
      $R.log("Controller onダウンロードOfCheckRequestData : start");

      var status = this.checkRequestData(requestData);

      $R.log("Controller onダウンロードOfCheckRequestData : end");
      return status;
    }
    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,onプリント作成OfEditResponseData: function(responseData, mode) {
      $R.log("Controller onプリント作成OfEditResponseData : start");

      this.editResponseData(responseData);
      this.model.onプリント作成OfEditResponseData(responseData);

      $R.log("Controller onプリント作成OfEditResponseData : end");
    }
   ,onダウンロードOfEditResponseData: function(responseData, mode) {
      $R.log("Controller onダウンロードOfEditResponseData : start");

      this.editResponseData(responseData);
      this.model.onダウンロードOfEditResponseData(responseData);

      $R.log("Controller onダウンロードOfEditResponseData : end");
    }
  });
}(jQuery, Rmenu));