(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.ListEmployee02;

  // インスタンスプロパティを追加する
  var Controller = App.Controller = new $R.Class($R.Controller);
  Controller.fn.init = function(appspec, model, view) {
    $R.log("Controllerr init : start");

    this.appspec = appspec;
    this.model   = model;
    this.view    = view;
    this.createPubSubEvent();

    $R.log("Controllerr init : end");
  }

  // 共通モジュールを追加する
  Controller.include($R.Library.EnterTabPFKeyMixin);
  Controller.include($R.Library.ControllerMixin);

  // マスター一覧パターン　ミックスインを追加する
  Controller.include($R.Library.MasterMainteListControllerMixin);

  // ----------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　  　　
  // また、パターン内の処理を変更するときは、オーバライドする　
  // ----------------------------------------------------------
  Controller.include({
    // ---------------------------------------
    // 初期処理
    // ---------------------------------------
   on初期処理: function() {
      $R.log("Controller on初期処理 : start");

      this.setTableRowEvent();
      this.setTableObjectEvent();

      this.model.on初期処理();
      this.ajaxExecute("init");

      $R.log("Controller on初期処理 : end");
    }
    // -------------------------------------
    //  リクエストデータ　編集・チェック処理
    // -------------------------------------
   ,on初期処理OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on初期処理OfCheckRequestData : start");

      var status = this.checkRequestData(requestData);

      $R.log("Controller on初期処理OfCheckRequestData : end");
      return status;
    }
    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,on初期処理OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on初期処理OfEditResponseData : start");

      this.editResponseData(responseData);
      // セレクトボックスの一括初期表示
      this.onShowSelectBoxAll(responseData, this.appspec.selectbox);

      $R.log("Controller on初期処理OfEditResponseData : end");
    }
    // ---------------------------------------
    // ボタン・ファンクションキー イベント処理
    // ---------------------------------------
    ,on帳票: function(event) {
      $R.log("Controller on帳票 : start");

      this.ajaxExecute("print");

      $R.log("Controller on帳票 : end");
    }
   ,onダウンロード: function(event) {
      $R.log("Controller onダウンロード : start");

      this.ajaxExecute("download");

      $R.log("Controller onダウンロード : end");
    }
    // -----------------------------------
    //  リクエストデータ　チェック処理
    // -----------------------------------
   ,onプリント作成OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller onプリント作成OfCheckRequestData : start");

      var status = this.checkRequestData(requestData);

      $R.log("Controller onプリント作成OfCheckRequestData : end");
      return status;
    }
   ,onダウンロードOfCheckRequestData: function(requestData, mode) {
      $R.log("Controller onダウンロードOfCheckRequestData : start");

      var status = this.checkRequestData(requestData);

      $R.log("Controller onダウンロードOfCheckRequestData : end");
      return status;
    }
    // -----------------------------------
    //  検索処理
    // -----------------------------------
   ,on検索: function(event, arg) {
      $R.log("Controller on検索 : start");

      this.on最初のページ(event);

      $R.log("Controller on検索 : end");
    }
    // -----------------------------------
    //  検索項目　クリア処理
    // -----------------------------------
   ,on検索文字列クリア: function(event, arg) {
      $R.log("Controller on検索文字列クリア : start");

      this.model.on検索文字列クリア();

      $R.log("Controller on検索文字列クリア : end");
    }
    // ---------------------------------------
    // チェンジ イベント処理
    // ---------------------------------------
   ,onChangeセレクトボックス: function(event) {
      $R.log("Controller onChangeセレクトボックス : start");

      this.model.onChangeSelectBox(event, this.appspec.selectbox);

      $R.log("Controller onChangeセレクトボックス : end");
    }
    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,onプリント作成OfEditResponseData: function(responseData, mode) {
      $R.log("Controller onプリント作成OfEditResponseData : start");

      this.editResponseData(responseData);
      this.model.onプリント作成OfEditResponseData(responseData);

      $R.log("Controller onプリント作成OfEditResponseData : end");
    }
   ,onダウンロードOfEditResponseData: function(responseData, mode) {
      $R.log("Controller onダウンロードOfEditResponseData : start");

      this.editResponseData(responseData);
      this.model.onダウンロードOfEditResponseData(responseData);

      $R.log("Controller onダウンロードOfEditResponseData : end");
    }
  });
}(jQuery, Rmenu));