(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.ListTantoName = {};

  // インスタンスプロパティを追加する
  var AppSpec = App.AppSpec = new $R.Class($R.AppSpec);
  AppSpec.fn.init = function(name) {
    $R.log("AppSpec init : start");

    this.name       = name;
    this.nextname   = "MainteTantoName";
    this.beforename = "";

    $R.log("AppSpec init : end");
  }

  // 共通モジュールを追加する
  AppSpec.include($R.Library.AppSpecMixin);

  AppSpec.include({
    // -----------------------------------------------------------------------------------------------
    // プログラム・JSONファイルのURL情報を定義する（サブシステム名・種類・Apps・プログラムフォルダ名）
    // -----------------------------------------------------------------------------------------------
    urlInfo: [
      {app:  "RmenuTutorial/Html/Apps/ListTantoName/"}
     ,{json: "RmenuTutorial/Json/Apps/ListTantoName/"}
    ]
    // --------------------------
    // JSONファイル情報を定義する
    // --------------------------
   ,jsonInfo: [
      {dataset:     "yes"}
     ,{validation:  "yes"}
    ]
    // ----------------------------------------------------------------------------------------
    // トランザクション・リクエストチェック・レスポンス編集・エラーのコールバック関数を定義する
    // ----------------------------------------------------------------------------------------
   ,requestInfo: [
      ["selectmaintable", "onメインテーブル照会OfCheckRequestData",  "onメインテーブル照会OfEditResponseData",  "onErrorResponseData"]
     // ここから追加処理
     ,["print",           "onプリント作成OfCheckRequestData",        "onプリント作成OfEditResponseData",        "onErrorResponseData"]
     ,["download",        "onダウンロードOfCheckRequestData",        "onダウンロードOfEditResponseData",        "onErrorResponseData"]
    ]
    // --------------------------------------------------
    // エンター・タブとPFキーのコールバック関数を定義する
    // --------------------------------------------------
   ,enterTabPFKey: {
      Enter:true
     ,Tab:true
     ,F1:"on登録"
     ,F2:"on転用"
     ,F3:"on訂正"
     ,F4:"on削除"
     ,F5:"on照会"
     // ここから追加処理
     ,F6:"on帳票"
     ,F7:"onダウンロード"
     // ここまで追加処理
     ,F8:null
     ,F9:"on最初のページ"
     ,F10:"on前のページ"
     ,F11:"on次のページ"
     ,F12:"on最後のページ"
     ,ESC:"on戻る"
     ,Forms:0
    }
    // ----------------------------------------------------------------
    // イベント設定はセレクタ・イベント・コールバック関数の順に指定する
    // ----------------------------------------------------------------
    // NAVボタンのイベントを定義する
   ,navButtonEvent: [
      ["#戻る",         "click", "on戻る"]
     ,["#登録",         "click", "on登録"]
     ,["#転用",         "click", "on転用"]
     ,["#訂正",         "click", "on訂正"]
     ,["#削除",         "click", "on削除"]
     ,["#照会",         "click", "on照会"]
     ,["#最初のページ", "click", "on最初のページ"]
     ,["#前のページ",   "click", "on前のページ"]
     ,["#次のページ",   "click", "on次のページ"]
     ,["#最後のページ", "click", "on最後のページ"]
     // ここから追加処理
     ,["#帳票",         "click", "on帳票"]
     ,["#ダウンロード", "click", "onダウンロード"]
    ]
    // バリデーションのイベントを定義する
   ,validationEvent: [
      ["#mainForm", "focus", "onFocus"]
     ,["#mainForm", "blur",  "onBlur"]
    ]
    // その他セレクターイベントを定義する
   ,selectorEvent: [
    ]
    // ------------------------------------------------------------------------
    // テーブルイベント設定はセレクタ・イベント・コールバック関数の順に指定する
    // ------------------------------------------------------------------------
    // テーブルRowイベントを定義する
   ,tableRowEvent: [
      ["#mainTable",         "click", "onテーブル行クリック"]
    ]
    // テーブルオブジェクト　イベントを定義する
   ,tableObjectEvent: [
    ]
    // ----------------------------------------------------------------------------------
    // カスタムイベント設定はイベント名・実行コンテキスト・コールバック関数の順に指定する
    // ----------------------------------------------------------------------------------
    // チェック用カスタムイベントを定義する
   ,pubsubCheckEvent: [
    ]
    // 導出項目編集用カスタムイベントを定義する
   ,pubsubDeriveEvent: [
      ["deriveトータル件数", "model", "onDeriveトータル件数"]
    ]
    // その他カスタムイベントを定義する
   ,pubsubOtherEvent: [
      ["showログイン情報",     "view", "showログイン情報"]
     ,["show初期処理",         "view", "show初期処理"]
     ,["showページ情報",       "view", "showページ情報"]
     ,["onテーブル表示",       "view", "onテーブル表示"]
     ,["onテーブル行クリック", "view", "onテーブル行クリック"]
    ]
  });
}(jQuery, Rmenu));