(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.MainteConsumptionTax;

  // インスタンスプロパティを追加する
  var Controller = App.Controller = new $R.Class($R.Controller);
  Controller.fn.init = function(appspec, model, view) {
    $R.log("Controllerr init : start");

    this.appspec = appspec;
    this.model   = model;
    this.view    = view;
    this.createPubSubEvent();

    var self = this;

    var datetimepickerArg = {
        format : 'yyyy/MM/dd',
        language : 'ja',
        pickTime : false
    };

    var api01 = $('#施行日カレンダー').datetimepicker(datetimepickerArg).data('datetimepicker');
    api01.widget.on('click','td.day',function(){
        api01.hide();
        self.onChangeテーブルＩＤ();
    });

    $R.log("Controllerr init : end");
  }

  // モジュールを追加する
  Controller.include($R.Library.EnterTabPFKeyMixin);
  Controller.include($R.Library.ControllerMixin);

  // マスターメンテパターン　ミックスインを追加する
  Controller.include($R.Library.MasterMainteControllerMixin);

  // ----------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　  　　
  // また、パターン内の処理を変更するときは、オーバライドする　
  // ----------------------------------------------------------
  Controller.include({
    // ---------------------------------------
    // チェンジ イベント処理（追加処理）
    // ---------------------------------------
    onChangeカレンダー: function(event) {
      $R.log("Controller onChangeカレンダー : start");

      this.model.onChangeカレンダー(event);

      $R.log("Controller onChangeカレンダー : end");
    }

    // ---------------------------------------
    // チェンジ イベント処理（追加処理）datetimepicker用
    // ---------------------------------------
   ,onChangeテーブルＩＤ: function(event) {
      $R.log("Controller onChangeテーブルＩＤ : start");

      this.model.onChangeテーブルＩＤ();

      $R.log("Controller onChangeテーブルＩＤ : end");
    }

  });

}(jQuery, Rmenu));