(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.MainteEmployee03;

  // インスタンスプロパティを追加する
  var Controller = App.Controller = new $R.Class($R.Controller);
  Controller.fn.init = function(appspec, model, view) {
    $R.log("Controllerr init : start");

    this.appspec = appspec;
    this.model   = model;
    this.view    = view;
    this.createPubSubEvent();

    $R.log("Controllerr init : end");
  }

  // モジュールを追加する
  Controller.include($R.Library.EnterTabPFKeyMixin);
  Controller.include($R.Library.ControllerMixin);

  // マスターメンテパターン　ミックスインを追加する
  Controller.include($R.Library.MasterMainteControllerMixin);

  // ----------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　  　　
  // また、パターン内の処理を変更するときは、オーバライドする　
  // ----------------------------------------------------------
  Controller.include({
    // ---------------------------------------
    // 初期処理
    // ---------------------------------------
   on初期処理: function() {
      $R.log("Controller on初期処理 : start");

      this.setTableRowEvent();
      this.setTableObjectEvent();

      this.model.on初期処理();
      this.ajaxExecute("init");

      $R.log("Controller on初期処理 : end");
    }
    // -------------------------------------
    //  リクエストデータ　編集・チェック処理
    // -------------------------------------
   ,on初期処理OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on初期処理OfCheckRequestData : start");

      var status = this.checkRequestData(requestData);

      $R.log("Controller on初期処理OfCheckRequestData : end");
      return status;
    }
    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,on初期処理OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on初期処理OfEditResponseData : start");

      this.editResponseData(responseData);
      // セレクトボックスの一括初期表示
      this.onShowSelectBoxAll(responseData, this.appspec.selectbox);

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.beforename);
      var mode = sessionStorage.loadItem("処理モード");

      if (mode != "insert") {
        this.model.setテーブルＩＤ();
        this.ajaxExecute("select");
      }

      $R.log("Controller on初期処理OfEditResponseData : end");
    }

    // ---------------------------------------
    // チェンジ イベント処理
    // ---------------------------------------
   ,onChangeセレクトボックス: function(event) {
      $R.log("Controller onChangeセレクトボックス : start");

      this.model.onChangeSelectBox(event, this.appspec.selectbox);

      $R.log("Controller onChangeセレクトボックス : end");
    }

  });

}(jQuery, Rmenu));