(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.MainteHoliday;

  // インスタンスプロパティを追加する
  var View = App.View = new $R.Class($R.View);
  View.fn.init = function(appspec) {
    $R.log("View init : start");

    this.appspec = appspec;

    $R.log("View init : end");
  }

  // モジュールを追加する
  View.include($R.Library.FormatMixin);
  View.include($R.Library.OutlineMixin);
  View.include($R.Library.LoadTemplateMixin);
  View.include($R.Library.ViewMixin);

  // マスターメンテパターン　ミックスインを追加する
  View.include($R.Library.MasterMainteViewMixin);

  // ----------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　  　　
  // また、パターン内の処理を変更するときは、オーバライドする　
  // ----------------------------------------------------------
  View.include({
    // -------------------------
    //  ヘッダタイトルを表示する
    // -------------------------
   showヘッダータイトル: function(arg) {
      $R.log("View showヘッダータイトル : start");

      var title = $("#ヘッダータイトル").html();
      var mode  = arg["処理モード"];

      switch (mode) {
        case "select":
          title   += "（照会）";
          $("#実行").attr("disabled","disabled");
          $("#カレンダー区分").attr("readonly","readonly");
          $("#休日日付").attr("readonly","readonly");
          break;
        case "insert":
          title   += "（新規）";
          $("#カレンダー区分").removeAttr("readonly");
          $("#休日日付").removeAttr("readonly");
          break;
        case "convert":
          title   += "（転用）";
          $("#カレンダー区分").removeAttr("readonly");
          $("#休日日付").removeAttr("readonly");
          break;
        case "update":
          title   += "（訂正）";
          $("#カレンダー区分").attr("readonly","readonly");
          $("#休日日付").attr("readonly","readonly");
          break;
        case "delete":
          title   += "（削除）";
          $("#カレンダー区分").attr("readonly","readonly");
          $("#休日日付").attr("readonly","readonly");
      }
      $("#ヘッダータイトル").html(title); 

      $R.log("View showヘッダータイトル : end");
    }
  });

}(jQuery, Rmenu));