(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.ThemeMainte;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // 基本名称メンテ　パターン　ミックスインを追加する
  Model.include($R.Library.BaseNameMainteModelMixin9);

  // ----------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　  　　
  // また、パターン内の処理を変更するときは、オーバライドする　
  // ----------------------------------------------------------
  Model.include({
    // -------------------------------------------------------
    //  テーブルの選択行をセッションストレージに格納する
    // -------------------------------------------------------
    on使用行クリック: function(arg) {
      $R.log("Model on使用行クリック : start");

      var clickRow  = arg["クリック行"];

      var dataset    = this.dataset.getData();
      var detailInfo = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
      var maxLines   = detailInfo["record"]["使用"]["value"].length;
      var i;

      for (i = 0; i < maxLines; i++) {
        detailInfo["record"]["使用"]["value"][i] = "";
      }
      detailInfo["record"]["使用"]["value"][clickRow] = "1";

      var arg9        = {};
      arg9["cssName"] = detailInfo["record"]["テーマコード"]["value"][clickRow];
      this.pubsub.publish("on使用行クリック", arg9);

      $R.log("Model on使用行クリック : end");
    }
    // -------------------------------------------------------
    //  実行前編集処理
    // -------------------------------------------------------
    ,on実行前編集処理: function(requestData) {
      $R.log("Model on実行前編集処理 : start");

      var dataset     = this.dataset.getData();
      var detailInfo  = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
      var requestInfo = this.appspec.getJSONChunkByIdAtRecords(requestData, "detail");
      var maxLines    = requestInfo["record"]["使用"]["value"].length;
      var i;

      var useRadioBox = $(".使用");
      for (var i = 0; i < maxLines; i++) {
        if ( $(useRadioBox[i]).prop('checked') ) {
          requestInfo["record"]["使用"]["value"][i] = "1";
        }
        else {
          requestInfo["record"]["使用"]["value"][i] = "0";
        }
      }

      $R.log("Model on実行前編集処理 : end");
    }
    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,onメインテーブル照会OfEditResponseData: function(responseData) {
      $R.log("Model onメインテーブル照会OfEditResponseData : start");

      var dataset      = this.dataset.getData();
      var detailInfo   = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
      var defaultline  = detailInfo["defaultline"];

      var responseInfo = this.appspec.getJSONChunkByIdAtRecords(responseData, "detail");

      var useRadioBox = $(".使用");
      if (useRadioBox.length > 0) {
        for (var i = 0; i < defaultline; i++) {
          if (responseInfo["record"]["使用"]["value"][i] == "1") {
            $(useRadioBox[i]).prop("checked", true);
            break;
          }
        }
      }

      $R.log("Model onメインテーブル照会OfEditResponseData : end");
    }

  });

}(jQuery, Rmenu));