(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.main;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  Model.include({
    // --------
    // 処理開始
    // --------
    initExecute: function() {
      $R.log("Model initExecute : start");

      //this.dataset.clearDataValue();                   // Datasetの値をクリアする
      //this.dataset.clearFormElementNo();               // フォームオブジェクトの要素番号をクリアする
      //this.dataset.setFormElementNo();                 // フォームオブジェクトの要素番号を設定する

      $R.log("Model initExecute : end");
    }
    // -------------------------------
    //  ドキュメントファイルを読み込む
    // -------------------------------
   ,postDocsTransition: function(self, argArray) {
      $R.log("Model postDocsTransition : start");

      var requestData = this.appspec.sysname + "/Html/RmenuTutorialDocs/" + argArray[0] + "/" + argArray[1];

      $.ajax({
         url:         $R.RmenuRackURL + "RmenuDocs.rb"
        ,type:        "POST"
        ,data:        "data=" + requestData
        ,dataType:    "html"
        ,success:     function(data) {
           var arg = {tabName: argArray[2], tabData: data};
           self.pubsub.publish("addTab", arg);
         }
        ,error  :     function() {
           var arg = {};
           arg["title"]   = "通信エラー";
           arg["status"]  = "ERROR";
           arg["message"] = "サーバとの接続に失敗しました。担当者に連絡して下さい。";
           self.pubsub.publish("alertDialog", arg);
         }
      });


      $R.log("Model postDocsTransition : end");
    }
    // タブを追加し、新しいテキストファイルを表示する
   ,postTextTransition: function(textName) {
      window.open("", textName);

      var form     = document.createElement("form");
      form.action  = $R.RmenuRackURL + "RmenuText.rb";
      form.target  = textName;
      form.method  = 'post';
      this.postTransition(form, textName);
    }

  });
}(jQuery, Rmenu));