# coding: UTF-8

require 'RmenuJsonMixin'
require 'RmenuTutorial/Server/Modules/RmenuTutorialMasterMainteOfModelMixin'

class BaseSystemSessionList_model
  include RmenuJsonMixin
  include RmenuTutorialMasterMainteOfModelMixin

  def initialize(rmenu_dbi, sql_data, request_data)
    begin
      # initialize 開始ログを出力する
      $Mlog.debug("BaseSystemSessionList_model") {"initialize start"}                   # Logファイル Debug用

      @rmenu_dbi      = rmenu_dbi
      @sql_data       = sql_data
      @request_data   = request_data

      # initialize 終了ログを出力する
      $Mlog.debug("BaseSystemSessionList_model") {"initialize normal end"}              # Logファイル Debug用
    rescue Exception
      # エラーログを出力する
      $Mlog.error("BaseSystemSessionList_model") {"initialize exception: #{$!}"}        # Logファイル Debug用
      raise
    end
  end

  # 総件数を取得するSQLを変更する
  def setSql総件数(idname1, idname2)
    $Mlog.debug("BaseSystemSessionList_model") {"setSql総件数 start"}                  # Logファイル Debug用

    headerRecord  = getJsonChunkById(@request_data, "records", idname1)
    searchString  = headerRecord["record"]["検索文字列"]["value"][0]

    sqlInfo         = getJsonChunkById(@sql_data, "sqls", idname2)
    # 検索文字列
    if searchString == ""
      sqlInfo["sql"]["freesql"][3] = ""
      sqlInfo["sql"]["freesql"][4] = ""
    else
      sqlInfo["sql"]["freesql"][4] = "AND txuserkubun LIKE '%#{searchString}%'"
    end

    $Mlog.debug("BaseSystemSessionList_model") {"setSql総件数 end"}                    # Logファイル Debug用
    return "OK"
  end

  # 取引先検索SQLを変更する
  def setSqlデータ検索(idname1, idname2)
    $Mlog.debug("BaseSystemSessionList_model") {"setSqlデータ検索 start"}                  # Logファイル Debug用

    headerRecord  = getJsonChunkById(@request_data, "records", idname1)
    searchString  = headerRecord["record"]["検索文字列"]["value"][0]

    sqlInfo         = getJsonChunkById(@sql_data, "sqls", idname2)
    # 検索文字列
    if searchString == ""
      sqlInfo["sql"]["freesql"][10] = ""
      sqlInfo["sql"]["freesql"][11] = ""
    else
      sqlInfo["sql"]["freesql"][10] = "AND txuserkubun LIKE '%#{searchString}%'"
    end

    $Mlog.debug("BaseSystemSessionList_model") {"setSqlデータ検索 end"}                    # Logファイル Debug用
    return "OK"
  end

end
