# coding: UTF-8

require "date"
require 'RmenuJsonMixin'                                                        # ID名で該当レコードを取得する

class ClassNamePrint9_form
  include RmenuJsonMixin

  def initialize(pdfcreate, response_data, sql_data, request_data)
    begin
      # initialize 開始ログを出力する
      $PDFC.debug("ClassNamePrint9_form") {"initialize start"}                          # Logファイル Debug用

      @pdfcreate      = pdfcreate
      @response_data  = response_data
      @sql_data       = sql_data
      @request_data   = request_data
      
      # initialize 終了ログを出力する
      $PDFC.debug("ClassNamePrint9_form") {"initialize normal end"}                     # Logファイル Debug用
    rescue Exception
      # エラーログを出力する
      $PDFC.error("ClassNamePrint9_form") {"initialize exception: #{$!}"}               # Logファイル Debug用
      raise
    end
  end

  # ページヘッダー処理（システム日付・ページ番号）
  def page_header()
    $PDFC.debug("ClassNamePrint9_form") {"page_header start"}                               # Logファイル Debug用

    responseInfo   = getJsonChunkById(@response_data, "records", "page_header")
    responseRecord = responseInfo["record"]

    date                                 = Date.today
    responseRecord["日付"]["value"][0]   = date.strftime("%Y/%m/%d")
    responseRecord["ページ"]["value"][0] = @pdfcreate.getTotalPageCount()

    $PDFC.debug("ClassNamePrint9_form") {"page_header end"}                                 # Logファイル Debug用
    return "OK"
  end
end
