# coding: UTF-8

require 'RmenuTutorial/Server/Modules/RmenuTutorialOfMasterMainteOfModelMixin'

class CustomerSearch_model
  include RmenuTutorialOfMasterMainteOfModelMixin

  def initialize(rmenu_dbi, sql_data, request_data)
    begin
      # initialize 開始ログを出力する
      $Mlog.debug("CustomerSearch_model") {"initialize start"}                   # Logファイル Debug用

      @rmenu_dbi      = rmenu_dbi
      @sql_data       = sql_data
      @request_data   = request_data

      # initialize 終了ログを出力する
      $Mlog.debug("CustomerSearch_model") {"initialize normal end"}              # Logファイル Debug用
    rescue Exception
      # エラーログを出力する
      $Mlog.error("CustomerSearch_model") {"initialize exception: #{$!}"}        # Logファイル Debug用
      raise
    end
  end

  # SQL文の検索条件を変更する
  def setSql(idname1, idname2 ,genesql_freesql)
    $Mlog.debug("CustomerSearch_model") {"setSql start"}                  # Logファイル Debug用

    requestInfo  = getJsonChunkById(@request_data, "records", idname1)
    searchString01 = requestInfo["record"]["検索受注番号識別コード"]["value"][0]
    searchString02 = requestInfo["record"]["検索得意先略称"]["value"][0]

    sqlInfo      = getJsonChunkById(@sql_data, "sqls", idname2)

    rep = ""
    # 検索受注番号識別コード
    if searchString01 != ""
      rep = rep + "AND 受注番号識別コード LIKE '#{searchString01}%'"
    end
    # 検索得意先略称
    if searchString02 != ""
      rep = rep + "AND 得意先略称 LIKE '%#{searchString02}%'"
    end

    # 検索条件の置き換え
    if    genesql_freesql == 'genesql'
      sqlInfo["sql"]["genesql"]["where"].sub!(/&&/,rep)
    elsif genesql_freesql == 'freesql'
      strJoin = sqlInfo["sql"]["freesql"].join("\t")
      strJoin.sub!(/&&/,rep)
      strSplit = strJoin.split("\t")
      sqlInfo["sql"]["freesql"].each_with_index do |temp, idx|
        sqlInfo["sql"]["freesql"][idx] = strSplit[idx]
      end
    end

    $Mlog.debug("CustomerSearch_model") {"setSql end"}                    # Logファイル Debug用
    return "OK"
  end

  # SQL文のソート条件を変更する
  def setSortCondition(idname1, idname2 ,genesql_freesql)
    $Mlog.debug("SupplierSearch_model") {"setSortCondition start"}                  # Logファイル Debug用

    requestInfo  = getJsonChunkById(@request_data, "records", idname1)
    unitname     = requestInfo["record"]["ログイン部署名"]["value"][0]

    sqlInfo      = getJsonChunkById(@sql_data, "sqls", idname2)

    rep = "得意先ＩＤ"

    case unitname
      when "大阪" then
        rep = " 大阪得意先表示順,得意先ＩＤ"
      when "東京" then
        rep = " 東京得意先表示順,得意先ＩＤ"
    end

    # ソート条件の置き換え
    if    genesql_freesql == 'genesql'
      sqlInfo["sql"]["genesql"]["order"].sub!(/&&/,rep)
    elsif genesql_freesql == 'freesql'
      strJoin = sqlInfo["sql"]["freesql"].join("\t")
      strJoin.sub!(/&&/,rep)
      strSplit = strJoin.split("\t")
      sqlInfo["sql"]["freesql"].each_with_index do |temp, idx|
        sqlInfo["sql"]["freesql"][idx] = strSplit[idx]
      end
    end

    $Mlog.debug("SupplierSearch_model") {"setSortCondition end"}                    # Logファイル Debug用
    return "OK"
  end

end
