# coding: UTF-8

require 'RmenuJsonMixin'
require 'RmenuTutorial/Server/Modules/RmenuTutorialMasterMainteOfModelMixin'

class ListEmployee04_model
  include RmenuJsonMixin
  include RmenuTutorialMasterMainteOfModelMixin

  def initialize(rmenu_dbi, sql_data, request_data)
    begin
      # initialize 開始ログを出力する
      $Mlog.debug("ListEmployee04_model") {"initialize start"}                   # Logファイル Debug用

      @rmenu_dbi      = rmenu_dbi
      @sql_data       = sql_data
      @request_data   = request_data

      # initialize 終了ログを出力する
      $Mlog.debug("ListEmployee04_model") {"initialize normal end"}              # Logファイル Debug用
    rescue Exception
      # エラーログを出力する
      $Mlog.error("ListEmployee04_model") {"initialize exception: #{$!}"}        # Logファイル Debug用
      raise
    end
  end

  # SQL文の検索条件を変更する
  def setSql(idname1, idname2 ,genesql_freesql)
    $Mlog.debug("ListEmployee04_model") {"setSql start"}                  # Logファイル Debug用

    requestInfo  = getJsonChunkById(@request_data, "records", idname1)

    employeeCode  = requestInfo["record"]["検索従業員№"]["value"][0]
    employeeKana  = requestInfo["record"]["検索カナ名"  ]["value"][0]
    employeeName  = requestInfo["record"]["検索漢字名"  ]["value"][0]
    employeeKoyou = requestInfo["record"]["検索雇用区分"]["value"][0]
    employeeNyusha = requestInfo["record"]["検索入社日"  ]["value"][0]
    employeeTaisha = requestInfo["record"]["検索退社日"  ]["value"][0]

    sqlInfo      = getJsonChunkById(@sql_data, "sqls", idname2)

    rep = "true"

    # 検索従業員№
    if employeeCode != ""
        rep = rep + " AND NRJYUGYOIN LIKE '#{employeeCode}%'"
    end

    # 検索カナ名
    if employeeKana != ""
        rep = rep + " AND TXKANA like '#{employeeKana}%'"
    end

    # 検索漢字名
    if employeeName != ""
        rep = rep + " AND TXKANJI like '#{employeeName}%'"
    end

    # 検索雇用区分
    if employeeKoyou != ""
        rep = rep + " AND KBKOYOU = '#{employeeKoyou}'"
    end

    # 検索入社日
    if employeeNyusha != ""
        rep = rep + " AND DTNYUSYA = '#{employeeNyusha}'"
    end

    # 検索退社日
    if employeeTaisha != ""
        rep = rep + " AND DTTAISYA = '#{employeeTaisha}'"
    end


    sqlInfo["sql"]["genesql"]["where"] = rep

    $Mlog.debug("ListEmployee04_model") {rep}               # Logファイル Debug用

    # 検索条件の置き換え
    if    genesql_freesql == 'genesql'
      sqlInfo["sql"]["genesql"]["where"].sub!(/&&/,rep)
    elsif genesql_freesql == 'freesql'
      strJoin = sqlInfo["sql"]["freesql"].join("\t")
      strJoin.sub!(/&&/,rep)
      strSplit = strJoin.split("\t")
      sqlInfo["sql"]["freesql"].each_with_index do |temp, idx|
        sqlInfo["sql"]["freesql"][idx] = strSplit[idx]
      end
    end

    $Mlog.debug("ListEmployee04_model") {"setSql end"}                    # Logファイル Debug用
    return "OK"
  end

end
