# coding: UTF-8

require "date"
require 'RmenuJsonMixin'                                                        # ID名で該当レコードを取得する

class PrintListBankBranchName_form
  include RmenuJsonMixin

  def initialize(pdfcreate, response_data, sql_data, request_data)
    begin
      # initialize 開始ログを出力する
      $PDFC.debug("PrintListBankBranchName_form") {"initialize start"}                          # Logファイル Debug用

      @pdfcreate      = pdfcreate
      @response_data  = response_data
      @sql_data       = sql_data
      @request_data   = request_data

      # initialize 終了ログを出力する
      $PDFC.debug("PrintListBankBranchName_form") {"initialize normal end"}                     # Logファイル Debug用
    rescue Exception
      # エラーログを出力する
      $PDFC.error("PrintListBankBranchName_form") {"initialize exception: #{$!}"}               # Logファイル Debug用
      raise
    end
  end

  # ページフォーマット（罫線描画等）
  def background_pattern()
    begin
      $PDFC.debug("PrintListBankBranchName_form") {"background_pattern start"}                               # Logファイル Debug用

    pdfObject = @pdfcreate.getPdfObject()


    pdfObject.fill_color "ffd700"
    pdfObject.fill_rectangle [-33, 812], 593, 42


      $PDFC.debug("PrintListBankBranchName_form") {"background_pattern end"}                                 # Logファイル Debug用
      return "OK"
    rescue Exception
      # エラーログを出力する
      $PDFC.error("PrintListBankBranchName_form") {"background_pattern: #{$!}"}               # Logファイル Debug用
      raise
    end
  end

  # ページヘッダー処理（システム日付・ページ番号）
  def page_header()
    begin
      $PDFC.debug("PrintListBankBranchName_form") {"page_header start"}                               # Logファイル Debug用

      responseRecord       = getJsonChunkById(@response_data, "records", "page_header","record")

      responseRecord["ページ"]["value"][0]     = @pdfcreate.getTotalPageCount()

      $PDFC.debug("PrintListBankBranchName_form") {"page_header end"}                                 # Logファイル Debug用
      return "OK"
    rescue Exception
      # エラーログを出力する
      $PDFC.error("PrintListBankBranchName_form") {"page_header: #{$!}"}               # Logファイル Debug用
      raise
    end
  end

  # 明細（印刷行数）
  def page_detail()
    begin
      $PDFC.debug("PrintListBankBranchName_form") {"page_detail start"}                               # Logファイル Debug用

      responseRecord       = getJsonChunkById(@response_data, "records", "detail","record")

      tcount =  @pdfcreate.getTotalRecordCount()

      responseRecord["印刷行数"]["value"][tcount - 1]   = tcount

      $PDFC.debug("PrintListBankBranchName_form") {"page_detail end"}                                 # Logファイル Debug用
      return "OK"
    rescue Exception
      # エラーログを出力する
      $PDFC.error("PrintListBankBranchName_form") {"page_detail: #{$!}"}               # Logファイル Debug用
      raise
    end
  end

end
