(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.AccessLogInfo;

  // インスタンスプロパティを追加する
  var Controller = App.Controller = new $R.Class($R.Controller);
  Controller.fn.init = function(appspec, model, view) {
    $R.log("Controllerr init : start");

    this.appspec = appspec;
    this.model   = model;
    this.view    = view;
    this.createPubSubEvent();

    var self = this;

    var api1 = $('#datetimepicker').datetimepicker({
	      format : 'yyyy/MM/dd',
        language : 'ja',
      	pickTime : false
    }).data('datetimepicker');
    api1.widget.on('click','td.day',function(){
      	api1.hide();
        self.onChangeアクセス日付();
    });

    $R.log("Controllerr init : end");
  };

  // 共通モジュールを追加する
  Controller.include($R.Library.EnterTabPFKeyMixin);
  Controller.include($R.Library.ControllerMixin);

  // マスター一覧パターン　ミックスインを追加する
  Controller.include($R.Library.MasterMainteListControllerMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Controller.include({
    // --------
    // 処理開始
    // --------
    initExecute: function() {
      $R.log("Controller initExecute : start");

      this.model.getログイン情報();
      this.on初期処理();

      $R.log("Controller initExecute : end");
    }
		
    // ---------------------------------------
    // 初期処理
    // ---------------------------------------
   ,on初期処理: function() {
      $R.log("Controller on初期処理 : start");

      this.model.on初期処理();
      this.ajaxExecute("init");

      $R.log("Controller on初期処理 : end");
    }
    // -------------------------------
    //  ページネーション　イベント処理
    // -------------------------------
   ,on初期のページ: function(employee) {
      $R.log("Controller on初期のページ : start");

      this.model.on最初のページ(employee);
      this.ajaxExecute("selectmaintable");

      $R.log("Controller on初期のページ : end");
    }
		
    // -------------------------------
    //  ページネーション　イベント処理
    // -------------------------------
   ,on最初のページ: function(event) {
      $R.log("Controller on最初のページ : start");
			
			var employee = this.model.get従業員コード();
      this.model.on最初のページ(employee);
      this.ajaxExecute("selectmaintable");

      $R.log("Controller on最初のページ : end");
    }

    // -------------------------------------
    // ボタン イベント処理
    // -------------------------------------
   ,on照会: function(event) {
      $R.log("Controller on照会 : start");

			var employee = this.model.get従業員コード();
      this.model.on最初のページ(employee);
      this.ajaxExecute("selectmaintable");
			
      $R.log("Controller on照会 : end");
    }
   ,on削除: function(event) {
      $R.log("Controller on削除 : start");

			var employee = this.model.get従業員コード();
      this.model.on最初のページ(employee);
      this.ajaxExecute("delete");
			
      $R.log("Controller on削除 : end");
    }
    // -------------------------------------
    // チェンジ イベント処理（追加処理）
    // -------------------------------------
   ,onChangeアクセス日付: function() {
      $R.log("Controller onChangeアクセス日付 : start");

      this.model.onChangeアクセス日付();
			
      $R.log("Controller onChangeアクセス日付 : end");
    }
   ,onChangeセレクトボックス: function(event) {
      $R.log("Controller onChangeセレクトボックス : start");

      var employee = this.model.onChangeSelectBox(event, this.appspec.selectbox);

      this.model.on最初のページ(employee);
      this.ajaxExecute("selectmaintable");

      $R.log("Controller onChangeセレクトボックス : end");
    }

    // -------------------------------------
    //  リクエストデータ　編集・チェック処理
    // -------------------------------------
   ,on初期処理OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on初期処理OfCheckRequestData : start");

      var status = this.checkRequestData(requestData);

      $R.log("Controller on初期処理OfCheckRequestData : end");
      return status;
    }

   ,onメインテーブル削除OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller onメインテーブル削除OfCheckRequestData : start");

      var status = this.checkRequestData(requestData);

      $R.log("Controller onメインテーブル削除OfCheckRequestData : end");
      return status;
    }

    // -----------------------------------------------
    //  メインテーブル照会　レスポンスデータ　編集処理
    // -----------------------------------------------
    // -------------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------------
   ,on初期処理OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on初期処理OfEditResponseData : start");

      this.editResponseData(responseData);
			
      // セレクトボックスの一括初期表示
      this.onShowSelectBoxAll(responseData, this.appspec.selectbox);
			
      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var currentpage = sessionStorage.loadItem("カレントページ");
      if (currentpage){
				this.view.onリロード();
        this.onリロード();
      }
      else {
				var employee = this.view.on初期のページ();
        this.on初期のページ(employee);
      }

      $R.log("Controller on初期処理OfEditResponseData : end");
    }

   ,onメインテーブル削除OfEditResponseData: function(responseData, mode) {
      $R.log("Controller onメインテーブル削除OfEditResponseData : start");

      this.editResponseData(responseData);
      this.model.onメインテーブル照会OfEditResponseData(responseData);
			
      $R.log("Controller onメインテーブル削除OfEditResponseData : end");
    }

		
  });

}(jQuery, Rmenu));