(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.AccessLogInfo;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // マスター一覧パターン　ミックスインを追加する
  Model.include($R.Library.MasterMainteListModelMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  Model.include({
    // -------------------------------------------------------------------
    //  初期処理
    // -------------------------------------------------------------------
    on初期処理: function() {
      $R.log("Model on初期処理 : start");
			
      var arg = {};
      this.pubsub.publish("show初期処理", arg);
			
			var today = this.getシステム日付();
      var wday  = this.get曜日(today);
      this.dataset.setElementData(today, "アクセス日付");
			
      var arg = {アクセス日付: today};
      this.pubsub.publish("showアクセス日付", arg);

      var arg  = {アクセス曜日: wday};
      this.pubsub.publish("showアクセス曜日", arg);

      $R.log("Model on初期処理 : end");
    }
    // -------------------------------------------------------------------
    //  システム日付を取得する
    // -------------------------------------------------------------------
   ,getシステム日付: function() {
      $R.log("Model getシステム日付 : start");

      var date  = new Date();
			var year  = date.getFullYear();
			var month = date.getMonth() + 1;
			var day   = date.getDate();
			
			if (month < 10) {
				month = "0" + month;
			}
			
			if (day < 10) {
				day = "0" + day;
			}
			
      var today = year + "/" +month + "/" + day;

      $R.log("Model getシステム日付 : end");
			return today;
    }
    // -------------------------------------------------------------------
    //  曜日を取得する
    // -------------------------------------------------------------------
   ,get曜日: function(date) {
      $R.log("Model get曜日 : start");

      var today   = new Date(date) ;
      var weekday = ["日", "月", "火", "水", "木", "金", "土"] ;
      var	wday    = "（" + weekday[today.getDay()] + "）" ;

      $R.log("Model get曜日 : end");
			return wday;
    }

    // -------------------------------------------
    //  ページネーション最初処理
    // -------------------------------------------
   ,on最初のページ: function(employee) {
      $R.log("Model on最初のページ : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var dataset    = this.dataset.getData();
      var detailInfo = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
      var pageline   = detailInfo["defaultline"];
      sessionStorage.saveItem("ページライン数", pageline);
      sessionStorage.saveItem("カレントページ", 1);
      sessionStorage.saveItem("検索従業員コード", employee);

      this.dataset.setElementData(pageline, "ページライン数");
      this.dataset.setElementData(1, "カレントページ");
      this.dataset.setElementData(employee, "検索従業員コード");

      sessionStorage.saveItem("処理モード", "");

      $R.log("Model on最初のページ : end");
    }
		
    // -------------------------------------------
    //  ページネーションリロード処理
    // -------------------------------------------
   ,onリロード: function() {
      $R.log("Model onリロード : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);

      var pageline = sessionStorage.loadItem("ページライン数");
      var pageno   = sessionStorage.loadItem("カレントページ");
      var employee = sessionStorage.loadItem("検索従業員コード");

      this.dataset.setElementData(pageline, "ページライン数");
      this.dataset.setElementData(pageno, "カレントページ");
      this.dataset.setElementData(employee, "検索従業員コード");

      $R.log("Model onリロード : end");
    }
		
    // -------------------------------------
    // チェンジ イベント処理
    // -------------------------------------
   ,onChangeアクセス日付: function() {
      $R.log("Model onChangeアクセス日付 : start");

      var createDate   = $("#アクセス日付").val();
      this.dataset.setElementData(createDate, "アクセス日付");
			
      var wday = this.get曜日(createDate);
      var arg  = {アクセス曜日: wday};
      this.pubsub.publish("showアクセス曜日", arg);

      $R.log("Model onChangeアクセス日付 : end");
    }

    // -------------------------------------
    // チェンジ イベント処理
    // -------------------------------------
   ,get従業員コード: function() {
      $R.log("Model get従業員コード : start");

      var employee   = $("#従業員選択").val();

      $R.log("Model get従業員コード : end");
			return employee;
    }

	});

}(jQuery, Rmenu));