(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.AccessLogInfo;

  // インスタンスプロパティを追加する
  var View = App.View = new $R.Class($R.View);
  View.fn.init = function(appspec) {
    $R.log("View init : start");

    this.appspec = appspec;

    $R.log("View init : end");
  }

  // 共通モジュールを追加する
  View.include($R.Library.FormatMixin);
  View.include($R.Library.OutlineMixin);
  View.include($R.Library.LoadTemplateMixin);
  View.include($R.Library.ViewMixin);

  // マスター一覧パターン　ミックスインを追加する
  View.include($R.Library.MasterMainteListViewMixin);

  // --------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　　　
  // また、パターン内の処理を変更するときは、オーバライドする
  // --------------------------------------------------------
  View.include({
    // --------
    // 処理開始
    // --------
    initExecute: function(dataset) {
      $R.log("View initExecute : start");

      this.initテンプレートロード();
      this.initAlertDialog();                     // 警告メッセージ用ダイアログ 初期処理
      this.initConfirmDialog(this);               // 確認メッセージ用ダイアログ 初期処理
      this.initExecuteDialog(this);               // 実行確認メッセージ用ダイアログ 初期処理
      this.initServerDialog(this);                // サーバ確認メッセージ用ダイアログ 初期処理

      // テーブルの空行を作成する
      var detailInfo  = this.appspec.getJSONChunkByIdAtRecords(dataset, "detail");
      var defaultline = detailInfo["defaultline"];
      this.createTableRows("#mainTable", defaultline);

      $R.log("View initExecute : end");
    }
		
    // -------------------------------
    //  ページネーション　イベント処理
    // -------------------------------
   ,on初期のページ: function() {
      $R.log("Controller on初期のページ : start");

      var category = $("#部門選択").val();

      $R.log("Controller on初期のページ : end");
			return category;
    }
    // -------------------------------------------------------------------
    //  アクセス日付を表示する
    // -------------------------------------------------------------------
   ,showアクセス日付: function(arg) {
      $R.log("View showアクセス日付 : start");
			
			var today = arg["アクセス日付"];
			$("#アクセス日付").val(today);
			
	    $R.log("View showアクセス日付 : end");
    }
    // -------------------------------------------------------------------
    //  ヘッダー曜日を表示する
    // -------------------------------------------------------------------
   ,showアクセス曜日: function(arg) {
      $R.log("View showアクセス曜日 : start");
			
			var wday  = arg["アクセス曜日"];
			$("#アクセス曜日").text(wday);
			
	    $R.log("View showアクセス曜日 : end");
    }

    // -------------------------------
    //  リロード時の部門設定
    // -------------------------------
   ,onリロード: function() {
      $R.log("Controller onリロード : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      var employee = sessionStorage.loadItem("検索従業員コード");
      $("#従業員選択").val(employee);

      $R.log("Controller onリロード : end");
    }


  });

}(jQuery, Rmenu));