(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.ClientViewer = {};

  // インスタンスプロパティを追加する
  var AppSpec = App.AppSpec = new $R.Class($R.AppSpec);
  AppSpec.fn.init = function(name, formcontroll) {
    $R.log("AppSpec init : start");

    this.name         = name;
    //this.formcontroll = formcontroll;

    $R.log("AppSpec init : end");
  }

  // 共通モジュールを追加する
  AppSpec.include($R.Library.AppSpecMixin);

  AppSpec.include({
    // -----------------------------------------------------------------------------------------------
    // プログラム・JSONファイルのURL情報を定義する（サブシステム名・種類・Apps・プログラムフォルダ名） 
    // -----------------------------------------------------------------------------------------------
    urlInfo: [
      {app:  "RmenuVisualTools/Html/Apps/ClientViewer/"}
     ,{json: "RmenuVisualTools/Json/Apps/ClientViewer/"}
    ]
    // --------------------------
    // JSONファイル情報を定義する
    // --------------------------
   ,jsonInfo: [
      {dataset:     "yes"}
     ,{validation:  "yes"}
    ]
    // ----------------------------------------------------------------------------------------
    // トランザクション・リクエストチェック・レスポンス編集・エラーのコールバック関数を定義する
    // ----------------------------------------------------------------------------------------
   ,requestInfo: [
       ["project",   "onプロジェクトOfCheckRequestData",     "onプロジェクトOfEditResponseData",     "onErrorResponseData"]
      ,["program",   "onプログラムOfCheckRequestData",       "onプログラムOfEditResponseData",       "onErrorResponseData"]
      ,["resource",  "onリソースOfCheckRequestData",         "onリソースOfEditResponseData",         "onErrorResponseData"]
    ]
    // --------------------------------------------------
    // エンター・タブとPFキーのコールバック関数を定義する
    // --------------------------------------------------
   ,enterTabPFKey: {
      Enter:true
     ,Tab:true
     ,F1:null
     ,F2:null
     ,F3:null
     ,F4:null
     ,F5:null
     ,F6:null
     ,F7:null
     ,F8:null
     ,F9:null
     ,F10:null
     ,F11:null
     ,F12:null
     ,ESC:"onEsc"
     ,Forms:0
    }
    // ----------------------------------------------------------------
    // イベント設定はセレクタ・イベント・コールバック関数の順に指定する
    // ----------------------------------------------------------------
    // NAVボタンイベントを定義する
   ,navButtonEvent: [
      ["#戻る",              "click", "on戻る"]
    ]
    // バリデーションイベントを定義する
   ,validationEvent: [
    ]
    // その他セレクターイベントを定義する
   ,selectorEvent: [
      ["#プロジェクト選択", "change", "onChangeプロジェクト選択"]
     ,["#プログラム選択"  , "change", "onChangeプログラム選択" ]
     ,["#モード選択"      , "change", "onChangeモード選択"   ]
    ]
    // ----------------------------------------------------------------------------------
    // カスタムイベント設定はイベント名・実行コンテキスト・コールバック関数の順に指定する
    // ----------------------------------------------------------------------------------
    // チェック用カスタムイベントを定義する
   ,pubsubCheckEvent: [
    ]
    // 導出項目編集用カスタムイベントを定義する
   ,pubsubDeriveEvent: [
    ]
    // その他カスタムイベントを定義する
   ,pubsubOtherEvent: [
    ]
    // ----------------------------------------------------------------------------------
    // セレクトボックス　定義
    // selectorid  : HTMLのIDを指定する
    // selectorname: HTMLのnameを指定する（テーブル内で使用する時に定義する）
    // init        :
    // initvalue   : 初期値（０）
    // inithtml    : 初期表示（～選択）
    // datasetid   : datasetのID名を指定する
    // valuename   : datasetに定義されているキー値の項目名
    // htmlname    : datasetに定義されている表示用データの項目名
    // change      :
    // datasetid   : datasetのID名を指定する
    // valuename   : 選択したキー値を格納するdatasetの項目名
    // htmlname    : 選択した表示値を格納するdatasetの項目名
    // ----------------------------------------------------------------------------------
   ,selectbox: [
      {
          selectorid: "プロジェクト選択"
         ,selectorname: ""
         ,init:     {initvalue: "0", inithtml: "プロジェクト選択", datasetid: "project", valuename: "選択プロジェクト", htmlname: "選択プロジェクト名"}
         ,change:   {datasetid: "searchCondition", valuename: "プロジェクト", htmlname: "プロジェクト名"}
      }
     ,{
          selectorid: "プログラム選択"
         ,selectorname: ""
         ,init:     {initvalue: "0", inithtml: "プログラム選択", datasetid: "program", valuename: "選択プログラム", htmlname: "選択プログラム名"}
         ,change:   {datasetid: "searchCondition", valuename: "プログラム", htmlname: "プログラム名"}
      }
     ,{
          selectorid: "モード選択"
         ,selectorname: ""
         ,init:     {initvalue: "0", inithtml: "モード選択", datasetid: "mode", valuename: "選択モード", htmlname: "選択モード名"}
         ,change:   {datasetid: "searchCondition", valuename: "モード", htmlname: "モード名"}
      }
//   ,{
//        selectorid: "テーブル選択"
//       ,selectorname: ""
//       ,init:     {initvalue: "0", inithtml: "テーブル選択", datasetid: "table", valuename: "選択テーブル", htmlname: "選択テーブル名"}
//       ,change:   {datasetid: "searchCondition", valuename: "検索テーブル", htmlname: "検索テーブル名"}
//    }
//   ,{
//        selectorid: "ルビー選択"
//       ,selectorname: ""
//       ,init:     {initvalue: "0", inithtml: "ルビー選択", datasetid: "ruby", valuename: "選択ルビー", htmlname: "選択ルビー名"}
//       ,change:   {datasetid: "searchCondition", valuename: "検索ルビー", htmlname: "検索ルビー名"}
//    }
    ]
  });
}(jQuery, Rmenu));