(function ($, $R) {
	// 名前空間を設定する
	var App = $R.Application.ClientViewer;

	// インスタンスプロパティを追加する
	var Controller = App.Controller = new $R.Class($R.Controller);
	Controller.fn.init = function (appspec, model, view) {
		$R.log("Controllerr init : start");

		this.appspec = appspec;
		this.model = model;
		this.view = view;
		this.createPubSubEvent();

		$R.log("Controllerr init : end");
	};

	// 共通モジュールを追加する
	Controller.include($R.Library.EnterTabPFKeyMixin);
	Controller.include($R.Library.ControllerMixin);

	// 関数を追加する
	Controller.include({
		// --------
		// 処理開始
		// --------
		initExecute : function () {
			$R.log("Controller initExecute : start");

			var arg = this.model.onログイン情報();
			this.view.onログイン情報(arg);
			this.on初期処理();

			$R.log("Controller initExecute : end");
		}

		// ---------------------------------------
		// 初期処理
		// ---------------------------------------
	,
		on初期処理 : function () {
			$R.log("Controller on初期処理 : start");

			var arg = this.model.on初期処理();
			this.view.on初期処理(arg);

			this.ajaxExecute("project");

			$R.log("Controller on初期処理 : end");
		}

		// ------------------------
		// Focus・Blue イベント処理
		// ------------------------
	,
		onFocus : function (event) {
			$R.log("Controller onFocus : start");

			this.onControllerFocus(event);

			$R.log("Controller onFocus : end");
		}
	,
		onBlur : function (event) {
			$R.log("Controller onBlur : start");

			this.onControllerBlur(event);

			$R.log("Controller onBlur : end");
		}

		// ------------------------
		// ボタン・ファンクションキー イベント処理
		// ------------------------
	,
		on戻る : function (event) {
			$R.log("Controller on戻る : start");

			this.model.clearセッション情報();
			this.model.previousTransition();
			window.close();

			$R.log("Controller on戻る : end");
		}
		// -------------------------------------
		// チェンジ イベント処理（追加処理）
		// -------------------------------------
	,
		onChangeプロジェクト選択 : function (event) {
			$R.log("Controller onChangeセレクトボックス : start");

			this.model.onChangeSelectBox(event, this.appspec.selectbox);
			this.view.onChangeプロジェクト選択();

			this.ajaxExecute("program");

			$R.log("Controller onChangeプロジェクト選択 : end");
		}
	,
		onChangeプログラム選択 : function (event) {
			$R.log("Controller onChangeプログラム選択 : start");

			this.model.onChangeSelectBox(event, this.appspec.selectbox);

			this.ajaxExecute("resource");

			$R.log("Controller onChangeプログラム選択 : end");
		}
	,
		onChangeモード選択 : function (event) {
			$R.log("Controller onChangeモード選択 : start");

			var mode = this.model.onChangeSelectBox(event, this.appspec.selectbox);

			var dataSetInfo = this.model.dataset.getData();
			this.view.onChangeモード選択(dataSetInfo, mode);

			$R.log("Controller onChangeモード選択 : end");
		}

		// -----------------------------------
		//  リクエストデータ　チェック処理
		// -----------------------------------
	,
		onプロジェクトOfCheckRequestData : function (requestData, mode) {
			$R.log("Controller onプロジェクトOfCheckRequestData : start");

			var status = this.model.onプロジェクトOfCheckRequestData(requestData, mode);
			if (status) {
				status = this.checkRequestData(requestData);
			}

			$R.log("Controller onプロジェクトOfCheckRequestData : end");
			return status;
		}
	,
		onプログラムOfCheckRequestData : function (requestData, mode) {
			$R.log("Controller onプログラムOfCheckRequestData : start");

			var status = this.model.onプログラムOfCheckRequestData(requestData, mode);
			if (status) {
				status = this.checkRequestData(requestData);
			}

			$R.log("Controller onプログラムOfCheckRequestData : end");
			return status;
		}
	,
		onリソースOfCheckRequestData : function (requestData, mode) {
			$R.log("Controller onリソースOfCheckRequestData : start");

			var status = this.model.onリソースOfCheckRequestData(requestData, mode);
			if (status) {
				status = this.checkRequestData(requestData);
			}

			$R.log("Controller onリソースOfCheckRequestData : end");
			return status;
		}
		// -------------------------------
		//  レスポンスデータ　編集処理
		// -------------------------------
	,
		onプロジェクトOfEditResponseData : function (responseData, mode) {
			$R.log("Controller onプロジェクトOfEditResponseData : start");

			this.editResponseData(responseData);
			this.model.onプロジェクトOfEditResponseData(responseData);
			this.view.onプロジェクトOfEditResponseData(responseData);

			// セレクトボックスの一括初期表示
			this.onShowSelectBoxAll(responseData, this.appspec.selectbox);

			$R.log("Controller onプロジェクトOfEditResponseData : end");
		}
	,
		onプログラムOfEditResponseData : function (responseData, mode) {
			$R.log("Controller onプログラムOfEditResponseData : start");

			this.editResponseData(responseData);
			this.model.onプログラムOfEditResponseData(responseData);
			this.view.onプログラムOfEditResponseData(responseData);

			// セレクトボックスの一括初期表示
			this.onShowSelectBoxAll(responseData, this.appspec.selectbox);

			$R.log("Controller onプログラムOfEditResponseData : end");
		}
	,
		onリソースOfEditResponseData : function (responseData, mode) {
			$R.log("Controller onリソースOfEditResponseData : start");

			var dataSetInfo = this.model.dataset.getData();

			this.editResponseData(responseData);
			this.model.onリソースOfEditResponseData(responseData);
			this.view.onリソースOfEditResponseData(responseData, dataSetInfo);

			// セレクトボックスの一括初期表示
			var dataSetInfo = this.model.dataset.getData();
			this.onShowSelectBoxById(dataSetInfo, "モード選択");

			$R.log("Controller onリソースOfEditResponseData : end");
		}
		// ---------------------------
		//  レスポンス　エラー処理
		// ---------------------------
	,
		onErrorResponseData : function (responseData, mode) {
			$R.log("Controller onErrorResponseData : start");

			this.errorResponseData(responseData);

			$R.log("Controller onErrorResponseData : end");
		}

	});
}
	(jQuery, Rmenu));
