(function ($, $R) {
	// 名前空間を設定する
	var App = $R.Application.ClientViewer;

	// インスタンスプロパティを追加する
	var Model = App.Model = new $R.Class($R.Model);
	Model.fn.init = function (appspec) {
		$R.log("Model init : start");

		this.appspec = appspec;

		$R.log("Model init : end");
	}

	// 共通モジュールを追加する
	Model.include($R.Library.ValidationMixin);
	Model.include($R.Library.ModelMixin);
	Model.include($R.Library.HtmlTransitionMixin);

	Model.include({
		// --------
		// 処理開始
		// --------
		initExecute : function () {
			$R.log("Model initExecute : start");

			//this.dataset.clearDataValue();                   // Datasetの値をクリアする
			//this.dataset.clearFormElementNo();               // フォームオブジェクトの要素番号をクリアする
			//this.dataset.setFormElementNo();                 // フォームオブジェクトの要素番号を設定する

			$R.log("Model initExecute : end");
		}
		// -------------------------------------------------------------------
		//  セッションストレージからログイン情報を取得し表示イベントを発行する
		// -------------------------------------------------------------------
	,
		onログイン情報 : function () {
			$R.log("Model onログイン情報 : start");

			// セッションデータに識別名を設定する
			sessionStorage.setIdName(this.appspec.sysname + ".Login");

			var username = sessionStorage.loadItem("ユーザ名称");
			var datetime = sessionStorage.loadItem("ログイン時刻");
			var jdate = sessionStorage.loadItem("ログイン和暦");
			var arg = {
				ユーザ名称 : username,
				ログイン時刻 : datetime,
				ログイン和暦 : jdate
			};

			$R.log("Model onログイン情報 : end");
			return arg;
		}
		// -------------------------------------------------------------------
		//  初期処理
		// -------------------------------------------------------------------
	,
		on初期処理 : function () {
			$R.log("Model on初期処理 : start");

			var arg = {};

			$R.log("Model on初期処理 : end");
			return arg;
		}
		// -------------------------------------------------
		//  セッションスト（ログイン情報）をレージクリアする
		// -----------------------------------------------
	,
		clearセッション情報 : function () {
			$R.log("Model clearセッション情報 : start");

			// セッションデータに識別名を設定する
			sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
			sessionStorage.deleteAll("");

			$R.log("Model clearセッション情報 : end");
		}
		// ---------------------------------------------------
		//  リクエストデータ　編集・チェック処理
		// ---------------------------------------------------
	,
		onプロジェクトOfCheckRequestData : function (requestData, mode) {
			$R.log("Model onプロジェクトOfCheckRequestData : start");

			$R.log("Model onプロジェクトOfCheckRequestData : end");
			return true;
		}
	,
		onプログラムOfCheckRequestData : function (requestData, mode) {
			$R.log("Model onプログラムOfCheckRequestData : start");

			$R.log("Model onプログラムOfCheckRequestData : end");
			return true;
		}
	,
		onリソースOfCheckRequestData : function (requestData, mode) {
			$R.log("Model onリソースOfCheckRequestData : start");

			$R.log("Model onリソースOfCheckRequestData : end");
			return true;
		}
		// -------------------------------------------------------
		//  レスポンスデータ　編集処理
		// -------------------------------------------------------
	,
		onプロジェクトOfEditResponseData : function (responseData) {
			$R.log("Model onプロジェクトOfEditResponseData : start");

			$R.log("Model onプロジェクトOfEditResponseData : end");
		}
	,
		onプログラムOfEditResponseData : function (responseData) {
			$R.log("Model onプログラムOfEditResponseData : start");

			$R.log("Model onプログラムOfEditResponseData : end");
		}
	,
		onリソースOfEditResponseData : function (responseData) {
			$R.log("Model onリソースOfEditResponseData : start");

			// dataset 選択モード の設定
			var resourceRecord = this.appspec.getJSONChunkByIdAtRecords(responseData, "resource")["record"];
			var jsonSource = "";
			var jsonObject = {};
			var appspecSource = "";

			jsonSource = resourceRecord["ＪＳソース"]["value"][0];
			jsonObject = JSON.parse(jsonSource);
			for (name in jsonObject) {
				if (name.match(/\.appspec\.js/)) {
					appspecSource = jsonObject[name];
					break;
				}
			}

			var str = appspecSource.replace(/(\n\r|\n|\r)/g, "`")
				.replace(/^.*\AppSpec\.include[` ]*\([` ]*/, "")
				.replace(/\)[` ]*;[` ]*}[` ]*\([` ]*jQuery[` ]*,[` ]*Rmenu[` ]*\)[` ]*\)[` ]*;[` ]*$/, "")
				.split("`");

			var arrayStr = [];
			var j = 0;
			for (var i = 0; i < str.length; i++) {
				if (!str[i].match(/^[ ]*\/\//)) {
					arrayStr[j] = str[i].replace(/\/\/.*/,"");
					j++;
				}
			}

			var appspecSourceText = arrayStr.join('');
			var appspecSourceObj = (new Function("return " + appspecSourceText))();

			var dataset    = this.dataset.getData();
			var dataChunk1 = this.appspec.getJSONChunkByIdAtRecords(dataset, "mode");
			
			for (var i = 0; i < appspecSourceObj["requestInfo"].length; i++) {
				dataChunk1["record"]["選択モード"  ]["value"][i] = appspecSourceObj["requestInfo"][i][0];
				dataChunk1["record"]["選択モード名"]["value"][i] = appspecSourceObj["requestInfo"][i][0];
			}

			$R.log("Model onリソースOfEditResponseData : end");
		}

	});
}
	(jQuery, Rmenu));
