(function ($, $R) {
	// 名前空間を設定する
	var App = $R.Application.ClientViewer;

	// インスタンスプロパティを追加する
	var View = App.View = new $R.Class($R.View);
	View.fn.init = function (appspec) {
		$R.log("View init : start");

		this.appspec = appspec;

		$R.log("View init : end");
	}

	// 共通モジュールを追加する
	View.include($R.Library.FormatMixin);
	View.include($R.Library.OutlineMixin);
	View.include($R.Library.LoadTemplateMixin);
	View.include($R.Library.ViewMixin);

	View.include({
		// --------
		// 処理開始
		// --------
		initExecute : function () {
			$R.log("View initExecute : start");

			this.initテンプレートロード();
			var w_crtW = new BigNumber(screen.width).div(100).round(0, 1)
			var w_crtH = new BigNumber(screen.height).div(100).round(0, 1)

			// OUTER-LAYOUT
			$('body').layout({
				north__paneSelector :  ".outer-north",
				west__paneSelector :   ".outer-west",
				center__paneSelector : ".outer-center",
				east__paneSelector :   ".outer-east",
				north__size : w_crtH * 8,
				west__size : w_crtW * 20,
				east__size : w_crtW * 15,
				spacing_open : 8,
				spacing_closed : 12,

				center__childOptions : {
					west__paneSelector :   ".middle-west",
					center__paneSelector : ".middle-center",
					east__paneSelector :   ".middle-east",
					west__size : w_crtW * 20,
					east__size : w_crtW * 22,
					spacing_open : 8,
					spacing_closed : 12,
					
				    center__childOptions : {
					    north__size : w_crtH * 29,
					    south__size : w_crtH * 28
				    },
				    east__childOptions : {
					    north__size : w_crtH * 29,
					    south__size : w_crtH * 28
				    }
				},
				east__childOptions : {
					north__size : w_crtH * 45
				},

			});

			$R.log("View initExecute : end");
		}
		// -------------------------------------------------------------------
		//  テンプレートをロードする
		// -------------------------------------------------------------------
	,
		initテンプレートロード : function () {
			$R.log("View initテンプレートロード : start");

			// ＣＳＳファイル名をセッションストレージから取得しロードする
			sessionStorage.setIdName(this.appspec.sysname + ".Login");
			var cssName = sessionStorage.loadItem("ＣＳＳファイル名");

			if (cssName) {
				var arg = {
					cssName : cssName
				};
				this.appendCSS(arg);
			}

			$('body').fadeIn("normal");

			$R.log("View initテンプレートロード : end");
		}
		// -------------------------------------------------------------------
		//  ログイン情報を表示する
		// -------------------------------------------------------------------
	,
		onログイン情報 : function (arg) {
			$R.log("View onログイン情報 : start");

			$("#ログイン和暦").html(arg["ログイン和暦"]);
			$("#ログイン日時").html(arg["ログイン時刻"]);
			$("#ユーザ氏名").html(arg["ユーザ名称"]);

			$R.log("View onログイン情報 : end");
		}
		// -------------------------------------------------------------------
		//  初期処理
		// -------------------------------------------------------------------
	,
		on初期処理 : function (arg) {
			$R.log("View on初期処理 : start");

			$R.log("View on初期処理 : end");
		}
		// ------------------------
		// ボタン・ファンクションキー イベント処理
		// ------------------------
	,
		onAppspec : function (event) {
			$R.log("View onAppspec : start");

			var textAreaElement = $("#appspecsource").get(0); // テキストエリアのelement取得
			var textAreaValue = $("#appspecsource").val();
			var appspecSelector = event.handleObj.selector.replace(/^#/, '');

			var selectionStart = 0;
			var selectionEnd   = 0;
			var regObj = RegExp(appspecSelector);
			var match = regObj.exec(textAreaValue);
			if (match) {
				selectionStart = match.index;
				selectionEnd   = match.index + match[0].length;
			}

			textAreaElement.selectionStart = textAreaValue.length;
			textAreaElement.selectionEnd   = textAreaValue.length;
			textAreaElement.focus();
			setTimeout(function(){
				textAreaElement.selectionStart = selectionStart;
				textAreaElement.selectionEnd   = selectionEnd;
				textAreaElement.focus();
			},100);

			$R.log("View onAppspec : end");
		}
		// -------------------------------------
		// チェンジ イベント処理（追加処理）
		// -------------------------------------
	,
		onChangeプロジェクト選択 : function () {
			$R.log("View onChangeプロジェクト選択 : start");

			$("#プログラム選択").val(0);

			$("#htmlsource").val("");

			$("#appspecsource").val("");
			$("#controllersource").val("");
			$("#modelsource").val("");
			$("#viewsource").val("");

			$("#controllerpattern").val("");
			$("#modelpattern").val("");
			$("#viewpattern").val("");

			$("#datasetsource").val("");
			$("#validationsource").val("");

			$("#requestsource1").val("");
			$("#requestsource2").val("");
			$("#requestsource3").val("");
			$("#responsesource1").val("");
			$("#responsesource2").val("");
			$("#responsesource3").val("");

			$R.log("View onChangeプロジェクト選択 : end");
		}
	,
		onChangeモード選択 : function (dataSetInfo, mode) {
			$R.log("View onChangeモード選択 : start");
			
			var searchRecord = this.appspec.getJSONChunkByIdAtRecords(dataSetInfo, "searchCondition")["record"];
			var programName = searchRecord["プログラム名"]["value"][0];

			var resourceRecord = this.appspec.getJSONChunkByIdAtRecords(dataSetInfo, "resource")["record"];
			var jsonSource = resourceRecord["ＪＳＯＮソース"]["value"][0];
			var jsonObject = JSON.parse(jsonSource);
			$("#requestsource1").val("");
			$("#responsesource1").val("");
			var regexp = new RegExp(programName+"_"+mode+"_tran.json");
			var i = 0;
			for (name in jsonObject) {
				if (name.match(regexp)) {
					i++;
					var tranString = jsonObject[name];
					var pos = tranString.indexOf("\"response\"");
					var requestString = tranString.slice(0, pos - 1);
					var responseString = tranString.slice(pos);
					$("#requestsource" + i).val(requestString + "}");
					$("#responsesource" + i).val("{\n" + responseString);
				}
			}

			$R.log("View onChangeモード選択 : end");
		}
		// -------------------------------
		//  レスポンスデータ　編集処理
		// -------------------------------
	,
		onプロジェクトOfEditResponseData : function (responseData) {
			$R.log("View onプロジェクトOfEditResponseData : start");

			$("#プログラム選択 option").remove();
			$("#モード選択 option").remove();

			$R.log("View onプロジェクトOfEditResponseData : end");
		}
	,
		onプログラムOfEditResponseData : function (responseData) {
			$R.log("View onプログラムOfEditResponseData : start");

			$("#モード選択 option").remove();

			$R.log("View onプログラムOfEditResponseData : end");
		}
	,
		onリソースOfEditResponseData : function (responseData, dataSetInfo) {
			$R.log("View onリソースOfEditResponseData : start");

			var searchRecord = this.appspec.getJSONChunkByIdAtRecords(dataSetInfo, "searchCondition")["record"];
			var programName = searchRecord["プログラム名"]["value"][0];

			var resourceRecord = this.appspec.getJSONChunkByIdAtRecords(responseData, "resource")["record"];
			var jsonSource = "";
			var jsonObject = {};

			$("#htmlsource").val(resourceRecord["ＨＴＭＬソース"]["value"][0]);

			jsonSource = resourceRecord["ＪＳソース"]["value"][0];
			jsonObject = JSON.parse(jsonSource);
			$("#appspecsource").val("");
			$("#controllersource").val("");
			$("#modelsource").val("");
			$("#viewsource").val("");
			for (name in jsonObject) {
				if (name.match(/\.appspec\.js/)) {
					$("#appspecsource").val(jsonObject[name]);
				} else if (name.match(/\.controller\.js/)) {
					$("#controllersource").val(jsonObject[name]);
				} else if (name.match(/\.model\.js/)) {
					$("#modelsource").val(jsonObject[name]);
				} else if (name.match(/\.view\.js/)) {
					$("#viewsource").val(jsonObject[name]);
				}
			}

			jsonSource = resourceRecord["ＪＳパターンソース"]["value"][0];
			jsonObject = JSON.parse(jsonSource);
			$("#controllerpattern").val("");
			$("#modelpattern").val("");
			$("#viewpattern").val("");
			for (name in jsonObject) {
				if (name.match(/\.controller\.mixin/)) {
					$("#controllerpattern").val(jsonObject[name]);
				} else if (name.match(/\.model\.mixin/)) {
					$("#modelpattern").val(jsonObject[name]);
				} else if (name.match(/\.view\.mixin/)) {
					$("#viewpattern").val(jsonObject[name]);
				}
			}

			jsonSource = resourceRecord["ＪＳＯＮソース"]["value"][0];
			jsonObject = JSON.parse(jsonSource);
			$("#datasetsource").val("");
			$("#validationsource").val("");
			$("#requestsource1").val("");
			$("#requestsource2").val("");
			$("#requestsource3").val("");
			$("#responsesource1").val("");
			$("#responsesource2").val("");
			$("#responsesource3").val("");
			var i = 0;
			for (name in jsonObject) {
				if (name.match(/dataset/)) {
					$("#datasetsource").val(jsonObject[name]);
				} else if (name.match(/validation/)) {
					$("#validationsource").val(jsonObject[name]);
				} else if (name.match(/_tran\.json/)) {
					i++;
					var tranString = jsonObject[name];
					var pos = tranString.indexOf("\"response\"");
					var requestString = tranString.slice(0, pos - 1);
					var responseString = tranString.slice(pos);
					$("#requestsource" + i).val(requestString + "}");
					$("#responsesource" + i).val("{\n" + responseString);
				}
			}

			$R.log("View onリソースOfEditResponseData : end");
		}

	});
}
	(jQuery, Rmenu));
