(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.Employee = {};

  // インスタンスプロパティを追加する
  var AppSpec = App.AppSpec = new $R.Class($R.AppSpec);
  AppSpec.fn.init = function(name) {
    $R.log("AppSpec init : start");

    this.name = name;

    $R.log("AppSpec init : end");
  }

  // 共通モジュールを追加する
  AppSpec.include($R.Library.AppSpecMixin);

  AppSpec.include({
    // -----------------------------------------------------------------------------------------------
    // プログラム・JSONファイルのURL情報を定義する（サブシステム名・種類・Apps・プログラムフォルダ名）
    // -----------------------------------------------------------------------------------------------
    urlInfo: [
      {app:  "RmenuVisualTools/Html/Apps/Employee/"}
     ,{json: "RmenuVisualTools/Json/Apps/Employee/"}
    ]
    // --------------------------
    // JSONファイル情報を定義する
    // --------------------------
   ,jsonInfo: [
      {dataset:     "yes"}
     ,{validation:  "yes"}
    ]
    // ----------------------------------------------------------------------------------------
    // トランザクション・リクエストチェック・レスポンス編集・エラーのコールバック関数を定義する
    // ----------------------------------------------------------------------------------------
   ,requestInfo: [
      ["selectmaintable", "onメインテーブル照会OfCheckRequestData",  "onメインテーブル照会OfEditResponseData",  "onErrorResponseData"]
     ,["execute",         "on実行処理OfCheckRequestData",            "on実行処理OfEditResponseData",            "onErrorResponseData"]
     ,["renumber",        "on表示順再設定OfCheckRequestData",        "on表示順再設定OfEditResponseData",        "onErrorResponseData"]
    ]
    // --------------------------------------------------
    // エンター・タブとPFキーのコールバック関数を定義する
    // --------------------------------------------------
   ,enterTabPFKey: {
      Enter:true
     ,Tab:true
     ,F1:"on実行"
     ,F2:null
     ,F3:null
     ,F4:null
     ,F5:null
     ,F6:null
     ,F7:null
     ,F8:null
     ,F9:null
     ,F10:null
     ,F11:null
     ,F12:null
     ,ESC:"on戻る"
     ,Forms:0
    }
    // ----------------------------------------------------------------
    // イベント設定はセレクタ・イベント・コールバック関数の順に指定する
    // ----------------------------------------------------------------
    // NAVボタンのイベントを定義する
   ,navButtonEvent: [
      ["#戻る",                  "click", "on戻る"]
     ,["#実行",                  "click", "on実行"]
     ,["#表示順再設定",          "click", "on表示順再設定"]
     ,["#mainTable td .行追加",  "click", "on行追加クリック"]
    ]
    // バリデーションのイベントを定義する
   ,validationEvent: [
      ["#mainForm", "focus", "onFocus"]
     ,["#mainForm", "blur",  "onBlur"]
    ]
    // その他セレクターイベントを定義する
   ,selectorEvent: [
    ]
    // ----------------------------------------------------------------------------------
    // カスタムイベント設定はイベント名・実行コンテキスト・コールバック関数の順に指定する
    // ----------------------------------------------------------------------------------
    // チェック用カスタムイベントを定義する
   ,pubsubCheckEvent: [
    ]
    // 導出項目編集用カスタムイベントを定義する
   ,pubsubDeriveEvent: [
    ]
    // その他カスタムイベントを定義する
   ,pubsubOtherEvent: [
      ["showログイン情報",     "view", "showログイン情報"]
     ,["show初期処理",         "view", "show初期処理"]
     ,["onテーブル表示",       "view", "onテーブル表示"]
    ]
  });
}(jQuery, Rmenu));