(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.LogsViewer = {};

  // インスタンスプロパティを追加する
  var AppSpec = App.AppSpec = new $R.Class($R.AppSpec);
  AppSpec.fn.init = function(name, formcontroll) {
    $R.log("AppSpec init : start");

    this.name         = name;
    //this.formcontroll = formcontroll;

    $R.log("AppSpec init : end");
  }
	
  // 共通モジュールを追加する
  AppSpec.include($R.Library.AppSpecMixin);

  AppSpec.include({
    // -----------------------------------------------------------------------------------------------
    // プログラム・JSONファイルのURL情報を定義する（サブシステム名・種類・Apps・プログラムフォルダ名） 
    // -----------------------------------------------------------------------------------------------
    urlInfo: [
      {app:  "RmenuVisualTools/Html/Apps/LogsViewer/"}
     ,{json: "RmenuVisualTools/Json/Apps/LogsViewer/"}
    ]
    // --------------------------
    // JSONファイル情報を定義する
    // --------------------------
   ,jsonInfo: [
      {dataset:     "yes"}
     ,{validation:  "yes"}
    ]
    // ----------------------------------------------------------------------------------------
    // トランザクション・リクエストチェック・レスポンス編集・エラーのコールバック関数を定義する
    // ----------------------------------------------------------------------------------------
   ,requestInfo: [
       ["init",     "onラックログOfCheckRequestData",   "onラックログOfEditResponseData",   "onErrorResponseData"]
      ,["search",   "on検索処理OfCheckRequestData",     "on検索処理OfEditResponseData",     "onErrorResponseData"]
    ]
    // --------------------------------------------------
    // エンター・タブとPFキーのコールバック関数を定義する
    // --------------------------------------------------
   ,enterTabPFKey: {
      Enter:true
     ,Tab:true
     ,F1:"on検索"
     ,F2:"on再読込"
     ,F3:null
     ,F4:null
     ,F5:null
     ,F6:null
     ,F7:null
     ,F8:null
     ,F9:null
     ,F10:null
     ,F11:null
     ,F12:null
     ,ESC:"onEsc"
     ,Forms:0
    }
    // ----------------------------------------------------------------
    // イベント設定はセレクタ・イベント・コールバック関数の順に指定する
    // ----------------------------------------------------------------
    // NAVボタンイベントを定義する
   ,navButtonEvent: [
      ["#検索",                "click", "on検索"]
     ,["#再読込",              "click", "on再読込"]
     ,["#戻る",                "click", "on戻る"]
     ,["#ラックログ td",       "click", "onラックログ"]
     ,["#コントローラログ td", "click", "onコントローラログ"]
     ,["#ビューログ td",       "click", "onビューログ"]
     ,["#モデルログ td",       "click", "onモデルログ"]
     ,["#モデルＤＢログ td",   "click", "onモデルＤＢログ"]
    ]
    // バリデーションイベントを定義する
   ,validationEvent: [
    ]
    // その他セレクターイベントを定義する
   ,selectorEvent: [
      ["#開始時刻選択"       , "change", "onChange開始時刻選択"]
     ,["#終了時刻選択"       , "change", "onChange終了時刻選択"]
    ]
    // ----------------------------------------------------------------------------------
    // カスタムイベント設定はイベント名・実行コンテキスト・コールバック関数の順に指定する
    // ----------------------------------------------------------------------------------
    // チェック用カスタムイベントを定義する
   ,pubsubCheckEvent: [
    ]
    // 導出項目編集用カスタムイベントを定義する
   ,pubsubDeriveEvent: [
    ]
    // その他カスタムイベントを定義する
   ,pubsubOtherEvent: [
      ["showログイン情報",      "view", "showログイン情報"]
    ]
    // ----------------------------------------------------------------------------------
    // セレクトボックス　定義
    // selectorid  : HTMLのIDを指定する
    // selectorname: HTMLのnameを指定する（テーブル内で使用する時に定義する）
    // init        :
    // initvalue   : 初期値（０）
    // inithtml    : 初期表示（～選択）
    // datasetid   : datasetのID名を指定する
    // valuename   : datasetに定義されているキー値の項目名
    // htmlname    : datasetに定義されている表示用データの項目名
    // change      :
    // datasetid   : datasetのID名を指定する
    // valuename   : 選択したキー値を格納するdatasetの項目名
    // htmlname    : 選択した表示値を格納するdatasetの項目名
    // ----------------------------------------------------------------------------------
   ,selectbox: [
      {
          selectorid: "開始時刻選択"
         ,selectorname: ""
         ,init:     {initvalue: "", inithtml: "開始時刻選択", datasetid: "開始時刻", valuename: "選択開始時刻１", htmlname: "選択開始時刻２"}
         ,change:   {datasetid: "searchCondition", valuename: "開始時刻１", htmlname: "開始時刻２"}
      }
     ,{
          selectorid: "終了時刻選択"
         ,selectorname: ""
         ,init:     {initvalue: "", inithtml: "終了時刻選択", datasetid: "終了時刻", valuename: "選択終了時刻１", htmlname: "選択終了時刻２"}
         ,change:   {datasetid: "searchCondition", valuename: "終了時刻１", htmlname: "終了時刻２"}
      }
		]
  });
}(jQuery, Rmenu));