(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.LogsViewer;

  // インスタンスプロパティを追加する
  var Controller = App.Controller = new $R.Class($R.Controller);
  Controller.fn.init = function(appspec, model, view) {
    $R.log("Controllerr init : start");

    this.appspec = appspec;
    this.model   = model;
    this.view    = view;
    this.createPubSubEvent();

    $R.log("Controllerr init : end");
  };

  // 共通モジュールを追加する
  Controller.include($R.Library.EnterTabPFKeyMixin);
  Controller.include($R.Library.ControllerMixin);

  // 関数を追加する
  Controller.include({
    // --------
    // 処理開始
    // --------
    initExecute: function() {
      $R.log("Controller initExecute : start");

      var arg = this.model.onログイン情報();
			this.view.onログイン情報(arg);

      this.on初期処理();

      $R.log("Controller initExecute : end");
    }
		
    // ---------------------------------------
    // 初期処理
    // ---------------------------------------
   ,on初期処理: function() {
      $R.log("Controller on初期処理 : start");

      var arg = this.model.on初期処理();
			this.view.on初期処理(arg);

      this.ajaxExecute("init");

      $R.log("Controller on初期処理 : end");
    }
		
    // ------------------------
    // イベント処理
    // ------------------------
   ,on検索: function(event) {
      $R.log("Controller on検索 : start");

      var status = this.model.on検索();
			if (!status) {
				return;
			}
			
      this.view.on検索();
      this.ajaxExecute("search");

      $R.log("Controller on検索 : end");
    }
		
   ,on再読込: function(event) {
      $R.log("Controller on再読込 : start");

      var dataSet = this.model.on再読込();
      this.view.on再読込(dataSet);
			
      this.ajaxExecute("init");

      $R.log("Controller on再読込 : end");
    }
		
   ,on戻る: function(event) {
      $R.log("Controller on戻る : start");

      this.model.clearセッション情報();
      window.close();

      $R.log("Controller on戻る : end");
    }
		
   ,onラックログ: function(event) {
      $R.log("Controller onラックログ : start");

	  var currData = event.currentTarget.innerText;
	  this.view.onラックログ(currData);

      $R.log("Controller onラックログ : end");
    }
		
   ,onコントローラログ: function(event) {
      $R.log("Controller onコントローラログ : start");

	  var currData = event.currentTarget.innerText;
	  this.view.onラックログ(currData);

      $R.log("Controller onコントローラログ : end");
    }
		
   ,onビューログ: function(event) {
      $R.log("Controller onビューログ : start");

	  var currData = event.currentTarget.innerText;
	  this.view.onラックログ(currData);

      $R.log("Controller onビューログ : end");
    }
		
   ,onモデルログ: function(event) {
      $R.log("Controller onモデルログ : start");

	  var currData = event.currentTarget.innerText;
	  this.view.onラックログ(currData);

      $R.log("Controller onモデルログ : end");
    }
		
   ,onモデルＤＢログ: function(event) {
      $R.log("Controller onモデルＤＢログ : start");

	  var currData = event.currentTarget.innerText;
	  this.view.onラックログ(currData);

      $R.log("Controller onモデルＤＢログ : end");
    }
		
    // -------------------------------------
    // チェンジ イベント処理（追加処理）
    // -------------------------------------
   ,onChange開始時刻選択: function(event) {
      $R.log("Controller onChange開始時刻選択 : start");

      this.model.onChangeSelectBox(event, this.appspec.selectbox);

      $R.log("Controller onChange開始時刻選択 : end");
    }
   ,onChange終了時刻選択: function(event) {
      $R.log("Controller onChange終了時刻選択 : start");

      this.model.onChangeSelectBox(event, this.appspec.selectbox);

      $R.log("Controller onChange終了時刻選択 : end");
    }
		
    // -----------------------------------
    //  リクエストデータ　チェック処理
    // -----------------------------------
   ,onラックログOfCheckRequestData: function(requestData, mode) {
      $R.log("Controller onラックログOfCheckRequestData : start");

      var status = this.checkRequestData(requestData);

      $R.log("Controller onラックログOfCheckRequestData : end");
      return status;
    }
		
   ,on検索処理OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on検索処理OfCheckRequestData : start");

      var status = this.checkRequestData(requestData);

      $R.log("Controller on検索処理OfCheckRequestData : end");
      return status;
    }
		
    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,onラックログOfEditResponseData: function(responseData, mode) {
      $R.log("Controller onラックログOfEditResponseData : start");

      this.editResponseData(responseData);
      this.model.onラックログOfEditResponseData(responseData, mode);
			this.view.onラックログOfEditResponseData(responseData, mode);

      // セレクトボックスの一括初期表示
      this.onShowSelectBoxAll(responseData, this.appspec.selectbox);
			
			$R.log("Controller onラックログOfEditResponseData : end");
    }

   ,on検索処理OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on検索処理OfEditResponseData : start");

      this.editResponseData(responseData);
      this.model.on検索処理OfEditResponseData(responseData, mode);
			this.view.on検索処理OfEditResponseData(responseData, mode);
			
			$R.log("Controller on検索処理OfEditResponseData : end");
    }

  });
}(jQuery, Rmenu));