(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.LogsViewer;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  Model.include({
    // --------
    // 処理開始
    // --------
    initExecute: function() {
      $R.log("Model initExecute : start");

      //this.dataset.clearDataValue();                   // Datasetの値をクリアする
      //this.dataset.clearFormElementNo();               // フォームオブジェクトの要素番号をクリアする
      //this.dataset.setFormElementNo();                 // フォームオブジェクトの要素番号を設定する

      $R.log("Model initExecute : end");
    }
		
    // -------------------------------------------------------------------
    //  セッションストレージからログイン情報を取得し表示イベントを発行する
    // -------------------------------------------------------------------
   ,onログイン情報: function() {
      $R.log("Model onログイン情報 : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + ".Login");

      var username = sessionStorage.loadItem("ユーザ名称");
      var datetime = sessionStorage.loadItem("ログイン時刻");
      var jdate    = sessionStorage.loadItem("ログイン和暦");
      var arg      = {ユーザ名称: username, ログイン時刻: datetime, ログイン和暦: jdate};

      $R.log("Model onログイン情報 : end");
			return arg;
    }
		
    // -------------------------------------------------------------------
    //  初期処理
    // -------------------------------------------------------------------
   ,on初期処理: function() {
      $R.log("Model on初期処理 : start");

      var arg = {};

      $R.log("Model on初期処理 : end");
			return arg;
    }
		
    // -------------------------------------------------
    //  セッションスト（ログイン情報）をレージクリアする
    // -----------------------------------------------  
   ,clearセッション情報: function() {
      $R.log("Model clearセッション情報 : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      sessionStorage.deleteAll("");

      $R.log("Model clearセッション情報 : end");
    }
		
    // ------------------------
    // イベント処理
    // ------------------------
   ,on検索: function() {
      $R.log("Model on検索 : start");
			
			var w_開始時刻 = $("#開始時刻選択").val();
			var w_終了時刻 = $("#終了時刻選択").val();
			
			if (w_終了時刻 == "") {
				w_終了時刻 = w_開始時刻;
			}
			
			if (w_開始時刻 != "") {
        this.dataset.setElementData(w_開始時刻, "開始時刻１");
        this.dataset.setElementData(w_終了時刻, "終了時刻１");
				
        $R.log("Model on検索 : end");
				return true;
			}

      var arg = {};
      arg["title"]   = "選択エラー";
      arg["status"]  = "ERROR";
      arg["message"] = "開始時刻が選択されていません。選択して下さい。";
      this.pubsub.publish("alertDialog", arg);
			
      $R.log("Model on検索 : end");
			return false;
    }
		
   ,on再読込: function() {
      $R.log("Model on再読込 : start");

      var dataSet        = this.dataset.getData();
      var resourceRecord = this.appspec.getJSONChunkByIdAtRecords(dataSet, "resource");
			
			resourceRecord["record"]["ラックログ"]["value"]       = [""];
			resourceRecord["record"]["コントローラログ"]["value"] = [""];
			resourceRecord["record"]["モデルログ"]["value"]       = [""];
			resourceRecord["record"]["モデルＤＢログ"]["value"]   = [""];
			resourceRecord["record"]["ビューログ"]["value"]       = [""];
			
      $R.log("Model on再読込 : end");
			return dataSet;
    }
		
    // -------------------------------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------------------------------
   ,onラックログOfEditResponseData: function(responseData, mode) {
      $R.log("Model onラックログOfEditResponseData : start");


      $R.log("Model onラックログOfEditResponseData : end");
    }

   ,on検索処理OfEditResponseData: function(responseData, mode) {
      $R.log("Model on検索処理OfEditResponseData : start");


      $R.log("Model on検索処理OfEditResponseData : end");
    }

  });
}(jQuery, Rmenu));