	(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.LogsViewer;

  // インスタンスプロパティを追加する
  var View = App.View = new $R.Class($R.View);
  View.fn.init = function(appspec) {
    $R.log("View init : start");

    this.appspec = appspec;

    $R.log("View init : end");
  }

  // 共通モジュールを追加する
  View.include($R.Library.FormatMixin);
  View.include($R.Library.OutlineMixin);
  View.include($R.Library.LoadTemplateMixin);
  View.include($R.Library.ViewMixin);

  View.include({
    // --------
    // 処理開始
    // --------
    initExecute: function() {
      $R.log("View initExecute : start");

      this.initテンプレートロード();
			var w_crtW = new BigNumber(screen.width).div(100).round(0,1)
			var w_crtH = new BigNumber(screen.height).div(100).round(0,1)

		  // OUTER-LAYOUT
		  $('body').layout({
				north__paneSelector :  ".outer-north"
			, center__paneSelector : ".outer-center"
			, north__size : w_crtH * 8
		  , spacing_open:	8
		  ,	spacing_closed:			           8 // ALL panes

			// MIDDLE-LAYOUT (child of outer-center-pane)
	  	,	center__childOptions: {
					north__paneSelector :  ".middle-north"
				, center__paneSelector : ".middle-center"
		    ,	north__size:			w_crtH * 40
			  ,	spacing_open:			          8 // ALL panes
			  ,	spacing_closed:			       8 // ALL panes

			   ,	north__childOptions: {
					    west__paneSelector:	".ui-layout-west"
					  , center__paneSelector:	".ui-layout-center"
					  , east__paneSelector:	".ui-layout-east"
			      ,	west__size:		 w_crtW * 40
			      ,	east__size:		 w_crtW * 30
				    ,	spacing_open:			         8  // ALL panes
				    ,	spacing_closed:			       8  // ALL panes
				
				  }
					
			   ,	center__childOptions: {
					    west__paneSelector:	".ui-layout-west"
					  , center__paneSelector:	".ui-layout-center"
					  , east__paneSelector:	".ui-layout-east"
			      ,	west__size:		 w_crtW * 33
			      ,	east__size:		 w_crtW * 30
				    ,	spacing_open:			         8  // ALL panes
				    ,	spacing_closed:			       8  // ALL panes
				
				  }
			  }
			
		  });


      $R.log("View initExecute : end");
    }
    // -------------------------------------------------------------------
    //  テンプレートをロードする
    // -------------------------------------------------------------------
   ,initテンプレートロード: function() {
      $R.log("View initテンプレートロード : start");

      // ＣＳＳファイル名をセッションストレージから取得しロードする
      sessionStorage.setIdName(this.appspec.sysname + ".Login");
      var cssName = sessionStorage.loadItem("ＣＳＳファイル名");

      if (cssName) {
        var arg = {cssName: cssName};
        this.appendCSS(arg);
      }

      $('body').fadeIn("normal");

      $R.log("View initテンプレートロード : end");
    }
    // -----------------------
    //  ログイン情報を表示する
    // -----------------------
   ,onログイン情報: function(arg) {
      $R.log("View onログイン情報 : start");

      $("#ログイン和暦").html(arg["ログイン和暦"]); 
      $("#ログイン日時").html(arg["ログイン時刻"]); 
      $("#ユーザ氏名").html(arg["ユーザ名称"]); 

      $R.log("View onログイン情報 : end");
    }
    // -------------------------------------------------------------------
    //  初期処理
    // -------------------------------------------------------------------
   ,on初期処理: function(arg) {
      $R.log("View on初期処理 : start");

      $R.log("View on初期処理 : end");
    }

    // ------------------------
    // イベント処理
    // ------------------------
   ,on検索: function() {
      $R.log("View on検索 : start");
			

      $R.log("View on検索 : end");
    }
		
   ,on再読込: function(dataSet) {
      $R.log("View on再読込 : start");
			
			$("#jsonViewer").val("");
      this.on検索処理OfEditResponseData(dataSet, "");

      $R.log("View on再読込 : end");
    }
		
   ,onラックログ: function(data) {
      $R.log("View onラックログ : start");
	  
	  var index      = data.indexOf("{");
	  
	  if (index > 0) {
	    var target     = data.substring(index, 99999);
	    var jsonObject = JSON.parse(target);
	  }
		else {
			var jsonObject = data;
		}
	  
	  $("#jsonViewer").val(JSON.stringify(jsonObject, null, "    "));

      $R.log("View onラックログ : end");
    }
		
    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,onラックログOfEditResponseData: function(responseData, mode) {
      $R.log("View onラックログOfEditResponseData : start");
			
			$("#開始時刻選択 option").remove();
			$("#終了時刻選択 option").remove();
			
      var resourceRecord = this.appspec.getJSONChunkByIdAtRecords(responseData, "resource")["record"];
			this.setテーブル再表示("#ラックログ", resourceRecord["ラックログ"]["value"]);
			
			
			
      $R.log("View onラックログOfEditResponseData : end");
    }
		
   ,on検索処理OfEditResponseData: function(responseData, mode) {
      $R.log("View on検索処理OfEditResponseData : start");
			
      var resourceRecord = this.appspec.getJSONChunkByIdAtRecords(responseData, "resource")["record"];
			this.setテーブル再表示("#コントローラログ", resourceRecord["コントローラログ"]["value"]);
			this.setテーブル再表示("#モデルログ", resourceRecord["モデルログ"]["value"]);
			this.setテーブル再表示("#モデルＤＢログ", resourceRecord["モデルＤＢログ"]["value"]);
			this.setテーブル再表示("#ビューログ", resourceRecord["ビューログ"]["value"]);
			
      $R.log("View on検索処理OfEditResponseData : end");
    }
		
    // -------------------------------------------------------
    // テーブル再表示
    // -------------------------------------------------------
   ,setテーブル再表示: function(w_テーブルＩＤ, w_表示データ) {
      $R.log("ViewMixin setテーブル再表示 : start");
			
			
      // テーブルの２行目以降を削除する
      $(w_テーブルＩＤ).find("tr:gt(1)").remove();

      //  テーブルの１行目の内容をクリア
      var cells = $(w_テーブルＩＤ + " tbody").find("tr:eq(0)").children();
			cells.eq(0).text("");


      // テーブルの表示行数を設定する
			w_表示行 = w_表示データ.length - 1;

      // １行目をコピーして、表示行数分テーブルを作成する
      for (var i = 0; i < w_表示行; i++) {
        $(w_テーブルＩＤ + " tbody").eq(0).clone(true).insertAfter($(w_テーブルＩＤ + " tbody").eq(i));
      }


      // データを表示する
      var rows = $(w_テーブルＩＤ + " tbody tr");
      for (var i = 0; i < rows.length; i++) {
				// 行の全セルを取得する
        var cells       = rows.eq(i).children();
				cells.eq(0).text(w_表示データ[i]);
				
      }
			
      $R.log("ViewMixin setテーブル再表示 : end");
    }
		
	});
}(jQuery, Rmenu));