(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.MainMenu;

  // インスタンスプロパティを追加する
  var Controller = App.Controller = new $R.Class($R.Controller);
  Controller.fn.init = function(appspec, model, view) {
    $R.log("Controllerr init : start");

    this.appspec = appspec;
    this.model   = model;
    this.view    = view;
    this.createPubSubEvent();

    $R.log("Controllerr init : end");
  };

  // 共通モジュールを追加する
  Controller.include($R.Library.EnterTabPFKeyMixin);
  Controller.include($R.Library.ControllerMixin);

  // メニューパターン　ミックスインを追加する
  Controller.include($R.Library.TabMenuControllerMixin);

  // ----------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　  　　
  // また、パターン内の処理を変更するときは、オーバライドする　
  // ----------------------------------------------------------
  Controller.include({
    // ------------------------
    // イベント処理
    // ------------------------
    onメニュータブ: function(event) {
      $R.log("Controller onメニュータブ : start");

      var tabName = $(event.target).attr("id");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      sessionStorage.saveItem("ターゲットタブ", tabName);

      $R.log("Controller onメニュータブ : end");
    }
   ,onメニュー: function(event) {
      $R.log("Controller onメニュー : start");

      var idName    = $(event.target).attr("id");
      var htmlName  = $(event.target).attr("name");
			var arg       = {タイプ: "メニュー", 次画面名: htmlName, メニューＩＤ: idName};
			this.model.onメニュー(arg);
			
      this.model.setUserImfo(arg);
			this.ajaxExecute("userinfo");

      $R.log("Controller onメニュー : end");
    }
   ,onタブメニュー: function(event) {
      $R.log("Controller onタブメニュー : start");

      var idName    = $(event.target).attr("id");
      var htmlName  = $(event.target).attr("name");
			var arg       = {タイプ: "タブメニュー", 次画面名: htmlName, メニューＩＤ: idName};
			this.model.onタブメニュー(arg);
			
      this.model.setUserImfo(arg);
			this.ajaxExecute("userinfo");

      $R.log("Controller onタブメニュー : end");
    }
    // -----------------------------------
    //  リクエストデータ　チェック処理
    // -----------------------------------
   ,onユーザ情報OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller onユーザ情報OfCheckRequestData : start");
			
			var status = this.model.onユーザ情報OfCheckRequestData(requestData, mode);

      $R.log("Controller onユーザ情報OfCheckRequestData : end");
      return status;
    }
    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,onユーザ情報OfEditResponseData: function(responseData, mode) {
      $R.log("Controller onユーザ情報OfEditResponseData : start");

      var arg  = this.model.getUserImfo();
			if (arg["タイプ"] == "タブメニュー") {
        this.model.postTabTransition(arg["画面名"]);
			}
			else {
        var currName  = this.appspec.urlInfo[0]["app"];
        this.model.setTransitionData(currName.slice(0, -1));
        this.model.postHtmlTransition(arg["画面名"]);
			}
			
			//var currName  = this.appspec.urlInfo[0]["app"];
      //this.model.setTransitionData(currName.slice(0, -1));
      //this.model.postHtmlTransition(arg["画面名"]);


      $R.log("Controller onユーザ情報OfEditResponseData : end");
    }
    // ---------------------------
    //  レスポンス　エラー処理
    // ---------------------------
   ,onErrorResponseData: function(responseData, mode) {
      $R.log("Controller onErrorResponseData : start");

      this.errorResponseData(responseData);

      $R.log("Controller onErrorResponseData : end");
    }
		

  });
}(jQuery, Rmenu));