(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.MainMenu;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  // メニューパターン　ミックスインを追加する
  Model.include($R.Library.TabMenuModelMixin);

  // ----------------------------------------------------------
  // パターンに含まれない処理を追加する　　　　　　　　　  　　
  // また、パターン内の処理を変更するときは、オーバライドする　
  // ----------------------------------------------------------
  Model.include({
    // ------------------------
    // イベント処理
    // ------------------------
    onメニュー: function(arg) {
      $R.log("Model onメニュー : start");
			
			var nextName  = arg["次画面名"].split("/"); 
			var maxCount  = nextName.length - 1;
			var menuID    = arg["メニューＩＤ"];
			

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + nextName[maxCount]);
      sessionStorage.saveItem("メニューＩＤ", menuID);
			
      $R.log("Model onメニュー : end");
    }
    ,onタブメニュー: function(arg) {
      $R.log("Model onタブメニュー : start");
			
			var nextName  = arg["次画面名"].split("/"); 
			var maxCount  = nextName.length - 1;
			var menuID    = arg["メニューＩＤ"];
			

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + nextName[maxCount]);
      sessionStorage.saveItem("メニューＩＤ", menuID);
			
      $R.log("Model onタブメニュー : end");
    }

    // -----------------------------------
    //  リクエストデータ　チェック処理
    // -----------------------------------
   ,onユーザ情報OfCheckRequestData: function(requestData, mode) {
      $R.log("Model onユーザ情報OfCheckRequestData : start");
			
      var headerRecord = this.appspec.getJSONChunkByIdAtRecords(requestData, "header")["record"];
			
      headerRecord["ユーザＩＤ"]["value"][0] = this.getUserID();
			var arg                                = this.getUserImfo();
      headerRecord["画面名"]["value"][0]     = arg["画面名"];
			
			var userObj = this.getDisplayInfo();
      headerRecord["host"]["value"][0]       = userObj["host"];
      headerRecord["hostname"]["value"][0]   = userObj["hostname"];
      headerRecord["port"]["value"][0]       = userObj["port"];
      headerRecord["request"]["value"][0]    = userObj["request"];
      headerRecord["code"]["value"][0]       = userObj["code"];
      headerRecord["browser"]["value"][0]    = userObj["browser"];
      headerRecord["version"]["value"][0]    = userObj["version"];
      headerRecord["lang"]["value"][0]       = userObj["lang"];
      headerRecord["platform"]["value"][0]   = userObj["platform"];
      headerRecord["useragent"]["value"][0]  = userObj["useragent"];
      headerRecord["referer"]["value"][0]    = userObj["referer"];
      headerRecord["domain"]["value"][0]     = userObj["domain"];
      headerRecord["screen_w"]["value"][0]   = userObj["screen_w"];
      headerRecord["screen_h"]["value"][0]   = userObj["screen_h"];
      headerRecord["screen_col"]["value"][0] = userObj["screen_col"];

      $R.log("Model onユーザ情報OfCheckRequestData : end");
      return true;
    }
   ,getDisplayInfo: function(displayInfo) {
      $R.log("Model getDisplayInfo : start");
			
      var userObj = {};
      userObj["host"]       = location.host;
      userObj["hostname"]   = location.hostname;
      userObj["port"]       = location.port;
      userObj["request"]    = location.pathname;
      userObj["code"]       = navigator.appCodeName;
      userObj["browser"]    = navigator.appName;
      userObj["version"]    = navigator.appVersion;
      userObj["lang"]       = navigator.language;
      userObj["platform"]   = navigator.platform;
      userObj["useragent"]  = navigator.userAgent;
      userObj["referer"]    = document.referrer;
      userObj["domain"]     = document.domain;
      userObj["screen_w"]   = screen.width;
      userObj["screen_h"]   = screen.height;
      userObj["screen_col"] = screen.colorDepth + "Bit";

      $R.log("Model getDisplayInfo : end");
      return userObj;
    }
   ,setUserImfo: function(arg) {
      $R.log("Model setUserImfo : start");
			
      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      sessionStorage.saveItem("タイプ", arg["タイプ"]);
      sessionStorage.saveItem("画面名", arg["次画面名"]);

      $R.log("Model setUserImfo : end");
    }
   ,getUserImfo: function() {
      $R.log("Model getUserImfo : start");
			
      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
			var arg = {};
      arg["タイプ"] = sessionStorage.loadItem("タイプ");
      arg["画面名"] = sessionStorage.loadItem("画面名");

      $R.log("Model getUserImfo : end");
      return arg;
    }
    // -------------------------------------------
    //  ローカルストレージの情報を取得する
    // -------------------------------------------
   ,getUserID: function() {
      $R.log("Model getUserID : start");
			
      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + ".Login");
      var userid = sessionStorage.loadItem("ユーザＩＤ");

      $R.log("Model getUserID : end");
			return userid;
    }

  });

}(jQuery, Rmenu));