(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.ServerViewer;

  // インスタンスプロパティを追加する
  var Controller = App.Controller = new $R.Class($R.Controller);
  Controller.fn.init = function(appspec, model, view) {
    $R.log("Controller init : start");

    this.appspec = appspec;
    this.model   = model;
    this.view    = view;
    this.createPubSubEvent();

    $R.log("Controller init : end");
  };

  // 共通モジュールを追加する
  Controller.include($R.Library.EnterTabPFKeyMixin);
  Controller.include($R.Library.ControllerMixin);

  // 関数を追加する
  Controller.include({
    // --------
    // 処理開始
    // --------
    initExecute: function() {
      $R.log("Controller initExecute : start");

      var arg = this.model.onログイン情報();
      this.view.onログイン情報(arg);

      this.on初期処理();

      $R.log("Controller initExecute : end");
    }

    // ---------------------------------------
    // 初期処理
    // ---------------------------------------
   ,on初期処理: function() {
      $R.log("Controller on初期処理 : start");

      var arg = this.model.on初期処理();
      this.view.on初期処理(arg);

      this.ajaxExecute("project");

      $R.log("Controller on初期処理 : end");
    }
    // ------------------------
    // Focus・Blue イベント処理
    // ------------------------
   ,onFocus: function(event) {
      $R.log("Controller onFocus : start");

      this.onControllerFocus(event);

      $R.log("Controller onFocus : end");
    }
   ,onBlur: function(event) {
      $R.log("Controller onBlur : start");

      this.onControllerBlur(event);

      $R.log("Controller onBlur : end");
    }
    // ---------------------------------------
    // ボタン・ファンクションキー イベント処理
    // ---------------------------------------
   ,on戻る: function(event) {
      $R.log("Controller on戻る : start");

      this.model.clearセッション情報();
      //this.model.previousTransition();
      window.close();

      $R.log("Controller on戻る : end");
    }
    // -------------------------------------
    // チェンジ イベント処理（追加処理）
    // -------------------------------------
   ,onChangeプロジェクト選択: function(event) {
      $R.log("Controller onChangeセレクトボックス : start");

      this.model.onChangeSelectBox(event, this.appspec.selectbox);
      this.view.onChangeプロジェクト選択();

      this.ajaxExecute("program");

      $R.log("Controller onChangeプロジェクト選択 : end");
    }
   ,onChangeプログラム選択: function(event) {
      $R.log("Controller onChangeプログラム選択 : start");

      this.model.onChangeSelectBox(event, this.appspec.selectbox);

      this.ajaxExecute("mode");

      $R.log("Controller onChangeプログラム選択 : end");
    }
   ,onChangeモード選択: function(event) {
      $R.log("Controller onChangeモード選択 : start");

      var mode = this.model.onChangeSelectBox(event, this.appspec.selectbox);

      var dataSetInfo = this.model.dataset.getData();
      this.view.onChangeモード選択(dataSetInfo, mode);

      $R.log("Controller onChangeモード選択 : end");
    }
   ,onChangeテーブル選択: function(event) {
      $R.log("Controller onChangeテーブル選択 : start");

      this.model.onChangeSelectBox(event, this.appspec.selectbox);
			
      this.ajaxExecute("attribute");

      $R.log("Controller onChangeテーブル選択 : end");
    }
   ,onChangeＲｕｂｙモジュール選択: function(event) {
      $R.log("Controller onChangeＲｕｂｙモジュール選択 : start");

      var rubyname = this.model.onChangeSelectBox(event, this.appspec.selectbox);

      var dataSetInfo = this.model.dataset.getData();
      this.view.onChangeＲｕｂｙモジュール選択(dataSetInfo, rubyname);

      $R.log("Controller onChangeＲｕｂｙモジュール選択 : end");
    }
    // -----------------------------------
    //  リクエストデータ　チェック処理
    // -----------------------------------
   ,onプロジェクトOfCheckRequestData: function(requestData, mode) {
      $R.log("Controller onプロジェクトOfCheckRequestData : start");

      var status = this.model.onプロジェクトOfCheckRequestData(requestData, mode);
      if (status) {
        status = this.checkRequestData(requestData);
      }

      $R.log("Controller onプロジェクトOfCheckRequestData : end");
      return status;
    }
   ,onプログラムOfCheckRequestData: function(requestData, mode) {
      $R.log("Controller onプログラムOfCheckRequestData : start");

      var status = this.model.onプログラムOfCheckRequestData(requestData, mode);
      if (status) {
        status = this.checkRequestData(requestData);
      }

      $R.log("Controller onプログラムOfCheckRequestData : end");
      return status;
    }
   ,onモードOfCheckRequestData: function(requestData, mode) {
      $R.log("Controller onモードOfCheckRequestData : start");

      var status = this.model.onモードOfCheckRequestData(requestData, mode);
      if (status) {
        status = this.checkRequestData(requestData);
      }

      $R.log("Controller onモードOfCheckRequestData : end");
      return status;
    }
   ,onテーブルOfCheckRequestData: function(requestData, mode) {
      $R.log("Controller onテーブルOfCheckRequestData : start");

      var status = this.model.onテーブルOfCheckRequestData(requestData, mode);
      if (status) {
        status = this.checkRequestData(requestData);
      }

      $R.log("Controller onテーブルOfCheckRequestData : end");
      return status;
    }
   ,on属性OfCheckRequestData: function(requestData, mode) {
      $R.log("Controller on属性OfCheckRequestData : start");

      var status = this.model.on属性OfCheckRequestData(requestData, mode);
      if (status) {
        status = this.checkRequestData(requestData);
      }

      $R.log("Controller on属性OfCheckRequestData : end");
      return status;
    }
    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,onプロジェクトOfEditResponseData: function(responseData, mode) {
      $R.log("Controller onプロジェクトOfEditResponseData : start");

      this.editResponseData(responseData);
      this.model.onプロジェクトOfEditResponseData(responseData);
      this.view.onプロジェクトOfEditResponseData(responseData);

       // セレクトボックスの一括初期表示
      this.onShowSelectBoxAll(responseData, this.appspec.selectbox);

      $R.log("Controller onプロジェクトOfEditResponseData : end");
    }
   ,onプログラムOfEditResponseData: function(responseData, mode) {
      $R.log("Controller onプログラムOfEditResponseData : start");

      this.editResponseData(responseData);
      this.model.onプログラムOfEditResponseData(responseData);
      this.view.onプログラムOfEditResponseData(responseData);

       // セレクトボックスの一括初期表示
      this.onShowSelectBoxAll(responseData, this.appspec.selectbox);

      $R.log("Controller onプログラムOfEditResponseData : end");
    }
   ,onモードOfEditResponseData: function(responseData, mode) {
      $R.log("Controller onモードOfEditResponseData : start");

      var dataSetInfo = this.model.dataset.getData();

      this.editResponseData(responseData);
      this.model.onモードOfEditResponseData(responseData);
      this.view.onモードOfEditResponseData(responseData, dataSetInfo);

       // セレクトボックスの一括初期表示
      this.onShowSelectBoxAll(responseData, this.appspec.selectbox);

      // データベース名を使用してテーブル名を取得する
      var tableRecord   = this.appspec.getJSONChunkByIdAtRecords(dataSetInfo, "table")["record"];
      if ($("#データベース名").text() == "") {
        this.ajaxExecute("table");
      }

      $R.log("Controller onモードOfEditResponseData : end");
    }
   ,onテーブルOfEditResponseData: function(responseData, mode) {
      $R.log("Controller onテーブルOfEditResponseData : start");

      var dataSetInfo = this.model.dataset.getData();

      this.editResponseData(responseData);
      this.model.onテーブルOfEditResponseData(responseData);
      this.view.onテーブルOfEditResponseData(responseData, dataSetInfo);

       // セレクトボックスの一括初期表示
      this.onShowSelectBoxAll(responseData, this.appspec.selectbox);

      $R.log("Controller onテーブルOfEditResponseData : end");
    }
   ,on属性OfEditResponseData: function(responseData, mode) {
      $R.log("Controller on属性OfEditResponseData : start");

      var dataSetInfo = this.model.dataset.getData();

      this.editResponseData(responseData);
      this.model.on属性OfEditResponseData(responseData);
      this.view.on属性OfEditResponseData(responseData, dataSetInfo);

      $R.log("Controller on属性OfEditResponseData : end");
    }
    // ---------------------------
    //  レスポンス　エラー処理
    // ---------------------------
   ,onErrorResponseData: function(responseData, mode) {
      $R.log("Controller onErrorResponseData : start");

      this.errorResponseData(responseData);

      $R.log("Controller onErrorResponseData : end");
    }

  });
}(jQuery, Rmenu));