(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.ViewerJson;

  // インスタンスプロパティを追加する
  var Model = App.Model = new $R.Class($R.Model);
  Model.fn.init = function(appspec) {
    $R.log("Model init : start");

    this.appspec = appspec;

    $R.log("Model init : end");
  }

  // 共通モジュールを追加する
  Model.include($R.Library.ValidationMixin);
  Model.include($R.Library.ModelMixin);
  Model.include($R.Library.HtmlTransitionMixin);

  Model.include({
    // --------
    // 処理開始
    // --------
    initExecute: function() {
      $R.log("Model initExecute : start");

      //this.dataset.clearDataValue();                   // Datasetの値をクリアする
      //this.dataset.clearFormElementNo();               // フォームオブジェクトの要素番号をクリアする
      //this.dataset.setFormElementNo();                 // フォームオブジェクトの要素番号を設定する

      $R.log("Model initExecute : end");
    }
    // -------------------------------------------------------------------
    //  セッションストレージからログイン情報を取得し表示イベントを発行する
    // -------------------------------------------------------------------
   ,onログイン情報: function() {
      $R.log("Model onログイン情報 : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + ".Login");

      var username = sessionStorage.loadItem("ユーザ名称");
      var datetime = sessionStorage.loadItem("ログイン時刻");
      var jdate    = sessionStorage.loadItem("ログイン和暦");
      var arg      = {ユーザ名称: username, ログイン時刻: datetime, ログイン和暦: jdate};

      $R.log("Model onログイン情報 : end");
			return arg;
    }
    // -------------------------------------------------------------------
    //  初期処理
    // -------------------------------------------------------------------
   ,on初期処理: function() {
      $R.log("Model on初期処理 : start");

      var arg = {};

      $R.log("Model on初期処理 : end");
			return arg;
    }
    // -------------------------------------------------
    //  セッションスト（ログイン情報）をレージクリアする
    // -----------------------------------------------  
   ,clearセッション情報: function() {
      $R.log("Model clearセッション情報 : start");

      // セッションデータに識別名を設定する
      sessionStorage.setIdName(this.appspec.sysname + "." + this.appspec.name);
      sessionStorage.deleteAll("");

      $R.log("Model clearセッション情報 : end");
    }
    // ---------------------------------------------------
    //  リクエストデータ　編集・チェック処理
    // ---------------------------------------------------
   ,onプロジェクトOfCheckRequestData: function(requestData, mode) {
      $R.log("Model onプロジェクトOfCheckRequestData : start");

      $R.log("Model onプロジェクトOfCheckRequestData : end");
      return true;
    }
   ,onプログラムOfCheckRequestData: function(requestData, mode) {
      $R.log("Model onプログラムOfCheckRequestData : start");

      $R.log("Model onプログラムOfCheckRequestData : end");
      return true;
    }
   ,onモードOfCheckRequestData: function(requestData, mode) {
      $R.log("Model onモードOfCheckRequestData : start");

      $R.log("Model onモードOfCheckRequestData : end");
      return true;
    }
   ,onテーブルOfCheckRequestData: function(requestData, mode) {
      $R.log("Model onテーブルOfCheckRequestData : start");
			
      $R.log("Model onテーブルOfCheckRequestData : end");
      return true;
    }
   ,on属性OfCheckRequestData: function(requestData, mode) {
      $R.log("Model on属性OfCheckRequestData : start");
			
      $R.log("Model on属性OfCheckRequestData : end");
      return true;
    }
    // -------------------------------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------------------------------
   ,onプロジェクトOfEditResponseData: function(responseData) {
      $R.log("Model onプロジェクトOfEditResponseData : start");


      $R.log("Model onプロジェクトOfEditResponseData : end");
    }
   ,onプログラムOfEditResponseData: function(responseData) {
      $R.log("Model onプログラムOfEditResponseData : start");


      $R.log("Model onプログラムOfEditResponseData : end");
    }
   ,onモードOfEditResponseData: function(responseData) {
      $R.log("Model onモードOfEditResponseData : start");

      var resourceRecord = this.appspec.getJSONChunkByIdAtRecords(responseData, "resource")["record"];
			var dataSetInfo    = this.dataset.getData();
      var searchRecord   = this.appspec.getJSONChunkByIdAtRecords(dataSetInfo, "searchCondition")["record"];
			
			searchRecord["検索ＤＢ名"]["value"][0] = resourceRecord["ＤＢ名"]["value"][0];


      $R.log("Model onモードOfEditResponseData : end");
    }
   ,onテーブルOfEditResponseData: function(responseData) {
      $R.log("Model onテーブルOfEditResponseData : start");


      $R.log("Model onテーブルOfEditResponseData : end");
    }
   ,on属性OfEditResponseData: function(responseData) {
      $R.log("Model on属性OfEditResponseData : start");


      $R.log("Model on属性OfEditResponseData : end");
    }

  });
}(jQuery, Rmenu));