(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.ViewerJson;

  // インスタンスプロパティを追加する
  var View = App.View = new $R.Class($R.View);
  View.fn.init = function(appspec) {
    $R.log("View init : start");

    this.appspec = appspec;

    $R.log("View init : end");
  }

  // 共通モジュールを追加する
  View.include($R.Library.FormatMixin);
  View.include($R.Library.OutlineMixin);
  View.include($R.Library.LoadTemplateMixin);
  View.include($R.Library.ViewMixin);

  View.include({
    // --------
    // 処理開始
    // --------
    initExecute: function() {
      $R.log("View initExecute : start");

      this.initテンプレートロード();
			var w_crtW = new BigNumber(screen.width).div(100).round(0,1)
			var w_crtH = new BigNumber(screen.height).div(100).round(0,1)
			
		  // CREATE THE LAYOUT
		  $("body").layout({
			  resizeWhileDragging: 			true
		  ,	fxName:							"none"
		  ,	north__size:					w_crtH * 8
		  ,	west__size:						w_crtW * 18
		  ,	east__size:						w_crtW * 15
		  ,	spacing_open:					         8
		  ,	spacing_closed:					       8
		  ,	north__togglerLength_closed:	 105
		  ,	north__togglerLength_open:		 105
		  ,	west__togglerLength_closed:		 105
		  ,	west__togglerLength_open:		   105
		  ,	south__togglerLength_closed:	 105
		  ,	south__togglerLength_open:		 105

		  //	Center Sidebar options
		  ,	center__childOptions:	{
			  	minSize:				           50
			 ,	north__size:			w_crtH * 20
			  }

		  //	West Sidebar options
		  ,	west__childOptions:	{
			  	minSize:				           50
			 ,	north__size:			w_crtH * 20
			  }

		  //	East Sidebar options
		  ,	east__childOptions:	{
			  	minSize:				           50
			 ,	north__size:			w_crtH * 40
			  }

		  });
			

      $R.log("View initExecute : end");
    }
    // -------------------------------------------------------------------
    //  テンプレートをロードする
    // -------------------------------------------------------------------
   ,initテンプレートロード: function() {
      $R.log("View initテンプレートロード : start");

      // ＣＳＳファイル名をセッションストレージから取得しロードする
      sessionStorage.setIdName(this.appspec.sysname + ".Login");
      var cssName = sessionStorage.loadItem("ＣＳＳファイル名");

      if (cssName) {
        var arg = {cssName: cssName};
        this.appendCSS(arg);
      }

      $('body').fadeIn("normal");

      $R.log("View initテンプレートロード : end");
    }
    // -----------------------
    //  ログイン情報を表示する
    // -----------------------
   ,onログイン情報: function(arg) {
      $R.log("View onログイン情報 : start");

      $("#ログイン和暦").html(arg["ログイン和暦"]); 
      $("#ログイン日時").html(arg["ログイン時刻"]); 
      $("#ユーザ氏名").html(arg["ユーザ名称"]); 

      $R.log("View onログイン情報 : end");
    }
    // -------------------------------------------------------------------
    //  初期処理
    // -------------------------------------------------------------------
   ,on初期処理: function(arg) {
      $R.log("View on初期処理 : start");

      $R.log("View on初期処理 : end");
    }
    // -------------------------------------
    // チェンジ イベント処理（追加処理）
    // -------------------------------------
   ,onChangeプロジェクト選択: function() {
      $R.log("View onChangeセレクトボックス : start");
			
			$("#テーブル選択").val(0);
			$("#モード選択").val(0);
			$("#ルビー選択").val(0);

			$("#データベース名").text("");
			$("#テーブル選択 option").remove();
			$("#テーブル項目").find("tr:gt(0)").remove();
			
			$("#htmlsource").val("");
			$("#validationsource").val("");

			$("#datasetsource1").val("");
			$("#requestsource").val("");
			$("#sqlsource").val("");
			$("#responsesource").val("");
			$("#datasetsource2").val("");
			
			$("#ルビー選択 option").remove();
			$("#rubysource").val("");

      $R.log("View onChangeプロジェクト選択 : end");
    }
   ,onChangeモード選択: function(dataSetInfo, mode) {
      $R.log("View onChangeモード選択 : start");
			
      var searchRecord   = this.appspec.getJSONChunkByIdAtRecords(dataSetInfo, "searchCondition")["record"];
			var programName    = searchRecord["プログラム名"]["value"][0];
			
      var resourceRecord = this.appspec.getJSONChunkByIdAtRecords(dataSetInfo, "resource")["record"];
			jsonSource         = resourceRecord["ＪＳＯＮソース"]["value"][0];
			jsonObject         = JSON.parse(jsonSource)
			
      for(key in jsonObject){
				if (key == (programName + "_dataset.json")) {
					continue;
				}
				if (key == (programName + "_validation.json")) {
					continue;
				}

				
				if (key == (programName + "_" + mode + "_sql.json")) {
					$("#sqlsource").val(jsonObject[key]);
					continue;
				}
				
				if (key == (programName + "_" + mode + "_tran.json")) {
				  var tranString = jsonObject[key];
					
					var pos = tranString.indexOf("\"response\"");
					var requestString  = tranString.slice(0, pos - 1);
					var responseString = tranString.slice(pos);
					
				  $("#requestsource").val(requestString + "}");
				$("#responsesource").val("{\n" + responseString );
					continue;
				}
				
      }
			
      $R.log("View onChangeモード選択 : end");
    }
   ,onChangeルビー選択: function(dataSetInfo, rubyname) {
      $R.log("View onChangeルビー選択 : start");
			
      var resourceRecord = this.appspec.getJSONChunkByIdAtRecords(dataSetInfo, "resource")["record"];
			rubySource         = resourceRecord["Ｒｕｂｙソース"]["value"][0];
			rubyObject         = JSON.parse(rubySource)
			
			$("#rubysource").val(rubyObject[rubyname]);
			
      $R.log("View onChangeルビー選択 : end");
    }
    // -------------------------------
    //  レスポンスデータ　編集処理
    // -------------------------------
   ,onプロジェクトOfEditResponseData: function(responseData) {
      $R.log("View onプロジェクトOfEditResponseData : start");
			
			$("#プログラム選択 option").remove();
			$("#モード選択 option").remove();
			
      $R.log("View onプロジェクトOfEditResponseData : end");
    }
   ,onプログラムOfEditResponseData: function(responseData) {
      $R.log("View onプログラムOfEditResponseData : start");

			$("#モード選択 option").remove();

      $R.log("View onプログラムOfEditResponseData : end");
    }
   ,onモードOfEditResponseData: function(responseData, dataSetInfo) {
      $R.log("View onモードOfEditResponseData : start");
			
      var searchRecord   = this.appspec.getJSONChunkByIdAtRecords(dataSetInfo, "searchCondition")["record"];
			var programName    = searchRecord["プログラム名"]["value"][0];
			
      var resourceRecord = this.appspec.getJSONChunkByIdAtRecords(responseData, "resource")["record"];
			$("#htmlsource").val(resourceRecord["ＨＴＭＬソース"]["value"][0]);
			
			jsonSource = resourceRecord["ＪＳＯＮソース"]["value"][0];
			jsonObject = JSON.parse(jsonSource)
			
			$("#validationsource").val(jsonObject[programName + "_validation.json"]);
			$("#datasetsource1").val(jsonObject[programName + "_dataset.json"]);
			$("#datasetsource2").val(jsonObject[programName + "_dataset.json"]);
			$("#requestsource").val("");
			$("#sqlsource").val("");
			$("#responsesource").val("");
			$("#rubysource").val("");

      $R.log("View onモードOfEditResponseData : end");
    }
   ,onテーブルOfEditResponseData: function(responseData, dataSetInfo) {
      $R.log("View onテーブルOfEditResponseData : start");
			
      var searchRecord   = this.appspec.getJSONChunkByIdAtRecords(dataSetInfo, "searchCondition")["record"];
			var databaseName   = searchRecord["検索ＤＢ名"]["value"][0];
			
			$("#データベース名").text(databaseName);
			

      $R.log("View onテーブルOfEditResponseData : end");
    }
   ,on属性OfEditResponseData: function(responseData, dataSetInfo) {
      $R.log("View on属性OfEditResponseData : start");
			
			// 全ての行を削除する
			$("#テーブル項目").find("tr:gt(0)").remove();
			
      var resourceRecord = this.appspec.getJSONChunkByIdAtRecords(responseData, "resource")["record"];
      var maxSize        = resourceRecord["カラム名"]["value"].length;

			// テーブルに行を追加する
			var strHTML = "";
			for (var row = 0; row < maxSize; row++) {
			  strHTML += this.createDetail(resourceRecord, row);
			}
			$("#テーブル項目").append(strHTML);

      $R.log("View on属性OfEditResponseData : end");
    }
		// 明細行のHTMLソースを生成する
   ,createDetail: function(resourceRecord, row) {
			
      var strHTML = "<tr><td>" + resourceRecord["カラム名"]["value"][row] + "</td>";
			strHTML    += "<td>"     + resourceRecord["データ型"]["value"][row] + "</td>";
			strHTML    += "<td>"     + resourceRecord["ヌル制約"]["value"][row] + "</td></tr>";
			
    	return strHTML;
    }

	});
}(jQuery, Rmenu));