(function($, $R){
  // 名前空間を設定する
  var App = $R.Application.VisualClient;

  // インスタンスプロパティを追加する
  var View = App.View = new $R.Class($R.View);
  View.fn.init = function(appspec) {
    $R.log("View init : start");

    this.appspec = appspec;

    $R.log("View init : end");
  }

  // 共通モジュールを追加する
  View.include($R.Library.FormatMixin);
  View.include($R.Library.OutlineMixin);
  View.include($R.Library.LoadTemplateMixin);
  View.include($R.Library.ViewMixin);

  View.include({
    // --------
    // 処理開始
    // --------
    initExecute: function() {
      $R.log("View initExecute : start");

      this.initテンプレートロード();
			var w_crtW = new BigNumber(screen.width).div(100).round(0,1)
			var w_crtH = new BigNumber(screen.height).div(100).round(0,1)

		  // OUTER-LAYOUT
		  $('body').layout({
			  center__paneSelector:	".outer-center"
		  ,	west__paneSelector:		".outer-west"
		  ,	east__paneSelector:		".outer-east"
		  ,	north__size:					w_crtH * 10
		  ,	south__size:					w_crtH *  5
		  ,	west__size:						w_crtW * 15
		  ,	east__size:						w_crtW * 15
		  ,	spacing_open:			              8 // ALL panes
		  ,	spacing_closed:			           12 // ALL panes

		  //	West Sidebar options
		  ,	west__childOptions:	{
			  	minSize:				           50	// ALL panes
			 ,	south__size:			w_crtH * 45
		  	}

		  //	East Sidebar options
		  ,	east__childOptions:	{
			  	minSize:				           50	// ALL panes
			 ,	north__size:			w_crtH * 28
			 ,	south__size:			w_crtH * 25
		  	}

			// MIDDLE-LAYOUT (child of outer-center-pane)
	  	,	center__childOptions: {
		  		center__paneSelector:	".middle-center"
			 ,	west__paneSelector:		".middle-west"
			 ,	west__size:				w_crtW * 15
			 ,	spacing_open:			          8 // ALL panes
			 ,	spacing_closed:			       12 // ALL panes

				  // INNER-LAYOUT (child of middle-center-pane)
			   ,	center__childOptions: {
					    center__paneSelector:	".inner-center"
			     ,	east__paneSelector:		".inner-east"
			     ,	north__size:		 w_crtH * 15
			     ,	east__size:			 w_crtW * 26
				   ,	spacing_open:			         8  // ALL panes
				   ,	spacing_closed:			       8  // ALL panes
				
				
			      ,	east__childOptions: {
				        minSize:				        50	// ALL panes
			       ,	north__size:	 w_crtH * 19
			       ,	south__size:	 w_crtH * 19
				     ,	spacing_open:			       8  // ALL panes
				     ,	spacing_closed:			     8  // ALL panes
				     ,	north__spacing_closed:	12
				     ,	south__spacing_closed:	12
				     }
						 
			      ,	center__childOptions: {
				        minSize:				        50	// ALL panes
			       ,	north__size:	 w_crtH * 19
			       ,	south__size:	 w_crtH * 19
				     ,	spacing_open:			       8  // ALL panes
				     ,	spacing_closed:			     8  // ALL panes
				     ,	north__spacing_closed:	12
				     ,	south__spacing_closed:	12
				     }
				  }
			  }
			
		  });


      $R.log("View initExecute : end");
    }
    // -------------------------------------------------------------------
    //  テンプレートをロードする
    // -------------------------------------------------------------------
   ,initテンプレートロード: function() {
      $R.log("View initテンプレートロード : start");

      // ＣＳＳファイル名をセッションストレージから取得しロードする
      sessionStorage.setIdName(this.appspec.sysname + ".Login");
      var cssName = sessionStorage.loadItem("ＣＳＳファイル名");

      if (cssName) {
        var arg = {cssName: cssName};
        this.appendCSS(arg);
      }

      $('body').fadeIn("normal");

      $R.log("View initテンプレートロード : end");
    }
    // -----------------------
    //  ログイン情報を表示する
    // -----------------------
   ,showログイン情報: function(arg) {
      $R.log("View showログイン情報 : start");

      $("#ログイン和暦").html(arg["ログイン和暦"]); 
      $("#ログイン日時").html(arg["ログイン時刻"]); 
      $("#ユーザ氏名").html(arg["ユーザ名称"]); 

      $R.log("View showログイン情報 : end");
    }

	});
}(jQuery, Rmenu));