# coding: UTF-8

require 'RmenuVisualTools/Server/Modules/RmenuVisualToolsOfMasterMainteOfModelMixin'

class AccessLogInfo_model
  include RmenuVisualToolsOfMasterMainteOfModelMixin

  def initialize(rmenu_dbi, sql_data, request_data)
    begin
      # initialize 開始ログを出力する
      $Mlog.debug("AccessLogInfo_model") {"initialize start"}                   # Logファイル Debug用

      @rmenu_dbi      = rmenu_dbi
      @sql_data       = sql_data
      @request_data   = request_data

      # initialize 終了ログを出力する
      $Mlog.debug("AccessLogInfo_model") {"initialize normal end"}              # Logファイル Debug用
    rescue Exception
      # エラーログを出力する
      $Mlog.error("AccessLogInfo_model") {"initialize exception: #{$!}"}        # Logファイル Debug用
      raise
    end
  end
	
  # 検索条件の置換処理
  def set検索条件(idName1, idName2)
    $Mlog.debug("AccessLogInfo_model") {"set検索条件 start"}                  # Logファイル Debug用

    requestRecord   = getJsonChunkById(@request_data, "records", idName1,          "record")
    sqlRecord       = getJsonChunkById(@sql_data,     "sqls",    idName2, "input", "record")
		
    sqlRecord["アクセス日付" ]["value"][0] = editRegexp(requestRecord["アクセス日付" ]["value"][0], "complete")
    sqlRecord["ユーザＩＤ" ]["value"][0]   = editRegexp(requestRecord["検索従業員コード" ]["value"][0], "complete")
				
    $Mlog.debug("AccessLogInfo_model") {"set検索条件 end"}                    # Logファイル Debug用
    return "OK"
  end

end
