# coding: UTF-8

require 'RmenuLoggerMixin'                                                      # Logファイル Debug用
require 'RmenuJsonMixin'                                                        # ID名で該当レコードを取得する

module RmenuVisualToolsOfMasterMainteOfModelMixin
  include RmenuLoggerMixin                                                      # Logファイル Debug用
  include RmenuJsonMixin

  # カレントページ数とページ当りの行数を使って、オフセット行数を計算する
  def getOffsetLineOfRmenuVisualTools(idName1, idName2)
    $Mlog.debug("RmenuVisualToolsOfBaseNameMainteOfModelMixin") {"getOffsetLineOfRmenuVisualTools start"}                  # Logファイル Debug用

    requestRecord   = getJsonChunkById(@request_data, "records", idName1)
    page_line       = requestRecord["record"]["ページライン数"]["value"][0].to_i
    cur_page        = requestRecord["record"]["カレントページ"]["value"][0].to_i
    offset_line     = (cur_page - 1) * page_line
    $Mlog.debug("RmenuVisualToolsOfBaseNameMainteOfModelMixin") {"ページライン数 :     #{page_line}"}
    $Mlog.debug("RmenuVisualToolsOfBaseNameMainteOfModelMixin") {"カレントページ :     #{cur_page}"}
    $Mlog.debug("RmenuVisualToolsOfBaseNameMainteOfModelMixin") {"オフセットライン数 : #{offset_line}"}

    sqlRecord = getJsonChunkById(@sql_data, "sqls", idName2, "input")
    sqlRecord["record"]["オフセットライン数"]["value"][0] = offset_line.to_s

    $Mlog.debug("RmenuVisualToolsOfBaseNameMainteOfModelMixin") {"getOffsetLineOfRmenuVisualTools end"}                    # Logファイル Debug用
    return "OK"
  end
	
  # 指定された文字列を正規表現に編集する。
  # 入力値:
  #   str: 正規表現に編集する文字列(複数指定はカンマ区切り)
  #   op :先頭一致:"prefix" 後方一致:"suffix" 部分一致:"partial" 完全一致:"complete"
  # 出力値:
  #   ret: 編集された正規表現
  def editRegexp(str,op)
    # 不要文字削除
    w_str = str.to_s.gsub(/^[ 　,]+|[ 　,]+$/, "").gsub(/[,][ 　]+/, ",").gsub(/[ 　]+[,]/, ",").gsub(/[,]+/, ",")
    # 正規表現編集する文字列があるとき
    if w_str != ""
      case op
      when "prefix"
        # 前方一致の正規表現に編集する
        ret = '^' + w_str.split(/,/).join('|^')
      when "suffix"
        # 後方一致の正規表現に編集する
        ret = w_str.split(/,/).join('$|') + '$'
      when "partial"
        # 部分一致の正規表現に編集する
        ret = w_str.split(/,/).join('|')
      when "complete"
        # 完全一致の正規表現に編集する
        ret = '^' + w_str.split(/,/).join('$|^') + '$'
      end
    # ないとき
    else
      ret = ".*"
    end

    return ret
  end

end
